SystemOrganization addCategory: #'Seaside-Builder'!
SystemOrganization addCategory: #'Seaside-Canvas'!
SystemOrganization addCategory: #'Seaside-Canvas-Tags'!
SystemOrganization addCategory: #'Seaside-Component'!
SystemOrganization addCategory: #'Seaside-Components-Decorations'!
SystemOrganization addCategory: #'Seaside-Components-Dialogs'!
SystemOrganization addCategory: #'Seaside-Components-Frames'!
SystemOrganization addCategory: #'Seaside-Components-Tools'!
SystemOrganization addCategory: #'Seaside-Components-Tools-Squeak'!
SystemOrganization addCategory: #'Seaside-Components-Widgets'!
SystemOrganization addCategory: #'Seaside-Configuration'!
SystemOrganization addCategory: #'Seaside-Continuations'!
SystemOrganization addCategory: #'Seaside-Document'!
SystemOrganization addCategory: #'Seaside-Document-Elements'!
SystemOrganization addCategory: #'Seaside-Examples-Store'!
SystemOrganization addCategory: #'Seaside-Examples-Store-Model'!
SystemOrganization addCategory: #'Seaside-Examples-Test'!
SystemOrganization addCategory: #'Seaside-HTTP'!
SystemOrganization addCategory: #'Seaside-Libraries'!
SystemOrganization addCategory: #'Seaside-Platform'!
SystemOrganization addCategory: #'Seaside-Rendering'!
SystemOrganization addCategory: #'Seaside-RenderLoop'!
SystemOrganization addCategory: #'Seaside-RequestHandler'!
SystemOrganization addCategory: #'Seaside-Session'!
SystemOrganization addCategory: #'Seaside-StateRegistry'!
SystemOrganization addCategory: #'Seaside-Utilities'!
SystemOrganization addCategory: #'Seaside-Utilities-Squeak'!

!String methodsFor: '*seaside2' stamp: 'avi 3/16/2004 16:33'!
asCapitalizedPhrase
	|read words currentWord capitalizedWord|
	(self noneSatisfy: [:ea | ea isLowercase] ) ifTrue: [^ self].
	words _ WriteStream on: String new.
	read _ ReadStream on: self.
	[read atEnd] whileFalse:
		[currentWord _ WriteStream on: String new.
		currentWord nextPut: read next.
		[|x| x _ read peek. x isNil or: [x isUppercase]] whileFalse:
			[currentWord nextPut: read next].
		capitalizedWord _ currentWord contents capitalized.
			(#(Of In At A Or To By) includes: capitalizedWord)
				ifTrue: [capitalizedWord _ capitalizedWord asLowercase].
		words nextPutAll: capitalizedWord.
		words nextPutAll: ' '].
	words skip: -1.
	^ words contents ! !

!String methodsFor: '*seaside2' stamp: 'mb 6/2/2006 10:47'!
asMIMEDocument 
	^self asMIMEDocumentType: 'text/plain'! !

!String methodsFor: '*seaside2' stamp: 'mb 6/2/2006 10:54'!
asMIMEDocumentType: mimeType
	^SeasidePlatformSupport mimeDocumentClass contentType: mimeType content: self! !

!String methodsFor: '*seaside2' stamp: 'ab 3/29/2003 00:15'!
prettyPrintHtmlOn: aStream indentLevel: aNumber
	aStream nextPutAll: self! !

!String methodsFor: '*seaside2' stamp: 'ab 1/11/2003 12:46'!
printHtmlOn: aStream
	aStream nextPutAll: self! !

!String methodsFor: '*seaside2' stamp: 'lr 6/13/2006 16:06'!
renderOn: aRenderer
	aRenderer text: self! !

!String methodsFor: '*seaside2' stamp: 'jf 2/18/2004 15:21'!
renderOn: html indentLevel: level
	html text: self! !

!String methodsFor: '*seaside2-squeak' stamp: 'mb 3/23/2006 11:46'!
trimBlanks
	^self withBlanksTrimmed! !

!MessageSend methodsFor: '*seaside2-squeak' stamp: 'ab 7/10/2003 11:40'!
evaluateWithArguments: anArray
	^ self valueWithArguments: anArray! !

!MessageSend methodsFor: '*seaside2' stamp: 'avi 9/19/2006 14:38'!
fixCallbackTemps! !

!MessageSend methodsFor: '*seaside2' stamp: 'ab 3/5/2003 18:30'!
numArgs
	^ selector numArgs! !

!MessageSend methodsFor: '*seaside2' stamp: 'lr 8/4/2006 09:18'!
renderOn: html
	self value: html! !

!MessageSend methodsFor: '*seaside2' stamp: 'ab 7/10/2003 11:40'!
value: anObject
	^ self evaluateWithArguments: (Array with: anObject)! !

!MessageSend methodsFor: '*seaside2-squeak' stamp: 'ab 8/24/2003 16:38'!
valueWithPossibleArgs: anArray 

	self numArgs = 0 ifTrue: [^self value].
	self numArgs = anArray size ifTrue: [^self valueWithArguments: anArray].
	self numArgs > anArray size ifTrue: [
		^self valueWithArguments: anArray,
				(Array new: (self numArgs - anArray size))
	].
	^self valueWithArguments: (anArray copyFrom: 1 to: self numArgs)

! !

!Color methodsFor: '*seaside2' stamp: 'avi 4/29/2004 13:06'!
asHTMLColor
	^ '#', self hex! !

!Color methodsFor: '*seaside2' stamp: 'mb 5/13/2006 07:45'!
hex
	| aStream |
	aStream _ (String new: 6) writeStream. 
	aStream nextPutAll: (((self red * 255) asInteger printStringBase: 16)
		padded: #left to: 2 with: $0).
	aStream nextPutAll: (((self green * 255) asInteger printStringBase: 16)
		padded: #left to: 2 with: $0).
	aStream nextPutAll: (((self blue * 255) asInteger printStringBase: 16)
		padded: #left to: 2 with: $0).
	^ aStream contents
! !

!MIMEDocument methodsFor: '*seaside2-squeak' stamp: 'pmm 4/18/2006 20:09'!
asMIMEDocument
	^self! !

!MIMEDocument methodsFor: '*seaside2-squeak' stamp: 'mb 6/2/2006 10:44'!
asMIMEDocumentType: mimeType
	^self! !

!Stream methodsFor: '*seaside2-squeak' stamp: 'avi 8/31/2003 15:48'!
closed
	^false! !

!BlockContext methodsFor: '*seaside2' stamp: 'avi 9/19/2006 14:49'!
fixCallbackTemps
	"Fix the values of the temporary variables used in the block that are 
	ordinarily shared with the method in which the block is defined."

	| temps |
	home _ home copy.
	home swapSender: nil.
	home isMethodContext ifTrue:
		[temps _ self tempVarRefs.
		1 to: home size do: [:i | (temps includes: i) ifFalse: [home tempAt: i put: nil]]]
! !

!BlockContext methodsFor: '*seaside2' stamp: 'ab 2/11/2003 20:09'!
handleRequest: aRequest
	^ self value: aRequest! !

!BlockContext methodsFor: '*seaside2' stamp: 'ac 5/16/2003 16:30'!
renderOn: aRenderer
	self numArgs = 0 
		ifTrue: [self value]
		ifFalse: [self value: aRenderer]! !

!BlockContext methodsFor: '*seaside2' stamp: 'avi 9/19/2006 14:49'!
tempVarRefs
	| method scanner end tempVars byte type offset |

	home ifNil: [^false].
	tempVars _ Set new.
	method _ self method.
	"Determine end of block from long jump preceding it"
	end _ (method at: startpc-2)\\16-4*256 + (method at: startpc-1) + startpc - 1.
	scanner _ InstructionStream new method: method pc: startpc.

	[scanner pc <= end] whileTrue:
		[byte  _ scanner nextByte.
		type _ byte // 16.
		offset _ byte \\ 16.
		type = 1 ifTrue: [tempVars add: offset + 1].
		scanner nextInstruction].
	^ tempVars! !

TestCase subclass: #AmbTest
	instanceVariableNames: 'amb'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Continuations'!

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 12:20'!
pickANumber
	^ self pickANumberGreaterThan: 0! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 12:20'!
pickANumberGreaterThan: aNumber
	^ amb valueOf: [aNumber + 1] or: [self pickANumberGreaterThan: aNumber + 1]! !

!AmbTest methodsFor: 'running' stamp: 'ab 12/13/2002 01:15'!
setUp
	amb := Amb new! !

!AmbTest methodsFor: 'tests' stamp: 'ab 12/6/2002 02:43'!
testAllValuesAboveFive
	|x results|
	results := amb allValues:
				[x := amb oneOf: (1 to: 10).
				amb assert: (x > 5).
				x].			
	self assert: results = #(6 7 8 9 10).
! !

!AmbTest methodsFor: 'tests' stamp: 'avi 4/28/2004 11:31'!
testMaybe
	|x y z|
	x := amb maybe.
	y := amb maybe.
	z := amb maybe not.

	amb deny: x = y.
	amb deny: x = z.
	
	self assert: x.
	self deny: y.
	self deny: z.! !

!AmbTest methodsFor: 'tests' stamp: 'ab 12/6/2002 12:21'!
testPickANumber
	self assert: self pickANumber = 1.! !

!AmbTest methodsFor: 'tests' stamp: 'ab 12/6/2002 12:21'!
testPickANumberAboveFive
	|x|
	x := self pickANumber.
	amb assert: (x > 5).
	self assert: x = 6.
! !

!AmbTest methodsFor: 'tests' stamp: 'avi 4/26/2004 14:45'!
testSicpLogicProblem
	"Baker, Cooper, Fletcher, Miller, and Smith live on different floors of an apartment house that contains only five floors. Baker does not live on the top floor. Cooper does not live on the bottom floor. Fletcher does not live on either the top or the bottom floor. Miller lives on a higher floor than does Cooper. Smith does not live on a floor adjacent to Fletcher's. Fletcher does not live on a floor adjacent to Cooper's. Where does everyone live?"

"This implementation is too slow - uncomment to actually run it."
	
"	|baker cooper fletcher miller smith|
	baker := amb oneOf: (1 to: 5).
	cooper := amb oneOf: (1 to: 5).
	fletcher := amb oneOf: (1 to: 5).
	miller := amb oneOf: (1 to: 5).
	smith := amb oneOf: (1 to: 5).
	
	amb assert: (Set new add: baker; add: cooper; add: fletcher; add: miller; add: smith; size) = 5.
	
	amb deny: baker = 5.
	amb deny: cooper = 1.
	amb deny: fletcher = 5.
	amb deny: fletcher = 1.
	amb assert: miller > cooper.
	amb deny: (smith - fletcher) abs = 1.
	amb deny: (fletcher - cooper) abs = 1.
	
	self assert: baker = 3.
	self assert: cooper = 2.
	self assert: fletcher = 4.
	self assert: miller = 5.
	self assert: smith = 1.
"	! !

!AmbTest methodsFor: 'tests' stamp: 'avi 4/26/2004 14:45'!
testSicpLogicProblemFaster
	"Baker, Cooper, Fletcher, Miller, and Smith live on different floors of an apartment house that contains only five floors. Baker does not live on the top floor. Cooper does not live on the bottom floor. Fletcher does not live on either the top or the bottom floor. Miller lives on a higher floor than does Cooper. Smith does not live on a floor adjacent to Fletcher's. Fletcher does not live on a floor adjacent to Cooper's. Where does everyone live?"
	
	|baker cooper fletcher miller smith|
	fletcher := amb oneOf: (1 to: 5).
	amb deny: fletcher = 5.
	amb deny: fletcher = 1.

	smith := amb oneOf: (1 to: 5).
	amb deny: (smith - fletcher) abs = 1.

	cooper := amb oneOf: (1 to: 5).
	amb deny: cooper = 1.
	amb deny: (fletcher - cooper) abs = 1.

	miller := amb oneOf: (1 to: 5).
	amb assert: miller > cooper.

	baker := amb oneOf: (1 to: 5).
	amb deny: baker = 5.
	
	amb assert: (Set new add: baker; add: cooper; add: fletcher; add: miller; add: smith; size) = 5.
	self assert: baker = 3.
	self assert: cooper = 2.
	self assert: fletcher = 4.
	self assert: miller = 5.
	self assert: smith = 1.! !

!AmbTest methodsFor: 'tests' stamp: 'ab 12/6/2002 02:27'!
testSolveAnEquation
	|x y|
	x := amb oneOf: (1 to: 10).
	y := amb oneOf: (1 to: 10).
	amb assert: (y * x) = 42.
	self assert: x = 6.
	self assert: y = 7.
! !

TestCase subclass: #ContinuationTest
	instanceVariableNames: 'tmp tmp2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Continuations'!

!ContinuationTest methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 19:23'!
callcc: aBlock
	^ Continuation currentDo: aBlock! !

!ContinuationTest methodsFor: 'tests' stamp: 'ab 6/15/2003 17:26'!
testBlockEscape
	|x|
	tmp := 0.
	x := [tmp := tmp + 1. tmp2 value].
	self callcc: [:cc | tmp2 := cc. x value].
	tmp2 := [].
	x value.
	self assert: tmp = 2.! !

!ContinuationTest methodsFor: 'tests' stamp: 'ab 6/15/2003 17:26'!
testBlockTemps
	|y|
	#(1 2 3) do:
		[:i ||x|
			x := i.
			tmp ifNil: [tmp2 := (self callcc: [:cc | tmp := cc. [:q]])].
			tmp2 value: x.
			x := 17].
	y := (self callcc: [:cc | tmp value: cc. 42]).
	self assert: y = 1.! !

!ContinuationTest methodsFor: 'tests' stamp: 'ab 6/15/2003 17:26'!
testBlockVars
	|continuation|
	tmp := 0.
	tmp := (self callcc: [:cc | continuation := cc. 0]) + tmp.
	tmp2 
		ifNotNil: [tmp2 value]
		ifNil:
			[#(1 2 3) do:
				[:i |
				self callcc: [:cc | tmp2 := cc. continuation value: i]]].
	self assert: tmp = 6.! !

!ContinuationTest methodsFor: 'tests' stamp: 'ab 2/14/2003 01:17'!
testComprehension
	"What should this print out?
	
	|yin yang|
	yin := [:x | Transcript cr. x] value: Continuation current.
	yang := [:x | Transcript nextPut: $*. x] value: Continuation current.
	yin value: yang."! !

!ContinuationTest methodsFor: 'tests' stamp: 'ab 6/15/2003 17:26'!
testMethodTemps
	|i continuation|
	i := 0.
	i := i + (self callcc: [:cc | continuation := cc. 1]).
	self assert: i ~= 3.
	i = 2 ifFalse: [continuation value: 2].! !

!ContinuationTest methodsFor: 'tests' stamp: 'ab 6/15/2003 17:26'!
testSimpleCallCC
	|x continuation|
	x := self callcc: [:cc | continuation := cc. false].
	x ifFalse: [continuation value: true].
	self assert: x.! !

!ContinuationTest methodsFor: 'tests' stamp: 'ab 6/15/2003 17:27'!
testSimplestCallCC
	|x|
	x := self callcc: [:cc | cc value: true].
	self assert: x.! !

TestCase subclass: #WAConfigurationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WAConfigurationTest methodsFor: 'tests' stamp: 'mb 4/23/2006 15:15'!
testLinearization
	"from http://www.webcom.com/haahr/dylan/linearization-oopsla96.html"
	| root boat dayBoat wheelBoat engineLess pedalWheelBoat smallMultihull smallCatamaran pedalo |
	root := WAUserConfiguration new.
	boat := WAUserConfiguration new addAncestor: root; yourself.
	dayBoat := WAUserConfiguration new addAncestor: boat; yourself.
	wheelBoat := WAUserConfiguration new addAncestor: boat; yourself.
	engineLess := WAUserConfiguration new addAncestor: dayBoat; yourself.
	pedalWheelBoat := WAUserConfiguration new addAncestor: engineLess; addAncestor: wheelBoat; yourself.
	smallMultihull := WAUserConfiguration new addAncestor: dayBoat; yourself.
	smallCatamaran := WAUserConfiguration new addAncestor: smallMultihull; yourself.
	pedalo := WAUserConfiguration new addAncestor: pedalWheelBoat; addAncestor: smallCatamaran; yourself.

	self assert: pedalWheelBoat allAncestors = (Array with: engineLess with: dayBoat with: wheelBoat with: boat with: root).
	self assert: smallCatamaran allAncestors = (Array with: smallMultihull with: dayBoat with: boat with: root).
	self assert: pedalo allAncestors = ((Array with: pedalWheelBoat with: engineLess with: smallCatamaran with: smallMultihull), (Array with: dayBoat with: wheelBoat with: boat with: root)).! !

TestCase subclass: #WAFileLibraryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 10/6/2006 10:57'!
assertFile: aString contentType: aMimeType handler: aHandler symbol: aSymbol library: aLibrary
	| request response contentDispostion |
	request := WARequest
		method: 'GET'
		url: '/i/dont/care/', aLibrary name ,'/', aString
		headers: Dictionary new
		fields: Dictionary new
		cookies: Dictionary new.
	response := aHandler handleRequest: request.
	self assert: response status = '200'.
	self assert: response contentType = aMimeType.
	contentDispostion := response headers detect: [ :each |
		each key = 'Content-Disposition' ].
	self assert:  contentDispostion value =  ('attachment; filename="', aString, '"').
	self assert: response stream contents = (aLibrary perform: aSymbol).! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 4/21/2006 22:57'!
testAsFileName
	| library |
	library := WAFileLibraryDemo new.
	self assert: (library asFilename: #mainJs) = 'main.js'! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 4/21/2006 22:57'!
testAsSelector
	| library |
	library := WAFileLibraryDemo new.
	self assert: (library asSelector: 'main.css') = #mainCss.
	self assert: (library asSelector: 'main.js') = #mainJs! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 5/2/2006 19:48'!
testCompileByteArray
	| library data file first second |
	library := WAFileLibraryDemo new.
	self deny: (library class selectors includes: #demoJpeg).
	data := (1 to: 255) asByteArray.
	file := WAFile new
		contentType: 'image/jpeg';
		contents: data;
		fileName: 'demo.jpeg';
		yourself.
	library addFile: file.
	self assert: (library class selectors includes: #demoJpeg).
	first := library perform: #demoJpeg.
	self assert: first = data.
	second := library perform: #demoJpeg.
	self assert: first == second.
	library removeFile: file fileName.
	self deny: (library class selectors includes: #demoJpeg).
	
! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 5/2/2006 19:50'!
testCompileString
	| library data file first second |
	library := WAFileLibraryDemo new.
	self deny: (library class selectors includes: #demoTxt).
	data := 'this is a string'.
	file := WAFile new
		contentType: 'text/plain';
		contents: data;
		fileName: 'demo.txt';
		yourself.
	library addFile: file.
	self assert: (library class selectors includes: #demoTxt).
	first := library perform: #demoTxt.
	self assert: first = data.
	second := library perform: #demoTxt.
	self assert: first == second.
	library removeFile: file fileName.
	self deny: (library class selectors includes: #demoTxt).
	
! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 4/23/2006 19:40'!
testFileLibraryDemo
	| actual expected |
	actual := WAFileLibraryDemo new filenames.
	expected := #('main.css' 'main.jpg').
	self assert: actual size = expected size.
	expected do: [ :each |
		self assert: (actual includes: each) ]! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 4/22/2006 10:20'!
testKalseyTabs
	| handler library |
	handler := WAFileHandler new.
	library := WAStandardStyles new.
	handler libraries: (Array with: library).
	self
		assertFile: 'kalseyTabs.css'
		contentType: 'text/css'
		handler: handler
		symbol: #kalseyTabs
		library: library! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 4/22/2006 10:20'!
testKalseyTabsCascade
	| handler library1 library2 |
	handler := WAFileHandler new.
	library1 := WAFileLibraryDemo new.
	library2 := WAStandardStyles new.
	handler libraries: (Array with: library1 with: library2).
	self
		assertFile: 'kalseyTabs.css'
		contentType: 'text/css'
		handler: handler
		symbol: #kalseyTabs
		library: library2! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 10/4/2006 20:39'!
testLiveUpdate
	| handler library |
	handler := WAFileHandler new.
	library := WAStandardScripts new.
	handler libraries: (Array with: library).
	self
		assertFile: 'misc.js'
		contentType: 'text/javascript'
		handler: handler
		symbol: #misc
		library: library! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 4/22/2006 10:21'!
testMainCss
	| handler library |
	handler := WAFileHandler new.
	library := WAFileLibraryDemo new.
	handler libraries: (Array with: library).
	self
		assertFile: 'main.css'
		contentType: 'text/css'
		handler: handler
		symbol: #mainCss
		library: library! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 4/22/2006 10:21'!
testMainCssCascade
	| handler library1 library2 |
	handler := WAFileHandler new.
	library1 := WAFileLibraryDemo new.
	library2 := WAStandardStyles new.
	handler libraries: (Array with: library1 with: library2).
	self
		assertFile: 'main.css'
		contentType: 'text/css'
		handler: handler
		symbol: #mainCss
		library: library1! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 10/6/2006 10:37'!
testMainJpg
	| handler library request response contentDispostion contents |
	handler := WAFileHandler new.
	library := WAFileLibraryDemo new.
	handler libraries: (Array with: library).
	request := WARequest
		method: 'GET'
		url: '/i/dont/care/WAFileLibraryDemo/main.jpg'
		headers: Dictionary new
		fields: Dictionary new
		cookies: Dictionary new.
	response := handler handleRequest: request.
	self assert: response status = '200'.
	self assert: response contentType = 'image/jpeg'.
	contentDispostion := response headers detect: [ :each |
		each key = 'Content-Disposition' ].
	self assert:  contentDispostion value =  'attachment; filename="main.jpg"'.
	contents := response stream binary; contents.
	self assert: contents = (library perform: #mainJpg)! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 4/21/2006 22:59'!
testMainJs
	| handler library request response |
	handler := WAFileHandler new.
	library := WAFileLibraryDemo new.
	handler libraries: (Array with: library).
	request := WARequest
		method: 'GET'
		url: '/i/dont/care/main.js'
		headers: Dictionary new
		fields: Dictionary new
		cookies: Dictionary new.
	response := handler handleRequest: request.
	self assert: response status = '404'.! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 10/4/2006 20:40'!
testStandardScripts
	| actual expected |
	actual := WAStandardScripts new filenames.
	expected := #('shortcuts.js' 'misc.js').
	self assert: actual size = expected size.
	expected do: [ :each |
		self assert: (actual includes: each) ]! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 4/23/2006 19:39'!
testStandardStyles
	| actual expected |
	actual := WAStandardStyles new filenames.
	expected := #('basics.css' 'kalseyTabs.css' 'sourceStyle.css').
	self assert: actual size = expected size.
	expected do: [ :each |
		self assert: (actual includes: each) ]! !

TestCase subclass: #WAProxyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAProxyTest methodsFor: 'testing' stamp: 'mb 1/5/2006 13:57'!
test
	| ad p |
	ad := WAStoreAddress new.
	ad street: 'Parkway'.
	p := WAModelProxy on: ad.
	self assert: p street = ad street.
	self assert: ad city isNil.
	self assert: p city = ad city.
	p city: 'NYC'.
	self assert: p city = 'NYC'.
	self assert: ad city isNil.
	p commit.
	self assert: ad city = 'NYC'.	! !

TestCase subclass: #WAStateRegistryTest
	instanceVariableNames: 'registry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-StateRegistry'!

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 20:22'!
assertSnapshot: x isIdenticalTo: y
	! !

!WAStateRegistryTest methodsFor: 'running' stamp: 'ab 2/18/2003 18:16'!
setUp
	registry := WAStateRegistry new! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 20:22'!
snapshot: x isIdenticalTo: y
	^ ((IdentitySet withAll: x values) includesAllOf: y values).! !

!WAStateRegistryTest methodsFor: 'tests' stamp: 'ab 2/18/2003 20:23'!
testConsecutiveSnapshots
	|a snap1 snap2 snap3 |
	a := ValueHolder new contents: 1.
	registry registerObject: a.
	snap1 := registry snapshot.
	snap2 := registry snapshot.
	self assert: (self snapshot: snap1 isIdenticalTo: snap2).
	a contents: 2.
	snap3 := registry snapshot.
	self deny: (self snapshot: snap3 isIdenticalTo: snap2).
	! !

!WAStateRegistryTest methodsFor: 'tests' stamp: 'lr 11/16/2006 19:16'!
testGarbageCollection
	| a |
	a := ValueHolder new contents: 1.
	registry registerObject: a.
	registry snapshot.
	Smalltalk garbageCollect.
	self assert: registry size = 1.
	a := nil.
	Smalltalk garbageCollect.
	
	"This used to test the contrary, but it is changed now since the default implementation doesn' use weak dictionaries anymore."
	self deny: registry isEmpty
! !

!WAStateRegistryTest methodsFor: 'tests' stamp: 'ab 2/18/2003 20:24'!
testNoChangeAfterRestore
	| a snap1 snap2 snap3 |
	a := ValueHolder new contents: 1.
	registry registerObject: a.
	snap1 := registry snapshot.
	a contents: 2.
	snap2 := registry snapshot.
	self deny: (self snapshot: snap1 isIdenticalTo: snap2).
	registry restoreSnapshot: snap1.
	self assert: a contents = 1.
	snap3 := registry snapshot.
	self assert: (self snapshot: snap1 isIdenticalTo: snap3).! !

!WAStateRegistryTest methodsFor: 'tests' stamp: 'ab 2/18/2003 18:17'!
testRevert
	|a snap1|
	a := ValueHolder new contents: 1.
	registry registerObject: a.
	snap1 := registry snapshot.
	a contents: 2.
	self assert: a contents = 2.
	registry restoreSnapshot: snap1.
	self assert: a contents = 1	! !

!WAStateRegistryTest methodsFor: 'tests' stamp: 'ab 2/18/2003 18:22'!
testRevertTwice
	|a snap1|
	a := ValueHolder new contents: 1.
	registry registerObject: a.
	snap1 := registry snapshot.
	a contents: 2.
	self assert: a contents = 2.
	registry restoreSnapshot: snap1.
	self assert: a contents = 1.
	a contents: 3.
	registry restoreSnapshot: snap1.
	self assert: a contents = 1.! !

TestCase subclass: #WAValueTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAValueTest commentStamp: '<historical>' prior: 0!
To test the refactorings from Yar Hwee Boon [hboon@motionobj.com]!

!WAValueTest methodsFor: 'testing' stamp: 'mb 11/4/2005 14:01'!
originalValue: anOriginalValue input: anInputObject expectedOutput: anExpectedOutputObject 
	| answer |
	(WAHtmlRenderer new
		fromStringConverterBlockFor: anOriginalValue
		callback: [:v | answer := v])
		value: anInputObject.
	self assert: answer = anExpectedOutputObject! !

!WAValueTest methodsFor: 'testing' stamp: 'mb 11/4/2005 14:01'!
testFloat
	self
		originalValue: 12.34
		input: '92.6'
		expectedOutput: 92.6! !

!WAValueTest methodsFor: 'testing' stamp: 'mb 11/4/2005 14:02'!
testFractionWithFloat
	self
		originalValue: 1 / 3
		input: '3.4'
		expectedOutput: 3.4! !

!WAValueTest methodsFor: 'testing' stamp: 'mb 11/4/2005 14:02'!
testFractionWithFraction
	self
		originalValue: 1 / 3
		input: '2/5'
		expectedOutput: 2! !

!WAValueTest methodsFor: 'testing' stamp: 'mb 11/4/2005 14:02'!
testFractionWithInteger
	self
		originalValue: 1 / 3
		input: '2'
		expectedOutput: 2! !

!WAValueTest methodsFor: 'testing' stamp: 'mb 11/4/2005 14:02'!
testFractionWithOriginalValue
	| value |
	"The #deny: check is to ensure value is stringent enough. For example 1/3 is not a suitable value."
	value := 1 /33.
	self deny: value asFloat asString asNumber = value.
	self
		originalValue: value
		input: value asFloat asString
		expectedOutput: value! !

!WAValueTest methodsFor: 'testing' stamp: 'mb 11/4/2005 14:02'!
testInteger
	self
		originalValue: 123
		input: '987'
		expectedOutput: 987! !

!WAValueTest methodsFor: 'testing' stamp: 'mb 11/4/2005 14:03'!
testNilWithEmptyString
	self
		originalValue: nil
		input: ''
		expectedOutput: nil! !

!WAValueTest methodsFor: 'testing' stamp: 'mb 11/4/2005 14:03'!
testNilWithNonEmptyString
	self
		originalValue: nil
		input: '123'
		expectedOutput: '123'! !

!WAValueTest methodsFor: 'testing' stamp: 'mb 11/4/2005 14:03'!
testObject
	self
		originalValue: Object new
		input: '2.3'
		expectedOutput: '2.3'! !

!Symbol methodsFor: '*seaside2-squeak' stamp: 'mb 5/29/2006 19:12'!
asMutator
	"Needed when using Seaside on older versions of Squeak,
	method not exported to vw"
	^ (self copyWith: $:) asSymbol.! !

Object subclass: #Amb
	instanceVariableNames: 'failureContinuation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Continuations'!

!Amb class methodsFor: 'instance creation' stamp: 'lr 5/3/2006 09:24'!
new
	^ self basicNew initialize! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 19:23'!
allValues: aBlock
	|kPrev results|
	kPrev := failureContinuation.
	results := OrderedCollection new.
	(Continuation currentDo:
		[:kRetry |
		failureContinuation := [:v | kRetry value: false].
		results add: aBlock value.
		kRetry value: true])
			ifTrue: [self fail].
	failureContinuation := kPrev.
	^ results asArray	 ! !

!Amb methodsFor: 'error handling' stamp: 'ab 12/6/2002 02:11'!
assert: aBoolean
	aBoolean ifFalse: [self fail]! !

!Amb methodsFor: 'error handling' stamp: 'ab 12/6/2002 02:12'!
deny: aBoolean
	self assert: aBoolean not! !

!Amb methodsFor: 'error handling' stamp: 'ab 12/6/2002 02:15'!
fail
	^ failureContinuation value: nil! !

!Amb methodsFor: 'initialize-release' stamp: 'avi 4/27/2004 14:28'!
initialize
	failureContinuation := [:v | self error: 'Amb tree exhausted'].! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 5/29/2003 22:29'!
maybe
	^ self oneOf: (Array with: true with: false)! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 02:09'!
oneOf: aCollection
	^ self valueOfOneOf: (aCollection collect: [:ea | [ea] fixTemps])! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 5/29/2003 22:30'!
valueOf: blockOne or: blockTwo
	^ self valueOfOneOf: (Array with: blockOne with: blockTwo)! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 5/29/2003 22:30'!
valueOf: blockOne or: blockTwo or: blockThree
	^ self valueOfOneOf: (Array with: blockOne with: blockTwo with: blockThree)! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 19:23'!
valueOfOneOf: blockCollection
	|kPrev|
	kPrev := failureContinuation.
	^ Continuation currentDo:
		[:kEntry |
		blockCollection do:
			[:ea |
			Continuation currentDo:
				[:kNext |
				failureContinuation :=
					[:v | failureContinuation := kPrev. kNext value: v] fixTemps.
				kEntry value: ea value]].
		kPrev value: nil]
			 ! !

Object subclass: #Continuation
	instanceVariableNames: 'values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Continuations'!

Continuation subclass: #AnswerContinuation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Continuations'!

!Continuation class methodsFor: 'instance creation' stamp: 'ab 6/15/2003 19:13'!
current
	^ self fromContext: thisContext sender! !

!Continuation class methodsFor: 'instance creation' stamp: 'ab 6/15/2003 19:13'!
currentDo: aBlock
	^ aBlock value: (self fromContext: thisContext sender)! !

!Continuation class methodsFor: 'instance creation' stamp: 'ab 6/15/2003 19:13'!
fromContext: aStack
	^self new initializeFromContext: aStack! !

!Continuation methodsFor: 'private' stamp: 'avi 4/24/2004 12:39'!
initializeFromContext: aContext
	| valueStream context |
	valueStream := WriteStream on: (Array new: 20).
	context := aContext.
	[context notNil] whileTrue:
		[valueStream nextPut: context.
		1 to: context class instSize do: [:i | valueStream nextPut: (context instVarAt: i)].
		1 to: context localSize do: [:i | valueStream nextPut: (context localAt: i)].
		context := context sender].
	values := valueStream contents! !

!Continuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:18'!
numArgs
	^ 1! !

!Continuation methodsFor: 'as yet unclassified' stamp: 'avi 4/24/2004 12:39'!
restoreValues
	| valueStream context |
	valueStream := values readStream.
	[valueStream atEnd] whileFalse:
		[context := valueStream next.
		1 to: context class instSize do: [:i | context instVarAt: i put: valueStream next].
		1 to: context localSize do: [:i | context localAt: i put: valueStream next]]! !

!Continuation methodsFor: 'private' stamp: 'ab 6/15/2003 19:13'!
terminate: aContext
	| context |
	context := aContext.
	[context notNil] whileTrue: [context := context swapSender: nil]
! !

!Continuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:13'!
value
	self value: nil! !

!Continuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:12'!
value: v
	self terminate: thisContext.
	self restoreValues.
	thisContext swapSender: values first.
	^v! !

!Continuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:22'!
valueWithArguments: v
	v size == 1 ifFalse: [^self error: 'continuations can only be resumed with one argument'].
	self value: v first! !

Continuation subclass: #EscapeContinuation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Continuations'!

Continuation subclass: #ResponseContinuation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Continuations'!

!Object methodsFor: '*seaside2' stamp: 'mb 3/16/2006 10:32'!
asSeasideString
	^ self displayString
! !

!Object methodsFor: '*seaside2-squeak' stamp: 'lr 10/28/2006 13:05'!
beMutable! !

!Object methodsFor: '*seaside2' stamp: 'mb 3/23/2006 07:32'!
convertSeasideString: aString
	^ aString
! !

!Object methodsFor: '*seaside2' stamp: 'mb 10/13/2006 00:19'!
deprecatedApi
	WADeprecatedApi raiseSignal: thisContext sender displayString! !

!Object methodsFor: '*seaside2-squeak' stamp: 'lr 7/12/2005 17:01'!
displayString
	^ self asString! !

!Object methodsFor: '*seaside2' stamp: 'ab 10/1/2002 13:47'!
inspectorFields
	|members|
	members _ self class allInstVarNames
					collect: [:ivar | ivar -> (self instVarNamed: ivar)].
						
	self class isVariable ifTrue:
		[members _ members, ((1 to: self size) collect: [:i | i -> (self at: i)])].
	^ members! !

!Object methodsFor: '*seaside2' stamp: 'avi 9/1/2004 21:20'!
isIdenticalToSnapshot: anObject
	1 to: self class instSize do:
		[:i | (anObject instVarAt: i) == (self instVarAt: i) ifFalse: [^ false]].
	self class isVariable ifTrue:
		[1 to: self size do: [:i | (anObject at: i) == (self at: i) ifFalse: [^ false]]].
	^ true! !

!Object methodsFor: '*seaside2' stamp: 'avi 3/14/2005 15:19'!
labelForSelector: aSymbol
	^ aSymbol asCapitalizedPhrase! !

!Object methodsFor: '*seaside2' stamp: 'ab 10/26/2002 20:05'!
renderOn: aRenderer
	aRenderer text: self! !

!Object methodsFor: '*seaside2' stamp: 'avi 9/1/2004 21:19'!
restoreFromSnapshot: anObject
	1 to: self class instSize do: [:i | self instVarAt: i put: (anObject instVarAt: i)].
	self class isVariable ifTrue: [1 to: self size do: [:i | self at: i put: (anObject at: i)]].
! !

!Object methodsFor: '*seaside2' stamp: 'avi 9/1/2004 21:20'!
snapshotCopy
	^ self shallowCopy! !

!Object methodsFor: '*seaside2' stamp: 'mb 3/23/2006 17:53'!
validationError: message
	^WAValidationNotification raiseSignal: message
! !

Object subclass: #SeasidePlatformSupport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

!SeasidePlatformSupport class methodsFor: 'startup' stamp: 'mb 11/27/2005 10:16'!
addToStartUpList: anObject
	Smalltalk addToStartUpList: anObject.! !

!SeasidePlatformSupport class methodsFor: 'file-library' stamp: 'pmm 4/24/2006 22:51'!
asMethodReturningByteArray: aByteArrayOrString named: aSymbol
	| optimze |
	optimze := Preferences
		valueOfFlag: #compileUseNewCompiler
		ifAbsent: [ false ].
	^optimze
		ifTrue: [ self asMethodReturningByteArrayLiteral: aByteArrayOrString named: aSymbol ]
		ifFalse: [ self asMethodReturningByteArrayWithCache: aByteArrayOrString named: aSymbol ]! !

!SeasidePlatformSupport class methodsFor: 'file-library' stamp: 'pmm 4/24/2006 22:45'!
asMethodReturningByteArrayLiteral: aByteArrayOrString named: aSymbol
	^String streamContents: [ :stream |
		stream nextPutAll: aSymbol; cr.
		stream tab; nextPutAll: '^ #['.
		aByteArrayOrString asByteArray
			do: [ :each | each printOn: stream ]
			separatedBy: [ stream space ].
		stream nextPutAll: ']' ]! !

!SeasidePlatformSupport class methodsFor: 'file-library' stamp: 'mb 10/17/2006 19:15'!
asMethodReturningByteArrayWithCache: aByteArrayOrString named: aSymbol
	^String streamContents: [ :stream |
		stream nextPutAll: aSymbol; cr.
		stream tab; nextPutAll: '| xxxCache |'; cr.
		stream tab; nextPutAll: 'xxxCache := #(nil) beMutable.'; cr.
		stream tab; nextPutAll: '(xxxCache at: 1) isNil ifTrue: ['; cr.
		stream tab; tab; nextPutAll: 'xxxCache at: 1 put: #('.
		aByteArrayOrString asByteArray
			do: [ :each | each printOn: stream ]
			separatedBy: [ stream space ].
		stream nextPutAll: ') asByteArray ].'; cr.
		stream tab; nextPutAll: '^ xxxCache at: 1'. ]! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'avi 9/18/2003 16:43'!
base64Decode: aString
	^ (Base64MimeConverter mimeDecodeToChars: aString readStream) contents
		! !

!SeasidePlatformSupport class methodsFor: 'file-library' stamp: 'pmm 4/21/2006 23:39'!
compile: aString into: aClass classified: aSymbol
	aClass compile: aString classified: aSymbol! !

!SeasidePlatformSupport class methodsFor: 'file-library' stamp: 'pmm 10/5/2006 18:32'!
contentsOfFile: aString binary: aBoolean
	| stream |
	stream := aBoolean
		ifTrue: [ (FileDirectory default oldFileNamed: aString)
			binary;
			yourself ]
		ifFalse: [ (CrLfFileStream oldFileNamed: aString)
			ascii;
			yourself ].
	^[ stream contents ] ensure: [ stream close ]! !

!SeasidePlatformSupport class methodsFor: 'file-library' stamp: 'pmm 10/5/2006 19:23'!
convertToSmalltalkNewlines: aString
	"yes this is stupid, inefficent code but hey, it's Squeak!!"
	^(aString
		copyReplaceAll: (String with: Character cr with: Character lf)
		with: (String with: Character cr))
			copyReplaceAll: (String with: Character lf)
			with: (String with: Character cr)! !

!SeasidePlatformSupport class methodsFor: 'email' stamp: 'avi 3/11/2004 13:13'!
deliverMailFrom: fromAddress to: recipientList text: messageText
	SMTPClient
		deliverMailFrom: fromAddress
		to: recipientList
		text: messageText
		usingServer: self smtpServer! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'avi 4/28/2004 11:40'!
ensureAuthorInitials: aBlock
	Utilities authorInitialsPerSe isEmpty
		ifTrue: [Utilities setAuthorInitials: aBlock value].
! !

!SeasidePlatformSupport class methodsFor: 'file-library' stamp: 'pmm 6/5/2006 21:29'!
filesIn: aPathString
	| directory |
	directory := FileDirectory on: aPathString.
	^directory fileNames collect: [ :each |
		directory fullNameFor: each ]! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'pmm 9/12/2006 19:24'!
getDocumentWithUrl: url
	"(WAUrl new
		hostname: 'www.google.com'; 
		addToPath: 'search';
		addParameter: 'hl' value: 'fr';
		addParameter: 'q' value: 'Seaside';
		addParameter: 'lr' value: '';
		yourself) getDocument"
	^ HTTPSocket httpGetDocument: url urlString args: url parametersForHttpSocket! !

!SeasidePlatformSupport class methodsFor: 'testing' stamp: 'avi 1/1/2005 15:05'!
isProxy: anObject
	^ (anObject class allSuperclasses includes: Object) not! !

!SeasidePlatformSupport class methodsFor: 'file-library' stamp: 'pmm 6/5/2006 21:32'!
localNameOf: aFilename
	^(FileDirectory on: aFilename) localName! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'pmm 9/12/2006 17:47'!
methodsOf: anAuthorString
	"self methodsOf: 'avi'"
	| methods |
	methods := ((Seaside2Info named: 'Seaside') methods select: [ :each |
			(each timeStamp copyUpTo: Character space) = anAuthorString ]).
	MessageSet
		openMessageList: methods
		name: methods size displayString , ' methods of ', anAuthorString! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 13:04'!
mimeDocumentClass
	^ MIMEDocument ! !

!SeasidePlatformSupport class methodsFor: 'factory' stamp: 'pmm 9/12/2006 19:23'!
mimeDocumentOfType: type from: aFilename
	"WACachedDocument clearCache.
	(WACachedDocument fileName: 'SqueakDebug.log') asMIMEDocument.
	(WACachedDocument fileName: 'SqueakDebug.log') asMIMEDocument."


	| content mimeType |
	mimeType := type ifNil: [
		self mimeDocumentClass guessTypeFromExtension: (FileDirectory extensionFor: aFilename) ].
	content := (StandardFileStream readOnlyFileNamed: aFilename) contentsOfEntireFile.
	^self mimeDocumentClass
		contentType: mimeType 
		content: content.
! !

!SeasidePlatformSupport class methodsFor: 'exceptions' stamp: 'mb 1/13/2006 09:54'!
openDebuggerOn: anError
	| process |
	process := Processor activeProcess.
	WorldState addDeferredUIMessage:
		[process 
			debug: anError signalerContext
			title: anError description
			full: true].
	process suspend! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 11:18'!
profileSendsDuring: aBlock
	Processor activeProcess priority: 20.
	Smalltalk garbageCollectMost.	
	^ String streamContents: 
			[:stream | 
			(MessageTally new)
				spyEvery: 1
				on: [aBlock value. Smalltalk garbageCollectMost];
				report: stream]! !

!SeasidePlatformSupport class methodsFor: 'factory' stamp: 'avi 4/27/2004 14:25'!
readWriteStream
	^ RWBinaryOrTextStream on: String new! !

!SeasidePlatformSupport class methodsFor: 'file-library' stamp: 'pmm 4/21/2006 23:56'!
removeSelector: aSymbol from: aClass
	aClass removeSelectorSilently: aSymbol! !

!SeasidePlatformSupport class methodsFor: 'requests' stamp: 'mb 5/30/2006 12:30'!
request: aString
	^FillInTheBlank request: aString! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'pmm 9/12/2006 19:23'!
seasideBanner
	"This is a copy of http://www.netstyle.ch/include/seaside/pics/top.jpg"
	"| mimeDoc |
	mimeDoc := 'http://www.netstyle.ch/include/seaside/pics/top.jpg' asUrl retrieveContents.
	Clipboard clipboardText: 
		(Base64MimeConverter mimeEncode: mimeDoc content readStream) contents"
	^self base64Decode:
'/9j/4AAQSkZJRgABAQAAAQABAAD/2wBDAAgGBgcGBQgHBwcJCQgKDBQNDAsLDBkSEw8UHRof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'! !

!SeasidePlatformSupport class methodsFor: 'email' stamp: 'avi 3/11/2004 13:10'!
smtpServer
	^ MailSender smtpServer! !

!SeasidePlatformSupport class methodsFor: 'accessing' stamp: 'mb 10/12/2006 20:14'!
versionString
	^SeasideVWInfo new versionString! !

!SeasidePlatformSupport class methodsFor: 'vm statistics' stamp: 'tonyg 1/3/2006 10:40'!
vmStatisticsReportString
	^ SmalltalkImage current vmStatisticsReportString ! !

!SeasidePlatformSupport class methodsFor: 'exceptions' stamp: 'mb 3/23/2006 08:12'!
walkbackStringsFor: anError
	^(anError signalerContext sender stackOfSize: 20) 
		collect: [:ctx | ctx printString].
! !

!SeasidePlatformSupport class methodsFor: 'factory' stamp: 'pmm 9/12/2006 17:34'!
weakDictionaryOfSize: aNumber
	^IdentityDictionary new: aNumber! !

Object subclass: #WAAbstractHtmlBuilder
	instanceVariableNames: 'attributeBuffer'
	classVariableNames: 'HtmlCharacters'
	poolDictionaries: ''
	category: 'Seaside-Builder'!

!WAAbstractHtmlBuilder commentStamp: '<historical>' prior: 0!
I am abstract class providing methods to build xhtml.  My most commonly used subclass is WAHtmlRenderer.!

!WAAbstractHtmlBuilder class methodsFor: 'encoding' stamp: 'lr 6/14/2006 08:00'!
encode: anObject
	^ String streamContents: [ :stream | self encode: anObject to: stream ]! !

!WAAbstractHtmlBuilder class methodsFor: 'encoding' stamp: 'lr 6/14/2006 08:00'!
encode: anObject to: aStream
	| charOrString |
	anObject displayString do: [:char |
		charOrString := HtmlCharacters 
			at: char asInteger + 1 
			ifAbsent: [ char asCharacter ].
		charOrString isString
			ifTrue: [ aStream nextPutAll: charOrString ]
			ifFalse: [ aStream nextPut: charOrString ] ]! !

!WAAbstractHtmlBuilder class methodsFor: 'initialization' stamp: 'avi 6/25/2004 20:46'!
initialize
	"WAHtmlBuilder initialize"
	HtmlCharacters := Array new: 256.
	
	0 to: 255 do: [:ea | HtmlCharacters at: ea + 1 put: ea asCharacter].
	
	#($" 'quot' $< 'lt' $& 'amp' $> 'gt') pairsDo:
		[:c :s | HtmlCharacters at: (c asInteger + 1) put: ('&',s,';') ]
	! !

!WAAbstractHtmlBuilder class methodsFor: 'instance creation' stamp: 'lr 11/16/2006 15:34'!
new
	self deprecatedApi.
	^ super new! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 2/19/2004 01:08'!
acronym: titleString do: aBlock
	self attributes at: 'title' put: titleString.
	self tag: 'acronym' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 3/1/2004 20:49'!
anchorWithMailto: emailString
	self anchorWithUrl: 'mailto:', emailString do: emailString! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 3/1/2004 20:50'!
anchorWithMailto: emailString subject: subjectString
	self anchorWithUrl: 'mailto:', emailString, '?subject=', subjectString do: emailString! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'lr 8/3/2006 08:38'!
anchorWithName: aString
	self attributes at: 'name' put: aString.
	self tag: #a! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'lr 5/3/2005 08:50'!
anchorWithPopupUrl: urlString extent: aPoint do: anObject
	self 
		anchorWithPopupUrl: urlString 
		name: ''
		extent: aPoint 
		toggles: #(menubar resizable scrollbars) 
		do: anObject
! !

!WAAbstractHtmlBuilder methodsFor: 'javascript' stamp: 'ac 12/10/2004 17:20'!
anchorWithPopupUrl: urlString extent: aPoint text: aString
	self 
		anchorWithPopupUrl: urlString 
		extent: aPoint 
		do: aString! !

!WAAbstractHtmlBuilder methodsFor: 'javascript' stamp: 'ac 12/23/2004 04:42'!
anchorWithPopupUrl: urlString name: nameString extent: aPoint toggles: aCollection do: anObject
	self attributes
		at: 'onClick' 
		put: (self popupStringWithUrl: urlString name: nameString extent: aPoint toggles: aCollection), '; return false'.
	
	self anchorWithUrl: urlString do: anObject. ! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'lr 8/3/2006 08:38'!
anchorWithUrl: urlString do: aBlock
	self attributes at: 'href' put: urlString.
	self tag: 'a' do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'lr 8/3/2006 08:37'!
anchorWithUrl: urlString title: titleString do: aBlock
	self attributes at: 'title' put: titleString.
	self anchorWithUrl: urlString do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'avi 4/24/2004 13:05'!
attributeAt: aString put: anObject
	self attributes at: aString put: anObject! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'ab 5/12/2003 11:27'!
attributes
	^ attributeBuffer ifNil: [attributeBuffer := WAHtmlAttributes new]! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'ab 1/11/2003 12:44'!
attributes: aCollection
	aCollection associationsDo: [:x | self attributeAt: x key put: x value]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:02'!
bold: aBlock
	self tag: 'b' do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:02'!
break
	self tag: 'br'! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: 'ab 7/3/2003 14:56'!
buttonForUrl: urlString withText: labelString
	self buttonForUrl: urlString withText: labelString data: #()
! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: 'mbany 4/14/2005 12:22'!
buttonForUrl: urlString withText: labelString data: assocCollection
	self formWithMethod: 'GET' action: urlString do:
		[assocCollection do: 
			[:each | self
				inputWithType: 'hidden'
				named: each key displayString
				value: each value].
		self submitButtonWithText: labelString]
! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: 'mb 11/27/2005 10:22'!
buttonWithType: typeString named: nameString value: valueString do: aBlock
	nameString ifNotNil:
		[self attributes
			at: 'name' put: nameString;
			at: 'id' ifAbsentPut: [nameString]].
	valueString ifNotNil: [self attributes value: valueString displayString].
		
	self attributes type: typeString.
	
	self tag: 'button' do: aBlock.
! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'avi 11/20/2003 18:44'!
closeTag: aString
	self document closeTag: aString ! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: 'ab 2/12/2003 21:04'!
cssClass: aString
	self attributeAt: 'class' put: aString! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: 'ab 2/12/2003 21:04'!
cssId: aString
	self attributeAt: 'id' put: aString! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
div: aBlock
	self tag: 'div' do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: 'ab 2/16/2003 00:33'!
divClass: aString with: anObject
	self cssClass: aString; div: anObject! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: 'ab 2/16/2003 00:33'!
divNamed: aString with: anObject
	self cssId: aString; div: anObject! !

!WAAbstractHtmlBuilder methodsFor: 'accessing' stamp: 'avi 11/20/2003 18:45'!
document
	self subclassResponsibility ! !

!WAAbstractHtmlBuilder methodsFor: 'dnu' stamp: 'ab 5/24/2003 00:41'!
doesNotUnderstand: aMessage
	| argCount |
	argCount := aMessage arguments size.
	argCount = 0 ifTrue: [^ self tag: aMessage selector].
	argCount = 1 ifTrue: [^ self tag: aMessage selector allButLast do: aMessage argument].
	^ super doesNotUnderstand: aMessage
! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'rbb 6/13/2003 00:07'!
emphasis: aBlock
	self tag: 'em' do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'mbany 4/14/2005 12:21'!
encodeCharacter: aCharacter
	self html: ('&#', aCharacter asInteger displayString, ';').  ! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'jf 2/18/2004 15:02'!
encodeText: anObject
	"deprecated"
	self text: anObject! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: 'mb 2/9/2006 14:23'!
ensureCssClass: aString
	self attributes at: 'class' ifAbsentPut: [aString]! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: 'mb 2/9/2006 14:21'!
ensureCssId: aString
	self attributes at: 'id' ifAbsentPut: [aString]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'mb 2/9/2006 17:39'!
fieldset: aBlock
	self tag: 'fieldset' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: 'mb 2/9/2006 17:42'!
fieldsetWithLegend: aString do: aBlock
	self fieldset: [
		self legend: aString.
		aBlock value.
	]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'jf 1/12/2004 16:16'!
formWithAction: actionUrl do: aBlock
	self formWithMethod: 'post' action: actionUrl do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'lr 8/3/2006 08:38'!
formWithMethod: methodString action: actionUrl do: aBlock
	self attributes
		 at: 'method' put: methodString;
		 at: 'action' put: actionUrl.
	self tag: 'form' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
heading: aString
	self heading: aString level: 1! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'mbany 4/14/2005 12:20'!
heading: anObject level: aNumber
	self tag: 'h', aNumber displayString do: anObject! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
horizontalRule
	self tag: 'hr'! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'jf 2/18/2004 15:01'!
html: aString
	self document text: aString.! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'jf 1/12/2004 16:21'!
image: urlString
	self image: urlString altText: ''! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'mb 2/9/2006 18:02'!
image: urlString altText: altString
	self attributeAt: 'alt' put: altString.
	self attributeAt: 'src' put: urlString.	
	self tag: #img.! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'lr 8/3/2006 08:39'!
image: urlString height: height
	self attributes at: 'height' put: height.
	self image: urlString! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'lr 8/3/2006 08:39'!
image: urlString height: height altText: altString
	self attributes at: 'height' put: height.
	self image: urlString altText: altString! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'lr 8/3/2006 08:39'!
image: urlString width: width
	self attributes at: 'width' put: width.
	self image: urlString! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'lr 8/3/2006 08:39'!
image: urlString width: width altText: altString
	self attributes at: 'width' put: width.
	self image: urlString altText: altString! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'lr 8/3/2006 08:40'!
image: urlString width: width height: height
	self attributes
		 at: 'width' put: width;
		 at: 'height' put: height.
	self image: urlString! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'lr 8/3/2006 08:40'!
image: urlString width: width height: height altText: altString
	self attributes
		 at: 'width' put: width;
		 at: 'height' put: height.
	self image: urlString altText: altString! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: 'JF 6/2/2003 19:26'!
inputWithType: type
	self inputWithType: type named: nil
! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: 'JF 6/2/2003 19:25'!
inputWithType: type named: name	
	self inputWithType: type named: name value: nil.
! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: 'lr 5/10/2005 16:15'!
inputWithType: type named: name value: value
	name ifNotNil: [self attributes at: 'name' put: name].
	value ifNotNil: [self attributes value: value displayString].
		
	self attributes type: type; addClass: type.
	
	self tag: 'input'.
! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'rbb 6/11/2003 17:01'!
italic: aBlock
	self tag: 'i' do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'mb 2/9/2006 17:41'!
label: aBlock
	self tag: 'label' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'mb 2/9/2006 17:42'!
labelFor: idString do: aBlock
	self attributes at: 'for' put: idString.
	self label: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'lr 8/3/2006 13:16'!
layoutTable: aBlock
	self attributes
		at: 'border'put: 0;
		at: 'cellspacing' put: 0;
		at: 'cellpadding' put: 0.
	self table: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'lr 8/3/2006 13:15'!
layoutTableOfWidth: width do: aBlock
	self attributes at: 'width' put: width.
	self layoutTable: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'mb 2/9/2006 17:41'!
legend: aBlock
	self tag: 'legend' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
list: aCollection
	self list: aCollection do: [:x | self text: x]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 3/15/2004 16:24'!
list: aCollection do: aBlock
	self unorderedList:
		[aCollection do:
			[:item |
			self listItem: [aBlock value: item]]]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'jf 11/24/2003 11:54'!
listItem: aBlock
	self tag: #li do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'avi 11/20/2003 18:51'!
openTag: aString
	self document openTag: aString attributes: self attributes.
	attributeBuffer := nil.! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 7/26/2004 12:51'!
orderedList: aBlock
	self tag: 'ol' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 7/26/2004 12:52'!
orderedList: aCollection do: aBlock
	self orderedList:
		[aCollection do:
			[:item |
			self listItem: [aBlock value: item]]]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
paragraph
	self tag: 'p'! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
paragraph: aBlock
	self tag: 'p' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'javascript' stamp: 'mbany 4/14/2005 12:24'!
popupStringWithUrl: urlString name: nameString extent: aPoint toggles: aCollection
	^ String streamContents:
		[:stream |
		stream 
			nextPutAll: 'window.open(';
			nextPut: $';
			nextPutAll: urlString;
			nextPut: $';
			nextPut: $,;
			nextPut: $';
			nextPutAll: nameString;
			nextPut: $';
			nextPut:$,;
			nextPut: $';
			nextPutAll: 'width=';
			nextPutAll: aPoint x displayString;
			nextPutAll: ',height=';
			nextPutAll: aPoint y displayString;
			nextPut: $,;
			nextPutAll: (self toggleStringFor: aCollection);
			nextPut: $';
			nextPutAll: ')']! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/16/2003 00:24'!
preformatted: anObject
	self tag: 'pre' do: anObject! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'ac 5/16/2003 16:11'!
render: anObject
	anObject renderOn: self! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 7/2/2004 14:21'!
script: aString
	self tag: 'script' do: [self html: aString]! !

!WAAbstractHtmlBuilder methodsFor: 'head' stamp: 'lr 8/3/2006 13:16'!
scriptWithUrl: urlString
	self attributes
		at: 'type' put: 'text/javascript';
		at: 'src' put: urlString.
	self tag: 'script'! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'mb 10/31/2006 16:11'!
space
	self html: self spaceEntity! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 2/19/2004 18:20'!
space: aNumber
	aNumber timesRepeat: [self space]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'mb 11/4/2006 10:23'!
spaceEntity
	"To be subclassed as needed"
	^'&nbsp;'! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 5/30/2003 00:29'!
spacerRow
	self tableRowWith: [self space]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
span: aBlock
	self tag: 'span' do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: 'mb 2/9/2006 14:23'!
spanClass: aString with: anObject
	self cssClass: aString; span: anObject! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: 'ab 2/16/2003 00:35'!
spanNamed: aString with: anObject
	self cssId: aString; span: anObject! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'mb 2/9/2006 17:41'!
strong: aBlock
	self tag: 'strong' do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: 'ac 11/26/2004 16:55'!
style: aString
	self attributeAt: 'style' put: aString! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
submitButton
	self inputWithType: 'submit'
! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: 'lr 8/3/2006 13:16'!
submitButtonWithText: aString
	self attributes at: 'value' put: aString.
	self inputWithType: 'submit'
! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:04'!
table: aBlock
	self tag: 'table' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableData: aBlock
	self tag: 'td' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'avi 2/19/2004 18:11'!
tableData: aBlock span: aNumber
	aNumber > 0 ifTrue:
		[self attributes at: 'colspan' put: aNumber.
		self tableData: aBlock]
! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableHeading: aBlock
	self tag: 'th' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/16/2003 00:26'!
tableHeadings: aCollection
	self tableRow: [aCollection do: [:ea | self tableHeading: ea]]! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableRow: aBlock
	self tag: 'tr' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableRowWith: aBlock
	self tableRow: [ self tableData: aBlock ]! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'avi 2/19/2004 18:10'!
tableRowWith: aBlock span: aNumber
	self tableRow: [ self tableData: aBlock span: aNumber]! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableRowWith: aBlock with: anotherBlock
	self tableRow: [ self tableData: aBlock; tableData: anotherBlock]! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableRowWith: x with: y with: z
	self tableRow: [ self tableData: x; tableData: y; tableData: z]! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'mb 2/9/2006 14:39'!
tableRowWithLabel: anObject column: aBlock
	self tableRow:
		[self 
			cssClass: 'label';
			tableData: anObject;
			tableData: aBlock]! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'mb 2/9/2006 14:39'!
tableRowWithLabel: anObject column: aBlock column: anotherBlock
	self tableRow:
		[self 
			cssClass: 'label';
			tableData: anObject;
			tableData: aBlock; 
			tableData: anotherBlock]! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'avi 11/20/2003 18:40'!
tag: aString
	self openTag: aString.
	self closeTag: aString.! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'avi 11/20/2003 18:40'!
tag: aString do: anObject
	self openTag: aString.
	self render: anObject.
	self closeTag: aString.! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'avi 4/24/2004 13:03'!
text: anObject
	self html: (self class encode: anObject)! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: 'mb 1/19/2006 18:02'!
textAreaNamed: name value: value
	name ifNotNil: [self attributes at: 'name' put: name].
	self attributes
		at: 'rows' ifAbsentPut: [3];
		at: 'cols' ifAbsentPut: [25].
	self tag: 'textarea' do: value.! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'mb 2/9/2006 17:50'!
textWithCRs: anObject
	"Replace all CRs with breaks"
	| aStream |
	aStream := anObject displayString readStream.
	[aStream atEnd] whileFalse:
		[self text: (aStream upTo: Character cr).
		aStream atEnd ifFalse: [self break]].	! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'mb 3/16/2006 15:51'!
textWithLFs: anObject
	"Replace all LFs with breaks"
	| aStream |
	aStream := anObject displayString readStream.
	[aStream atEnd] whileFalse:
		[self text: (aStream upTo: Character lf).
		aStream atEnd ifFalse: [self break]].	
! !

!WAAbstractHtmlBuilder methodsFor: 'javascript' stamp: 'pmm 11/2/2005 23:52'!
toggleStringFor: aCollection
	^ String streamContents:
		[:stream |
		aCollection 
			do: [:ea |
				stream
					nextPutAll: ea displayString;
					nextPutAll: '=yes']
			separatedBy: [stream nextPutAll: ',']]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
underline: aBlock
	self tag: 'u' do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 3/15/2004 16:23'!
unorderedList: aBlock
	self tag: 'ul' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'mb 3/16/2006 15:50'!
withLineBreaks: aString
	| stream |
	stream := aString readStream.
	[stream atEnd] whileFalse:
		[self text: stream nextLine.
		stream atEnd ifFalse: [self break]]
! !

WAAbstractHtmlBuilder subclass: #WAHtmlBuilder
	instanceVariableNames: 'document'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Builder'!

!WAHtmlBuilder class methodsFor: 'instance creation' stamp: 'avi 2/18/2004 19:46'!
on: aDocument
	^ self new document: aDocument! !

!WAHtmlBuilder methodsFor: 'accessing' stamp: 'avi 2/18/2004 19:46'!
document
	^ document! !

!WAHtmlBuilder methodsFor: 'accessing' stamp: 'avi 2/18/2004 19:46'!
document: aDocument
	document := aDocument! !

WAAbstractHtmlBuilder subclass: #WAHtmlRenderer
	instanceVariableNames: 'context callbacks shortcutBuffer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Builder'!

!WAHtmlRenderer commentStamp: '<historical>' prior: 0!
I am passed to the method #renderContentOn: of components unless #rendererClass has been redefined. On top of the basic XHTML construction methods inherited from WAAbstractHtmlBuilder, I provide an interface to attach event handlers to anchors and to form-elements.

To render any kind of squeak object call the message #render: It will do a double dispatch and call #renderOn: on this object.  For example:

	html render: 'Some text'.
	html render: 123.					" will print the child "
	html render: nil. 					" will do nothing "
	html render: #( 'a' 'b' 'c' ).			" will print every element "	
	html render: businessObject.			" will print the #displayString of your object "
	html render: childComponent.		" will render the child component "
	
This kind of double dispatch can be used with any xhtml-generating method:

	html divNamed: 'child' with: childComponent.
	html bold: #( 1 'First' ).!

!WAHtmlRenderer class methodsFor: 'as yet unclassified' stamp: 'avi 3/22/2004 12:20'!
context: aRenderingContext callbacks: aCallbackStore
	^ self basicNew initializeWithContext: aRenderingContext callbacks: aCallbackStore! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'mb 3/8/2006 12:09'!
addShortcut: aString
	| id |
	id := self ensureId.
	shortcutBuffer isNil ifTrue:
		[shortcutBuffer := Dictionary new].
	shortcutBuffer at: aString put: id.! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 2/9/2006 14:24'!
anchorOn: aSymbol of: anObject
	self
		ensureCssId: aSymbol;
		anchorWithAction: (MessageSend receiver: anObject selector: aSymbol)
		text: (self labelForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'pmm 6/7/2005 15:34'!
anchorWithAction: actionBlock do: linkBlock	
	self openAnchorWithAction: actionBlock.
	self render: linkBlock.
	self closeTag: 'a'.

! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ac 3/23/2006 18:15'!
anchorWithAction: aBlock fileName: fileName text: doBlock
	self 
		anchorWithUrl: 
			(self actionUrl,  '/', fileName, '?',
				(self callbacks registerActionCallback: aBlock))
		do: doBlock! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 4/8/2003 14:26'!
anchorWithAction: actionBlock form: aForm
	self anchorWithAction: actionBlock do: [self imageWithForm: aForm.]
! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 2/7/2004 02:09'!
anchorWithAction: actionBlock image: aForm
	self anchorWithAction: actionBlock do: [self imageWithForm: aForm.]
! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 1/23/2004 01:31'!
anchorWithAction: actionBlock text: aString
	self anchorWithAction: actionBlock do: aString! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'mb 3/9/2006 11:11'!
anchorWithAction: actionBlock text: aString submitFormNamed: formName
	| key |
	key := self context nextKey.
	#submitFormTriggeringCallback.
	self attributes at: 'onClick'
			put: 'submitFormTriggeringCallback('
				, formName asString printString 
				, ', ' 
				, key displayString printString 
				, ' , "href" ); return false;'.
	self anchorWithAction: actionBlock text: aString
	
! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'lr 6/8/2005 09:44'!
anchorWithCallback: actionBlock do: linkBlock
	self anchorWithUrl: (self urlForIdempotentAction: actionBlock) do: linkBlock! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'avi 11/20/2003 18:43'!
anchorWithDocument: anObject mimeType: mimeType fileName: fileName text: aString
	self openAnchorWithDocument: anObject mimeType: mimeType fileName: fileName.
	self text: aString.
	self closeTag: 'a'.! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'avi 11/3/2003 12:25'!
anchorWithDocument: anObject mimeType: mimeType text: aString
	self anchorWithDocument: anObject mimeType: mimeType fileName: nil text: aString! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'ab 1/11/2003 13:28'!
anchorWithDocument: anObject text: aString
	self anchorWithDocument: anObject mimeType: nil text: aString! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'ac 12/10/2004 17:15'!
anchorWithPopupAction: aBlock extent: aPoint do: anObject
	self
		anchorWithPopupUrl: (self urlForAction: aBlock)
		extent: aPoint
		do: anObject! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'ac 12/10/2004 17:20'!
anchorWithPopupAction: aBlock extent: aPoint text: aString
	self
		anchorWithPopupAction: aBlock 
		extent: aPoint 
		do: aString! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'ac 12/10/2004 17:17'!
anchorWithPopupAction: aBlock name: nameString extent: aPoint toggles: aCollection do: anObject
	self
		anchorWithPopupUrl: (self urlForAction: aBlock)
		name: nameString 
		extent: aPoint
		toggles: aCollection
		do: anObject! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'avi 6/8/2004 00:40'!
anchorWithScript: aString do: linkBlock
	self attributes at: 'onClick' put: aString.
	self anchorWithUrl: '#' do: linkBlock! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'mb 3/8/2006 14:19'!
autofocus: aBlock
	| elementId |
	elementId := self ensureId.
	aBlock value.
	#setFocus.
	self script: 'setFocus(', elementId asString printString, ')'! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'mb 3/8/2006 14:19'!
autofocus: aBlock withCursorAt: cursorPosition
	| elementId aStream |
	cursorPosition isNil ifTrue: [^self autofocus: aBlock].
	elementId := self ensureId.
	aBlock value.
	aStream := (String new: 30) writeStream.
	#setCursor.
	aStream
		nextPutAll: 'setCursor(';
		nextPutAll: elementId asString printString.
	cursorPosition isNumber ifTrue:
		[aStream nextPutAll: ',' , cursorPosition asString].
	"Cursor will go at end of field value, if position is not a number"
	aStream nextPut: $).
	self script: aStream contents
! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 2/9/2006 14:24'!
booleanMenuOn: aSymbol of: anObject
	self
		ensureCssId: aSymbol;
		booleanMenuWithValue: (anObject perform: aSymbol)
		callback: (self callbackForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 2/12/2003 17:21'!
booleanMenuWithValue: aBoolean callback: callbackBlock
	self booleanMenuWithValue: aBoolean callback: callbackBlock labels: #(Yes No)! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 5/6/2003 18:37'!
booleanMenuWithValue: aBoolean callback: callbackBlock labels: labelArray
	self
		selectFromList: (Array with: true with: false)
		selected: aBoolean
		callback: callbackBlock
		labels: [:b | b ifTrue: [labelArray first] ifFalse: [labelArray second]]! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'ab 1/11/2003 13:28'!
callbackForSelector: aSymbol of: anObject
	^ MessageSend receiver: anObject selector: (aSymbol copyWith: $:) asSymbol! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 3/22/2004 12:29'!
callbacks
	^ callbacks! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 6/7/2004 22:50'!
cancelButtonWithAction: aBlock
	self attributes value: 'Cancel'.
	self inputWithType: 'submit' named: (self callbacks registerCancelActionCallback: aBlock)
! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 2/9/2006 14:24'!
checkboxOn: aSymbol of: anObject
	self
		ensureCssId: aSymbol;
		checkboxWithValue: (anObject perform: aSymbol)
		callback: (self callbackForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'mb 3/8/2006 17:07'!
checkboxWithValue: aBoolean callback: callbackBlock
   | value originalAttributes originalShortcuts |
   value := ValueHolder new.
   originalAttributes := attributeBuffer.
   attributeBuffer := nil.
   originalShortcuts := shortcutBuffer.
   shortcutBuffer := nil.
   self
       hiddenInputWithCallback: [:v |  value contents: false].
   attributeBuffer := originalAttributes.
   shortcutBuffer := originalShortcuts.
   self attributeAt: 'checked' put: aBoolean.
   self
       valueInputOfType: 'checkbox'
       value: 'true'
       callback: [:v |  value contents: true].
   callbackBlock fixTemps.
   self
       hiddenInputWithCallback: [:v |  callbackBlock value: value contents]
! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'mb 3/9/2006 11:10'!
checkboxWithValue: aBoolean callback: callbackBlock submitFormNamed: formName 
	#submitForm.
	self attributes at: 'onClick'
			put: 'submitForm('
				, formName asString printString 
				, '); return false;'.
	self checkboxWithValue: aBoolean callback: callbackBlock
! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 7/5/2004 11:57'!
close! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'mb 3/8/2006 12:16'!
closeTag: aString
	super closeTag: aString.
	self installShortcuts.! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 11/20/2003 18:47'!
context
	^ context! !

!WAHtmlRenderer methodsFor: 'compound' stamp: 'avi 9/19/2006 14:30'!
dateInputWithValue: aDate callback: aBlock
	| values |
	aBlock fixCallbackTemps.
	
	values := Array new: 3.
	self
		selectFromList: (1 to: 12)
		selected: aDate monthIndex 
		callback: [ :month | values at: 2 put: month ]
		labels: [:ea | Date nameOfMonth: ea].
	self space.
	self
		textInputWithValue: aDate dayOfMonth 
		callback: [ :day | values at: 1 put: day ]
		maxLength: 2.
	self space.
	self 
		textInputWithValue: aDate year
		callback: [ :year | values at: 3 put: year]
		maxLength: 4.
	self hiddenInputWithCallback:
		[aBlock value: (Date
				newDay: (values first min: (Date daysInMonth: values second forYear: values third))
				monthNumber: values second
				year: values third)].
! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'mb 3/31/2006 12:26'!
defaultAction: actionBlock

	self
		style: 'position: absolute; top: -100em';
		submitButtonWithAction: actionBlock text: 'Default'.
	self
		style: 'position: absolute; top: -100em';
		textInputWithCallback: [:v | ].
! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'mb 3/31/2006 11:39'!
divWithShow: showLink hide: hideLink do: aBlock
	| linkId divId onClick |
	divId := self ensureId.
	linkId := self nextId.
	#swapDisplay.
	onClick := 'swapDisplay(', linkId printString, ', ', divId asString printString, '); return false;'.
	self attributes id: linkId; style: 'display: block'.
	self anchorWithScript: onClick do: showLink.
	self attributes id: divId; style: 'display: none'.
	self div: [
		self anchorWithScript: onClick do: hideLink.
		self div: aBlock.
	]! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 11/20/2003 18:46'!
document
	^ context document! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'mb 3/31/2006 11:40'!
ensureId
	^ (self attributes at: 'id' ifAbsentPut: [self nextId]) value! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 9/19/2006 14:30'!
fileUploadWithCallback: aBlock
	aBlock fixCallbackTemps.
	self
		inputWithType: 'file'
		named: (self callbacks registerCallback: [:f | aBlock value: (f = '' ifFalse: [f])])
! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 6/3/2004 19:23'!
form: aBlock
	self
		formWithMethod: 'post'
		action: context actionUrl urlString
		do: [
			self div: [
				context actionUrl parameters keysAndValuesDo:
				[:k :v |
				self inputWithType: 'hidden' named: k value: v].
			aBlock value
		]]! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'mb 11/27/2005 18:55'!
formWithDefaultAction: defaultBlock do: aBlock
	self form:
		[self defaultAction: defaultBlock.
		aBlock value]
! !

!WAHtmlRenderer methodsFor: 'private' stamp: 'mb 3/23/2006 07:31'!
fromStringConverterBlockFor: anObject callback: aBlock
	^ [:v | 
	aBlock value: 
		( [anObject convertSeasideString: v] on: Error do: [:e | v] )
	]
! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'mb 3/31/2006 11:41'!
getId
	"Compatibility"
	^ self nextId.! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 12/5/2003 00:51'!
hiddenInputWithCallback: callbackBlock
	self inputWithType: 'hidden' named: (self callbacks registerCallback: callbackBlock)
! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 1/11/2003 13:28'!
hiddenInputWithValue: anObject callback: callbackBlock
	self valueInputOfType: 'hidden'
		value: anObject
		callback: callbackBlock
! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'mb 9/14/2006 11:45'!
imageMapWithAction: aBlock form: aForm
	| point pointKey url id |
	aBlock fixTemps.
	point := ValueHolder new.
	pointKey := self callbacks registerCallback:
					[:ptString |
					point contents: (self parseImageMap: ptString)].
	url := self urlForAction: [aBlock value: point contents].
	self
		attributeAt: 'href'
		put: url, '&', pointKey, '='.
	id := self attributes at: 'id' ifAbsent: [nil].
	self tag: 'a' do: [
		id notNil ifTrue: [self cssId: id value , '-image'].
		self attributeAt: 'ismap' put: true.
		self imageWithForm: aForm.
	]! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'mb 2/17/2005 17:57'!
imageWithDocument: anObject mimeType: mimeType fileName: fileName
	self image: (self context urlForDocument: anObject mimeType: mimeType fileName: fileName).! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'mb 6/12/2006 14:24'!
imageWithFileNamed: fileName
	self imageWithFileNamed: fileName mimeType: nil! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'mb 6/12/2006 14:27'!
imageWithFileNamed: fileName mimeType: mimeType

	| document |
	document := WACachedDocument fileName: fileName.
	mimeType notNil ifTrue: [document mimeType: mimeType].
	self imageWithDocument: document mimeType: document mimeType fileName: fileName.
! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'mb 6/12/2006 10:25'!
imageWithForm: aForm
	self image: (self context urlForDocument: aForm mimeType: aForm mimeType) width: aForm width height: aForm height! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 3/22/2004 12:20'!
initializeWithContext: aRenderingContext callbacks: aCallbackStore
	context := aRenderingContext.
	callbacks := aCallbackStore.! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'mb 3/8/2006 14:19'!
installShortcuts
	| aStream |
	shortcutBuffer notNil ifTrue:
		[aStream := (String new: 30) writeStream.
		shortcutBuffer associations do:
			[:each |
			aStream
				nextPutAll: 'addShortcut(';
				nextPutAll: each key printString;
				nextPut: $,;
				nextPutAll: each value asString printString;
				nextPut: $)]
		separatedBy:
			[aStream nextPutAll: '; '].
		shortcutBuffer := nil.
		#addShortcut.
		self script: aStream contents].
		! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'mb 3/31/2006 11:40'!
label: aString input: aBlock
	| id |
	id := self nextId.
	self labelFor: id do:
		[self text: aString.
		self space.
		self cssId: id.
		aBlock value]! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'mb 3/31/2006 11:40'!
labelAfter: aString input: aBlock 
	| id |
	id := self nextId.
	self labelFor: id do: 
		[self cssId: id.
		aBlock value.
		self space.
		self text: aString]! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 2/9/2006 18:29'!
labelForSelector: aSymbol

	^ self labelForSelector: aSymbol of: nil! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 2/17/2005 10:42'!
labelForSelector: aSymbol of: anObject

	^ anObject labelForSelector: aSymbol! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 2/9/2006 18:37'!
labelledRowForCheckboxOn: aSymbol of: anObject
	self tableRowWithLabel: (self labelForSelector: aSymbol of: anObject)
		on: aSymbol
		column: [self checkboxOn: aSymbol of: anObject]! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 2/9/2006 18:40'!
labelledRowForList: aCollection on: aSymbol of: anObject
	self labelledRowForList: aCollection on: aSymbol of: anObject size: nil! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 5/6/2006 10:13'!
labelledRowForList: aCollection on: aSymbol of: anObject size: sizeIntegerOrNil
	self tableRowWithLabel: (self labelForSelector: aSymbol of: anObject)
		on: aSymbol
		column: 
			[sizeIntegerOrNil ifNotNil: [self attributeAt: #size put: sizeIntegerOrNil].
			self cssId: aSymbol.
			self
				selectFromList: aCollection
				selected: (anObject perform: aSymbol)
				callback: (self callbackForSelector: aSymbol of: anObject)]! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 2/9/2006 18:40'!
labelledRowForTextAreaOn: aSymbol of: anObject
	self tableRowWithLabel: (self labelForSelector: aSymbol of: anObject)
		on: aSymbol
		column: [self textAreaOn: aSymbol of: anObject]! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'JF 6/2/2003 13:31'!
labelledRowForTextInputOn: aSymbol of: anObject
	self labelledRowForTextInputOn: aSymbol of: anObject size: nil! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 2/9/2006 18:32'!
labelledRowForTextInputOn: aSymbol of: anObject size: sizeIntegerOrNil
	self tableRowWithLabel: (self labelForSelector: aSymbol of: anObject)
		on: aSymbol
		column: 
			[sizeIntegerOrNil ifNotNil: [self attributeAt: #size put: sizeIntegerOrNil].
			self textInputOn: aSymbol of: anObject]! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'mb 3/31/2006 11:40'!
nextId
	^ 'id', self context advanceKey
	! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 3/21/2004 00:03'!
openAnchorWithAction: actionBlock
	self
		attributeAt: 'href'
		put: (self urlForAction: actionBlock).
	self openTag: 'a'.! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'avi 5/22/2004 18:03'!
openAnchorWithDocument: anObject mimeType: mimeType fileName: fileName
	self attributeAt: 'href' put: (self context urlForDocument: anObject mimeType: mimeType fileName: fileName).
	self openTag: #a.! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 6/13/2004 23:16'!
openSelect
	| name |
	name := self callbacks registerDispatchCallback.
	self attributes at: 'name' put: name.
	self openTag: 'select'.	! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 1/15/2005 00:50'!
optionGroupWithLabel: aString do: aBlock
	self attributes at: 'label' put: aString.
	self tag: 'optgroup' do: aBlock! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 1/15/2005 00:49'!
optionWithLabel: aString callback: aBlock
	self optionWithLabel: aString selected: false callback: aBlock! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 11/20/2003 18:48'!
optionWithLabel: labelString selected: aBoolean callback: callbackBlock
	self 
		attributeAt: 'selected' put: aBoolean;
		attributeAt: 'value' put: (self callbacks registerCallback: callbackBlock).
	
	self tag: 'option' do: labelString.! !

!WAHtmlRenderer methodsFor: 'canvas compatibility' stamp: 'avi 3/18/2005 21:56'!
painter: aComponent
! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'ab 7/11/2003 00:09'!
parseImageMap: aString
	|s x y|
	('?*,*' match: aString) ifFalse: [^ nil].
	s := aString readStream.
	s upTo: $?.
	x := s upTo: $,.
	y := s upToEnd.
	^ x asNumber @ y asNumber
	! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 9/2/2004 13:18'!
passwordInputWithCallback: callbackBlock
	self passwordInputWithValue: '' callback: callbackBlock! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 9/30/2004 21:50'!
passwordInputWithValue: anObject callback: callbackBlock
	self
		valueInputOfType: 'password'
		value: anObject
		callback: callbackBlock
! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'mb 3/31/2006 11:41'!
peekNextId
	^ 'id', self context nextKey
	! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 11/20/2003 18:49'!
radioButtonInGroup: radioGroupKey selected: aBoolean callback: callbackBlock
	self attributeAt: 'checked' put: aBoolean.
	
	self inputWithType: 'radio' named: radioGroupKey value: (self callbacks registerCallback: callbackBlock)! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 3/22/2004 18:45'!
radioButtonInGroup: radioGroupKey withValue: value on: aSelector of: anObject
	self
		radioButtonInGroup: radioGroupKey
		selected: (value = (anObject perform: aSelector))
		callback: [anObject perform: aSelector asMutator with: value]! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 11/20/2003 18:48'!
radioGroup
	^ self callbacks registerDispatchCallback.! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 4/13/2004 19:48'!
registry
	^ WACurrentSession value application ! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 4/13/2004 21:43'!
request
	^ self context request! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 5/18/2004 14:01'!
response
	^ self context response! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'mbany 4/14/2005 12:30'!
selectFromList: aCollection selected: selectedObject callback: callbackBlock
	self selectFromList: aCollection selected: selectedObject callback: callbackBlock labels: [:i | i displayString]! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'mb 4/21/2006 17:50'!
selectFromList: aCollection selected: selectedObject callback: callbackBlock labels: labelsBlock
	self openSelect.
	callbackBlock fixTemps.

	aCollection do:
		[:item |
		self
			optionWithLabel: (labelsBlock value: item)
			selected: (item = selectedObject)
			callback: [callbackBlock value: item]] fixTemps.
	self closeTag: 'select'.! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 3/13/2004 14:58'!
selectFromList: aCollection selected: selectedObject callback: callbackBlock labels: labelsBlock nilLabel: aString
	self selectFromList: (Array with: nil), aCollection asArray
		selected: selectedObject
		callback: callbackBlock
		labels: [:ea | ea ifNil: [aString] ifNotNil: [labelsBlock value: ea]]! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 6/25/2003 23:03'!
selectInputOn: selectedSymbol of: anObject list: aCollection
	self
		selectFromList: aCollection
		selected: (anObject perform: selectedSymbol)
		callback: (self callbackForSelector: selectedSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'mb 3/31/2006 11:40'!
spanWithShow: showLink hide: hideLink do: aBlock
	| linkId divId onClick |
	divId := self ensureId.
	linkId := self nextId.
	#swapDisplay.
	onClick := 'swapDisplay(', linkId printString, ', ', divId asString printString, '); return false;'.
	self attributes id: linkId; style: 'display: block'.
	self anchorWithScript: onClick do: showLink.
	self attributes id: divId; style: 'display: none'.
	self span: [
		self anchorWithScript: onClick do: hideLink.
		self span: aBlock.
	]! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 2/9/2006 14:24'!
submitButtonOn: aSymbol of: anObject
	self
		ensureCssId: aSymbol;
		submitButtonWithAction: (MessageSend receiver: anObject selector: aSymbol)
		text: (self labelForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 11/20/2003 18:48'!
submitButtonWithAction: actionBlock
	self inputWithType: 'submit'
		named: (self callbacks registerActionCallback: actionBlock)
! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 2/7/2004 02:07'!
submitButtonWithAction: actionBlock do: aBlock
	self buttonWithType: 'submit'
		named: (self callbacks registerActionCallback: actionBlock)
		value: nil
		do: aBlock
! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'mb 9/21/2006 16:05'!
submitButtonWithAction: actionBlock image: aForm
	self attributes
		at: 'src' put: (self context urlForDocument: aForm);
		width: aForm width;
		height: aForm height.
	self inputWithType: 'image'
		named: (self callbacks registerImageCallback: actionBlock)
! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 1/11/2003 13:28'!
submitButtonWithAction: aBlock text: aString
	self attributeAt: 'value' put: aString.
	self submitButtonWithAction: aBlock! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 2/10/2006 12:20'!
tableRowWithLabel: anObject on: aSymbol column: aBlock
	self tableRowWithLabel: [self labelFor: aSymbol do: anObject] column: aBlock
! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 2/9/2006 14:25'!
textAreaOn: aSymbol of: anObject
	self
		ensureCssId: aSymbol;
		textAreaWithValue: (anObject perform: aSymbol)
		callback: (self callbackForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'mb 1/19/2006 18:07'!
textAreaWithCallback: callbackBlock
	self textAreaWithValue: nil callback: callbackBlock! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'mb 1/19/2006 18:10'!
textAreaWithValue: anObject callback: callbackBlock
	| callback updateKey |
	callback := self fromStringConverterBlockFor: anObject callback: callbackBlock.
	updateKey := self callbacks registerCallback: callback.
	self
		textAreaNamed: updateKey
		value: anObject asSeasideString.
	^updateKey! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 2/9/2006 14:25'!
textInputOn: aSymbol of: anObject
	self
		ensureCssId: aSymbol;
		textInputWithValue: (anObject perform: aSymbol)
		callback: (self callbackForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 6/24/2003 16:15'!
textInputWithCallback: callbackBlock
	self textInputWithValue: '' callback: callbackBlock! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 1/11/2003 13:28'!
textInputWithValue: anObject callback: callbackBlock
	self
		valueInputOfType: 'text'
		value: anObject
		callback: callbackBlock
! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 9/19/2006 14:30'!
textInputWithValue: aString callback: aBlock helpText: helpString
	aBlock fixCallbackTemps.
	aString ifNil:
		[self attributeAt: 'onfocus' put: 'if(''',helpString, ''' == this.value) {this.value=''''}; style.color=''black'''.
		self attributeAt: 'style' put: 'color: #aaa'].
	self textInputWithValue: (aString ifNil: [helpString]) callback: [:v | aBlock value: (v = helpString ifFalse: [v])]	! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 3/13/2004 14:17'!
textInputWithValue: anObject callback: callbackBlock maxLength: aNumber
	self attributes
		at: 'size' put: aNumber;
		at: 'maxlength' put: aNumber.
	self textInputWithValue: anObject callback: callbackBlock.! !

!WAHtmlRenderer methodsFor: 'compound' stamp: 'avi 9/19/2006 14:29'!
timeInputWithValue: aTime callback: aBlock
	| values |
	aBlock fixCallbackTemps.
	values := Array new: 2.
	self
		textInputWithValue: aTime hour
		callback: [:hour | values at: 1 put: hour]
		maxLength: 2.
	self space; text: ':'; space.
	self
		textInputWithValue: aTime minutes asTwoCharacterString
		callback: [:minute | values at: 2 put: minute asNumber]
		maxLength: 2.
	self hiddenInputWithCallback:
		[aBlock value:
			(Time
				hour: values first
				minute: (values second min: 59)
				second: 0)]
		
	
	! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'mbany 4/14/2005 12:31'!
unorderedList: aCollection selected: anObject callback: aBlock
	self unorderedList: aCollection selected: anObject  callback: aBlock labels: [:ea | ea displayString]! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'mb 11/16/2006 18:58'!
unorderedList: aCollection selected: anObject callback: aBlock labels: labelBlock
	aBlock fixTemps.
	self ensureCssClass: 'options'.
	self unorderedList: [
		aCollection do:
			[:ea |
			self cssClass: (ea = anObject
					ifTrue: ['option option-selected']
					ifFalse: ['option']).
			self listItem: [self anchorWithAction: [aBlock value: ea] text: (labelBlock value: ea)]].
	]! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 5/21/2004 18:10'!
unorderedListOn: aSymbol of: anObject list: aCollection
	self
		unorderedList: aCollection
		selected: (anObject perform: aSymbol)
		callback: (self callbackForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 11/7/2005 13:12'!
urlForAction: actionBlock
	| url |
	url := context actionUrl withParameter: (self callbacks registerActionCallback: actionBlock).
	^ url displayString! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'lr 6/8/2005 16:50'!
urlForAction: actionBlock andPath: aString
	| url |
	url := context actionUrl withParameter:  (self callbacks 
		registerActionCallback: actionBlock).
	url addToPath: aString.
	^ url displayString! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'avi 5/22/2004 18:05'!
urlForDocument: anObject
	^ self context urlForDocument: anObject! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'lr 8/3/2006 13:22'!
urlForIdempotentAction: actionBlock
	| url |
	url := (context actionUrl
		withParameter:  (self callbacks registerActionCallback: actionBlock))
		withParameter: '_n'.
	^ url displayString! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'mb 11/27/2005 18:59'!
valueInputOfType: typeString value: anObject callback: callbackBlock 
	| updateKey callback |
	callback := self fromStringConverterBlockFor: anObject callback: callbackBlock.
	updateKey := self callbacks registerCallback: callback.
	self
		inputWithType: typeString
		named: updateKey
		value: anObject asSeasideString.
	^ updateKey
! !

Object subclass: #WABrush
	instanceVariableNames: 'parent canvas isClosed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WABrush class methodsFor: 'instance creation' stamp: 'mb 1/12/2006 18:53'!
new
	^self basicNew initialize! !

!WABrush methodsFor: 'private' stamp: 'avi 6/17/2004 12:18'!
close
	self isClosed ifFalse: [self with: []]! !

!WABrush methodsFor: 'initialize-release' stamp: 'mb 1/12/2006 18:54'!
initialize! !

!WABrush methodsFor: 'testing' stamp: 'avi 6/17/2004 12:17'!
isClosed
	^ isClosed ifNil: [false]! !

!WABrush methodsFor: 'private' stamp: 'lr 9/14/2005 22:33'!
labelForSelector: aSymbol of: anObject
	^ anObject labelForSelector: aSymbol.! !

!WABrush methodsFor: 'accessing' stamp: 'avi 6/13/2004 00:27'!
parent
	^ parent! !

!WABrush methodsFor: 'convenience' stamp: 'mb 3/23/2006 16:19'!
session
	^ WACurrentSession value! !

!WABrush methodsFor: 'initialize-release' stamp: 'avi 6/13/2004 00:27'!
setParent: aBrush canvas: aCanvas
	parent := aBrush.
	canvas := aCanvas! !

!WABrush methodsFor: 'public api' stamp: 'avi 6/17/2004 12:17'!
with: aBlock
	canvas nest: aBlock.
	isClosed := true.! !

WABrush subclass: #WATagBrush
	instanceVariableNames: 'attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

WATagBrush subclass: #WAAnchorTag
	instanceVariableNames: 'url isNavigation callbackKey extraParameters extraPath promptString promptDefault fragment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAAnchorTag commentStamp: 'dc 7/11/2006 07:16' prior: 0!
I'm the class responsible for adding anchors (links) to your webpage. There are multiple ways of using me.


In the following case, the method #doSomethingOnClick will be sent to self when the user click on the anchor 'Click here to do something':

html anchor
  callback: [self doSomethingOnClick];
  text: 'Click here to do something'.


In fact, you are not obliged to render simple text for your anchors, a block can be executed instead:

html anchor
  callback: [self doSomethingIfUserClickMe];
  with: [put here some code to render things for the anchor text].


Following code is a shortcut to create an anchor:

html anchor
  on: #aSelector of: anObject

The text will be 'a Selector' (this is a special transformation of symbols to make them more readable)
The action will be the call of #aSelector on anObject.!

!WAAnchorTag methodsFor: 'private' stamp: 'lr 11/16/2006 11:18'!
actionUrl
	| actionUrl |
	^ callbackKey ifNotNil:
		[actionUrl := canvas context actionUrl withParameter: callbackKey.
		self isNavigation ifTrue: [actionUrl := actionUrl withParameter: '_n'].
		extraParameters ifNotNil:
			[extraParameters associationsDo: [:assoc | actionUrl addParameter: assoc key value: assoc value]]. 
		actionUrl fragment: fragment.
		extraPath
			ifNil: [actionUrl queryString]
			ifNotNil: [actionUrl addToPath: extraPath; asString]]! !

!WAAnchorTag methodsFor: 'callbacks' stamp: 'avi 11/27/2005 16:26'!
callback: aBlock
	callbackKey := canvas callbacks registerActionCallback: aBlock! !

!WAAnchorTag methodsFor: 'javascript' stamp: 'mb 3/8/2006 18:18'!
canHaveShortcut
	^true! !

!WAAnchorTag methodsFor: 'public api' stamp: 'mb 9/8/2006 10:36'!
document: aDocument
	self document: aDocument mimeType: nil! !

!WAAnchorTag methodsFor: 'public api' stamp: 'mb 9/8/2006 10:35'!
document: aDocument mimeType: mimeType
	self document: aDocument mimeType: mimeType fileName: nil! !

!WAAnchorTag methodsFor: 'public api' stamp: 'mb 9/8/2006 10:34'!
document: aDocument mimeType: mimeType fileName: fileName
	self url: (canvas context urlForDocument: aDocument mimeType: mimeType fileName: fileName)
! !

!WAAnchorTag methodsFor: 'public api' stamp: 'avi 11/27/2005 16:36'!
extraParameters: aCollection
	extraParameters := aCollection! !

!WAAnchorTag methodsFor: 'public api' stamp: 'avi 2/1/2006 13:08'!
extraPath: aString
	extraPath := aString! !

!WAAnchorTag methodsFor: 'accessing' stamp: 'cb 9/6/2006 13:22'!
fragment

	^fragment ! !

!WAAnchorTag methodsFor: 'accessing' stamp: 'cb 9/6/2006 13:23'!
fragment: aString

	fragment := aString! !

!WAAnchorTag methodsFor: 'private' stamp: 'pmm 9/12/2006 18:08'!
handlerForForm: formName
	^ promptString
		ifNil:
				['submitFormTriggeringCallback('
				, formName asString printString
				, ', '
				, callbackKey displayString printString
				, ', "href" ); return false;']
		ifNotNil: 
				['if(x = prompt('
				, promptString printString
				, ')) submitFormTriggeringCallback('
				, formName asString printString
				, ', '
				, callbackKey displayString printString
				, ', x); return false;']
! !

!WAAnchorTag methodsFor: 'initialize-release' stamp: 'pmm 9/12/2006 18:08'!
initialize
	super initialize.
	isNavigation := false! !

!WAAnchorTag methodsFor: 'testing' stamp: 'avi 11/27/2005 21:05'!
isNavigation
	^ isNavigation ifNil: [false]! !

!WAAnchorTag methodsFor: 'public api' stamp: 'avi 10/30/2005 00:50'!
mailto: aString
	self url: 'mailto:', aString.
	self text: aString! !

!WAAnchorTag methodsFor: 'attributes' stamp: 'avi 9/24/2005 20:50'!
name: aString
	self attributeAt: 'name' put: aString! !

!WAAnchorTag methodsFor: 'public api' stamp: 'avi 11/27/2005 16:30'!
navigation
	isNavigation := true! !

!WAAnchorTag methodsFor: 'deprecated' stamp: 'lr 11/16/2006 19:00'!
newTarget
	self deprecatedApi.
	self target: '_new'! !

!WAAnchorTag methodsFor: 'public api' stamp: 'lr 9/14/2005 23:51'!
on: aSymbol of: anObject
	self callback: [ anObject perform: aSymbol ].
	self with: (self labelForSelector: aSymbol of: anObject).! !

!WAAnchorTag methodsFor: 'events' stamp: 'lr 11/16/2006 15:30'!
onClick: aString
	super onClick: aString.
	self attributes at: 'href' ifAbsentPut: [ 'javascript:void(0)' ]
! !

!WAAnchorTag methodsFor: 'events' stamp: 'lr 11/16/2006 15:30'!
onMouseOut: aString
	super onMouseOut: aString.
	self attributes at: 'href' ifAbsentPut: [ 'javascript:void(0)' ]! !

!WAAnchorTag methodsFor: 'events' stamp: 'lr 3/13/2006 19:52'!
onMouseOver: aString 
	super onMouseOver: aString.
	self attributes at: 'href' ifAbsentPut: [ 'javascript:void(0)' ]! !

!WAAnchorTag methodsFor: 'callbacks' stamp: 'avi 3/15/2006 22:24'!
prompt: aString callback: aBlock
	self prompt: aString default: '' callback: aBlock! !

!WAAnchorTag methodsFor: 'callbacks' stamp: 'avi 3/15/2006 22:23'!
prompt: aString default: defaultString callback: aBlock
	callbackKey := canvas callbacks registerCallback: aBlock.
	promptString := aString.
	promptDefault := defaultString! !

!WAAnchorTag methodsFor: 'public api' stamp: 'avi 9/11/2005 14:40'!
resourceUrl: aString
	self url: (canvas document root absoluteUrlForResource: aString)! !

!WAAnchorTag methodsFor: 'attributes' stamp: 'avi 6/22/2005 14:46'!
submitFormNamed: aString
	self onClick: (self handlerForForm: aString)! !

!WAAnchorTag methodsFor: 'accessing' stamp: 'avi 6/13/2004 00:56'!
tag
	^ 'a'! !

!WAAnchorTag methodsFor: 'deprecated' stamp: 'lr 11/16/2006 15:29'!
target: aString
	self deprecatedApi.
	self attributeAt: 'target' put: aString! !

!WAAnchorTag methodsFor: 'deprecated' stamp: 'lr 11/16/2006 15:29'!
text: aString
	self deprecatedApi.
	self with: aString! !

!WAAnchorTag methodsFor: 'deprecated' stamp: 'lr 10/12/2006 11:51'!
toggleStringFor: aCollection
	self deprecatedApi.
	^ String streamContents:
		[:stream |
		aCollection 
			do: [:ea |
				stream
					nextPutAll: ea displayString;
					nextPutAll: '=yes']
			separatedBy: [stream nextPutAll: ',']]! !

!WAAnchorTag methodsFor: 'public api' stamp: 'avi 11/27/2005 16:26'!
url: aString
	url := aString! !

!WAAnchorTag methodsFor: 'public api' stamp: 'ac 2/5/2006 11:27'!
with: aBlock
	| newUrl |
	newUrl := url ifNil: [self actionUrl].
	newUrl ifNotNil: [self attributes at: 'href' put: newUrl].
	^ super with: aBlock! !

WAAnchorTag subclass: #WAPopupAnchorTag
	instanceVariableNames: 'name extent dependent showToolbar resizable showScrollbars'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAPopupAnchorTag methodsFor: 'public api' stamp: 'ac 7/8/2005 19:15'!
beDependent
	dependent := true! !

!WAPopupAnchorTag methodsFor: 'public api' stamp: 'ac 9/11/2005 13:08'!
beResizable
	resizable := true! !

!WAPopupAnchorTag methodsFor: 'accessing' stamp: 'ac 7/3/2005 16:08'!
extent: aPoint
	extent := aPoint! !

!WAPopupAnchorTag methodsFor: 'initialize-release' stamp: 'mb 4/23/2006 15:28'!
initialize
	super initialize.
	dependent := false.! !

!WAPopupAnchorTag methodsFor: 'testing' stamp: 'ac 7/8/2005 19:15'!
isDependent
	^ dependent ifNil: [false]! !

!WAPopupAnchorTag methodsFor: 'testing' stamp: 'ac 9/11/2005 13:07'!
isResizable
	^ resizable ifNil: [resizable := false]! !

!WAPopupAnchorTag methodsFor: 'accessing' stamp: 'ac 7/3/2005 16:07'!
name: aString
	name := aString! !

!WAPopupAnchorTag methodsFor: 'private' stamp: 'avi 2/2/2006 02:21'!
popupString
	^ String streamContents:
		[:stream |
		stream 
			nextPutAll: 'window.open(';
			nextPut: $';
			nextPutAll: (url ifNil: [self actionUrl]);
			nextPut: $';
			nextPut: $,;
			nextPut: $';
			nextPutAll: name;
			nextPut: $';
			nextPut:$,;
			nextPut: $';
			nextPutAll: 'width=';
			nextPutAll: extent x displayString;
			nextPutAll: ',height=';
			nextPutAll: extent y displayString;
			nextPut: $,;
			nextPutAll: self toggleString;
			nextPut: $';
			nextPutAll: ').focus()']! !

!WAPopupAnchorTag methodsFor: 'public api' stamp: 'avi 3/23/2006 22:56'!
shouldShowScrollbars
	^ showScrollbars ifNil: [showScrollbars := false]! !

!WAPopupAnchorTag methodsFor: 'public api' stamp: 'ac 9/11/2005 13:05'!
shouldShowToolbar
	^ showToolbar ifNil: [showToolbar := false]! !

!WAPopupAnchorTag methodsFor: 'public api' stamp: 'avi 3/23/2006 22:55'!
showScrollbars
	showScrollbars := true! !

!WAPopupAnchorTag methodsFor: 'public api' stamp: 'ac 9/11/2005 13:04'!
showToolbar
	showToolbar := true! !

!WAPopupAnchorTag methodsFor: 'public api' stamp: 'avi 3/23/2006 22:55'!
toggleArray
	^ Array streamContents:
		[:stream |
		self isDependent ifTrue: [stream nextPut: #dependent].
		self shouldShowToolbar ifTrue: [stream nextPut: #toolbar].
		self isResizable ifTrue: [stream nextPut: #resizable].
		self shouldShowScrollbars ifTrue: [stream nextPut: #scrollbars]]! !

!WAPopupAnchorTag methodsFor: 'public api' stamp: 'pmm 11/2/2005 23:53'!
toggleString
	^ String streamContents:
		[:stream | 
		self toggleArray 
			do: [:ea |
				stream
					nextPutAll: ea;
					nextPutAll: '=yes'] 
			separatedBy: [stream nextPutAll: ',']]! !

!WAPopupAnchorTag methodsFor: 'public api' stamp: 'ac 2/7/2006 10:50'!
with: aBlock
	self onClick: self popupString.
	self ignoreURL.
	^ super with: aBlock.! !

WATagBrush subclass: #WACanvasTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WACanvasTag methodsFor: 'attributes' stamp: 'lr 5/18/2006 08:52'!
extent: aPoint
	self width: aPoint x; height: aPoint y! !

!WACanvasTag methodsFor: 'attributes' stamp: 'lr 5/18/2006 08:51'!
height: aNumber
	self attributeAt: 'height' put: aNumber displayString! !

!WACanvasTag methodsFor: 'accessing' stamp: 'lr 5/18/2006 08:50'!
tag
	^ 'canvas'! !

!WACanvasTag methodsFor: 'attributes' stamp: 'lr 5/18/2006 08:51'!
width: aNumber
	self attributeAt: 'width' put: aNumber displayString! !

WACanvasTag subclass: #WAImageTag
	instanceVariableNames: 'url fileName mimeType document'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAImageTag methodsFor: 'attributes' stamp: 'avi 5/10/2005 14:33'!
altText: aString
	self attributes at: 'alt' put: aString
! !

!WAImageTag methodsFor: 'deprecated' stamp: 'lr 10/12/2006 14:25'!
border: aNumber
	self deprecatedApi.
	self attributes border: aNumber! !

!WAImageTag methodsFor: 'private' stamp: 'pmm 9/12/2006 18:04'!
close
	url isNil ifTrue: [
		self generateUrlForDocument ].
	self attributes at: 'src' put: url.
	super close.! !

!WAImageTag methodsFor: 'accessing' stamp: 'mb 6/12/2006 08:44'!
document: anObject
	document := anObject! !

!WAImageTag methodsFor: 'accessing' stamp: 'mb 6/12/2006 08:47'!
fileName: aString
	fileName := aString! !

!WAImageTag methodsFor: 'public api' stamp: 'mb 6/12/2006 08:50'!
form: aForm
	self extent: aForm extent.
	self document: aForm.! !

!WAImageTag methodsFor: 'private' stamp: 'pmm 9/12/2006 18:06'!
generateCachedDocumentFromFilename
	document := WACachedDocument fileName: fileName.
	mimeType isNil ifFalse: [
		document mimeType: mimeType ]! !

!WAImageTag methodsFor: 'private' stamp: 'pmm 9/12/2006 18:07'!
generateUrlForDocument
	document isNil ifTrue: [
		self generateCachedDocumentFromFilename ].
	mimeType isNil ifTrue: [
		mimeType := document mimeType ].
	url := canvas context
		urlForDocument: document
		mimeType: mimeType
		fileName: fileName! !

!WAImageTag methodsFor: 'initialize-release' stamp: 'mb 8/10/2006 08:01'!
initialize
	super initialize.
	self altText: ''.! !

!WAImageTag methodsFor: 'accessing' stamp: 'mb 6/12/2006 08:47'!
mimeType: aString
	mimeType := aString! !

!WAImageTag methodsFor: 'deprecated' stamp: 'lr 10/12/2006 14:25'!
noBorder
	self deprecatedApi.
	self border: 0! !

!WAImageTag methodsFor: 'public api' stamp: 'avi 9/11/2005 14:40'!
resourceUrl: aString
	self url: (canvas document root absoluteUrlForResource: aString)! !

!WAImageTag methodsFor: 'deprecated' stamp: 'lr 10/12/2006 14:25'!
src: aString
	self deprecatedApi.
	self url: aString
! !

!WAImageTag methodsFor: 'accessing' stamp: 'ac 3/16/2005 12:00'!
tag
	^ 'img'! !

!WAImageTag methodsFor: 'accessing' stamp: 'pmm 9/12/2006 18:01'!
url: aString
	url := aString
! !

WATagBrush subclass: #WACollectionTag
	instanceVariableNames: 'list selected callbackBlock labelsBlock multiple'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WACollectionTag methodsFor: 'adding' stamp: 'lr 9/25/2005 11:31'!
add: anObject
	^ list add: anObject.! !

!WACollectionTag methodsFor: 'adding' stamp: 'lr 9/25/2005 11:32'!
addAll: aCollection
	^ list addAll: aCollection.! !

!WACollectionTag methodsFor: 'attributes' stamp: 'lr 9/26/2005 13:44'!
beMultiple
	multiple := true.! !

!WACollectionTag methodsFor: 'attributes' stamp: 'mb 4/23/2006 15:10'!
beSingle
	multiple := false.! !

!WACollectionTag methodsFor: 'callbacks' stamp: 'avi 9/19/2006 14:31'!
callback: aBlock
	callbackBlock := aBlock fixCallbackTemps.! !

!WACollectionTag methodsFor: 'testing' stamp: 'mb 11/3/2006 14:08'!
hasCallback
	^callbackBlock notNil! !

!WACollectionTag methodsFor: 'initialization' stamp: 'mb 4/23/2006 15:10'!
initialize
	super initialize.
	list := OrderedCollection new.
	labelsBlock := [ :value | value ].
	multiple := false.
! !

!WACollectionTag methodsFor: 'testing' stamp: 'pmm 11/2/2005 22:11'!
isMultiple
	^ multiple.! !

!WACollectionTag methodsFor: 'testing' stamp: 'lr 9/26/2005 14:48'!
isSelected: anObject
	^ self isMultiple
		ifTrue: [ selected includes: anObject ]
		ifFalse: [ selected = anObject ].! !

!WACollectionTag methodsFor: 'private' stamp: 'lr 9/25/2005 11:40'!
labelForOption: anObject
	^ labelsBlock value: anObject.! !

!WACollectionTag methodsFor: 'callbacks' stamp: 'avi 9/19/2006 14:30'!
labels: aBlock
	labelsBlock := aBlock fixCallbackTemps.! !

!WACollectionTag methodsFor: 'accessing' stamp: 'lr 9/25/2005 11:34'!
list: aCollection
	self addAll: aCollection.! !

!WACollectionTag methodsFor: 'attributes' stamp: 'pmm 7/19/2006 20:10'!
on: selector of: anObject
	"copy pasted from WASelectTag, we need a traitified version of seaside"
	self selected: (anObject perform: selector).
	self callback: [ :value | anObject perform: selector asMutator with: value ].! !

!WACollectionTag methodsFor: 'accessing' stamp: 'mb 4/23/2006 18:31'!
selected: anObject
	selected := anObject! !

WACollectionTag subclass: #WAListTag
	instanceVariableNames: 'tag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAListTag methodsFor: 'actions' stamp: 'lr 9/25/2005 11:37'!
beOrdered
	tag := 'ol'.! !

!WAListTag methodsFor: 'actions' stamp: 'lr 9/25/2005 11:37'!
beUnordered
	tag := 'ul'.! !

!WAListTag methodsFor: 'private' stamp: 'lr 9/26/2005 15:18'!
callbackForOption: anObject
	self isMultiple 
		ifTrue: [ 
			selected := (self isSelected: anObject)
				ifTrue: [ selected copyWithout: anObject ]
				ifFalse: [ selected copyWith: anObject ].
			callbackBlock value: selected ]
		ifFalse: [ callbackBlock value: anObject ].! !

!WAListTag methodsFor: 'accessing' stamp: 'lr 9/25/2005 11:37'!
tag
	^ tag ifNil: [ 'ul' ].! !

!WAListTag methodsFor: 'public' stamp: 'lr 11/16/2006 08:10'!
with: aBlock
	| brush |
	super with: [
		list do: [ :each |
			brush := canvas listItem class: 'option'.
			(self isSelected: each)
				ifTrue: [ brush class: 'option-selected' ].
			brush with: [
				self hasCallback
					ifFalse: [ canvas render: (self labelForOption: each) ]
					ifTrue: [
						canvas anchor
							callback: [ self callbackForOption: each ];
							with: (self labelForOption: each) ] ] ].
		aBlock value ]! !

WACollectionTag subclass: #WASelectTag
	instanceVariableNames: 'otherLabel otherCallbackBlock isOptional promptString isSubmitOnChange optionalLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WASelectTag methodsFor: 'attributes' stamp: 'ac 4/13/2005 12:38'!
beOptional
	isOptional := true! !

!WASelectTag methodsFor: 'attributes' stamp: 'ac 2/1/2006 20:23'!
beSubmitOnChange
	isSubmitOnChange := true
! !

!WASelectTag methodsFor: 'testing' stamp: 'ac 4/13/2005 13:05'!
hasOther
	^ otherLabel notNil! !

!WASelectTag methodsFor: 'initialize-release' stamp: 'mb 4/23/2006 15:31'!
initialize
	super initialize.
	isOptional := false.
	isSubmitOnChange := false! !

!WASelectTag methodsFor: 'testing' stamp: 'pmm 11/2/2005 22:17'!
isOptional
	^ isOptional! !

!WASelectTag methodsFor: 'testing' stamp: 'pmm 11/2/2005 22:17'!
isSubmitOnChange
	^ isSubmitOnChange! !

!WASelectTag methodsFor: 'accessing' stamp: 'mb 1/13/2006 10:34'!
numberOfOptions
	| count |
	count := 0.
	self isOptional ifTrue: [count := count + 1].
	count := count + list size.
	^ count! !

!WASelectTag methodsFor: 'attributes' stamp: 'avi 8/30/2005 13:27'!
optionalLabel: aString
	optionalLabel := aString! !

!WASelectTag methodsFor: 'private' stamp: 'mb 11/3/2006 14:10'!
optionsOn: html
	| brush |
	self isOptional ifTrue: 
		[brush := html option 
			selected: selected isNil;
			yourself.
		self hasCallback ifTrue:
			[brush callback: [ callbackBlock value: nil ]].
		brush
			with: optionalLabel ].

	list do: 
		[:each | 
		brush := html option 
			selected: (self isSelected: each); 
			yourself.
		self hasCallback ifTrue:
			[brush callback: [ self isMultiple
				ifTrue: [ selected add: each ]
				ifFalse: [ callbackBlock value: each ] ] ].
		brush
			with: (self labelForOption: each) ]! !

!WASelectTag methodsFor: 'attributes' stamp: 'avi 9/19/2006 14:29'!
otherLabel: labelString otherCallback: aBlock promptString: aString
	otherLabel := labelString.
	otherCallbackBlock := aBlock fixCallbackTemps.
	promptString := aString.! !

!WASelectTag methodsFor: 'attributes' stamp: 'lr 9/26/2005 09:55'!
size: anInteger
	self attributes at: 'size' put: anInteger.! !

!WASelectTag methodsFor: 'accessing' stamp: 'ac 3/17/2005 16:44'!
tag
	^ 'select'! !

!WASelectTag methodsFor: 'public' stamp: 'mb 11/3/2006 15:12'!
with: aBlock
	| hidden value other onChange |

	onChange := ''.
	self hasOther ifTrue: 
		[other := (canvas context nextKey asNumber + self numberOfOptions + 1) displayString.
		hidden := canvas context nextKey asString.
		value := ValueHolder new.
		canvas insert:
			[canvas hiddenInput id: hidden; value: nil; callback: [:n | value contents: n]; with: []].
		onChange := 'if(this.value == ' , other printString
			, ') {chooseOther(this, ' , hidden printString
			, ', ' , promptString printString , ')};'].

	self isSubmitOnChange ifTrue: [onChange := onChange, ' submit();'].
	onChange isEmpty ifFalse: [self onChange: onChange].

	self isMultiple ifTrue: [
		canvas insert:
			[canvas hiddenInput 
				callback: [ selected := OrderedCollection new ];
				with: [] ] ].
	self hasCallback ifTrue: [
		self attributes 
			at: 'name' put: (self isMultiple
				ifTrue: [ canvas callbacks registerMultiDispatchCallback ]
				ifFalse: [ canvas callbacks registerDispatchCallback ])].
	self attributes
		at: 'multiple' put: self isMultiple.
	super with: 
		[self optionsOn: canvas. 
		aBlock value.
		self hasOther ifTrue: 
			[canvas option 
				selected: false; 
				callback: [otherCallbackBlock value: value contents];
				with: otherLabel]].

	(self isMultiple and: [self hasCallback]) ifTrue: [
		canvas insert:
			[canvas hiddenInput 
				callback: [ callbackBlock value: selected ];
				with: [] ] ].! !

WATagBrush subclass: #WACompound
	instanceVariableNames: 'callbackBlock value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WACompound methodsFor: 'callbacks' stamp: 'mb 11/3/2006 14:42'!
callback: aBlock
	callbackBlock := aBlock
! !

!WACompound methodsFor: 'testing' stamp: 'mb 11/3/2006 14:17'!
hasCallback
	^callbackBlock notNil! !

!WACompound methodsFor: 'callbacks' stamp: 'pmm 7/19/2006 20:13'!
on: selector of: anObject
	"copy pasted for the third time, we really need a traitified version of seaside"
	self value: (anObject perform: selector).
	self callback: [ :date | anObject perform: selector asMutator with: date ].! !

!WACompound methodsFor: 'public api' stamp: 'mb 1/30/2006 18:40'!
value: aValue
	value := aValue! !

WACompound subclass: #WADateInput
	instanceVariableNames: 'options month day year'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WADateInput methodsFor: 'private rendering' stamp: 'mb 11/3/2006 14:43'!
addCallback
	self hasCallback ifFalse: [^self].
	canvas forgetCurrentBrush.
	(canvas hiddenInput)
		callback:
			[callbackBlock value: self setValueWithNewDate];
		close.
! !

!WADateInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 14:18'!
addDayCallbackToBrush: aBrush
	self hasCallback ifFalse: [^self].
	aBrush on: #day of: self
! !

!WADateInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 14:18'!
addMonthCallbackToBrush: aBrush
	self hasCallback ifFalse: [^self].
	aBrush on: #month of: self

! !

!WADateInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 14:19'!
addYearCallbackToBrush: aBrush
	self hasCallback ifFalse: [^self].
	aBrush on: #year of: self! !

!WADateInput methodsFor: 'private callbacks' stamp: 'mb 11/4/2006 10:20'!
day
	^day! !

!WADateInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 14:16'!
day: anIntegerOrString
	day := [anIntegerOrString asNumber] on: Error do: [:e | 1]
! !

!WADateInput methodsFor: 'accessing' stamp: 'mb 11/3/2006 09:57'!
defaultOptions
	^#(month day year)! !

!WADateInput methodsFor: 'private callbacks' stamp: 'mb 11/4/2006 10:20'!
month
	^month! !

!WADateInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 14:16'!
month: anIntegerOrString
	month := [anIntegerOrString asNumber] on: Error do: [:e | 1]
! !

!WADateInput methodsFor: 'accessing' stamp: 'mb 11/3/2006 09:49'!
options
	^options ifNil: [ self defaultOptions ].! !

!WADateInput methodsFor: 'accessing' stamp: 'mb 11/3/2006 09:58'!
options: anArray
	"Valid values in the array : #year #month #day
	Can be used to control what is shown and in what order
	Default #(month day year)"
	options := anArray! !

!WADateInput methodsFor: 'private rendering' stamp: 'mb 11/3/2006 10:41'!
renderDay
	| brush |
	canvas forgetCurrentBrush.
	brush := (canvas textInput)
		id: (self id isNil ifTrue: [nil] ifFalse: [self id , '-day']);
		value: day;
		yourself.
	self addDayCallbackToBrush: brush.
	brush
		attributeAt: 'size' put: 2;
		attributeAt: 'maxlength' put: 2;
		attributeAt: 'max' put: 31;
		close.
! !

!WADateInput methodsFor: 'private rendering' stamp: 'mb 11/3/2006 14:16'!
renderMonth
	| brush |
	canvas forgetCurrentBrush.
	brush := (canvas select)
		id: self id;
		list: (1 to: 12);
		selected: month;
		yourself.
	self addMonthCallbackToBrush: brush.
	brush
		labels: [:ea | Date nameOfMonth: ea];
		close.
! !

!WADateInput methodsFor: 'private rendering' stamp: 'mb 11/3/2006 10:42'!
renderYear
	| brush |
	canvas forgetCurrentBrush.
	brush := (canvas textInput) 
		id: (self id isNil ifTrue: [nil] ifFalse: [self id , '-year']);
		value: year;
		yourself.
	self addYearCallbackToBrush: brush.
	brush
		attributeAt: 'size' put: 4;
		attributeAt: 'maxlength' put: 4;
		close.
! !

!WADateInput methodsFor: 'private callbacks' stamp: 'mb 11/9/2006 07:37'!
setValueWithNewDate
	^value := Date
				newDay: ((day min: (Date daysInMonth: month forYear: year)) max: 1)
				monthNumber: month
				year: year.
! !

!WADateInput methodsFor: 'public api' stamp: 'mb 11/3/2006 10:16'!
with: aBlock
	value isNil ifTrue: [value := Date today].
	day := value dayOfMonth.
	month := value monthIndex.
	year := value year.
	self options do:
		[:each |
		self perform: ('render' , each asLowercase capitalized) asSymbol]
	separatedBy:
		[canvas space].
	self addCallback.
! !

!WADateInput methodsFor: 'private callbacks' stamp: 'mb 11/4/2006 10:20'!
year
	^year! !

!WADateInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 14:16'!
year: anIntegerOrString
	year := [anIntegerOrString asNumber] on: Error do: [:e | 1900]
! !

WACompound subclass: #WAImageMapTag
	instanceVariableNames: 'form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAImageMapTag methodsFor: 'accessing' stamp: 'mb 9/12/2006 11:39'!
form: aForm
	form := aForm! !

!WAImageMapTag methodsFor: 'private' stamp: 'pmm 9/20/2006 18:06'!
parseImageMap: aString
	| stream x y |
	('?*,*' match: aString) ifFalse: [^ nil].
	stream := aString readStream.
	stream upTo: $?.
	x := stream upTo: $,.
	y := stream upToEnd.
	^ x asNumber @ y asNumber! !

!WAImageMapTag methodsFor: 'private' stamp: 'mb 9/14/2006 09:26'!
url
	| callbackKey pointKey url |
	callbackBlock fixTemps.
	pointKey := canvas callbacks registerCallback:
					[:ptString |
					value := self parseImageMap: ptString].
	callbackKey := canvas callbacks registerActionCallback:
					[callbackBlock value: value].
	url := canvas context actionUrl withParameter: callbackKey.
	^ url queryString, '&', pointKey, '='.

! !

!WAImageMapTag methodsFor: 'accessing' stamp: 'mb 9/14/2006 09:25'!
value: aValue
	self shouldNotImplement! !

!WAImageMapTag methodsFor: 'private' stamp: 'mb 9/14/2006 11:27'!
with: aBlock
	canvas forgetCurrentBrush.
	canvas anchor
		attributes: self attributes;
		url: self url;
		with:
			[canvas image
				id: (self id isNil ifTrue: [nil] ifFalse: [self id , '-image']);
				attributeAt: 'ismap' put: true;
				form: form]! !

WACompound subclass: #WATimeInput
	instanceVariableNames: 'withSeconds hours minutes seconds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WATimeInput methodsFor: 'private rendering' stamp: 'mb 11/3/2006 14:44'!
addCallback
	self hasCallback ifFalse: [^self].
	canvas forgetCurrentBrush.
	(canvas hiddenInput)
		callback:
			[callbackBlock value: self setValueWithNewTime];
		close

! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 14:21'!
addHoursCallbackToBrush: aBrush
	self hasCallback ifFalse: [^self].
	aBrush on: #hours of: self.

! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 14:22'!
addMinutesCallbackToBrush: aBrush
	self hasCallback ifFalse: [^self].
	aBrush on: #minutes of: self.

! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 14:22'!
addSecondsCallbackToBrush: aBrush
	self hasCallback ifFalse: [^self].
	aBrush on: #seconds of: self.

! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'mb 11/4/2006 10:21'!
hours
	^hours

! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 14:20'!
hours: anIntegerOrString
	hours := [anIntegerOrString asNumber] on: Error do: [:e | 0]

! !

!WATimeInput methodsFor: 'initialize-release' stamp: 'pmm 9/12/2006 19:18'!
initialize
	super initialize.
	self withoutSeconds! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'mb 11/4/2006 10:21'!
minutes
	^minutes! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 14:21'!
minutes: anIntegerOrString
	minutes := [anIntegerOrString asNumber] on: Error do: [:e | 0]

! !

!WATimeInput methodsFor: 'private rendering' stamp: 'mb 11/3/2006 10:44'!
renderHours
	| brush |
	canvas forgetCurrentBrush.
	brush := (canvas textInput)
		id: self id;
		value: hours asTwoCharacterString;
		yourself.
	self addHoursCallbackToBrush: brush.
	brush
		attributeAt: 'size' put: 2;
		attributeAt: 'maxlength' put: 2;
		close.
! !

!WATimeInput methodsFor: 'private rendering' stamp: 'mb 11/3/2006 10:45'!
renderMinutes
	| brush |
	canvas forgetCurrentBrush.
	brush := (canvas textInput)
		id: (self id isNil ifTrue: [nil] ifFalse: [self id , '-mins']);
		value: minutes asTwoCharacterString;
		yourself.
	self addMinutesCallbackToBrush: brush.
	brush
		attributeAt: 'size' put: 2;
		attributeAt: 'maxlength' put: 2;
		attributeAt: 'max' put: 59; 
		close.
! !

!WATimeInput methodsFor: 'private rendering' stamp: 'mb 11/3/2006 10:46'!
renderSeconds
	| brush |
	canvas forgetCurrentBrush.
	brush := (canvas textInput)
		id: (self id isNil ifTrue: [nil] ifFalse: [self id , '-secs']);
		value: seconds asTwoCharacterString;
		yourself.
	self addSecondsCallbackToBrush: brush.
	brush
		attributeAt: 'size' put: 2;
		attributeAt: 'maxlength' put: 2;
		attributeAt: 'max' put: 59; 
		close.
	! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'mb 11/4/2006 10:21'!
seconds
	^seconds! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 14:21'!
seconds: anIntegerOrString
	seconds := [anIntegerOrString asNumber] on: Error do: [:e | 0]

! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 11:11'!
setValueWithNewTime
	^value := Time
				hour: hours
				minute: (minutes min: 59)
				second: (seconds min: 59).
	! !

!WATimeInput methodsFor: 'public api' stamp: 'mb 11/3/2006 10:16'!
with: aBlock
	value isNil ifTrue: [value := Time now].
	hours := value hour.
	minutes := value minutes.
	seconds := value seconds.
	self renderHours.
	canvas space; text: ':'; space.
	self renderMinutes.
	withSeconds ifTrue:
		[canvas space; text: ':'; space.
		self renderSeconds]
	ifFalse:
		[seconds := 0].
	self addCallback.
! !

!WATimeInput methodsFor: 'accessing' stamp: 'mb 2/6/2006 09:55'!
withSeconds
	withSeconds := true! !

!WATimeInput methodsFor: 'accessing' stamp: 'mb 2/6/2006 09:56'!
withoutSeconds
	withSeconds := false! !

WATagBrush subclass: #WADivTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WADivTag methodsFor: 'public api' stamp: 'avi 6/3/2005 15:40'!
clear
	self class: 'clear'.
	self with: [canvas space]! !

!WADivTag methodsFor: 'accessing' stamp: 'avi 6/3/2005 15:39'!
tag
	^ 'div'! !

WATagBrush subclass: #WAFieldSetTag
	instanceVariableNames: 'legend'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAFieldSetTag methodsFor: 'private' stamp: 'mb 3/8/2006 18:03'!
before
	legend ifNotNil: [canvas legend: legend]
! !

!WAFieldSetTag methodsFor: 'accessing' stamp: 'mb 3/8/2006 17:47'!
legend: aString
	legend := aString
	! !

!WAFieldSetTag methodsFor: 'accessing' stamp: 'mb 3/8/2006 17:44'!
tag
	^ 'fieldset'! !

WATagBrush subclass: #WAFormInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

WAFormInputTag subclass: #WAAbstractTextAreaTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAAbstractTextAreaTag commentStamp: '<historical>' prior: 0!
An abstract class to describe the HTML elements that can have a text cursor.
The cursorPosition i-var holds the desired cursor position!

!WAAbstractTextAreaTag methodsFor: 'callbacks' stamp: 'lr 11/16/2006 15:27'!
callback: aBlock
	self name: (canvas callbacks registerCallback: aBlock).
	self value: self value asSeasideString! !

!WAAbstractTextAreaTag methodsFor: 'javascript' stamp: 'mb 10/10/2006 23:24'!
exampleText: aString
	(self value isNil or: [self value = aString]) ifTrue:
		[self
			onFocus: 'if(value == ', aString printString, '){value=''''; style.color=''black''}';
			style: 'color: #aaa';
			value: aString]! !

!WAAbstractTextAreaTag methodsFor: 'javascript' stamp: 'mb 3/23/2006 17:25'!
setCursorPosition: anInteger
	| aStream |
	"Insert the javascript for setting the cursor position"
	self ensureId.
	aStream := (String new: 30) writeStream.
	#setCursor.
	aStream
		nextPutAll: 'setCursor(';
		nextPutAll: self id printString.
	anInteger isNumber ifTrue:
		[aStream nextPutAll: ',' , anInteger asString].
	"Cursor will go at end of field value, if position is not a number"
	aStream nextPut: $).
	self session addLoadScript: aStream contents
! !

WAAbstractTextAreaTag subclass: #WATextAreaTag
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WATextAreaTag methodsFor: 'attributes' stamp: 'ac 3/22/2005 17:49'!
columns: anInteger
	self attributeAt: 'cols' put: anInteger.! !

!WATextAreaTag methodsFor: 'attributes' stamp: 'ac 3/22/2005 17:50'!
rows: anInteger
	self attributeAt: 'rows' put: anInteger.! !

!WATextAreaTag methodsFor: 'accessing' stamp: 'ac 4/13/2005 01:51'!
tag
	^ 'textarea'! !

!WATextAreaTag methodsFor: 'accessing' stamp: 'mb 1/31/2006 11:42'!
value
	^value! !

!WATextAreaTag methodsFor: 'accessing' stamp: 'ac 8/30/2005 16:26'!
value: aString
	value := aString! !

!WATextAreaTag methodsFor: 'public api' stamp: 'ac 8/30/2005 16:29'!
with: aBlock
	^ value ifNotNil: [super with: value] ifNil: [super with: aBlock]! !

WAAbstractTextAreaTag subclass: #WATextInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

WATextInputTag subclass: #WAPasswordInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAPasswordInputTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 17:33'!
type
	^ 'password'! !

!WATextInputTag methodsFor: 'attributes' stamp: 'lr 10/10/2005 20:04'!
beRangeInput
	self type: 'range'.! !

!WATextInputTag methodsFor: 'attributes' stamp: 'lr 10/10/2005 20:04'!
beSearchInput
	self type: 'search'.! !

!WATextInputTag methodsFor: 'attributes' stamp: 'pmm 10/11/2006 19:08'!
maxLength: aNumber
	self attributeAt: 'maxlength' put: aNumber! !

!WATextInputTag methodsFor: 'attributes' stamp: 'avi 11/7/2005 14:09'!
size: aNumber
	self attributeAt: 'size' put: aNumber! !

!WATextInputTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:50'!
type
	^ 'text'! !

WAFormInputTag subclass: #WACheckboxTag
	instanceVariableNames: 'value callback'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WACheckboxTag methodsFor: 'private' stamp: 'avi 4/28/2005 14:16'!
after
	canvas hiddenInput callback:
		[callback value: value.
		value := false]! !

!WACheckboxTag methodsFor: 'callbacks' stamp: 'avi 9/19/2006 14:31'!
callback: aBlock
	value := false.
	callback := aBlock fixCallbackTemps.
	super callback: [value := true]! !

!WACheckboxTag methodsFor: 'javascript' stamp: 'mb 3/8/2006 18:20'!
canHaveShortcut
	^true! !

!WACheckboxTag methodsFor: 'attributes' stamp: 'avi 9/19/2006 14:31'!
onTrue: trueBlock onFalse: falseBlock
	trueBlock fixCallbackTemps. falseBlock fixCallbackTemps.
	self callback: [ :v | v ifTrue: [ trueBlock value ] ifFalse: [ falseBlock value ] ].! !

!WACheckboxTag methodsFor: 'attributes' stamp: 'pmm 7/19/2006 19:29'!
submitFormNamed: formName
	self onClick: 'submitForm('
				, formName asString printString 
				, '); return false;'.! !

!WACheckboxTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:44'!
type
	^ 'checkbox'! !

!WACheckboxTag methodsFor: 'attributes' stamp: 'lr 9/23/2005 13:47'!
value: aBoolean
	self attributeAt: 'checked' put: aBoolean.! !

WAFormInputTag subclass: #WAFileUploadTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAFileUploadTag methodsFor: 'callbacks' stamp: 'avi 9/19/2006 14:30'!
callback: aBlock
	aBlock fixCallbackTemps.
	super callback: [ :file | aBlock value: (file = '' ifFalse: [ file ]) ].! !

!WAFileUploadTag methodsFor: 'callbacks' stamp: 'lr 10/19/2005 00:13'!
on: selector of: anObject
	self callback: [ :value | anObject perform: selector asMutator with: value ].! !

!WAFileUploadTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:45'!
type
	^ 'file'! !

!WAFormInputTag methodsFor: 'callbacks' stamp: 'lr 9/26/2005 12:47'!
callback: aBlock
	self name: (canvas callbacks registerCallback: aBlock).! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 9/23/2005 13:41'!
name: aString
	self attributes at: 'name' put: aString.! !

!WAFormInputTag methodsFor: 'callbacks' stamp: 'pmm 9/12/2006 17:53'!
on: selector of: anObject
	self value: (anObject perform: selector).
	self callback: [ :value | anObject perform: selector asMutator with: value ].! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 9/23/2005 17:43'!
readonly: aBoolean
	self attributes at: 'readonly' put: aBoolean.! !

!WAFormInputTag methodsFor: 'javascript' stamp: 'pmm 9/12/2006 18:25'!
setFocus
	self ensureId.
	self session addLoadScript: 'setFocus(', self id printString, ')'! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'pmm 9/12/2006 18:23'!
submitOnClick
	self onClick: 'submit()'.! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 10/10/2005 19:49'!
tabindex: anInteger
	self attributes at: 'tabindex' put: anInteger.! !

!WAFormInputTag methodsFor: 'accessing' stamp: 'ac 3/16/2005 12:08'!
tag
	^ 'input'! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 9/23/2005 13:42'!
text: aString
	self value: aString.! !

!WAFormInputTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:43'!
type
	^ nil! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 10/10/2005 19:49'!
type: aString
	self attributes at: 'type' put: aString.! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'mb 1/30/2006 18:59'!
value
	^self attributes at: 'value' ! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 9/23/2005 13:42'!
value: anObject
	anObject ifNotNil: [ self attributes at: 'value' put: anObject ].! !

!WAFormInputTag methodsFor: 'public' stamp: 'lr 11/16/2006 15:31'!
with: aBlock
	self type isNil ifFalse: [
		self attributes at: 'type' ifAbsentPut: [ self type ].
		self class: self type ].
	super with: aBlock! !

WAFormInputTag subclass: #WAHiddenInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAHiddenInputTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 17:45'!
type
	^ 'hidden'! !

WAFormInputTag subclass: #WARadioButtonTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WARadioButtonTag methodsFor: 'attributes' stamp: 'ac 7/6/2005 10:39'!
beChecked
	self attributeAt: 'checked' put: true.! !

!WARadioButtonTag methodsFor: 'attributes' stamp: 'ac 7/6/2005 10:40'!
beUnchecked
	self attributeAt: 'checked' put: false.! !

!WARadioButtonTag methodsFor: 'callbacks' stamp: 'ac 7/6/2005 11:24'!
callback: aBlock
	self attributeAt: 'value' put: (canvas callbacks registerCallback: aBlock).! !

!WARadioButtonTag methodsFor: 'javascript' stamp: 'mb 3/8/2006 18:20'!
canHaveShortcut
	^true! !

!WARadioButtonTag methodsFor: 'attributes' stamp: 'ac 7/6/2005 11:32'!
group: aRadioGroup
	self name: aRadioGroup key.! !

!WARadioButtonTag methodsFor: 'attributes' stamp: 'ac 7/6/2005 11:01'!
selected: aBoolean
	self attributeAt: 'checked' put: aBoolean.! !

!WARadioButtonTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:46'!
type
	^ 'radio'! !

WAFormInputTag subclass: #WASubmitButtonTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

WASubmitButtonTag subclass: #WAButtonTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAButtonTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 17:37'!
type
	^ 'button'! !

WASubmitButtonTag subclass: #WAImageButtonTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAImageButtonTag methodsFor: 'attributes' stamp: 'mb 6/8/2006 16:08'!
callback: aBlock
	self attributes at: 'name' ifAbsentPut: [canvas callbacks registerImageCallback: aBlock].! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 9/14/2005 22:02'!
extent: aPoint
	self width: aPoint x; height: aPoint y.! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 9/14/2005 22:04'!
form: aForm
	self extent: aForm extent.
	self url: (canvas context urlForDocument: aForm).! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 8/3/2006 08:43'!
height: aNumber
	self attributes at: 'height' put: aNumber! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 9/14/2005 22:03'!
resourceUrl: aString
	self url: (canvas document root absoluteUrlForResource: aString).! !

!WAImageButtonTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:49'!
type
	^ 'image'! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 9/14/2005 22:02'!
url: aString
	self attributes at: 'src' put: aString.! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 8/3/2006 08:43'!
width: aNumber
	self attributes at: 'width' put: aNumber! !

!WASubmitButtonTag methodsFor: 'callbacks' stamp: 'mb 1/5/2006 14:08'!
callback: aBlock
	self attributes at: 'name' ifAbsentPut: [canvas callbacks registerActionCallback: aBlock].
	
! !

!WASubmitButtonTag methodsFor: 'javascript' stamp: 'mb 3/8/2006 18:19'!
canHaveShortcut
	^true! !

!WASubmitButtonTag methodsFor: 'callbacks' stamp: 'jlr 4/13/2006 13:26'!
on: aSymbol of: anObject
	self value: (self labelForSelector: aSymbol of: anObject).
	self callback: [anObject perform: aSymbol ].! !

!WASubmitButtonTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:49'!
type
	^ 'submit'! !

WATagBrush subclass: #WAFormTag
	instanceVariableNames: 'defaultAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAFormTag methodsFor: 'attributes' stamp: 'lr 7/9/2006 18:56'!
action: aString
	self attributeAt: 'action' put: aString! !

!WAFormTag methodsFor: 'private' stamp: 'lr 7/9/2006 18:56'!
after
	canvas div: [
		canvas context actionUrl parameters keysAndValuesDo: [ :k :v |
			canvas hiddenInput name: k; value: v.
			canvas text: ' ' ] ]! !

!WAFormTag methodsFor: 'private' stamp: 'lr 11/16/2006 18:17'!
before
	defaultAction ifNotNil: [
		canvas submitButton
			callback: defaultAction;
			value: 'Default';
			style: 'position: absolute; top: -100em'.
		canvas textInput
			callback: [:v];
			style: 'position: absolute; top: -100em' ]! !

!WAFormTag methodsFor: 'callbacks' stamp: 'ac 4/13/2005 00:02'!
defaultAction: aBlock
	defaultAction := aBlock.! !

!WAFormTag methodsFor: 'attributes' stamp: 'lr 7/9/2006 18:57'!
method: aString
	self attributeAt: 'method' put: aString! !

!WAFormTag methodsFor: 'attributes' stamp: 'avi 6/8/2005 21:46'!
multipart
	self attributeAt: 'enctype' put: 'multipart/form-data'! !

!WAFormTag methodsFor: 'attributes' stamp: 'lr 9/14/2005 21:37'!
multipart: aBoolean
	aBoolean ifTrue: [ self multipart ].! !

!WAFormTag methodsFor: 'attributes' stamp: 'avi 6/9/2005 16:02'!
name: aString
	self attributeAt: 'name' put: aString! !

!WAFormTag methodsFor: 'attributes' stamp: 'avi 3/21/2006 16:51'!
noAutocomplete
	self attributeAt: 'autocomplete' put: 'off'! !

!WAFormTag methodsFor: 'attributes' stamp: 'lr 7/9/2006 18:57'!
post
	self method: 'post'! !

!WAFormTag methodsFor: 'initialize-release' stamp: 'lr 7/9/2006 18:56'!
setParent: aBrush canvas: aCanvas
	super setParent: aBrush canvas: aCanvas.
	self post; action: ''! !

!WAFormTag methodsFor: 'private' stamp: 'avi 6/17/2004 11:29'!
tag
	^ 'form'! !

WATagBrush subclass: #WAGenericTag
	instanceVariableNames: 'tag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WAGenericTag class methodsFor: 'instance creation' stamp: 'avi 6/13/2004 00:53'!
tag: aString
	^ self basicNew initializeWithTag: aString! !

!WAGenericTag methodsFor: 'initialize-release' stamp: 'avi 6/13/2004 00:40'!
initializeWithTag: aString
	tag := aString! !

!WAGenericTag methodsFor: 'accessing' stamp: 'avi 6/13/2004 00:40'!
tag
	^ tag! !

WATagBrush subclass: #WAHeadingTag
	instanceVariableNames: 'level'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAHeadingTag methodsFor: 'accessing' stamp: 'ac 3/16/2005 14:12'!
level
	^ level ifNil: [1]! !

!WAHeadingTag methodsFor: 'attributes' stamp: 'ac 3/16/2005 14:12'!
level1
	level := 1.! !

!WAHeadingTag methodsFor: 'attributes' stamp: 'ac 3/16/2005 14:12'!
level2
	level := 2.! !

!WAHeadingTag methodsFor: 'attributes' stamp: 'ac 3/16/2005 14:12'!
level3
	level := 3.! !

!WAHeadingTag methodsFor: 'attributes' stamp: 'ac 3/16/2005 14:12'!
level4
	level := 4.! !

!WAHeadingTag methodsFor: 'attributes' stamp: 'dc 8/16/2006 07:43'!
level5
	level := 5.! !

!WAHeadingTag methodsFor: 'attributes' stamp: 'dc 8/16/2006 07:43'!
level6
	level := 6.! !

!WAHeadingTag methodsFor: 'attributes' stamp: 'lr 9/14/2005 21:33'!
level: anInteger
	level := anInteger! !

!WAHeadingTag methodsFor: 'accessing' stamp: 'avi 5/10/2005 14:33'!
tag
	^ 'h', self level displayString ! !

WATagBrush subclass: #WAIframeTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAIframeTag methodsFor: 'conveniance' stamp: 'lr 3/10/2006 12:36'!
contents: anObject
	| key |
	key := canvas callbacks registerActionCallback: [ self performRendering: anObject ].
	self src: (canvas context actionUrl withParameter: key)! !

!WAIframeTag methodsFor: 'conveniance' stamp: 'lr 8/9/2006 08:34'!
document: anObject
	self document: anObject mimeType: nil! !

!WAIframeTag methodsFor: 'conveniance' stamp: 'lr 8/9/2006 08:31'!
document: anObject mimeType: aMimeString
	self document: anObject mimeType: aMimeString fileName: nil! !

!WAIframeTag methodsFor: 'conveniance' stamp: 'lr 8/9/2006 08:31'!
document: anObject mimeType: aMimeString fileName: aFileNameString
	self src: (canvas context
		urlForDocument: anObject 
		mimeType: aMimeString 
		fileName: aFileNameString)! !

!WAIframeTag methodsFor: 'attributes' stamp: 'lr 8/3/2006 08:42'!
height: anInteger
	self attributes at: 'height' put: anInteger! !

!WAIframeTag methodsFor: 'attributes' stamp: 'lr 3/10/2006 12:18'!
name: aString
	self attributes at: 'name' put: aString! !

!WAIframeTag methodsFor: 'private' stamp: 'pmm 10/7/2006 18:45'!
performRendering: anObject
	| innerContext docRoot session document response renderer  |
	innerContext := canvas context copy.
	docRoot := WARenderedHtmlRoot context: innerContext.
	docRoot resourceBaseUrl: innerContext document root resourceBaseUrl.
	docRoot base target: '_top'.
	session := WACurrentSession value.
	document := session outputDocumentClass root: docRoot.
	response := WAResponse new.
	response headerAt: 'Cache-Control' put: 'No-cache'.
	document stream: response stream.
	canvas context document: document.
	renderer := canvas species context: canvas context callbacks: canvas callbacks.
	renderer render: anObject; flush. 
	document close.
	session returnResponse: response! !

!WAIframeTag methodsFor: 'deprecated' stamp: 'lr 11/16/2006 15:32'!
src: anUrl
	self deprecatedApi.
	self url: anUrl! !

!WAIframeTag methodsFor: 'accessing' stamp: 'lr 3/8/2006 23:25'!
tag
	^ 'iframe'! !

!WAIframeTag methodsFor: 'attributes' stamp: 'pmm 8/26/2006 00:06'!
url: aString
	self attributeAt: 'src' put: aString! !

!WAIframeTag methodsFor: 'attributes' stamp: 'lr 8/3/2006 08:43'!
width: anInteger
	self attributes at: 'width' put: anInteger! !

WATagBrush subclass: #WALabelTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WALabelTag methodsFor: 'attributes' stamp: 'ac 7/9/2005 04:36'!
for: aString
	self attributeAt: 'for' put: aString.! !

!WALabelTag methodsFor: 'accessing' stamp: 'ac 7/9/2005 04:36'!
tag
	^ 'label'! !

WATagBrush subclass: #WAOptionTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAOptionTag methodsFor: 'attributes' stamp: 'ac 3/17/2005 17:53'!
callback: aBlock
	self attributeAt: 'value' put: (canvas callbacks registerCallback: aBlock).! !

!WAOptionTag methodsFor: 'attributes' stamp: 'pmm 7/19/2006 20:06'!
on: selector of: anObject
	"copy pasted from WASelectTag, we need a traitified version of seaside"
	self selected: (anObject perform: selector).
	self callback: [ :value | anObject perform: selector asMutator with: value ].! !

!WAOptionTag methodsFor: 'attributes' stamp: 'ac 3/17/2005 17:13'!
selected: aBoolean
	self attributeAt: 'selected' put: aBoolean.! !

!WAOptionTag methodsFor: 'accessing' stamp: 'ac 3/17/2005 17:13'!
tag
	^ 'option'! !

WATagBrush subclass: #WARubyTextTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WARubyTextTag methodsFor: 'attributes' stamp: 'pmm 9/18/2006 19:01'!
span: anInteger
	self attributeAt: 'rbspan' put: anInteger! !

!WARubyTextTag methodsFor: 'accessing' stamp: 'pmm 9/18/2006 19:00'!
tag
	^ 'rt'! !

WATagBrush subclass: #WAScriptTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAScriptTag methodsFor: 'private' stamp: 'lr 11/21/2006 20:36'!
after
	self document text: '/*]]>*/'! !

!WAScriptTag methodsFor: 'private' stamp: 'lr 11/21/2006 20:36'!
before
	self document text: '/*<!![CDATA[*/'! !

!WAScriptTag methodsFor: 'attributes' stamp: 'cwp 9/11/2006 17:25'!
resourceUrl: aString
	self url: (canvas document root absoluteUrlForResource: aString)! !

!WAScriptTag methodsFor: 'accessing' stamp: 'dwj 6/10/2005 13:10'!
tag
	^ 'script'! !

!WAScriptTag methodsFor: 'attributes' stamp: 'pmm 8/26/2006 00:05'!
url: aString
	self attributes at: 'src' put: aString! !

!WAScriptTag methodsFor: 'public' stamp: 'lr 11/21/2006 20:29'!
with: aString
	self attributes at: 'type' ifAbsentPut: [ 'text/javascript' ].
	super with: [ self document text: aString ]! !

WATagBrush subclass: #WATableCellTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WATableCellTag methodsFor: 'attributes' stamp: 'lr 9/26/2005 12:08'!
align: aString
	self attributes at: 'align' put: aString.! !

!WATableCellTag methodsFor: 'attributes' stamp: 'lr 9/26/2005 12:08'!
colSpan: anInteger
	self attributes at: 'colspan' put: anInteger.! !

!WATableCellTag methodsFor: 'attributes' stamp: 'lr 9/26/2005 12:08'!
rowSpan: anInteger
	self attributes at: 'rowspan' put: anInteger.! !

!WATableCellTag methodsFor: 'attributes' stamp: 'lr 9/26/2005 12:09'!
verticalAlign: aString
	self attributes at: 'valign' put: aString.! !

WATableCellTag subclass: #WATableDataTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WATableDataTag methodsFor: 'accessing' stamp: 'ac 3/17/2005 22:09'!
tag
	^ 'td'! !

WATableCellTag subclass: #WATableHeadingTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WATableHeadingTag methodsFor: 'accessing' stamp: 'ac 3/17/2005 22:10'!
tag
	^ 'th'! !

WATagBrush subclass: #WATableTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WATableTag methodsFor: 'deprecated' stamp: 'lr 11/16/2006 15:33'!
border: anInteger
	self deprecatedApi.
	self attributes at: 'border' put: anInteger! !

!WATableTag methodsFor: 'deprecated' stamp: 'lr 11/16/2006 15:33'!
cellpadding: anInteger
	self deprecatedApi.
	self attributes at: 'cellpadding' put: anInteger! !

!WATableTag methodsFor: 'deprecated' stamp: 'lr 11/16/2006 15:33'!
cellspacing: anInteger
	self deprecatedApi.
	self attributes at: 'cellspacing' put: anInteger! !

!WATableTag methodsFor: 'deprecated' stamp: 'lr 11/16/2006 18:07'!
layout
	self deprecatedApi.
	self border: 0.
	self cellspacing: 0.
	self cellpadding: 0! !

!WATableTag methodsFor: 'accessing' stamp: 'ac 3/16/2005 15:22'!
tag
	^ 'table'! !

!WATagBrush class methodsFor: 'code generation' stamp: 'pmm 9/12/2006 19:28'!
tag
	"WASelectTag tag"
	"WAGenericTag tag"
	^(self selectors includes: #tag)
		ifTrue: [ self new tag ]
		ifFalse: [ nil ]! !

!WATagBrush methodsFor: 'attributes' stamp: 'ac 3/16/2006 10:57'!
accessKey: aString
	self attributeAt: 'accesskey' put: aString! !

!WATagBrush methodsFor: 'javascript' stamp: 'pmm 9/12/2006 19:12'!
addShortcut: aString
	self canHaveShortcut ifFalse: [
		self error: 'May not assign shortcut on items that are not clickable' ].
	
	self ensureId.
	self session addLoadScript: (String streamContents: [ :stream |
		stream
			nextPutAll: 'addShortcut(';
			nextPutAll: aString printString;
			nextPut: $,;
			nextPutAll: self id printString;
			nextPut: $) ])! !

!WATagBrush methodsFor: 'attributes' stamp: 'mb 3/8/2006 17:51'!
addStyle: aString
	self attributes addStyle: aString.! !

!WATagBrush methodsFor: 'private' stamp: 'ac 3/17/2005 18:18'!
after! !

!WATagBrush methodsFor: 'attributes' stamp: 'mb 3/23/2006 17:08'!
attributeAt: key
	^(self attributes at: key ifAbsent: [key -> nil]) value.! !

!WATagBrush methodsFor: 'attributes' stamp: 'avi 6/17/2004 12:40'!
attributeAt: key put: value
	self attributes at: key put: value! !

!WATagBrush methodsFor: 'attributes' stamp: 'avi 6/13/2004 01:03'!
attributes
	^ attributes ifNil: [attributes := WAHtmlAttributes new]! !

!WATagBrush methodsFor: 'attributes' stamp: 'avi 6/17/2004 14:15'!
attributes: anHtmlAttributes
	attributes := anHtmlAttributes
! !

!WATagBrush methodsFor: 'private' stamp: 'ac 3/17/2005 18:18'!
before! !

!WATagBrush methodsFor: 'javascript' stamp: 'mb 3/8/2006 18:18'!
canHaveShortcut
	^false! !

!WATagBrush methodsFor: 'attributes' stamp: 'avi 6/22/2005 01:49'!
class: aString
	self attributes addClass: aString! !

!WATagBrush methodsFor: 'private' stamp: 'mb 3/16/2006 23:19'!
closeTag
	self document closeTag: self tag.
! !

!WATagBrush methodsFor: 'javascript' stamp: 'avi 3/9/2006 17:41'!
confirm: aString
	self onClick: 'return confirm("', aString, '")'! !

!WATagBrush methodsFor: 'events' stamp: 'mb 10/10/2006 22:49'!
disableEnter
	self onEnter: ''.! !

!WATagBrush methodsFor: 'attributes' stamp: 'ac 10/16/2005 19:55'!
disabled
	self disabled: true.! !

!WATagBrush methodsFor: 'attributes' stamp: 'ac 10/16/2005 19:55'!
disabled: aBoolean
	self attributes at: 'disabled' put: aBoolean.! !

!WATagBrush methodsFor: 'accessing' stamp: 'avi 6/13/2004 00:39'!
document
	^ canvas document! !

!WATagBrush methodsFor: 'public' stamp: 'pmm 9/12/2006 17:58'!
ensureId

	"Makes sure this tag has an id attribute and returns it.
	If it doesn't already have one, one is generated."

	| id |
	^self id ifNil: [
		id := canvas nextId.
		self id: id.
		id ]
! !

!WATagBrush methodsFor: 'accessing' stamp: 'pmm 10/12/2006 23:11'!
id

	"Convert to a String in case it was supplied as a Symbol"

	| idValue |
	idValue := self attributeAt: 'id'.
	^idValue ifNotNil: [ idValue asString ]
! !

!WATagBrush methodsFor: 'attributes' stamp: 'lr 10/12/2006 11:56'!
id: aString
	self attributeAt: 'id' put: aString! !

!WATagBrush methodsFor: 'javascript' stamp: 'ac 10/5/2005 00:16'!
ignoreURL
	^ self onClick: 'return false'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onBlur: aString
	"The onblur event occurs when an element loses focus either by the pointing device or by tabbing navigation."

	self attributes at: 'onblur' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onChange: aString
	"The onchange event occurs when a control loses the input focus and its value has been modified since gaining focus."

	self attributes at: 'onchange' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onClick: aString
	"The onclick event occurs when the pointing device button is clicked over an element."

	self attributes at: 'onclick' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onDoubleClick: aString
	"The ondblclick event occurs when the pointing device button is double clicked over an element."

	self attributes at: 'ondblclick' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'mb 10/10/2006 22:48'!
onEnter: aString
	self onKeyPress: 'if((window.event ? window.event.keyCode : event.which) == 13){', aString displayString, '; return false}; return true'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onError: aString
	self attributes at: 'onerror' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onFocus: aString
	"The onfocus event occurs when an element receives focus either by the pointing device or by tabbing navigation."

	self attributes at: 'onfocus' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onKeyDown: aString
	"The onkeydown event occurs when a key is pressed down over an element."

	self attributes at: 'onkeydown' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onKeyPress: aString
	"The onkeypress event occurs when a key is pressed and released over an element."

	self attributes at: 'onkeypress' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onKeyUp: aString
	"The onkeyup event occurs when a key is released over an element."

	self attributes at: 'onkeyup' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'mb 6/21/2006 18:28'!
onLoad: aString
	"The onload event occurs when the user agent finishes loading a window."

	self attributes at: 'onload' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onMouseDown: aString
	"The onmousedown event occurs when the pointing device button is pressed over an element."

	self attributes at: 'onmousedown' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onMouseMove: aString
	"The onmousemove event occurs when the pointing device is moved while it is over an element."

	self attributes at: 'onmousemove' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onMouseOut: aString
	"The onmouseout event occurs when the pointing device is moved away from an element."

	self attributes at: 'onmouseout' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onMouseOver: aString
	"The onmouseover event occurs when the pointing device is moved onto an element."

	self attributes at: 'onmouseover' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onMouseUp: aString
	"The onmouseup event occurs when the pointing device button is released over an element."

	self attributes at: 'onmouseup' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:49'!
onReset: aString
	"The onreset event occurs when a form is reset."

	self attributes at: 'onreset' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:49'!
onResize: aString
	self attributes at: 'onresize' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:49'!
onScroll: aString
	self attributes at: 'onscroll' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:49'!
onSelect: aString
	"The onselect event occurs when a user selects some text in a text field."

	self attributes at: 'onselect' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:49'!
onSubmit: aString
	"The onsubmit event occurs when a form is submitted."

	self attributes at: 'onsubmit' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:49'!
onUnload: aString
	"The onunload event occurs when the user agent removes a document from a window."

	self attributes at: 'onunload' append: aString separator: ';'! !

!WATagBrush methodsFor: 'private' stamp: 'mb 3/16/2006 23:18'!
openTag
	self document openTag: self tag attributes: attributes.! !

!WATagBrush methodsFor: 'public' stamp: 'avi 3/18/2005 22:10'!
section: aSymbol
	self class: (canvas painter classForSection: aSymbol).
	self with: [canvas painter perform: aSymbol with: canvas]! !

!WATagBrush methodsFor: 'attributes' stamp: 'mb 2/19/2006 16:26'!
style: aString
	self attributes addStyle: aString! !

!WATagBrush methodsFor: 'accessing' stamp: 'avi 6/13/2004 00:30'!
tag
	self subclassResponsibility! !

!WATagBrush methodsFor: 'attributes' stamp: 'pmm 9/18/2006 19:03'!
title: aString
	self attributeAt: 'title' put: aString! !

!WATagBrush methodsFor: 'public' stamp: 'mb 3/23/2006 08:57'!
with: aBlock
	self openTag.
	super with: [self within: aBlock].
	self closeTag.
! !

!WATagBrush methodsFor: 'convenience' stamp: 'avi 3/16/2006 12:20'!
withLineBreaks: aString
	self with: [canvas withLineBreaks: aString]! !

!WATagBrush methodsFor: 'private' stamp: 'ac 4/13/2005 00:44'!
within: aBlock
	self before.
	aBlock renderOn: canvas.
	self after.! !

Object subclass: #WACachedDocument
	instanceVariableNames: 'fullFileName mimeDocument mimeType'
	classVariableNames: 'Cache'
	poolDictionaries: ''
	category: 'Seaside-Document'!

!WACachedDocument commentStamp: '<historical>' prior: 0!
This class is for serving smallish files like PNG images etc using WADocumentHandler. Using the Canvas API for HTML generation you simply do this:

	html image fileName: 'myimage.png'

or:

	html image fileName: 'myimage.blurp' mimeType: 'blurp'

This will create a request handler in your WAApplication registry that is accessible on a unique URL and does not expire.
The actual contents of the file will only be read upon first access, we could augment this class with smarter caching, like checking the modification time on disk.

The class has a Cache class var holding a Dictionary of created instances so you can clear and preload files into the image using:

	WACachedDocument
		clearCache;
		fileName: 'myimage.png';
		fileName: 'another.gif'; "etc"
		preloadCache!

!WACachedDocument class methodsFor: 'cache' stamp: 'gk 1/19/2006 08:15'!
clearCache
	"Clear the cache of instances. This will cause
	the files to be lazily reread from disk."

	Cache := Dictionary new! !

!WACachedDocument class methodsFor: 'instance-creation' stamp: 'gk 1/12/2006 14:17'!
fileName: aFileName
	"Check the cache to see if we already have this file loaded.
	We only rely on the local filename!!"

	^Cache at: aFileName ifAbsentPut: [self fullFileName: aFileName]! !

!WACachedDocument class methodsFor: 'instance-creation' stamp: 'gk 1/10/2006 13:22'!
fullFileName: fullFileName

	^self new fullFileName: fullFileName! !

!WACachedDocument class methodsFor: 'initialize-release' stamp: 'gk 1/12/2006 14:05'!
initialize
	self clearCache! !

!WACachedDocument class methodsFor: 'cache' stamp: 'gk 1/19/2006 08:14'!
preloadCache
	"Load the files into the image for the currently
	created instances in the Cache."

	Cache valuesDo: [:d | d asMIMEDocument ]! !

!WACachedDocument methodsFor: 'comparing' stamp: 'gk 1/10/2006 13:13'!
= other
	"Currently we do not take file modification time on disk into account."

	^other species = self species and: [other fullFileName = fullFileName]! !

!WACachedDocument methodsFor: 'public' stamp: 'mb 6/2/2006 10:49'!
asMIMEDocument
	^self asMIMEDocumentType: mimeType! !

!WACachedDocument methodsFor: 'public' stamp: 'mb 6/2/2006 10:49'!
asMIMEDocumentType: type
	"Lazy caching."
	^mimeDocument ifNil: [
		mimeType := type.
		mimeDocument := SeasidePlatformSupport
				mimeDocumentOfType: mimeType 
				from: fullFileName].
	! !

!WACachedDocument methodsFor: 'accessing' stamp: 'gk 1/10/2006 11:19'!
fullFileName
	^fullFileName! !

!WACachedDocument methodsFor: 'initialize-release' stamp: 'gk 1/10/2006 11:12'!
fullFileName: aFileName
	fullFileName := aFileName
	! !

!WACachedDocument methodsFor: 'comparing' stamp: 'gk 1/10/2006 13:14'!
hash
	"Currently we do not take file modification time on disk into account.
	Note that mimeType and mimeDocument are set lazily later, so we can't use
	the mimeType in the hash."

	^fullFileName hash! !

!WACachedDocument methodsFor: 'accessing' stamp: 'gk 1/10/2006 11:18'!
mimeType
	^mimeType! !

!WACachedDocument methodsFor: 'accessing' stamp: 'gk 1/10/2006 11:14'!
mimeType: anObject
	^mimeType := anObject! !

Object subclass: #WACallback
	instanceVariableNames: 'context owner key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

WACallback subclass: #WAActionCallback
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WAActionCallback methodsFor: 'accessing' stamp: 'avi 9/19/2006 14:31'!
block: aZeroArgBlock
	block := aZeroArgBlock fixCallbackTemps.! !

!WAActionCallback methodsFor: 'as yet unclassified' stamp: 'avi 6/8/2004 01:51'!
evaluateWithArgument: anObject
	block value.
	self signalRenderNotification! !

!WAActionCallback methodsFor: 'testing' stamp: 'avi 6/7/2004 22:41'!
isFinal
	^ true! !

!WAActionCallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 22:37'!
priority
	^ 8! !

!WAActionCallback methodsFor: 'as yet unclassified' stamp: 'rjl 4/16/2006 15:56'!
signalRenderNotification 
	WARenderNotification raiseSignal! !

WAActionCallback subclass: #WACancelActionCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WACancelActionCallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 22:37'!
priority
	^ 3! !

WAActionCallback subclass: #WADefaultActionCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WADefaultActionCallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 22:37'!
priority
	^ 10! !

WAActionCallback subclass: #WAImageCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WAImageCallback methodsFor: 'as yet unclassified' stamp: 'avi 9/2/2004 14:46'!
convertKey: aString
	^ aString, '.x'! !

!WACallback methodsFor: 'comparing' stamp: 'avi 6/7/2004 22:38'!
<= other
	^ self priority < other priority or: [self priority = other priority and: [self key asNumber <= other key asNumber]]! !

!WACallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 21:48'!
context
	^ context! !

!WACallback methodsFor: 'as yet unclassified' stamp: 'avi 9/2/2004 14:46'!
convertKey: aString
	^ aString! !

!WACallback methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 21:49'!
evaluateWithArgument: anObject
	self subclassResponsibility! !

!WACallback methodsFor: 'as yet unclassified' stamp: 'avi 6/8/2004 01:52'!
evaluateWithField: anObject 
	self evaluateWithArgument: (self valueForField: anObject)! !

!WACallback methodsFor: 'accessing' stamp: 'avi 9/2/2004 14:46'!
key
	^ (self convertKey: key)! !

!WACallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 21:48'!
owner
	^ owner! !

!WACallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 22:17'!
priority
	self subclassResponsibility ! !

!WACallback methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 22:39'!
setContext: aRenderingContext owner: anObject key: aString
	context := aRenderingContext.
	owner := anObject.
	key := aString! !

!WACallback methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 21:51'!
valueForField: anObject
	^ anObject
		ifNil: ['']
		ifNotNil:
			[(anObject isCollection and: [anObject isString not])
					ifTrue: [anObject isEmpty
								ifTrue: ['']
								ifFalse: [anObject first]]
					ifFalse: [anObject]]! !

WACallback subclass: #WADispatchCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WADispatchCallback methodsFor: 'as yet unclassified' stamp: 'lr 4/19/2006 08:05'!
evaluateWithArgument: anObject
	(context callbackAt: anObject) 
		ifNotNilDo: [ :callback | callback evaluateWithArgument: nil ]! !

!WADispatchCallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 22:42'!
priority
	^ 5! !

WADispatchCallback subclass: #WAMultiDispatchCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WAMultiDispatchCallback methodsFor: 'as yet unclassified' stamp: 'lr 10/10/2005 19:56'!
evaluateWithField: anObject
	(anObject isCollection and: [ anObject isString not ]) 
		ifFalse: [ ^ super evaluateWithField: anObject ].
	anObject do: [ :each | 
		self evaluateWithArgument: (self valueForField: each) ].! !

WACallback subclass: #WAValueCallback
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WAValueCallback methodsFor: 'accessing' stamp: 'avi 9/19/2006 14:29'!
block: aOneArgBlock
	block := aOneArgBlock fixCallbackTemps! !

!WAValueCallback methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 22:17'!
evaluateWithArgument: anObject
	block valueWithPossibleArgs: (Array with: anObject)! !

!WAValueCallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 22:41'!
priority
	^ 5! !

Object subclass: #WACallbackRegistry
	instanceVariableNames: 'context owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WACallbackRegistry class methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 22:04'!
context: aContext owner: anObject
	^ self basicNew initializeWithContext: aContext owner: anObject! !

!WACallbackRegistry methodsFor: 'initialization' stamp: 'avi 6/7/2004 22:04'!
initializeWithContext: aContext owner: anObject
	context := aContext.
	owner := anObject! !

!WACallbackRegistry methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 22:10'!
registerActionCallback: aBlock
	^ self storeCallback: (WAActionCallback new block: aBlock)! !

!WACallbackRegistry methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 22:10'!
registerCallback: aBlock
	^ self storeCallback: (WAValueCallback new block: aBlock)! !

!WACallbackRegistry methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 22:41'!
registerCancelActionCallback: aBlock
	^ self storeCallback: (WACancelActionCallback new block: aBlock)! !

!WACallbackRegistry methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 22:41'!
registerDefaultActionCallback: aBlock
	^ self storeCallback: (WADefaultActionCallback new block: aBlock)! !

!WACallbackRegistry methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 22:10'!
registerDispatchCallback
	^ self storeCallback: WADispatchCallback new! !

!WACallbackRegistry methodsFor: 'as yet unclassified' stamp: 'avi 9/2/2004 14:42'!
registerImageCallback: aBlock
	^ self storeCallback: (WAImageCallback new block: aBlock)! !

!WACallbackRegistry methodsFor: 'as yet unclassified' stamp: 'lr 10/10/2005 20:00'!
registerMultiDispatchCallback
	^ self storeCallback: WAMultiDispatchCallback new! !

!WACallbackRegistry methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 22:43'!
storeCallback: aCallback
	| key |
	key := context storeCallback: aCallback.
	aCallback setContext: context owner: owner key: key.
	^ key
! !

Object subclass: #WACallbackStream
	instanceVariableNames: 'callbacks request'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WACallbackStream class methodsFor: 'as yet unclassified' stamp: 'avi 6/8/2004 01:58'!
callbacks: aDictionary request: aRequest
	^ self basicNew initializeWithCallbacks: aDictionary request: aRequest! !

!WACallbackStream methodsFor: 'testing' stamp: 'avi 6/8/2004 01:59'!
atEnd
	^ callbacks atEnd! !

!WACallbackStream methodsFor: 'initialization' stamp: 'lr 9/26/2005 14:10'!
initializeWithCallbacks: aDictionary request: aRequest
	| collection |
	collection := SortedCollection new.
	aRequest fields keys do:
		[:ea |
		aDictionary at: ea ifPresent: [:callback | collection add: callback]].
	callbacks := ReadStream on: collection asArray.
	request := aRequest! !

!WACallbackStream methodsFor: 'accessing' stamp: 'avi 6/8/2004 01:59'!
position
	^ callbacks position! !

!WACallbackStream methodsFor: 'as yet unclassified' stamp: 'avi 6/12/2004 00:21'!
processCallbacksWithOwner: anObject
	| callback |
	[callbacks atEnd not and: [callbacks peek owner == anObject]] whileTrue:
		[callback := callbacks next.
		callback evaluateWithField: (request fields at: callback key)]! !

!WACallbackStream methodsFor: 'accessing' stamp: 'avi 6/12/2004 00:25'!
upToEnd
	^ callbacks upToEnd! !

Object subclass: #WACanvas
	instanceVariableNames: 'currentBrush parentBrush painter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WACanvas methodsFor: 'public api' stamp: 'avi 6/17/2004 12:36'!
brush: aBrush
	self flush.
	currentBrush := aBrush.
	aBrush setParent: parentBrush canvas: self.
	^ aBrush! !

!WACanvas methodsFor: 'private' stamp: 'avi 6/17/2004 12:12'!
flush
	currentBrush ifNotNil:
		[currentBrush close.
		currentBrush := nil]! !

!WACanvas methodsFor: 'private' stamp: 'mb 1/30/2006 18:12'!
forgetCurrentBrush
	currentBrush := nil.! !

!WACanvas methodsFor: 'private' stamp: 'avi 9/21/2005 23:19'!
insert: aBlock
	| oldBrush |
	oldBrush := currentBrush.
	currentBrush := nil.
	aBlock value.
	currentBrush := oldBrush! !

!WACanvas methodsFor: 'private' stamp: 'avi 6/17/2004 12:37'!
nest: aBlock
	parentBrush := currentBrush.
	currentBrush := nil.
	aBlock renderOn: self.
	self flush.
	parentBrush := parentBrush parent.
! !

!WACanvas methodsFor: 'accessing' stamp: 'avi 3/18/2005 21:56'!
painter
	^ painter! !

!WACanvas methodsFor: 'accessing' stamp: 'avi 3/18/2005 21:56'!
painter: anObject
	painter := anObject! !

!WACanvas methodsFor: 'public api' stamp: 'pmm 10/15/2006 11:33'!
render: anObject
	self flush.
	anObject renderOn: self! !

WACanvas subclass: #WAHtmlCanvas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WAHtmlCanvas class methodsFor: 'as yet unclassified' stamp: 'ac 7/9/2005 04:31'!
generateBinaryFor: aCollection
	(aCollection size = 3 and: [(self includesSelector: aCollection third) not]) ifTrue:
		[self 
			compile: aCollection third, ' aBlock
	self ', aCollection second, ' with: aBlock'
			classified: self generatedCategory].
! !

!WAHtmlCanvas class methodsFor: 'as yet unclassified' stamp: 'mb 3/16/2006 16:04'!
generateTags
	"((( WAHtmlCanvas generateTags )))"
	self tags do:
		[:spec |
		self generateUnaryFor: spec.
		self generateBinaryFor: spec].! !

!WAHtmlCanvas class methodsFor: 'as yet unclassified' stamp: 'ac 7/9/2005 04:29'!
generateUnaryFor: aCollection
	(self includesSelector: aCollection second) ifFalse:
		[self 
			compile: aCollection second, '
	^ self ', (self patternFor: aCollection first)
			classified: self generatedCategory]! !

!WAHtmlCanvas class methodsFor: 'as yet unclassified' stamp: 'ac 7/9/2005 04:30'!
generatedCategory
	^ 'html-generated'! !

!WAHtmlCanvas class methodsFor: 'as yet unclassified' stamp: 'mb 3/16/2006 16:04'!
patternFor: aString
	WATagBrush allSubclassesDo:
		[:each | each tag = aString
			ifTrue: [^ 'brush: ', each name, ' new']].
	^ 'tag: ', aString printString! !

!WAHtmlCanvas class methodsFor: 'accessing' stamp: 'lr 11/16/2006 15:36'!
tags
	"
	self generateTags
	"

	^ #(
		('a' anchor)
		('iframe' iframe)

		
		('p' paragraph paragraph:)
		('div' div div:)
		('span' span span:)

		('blockquote' blockquote blockquote:)
		('address' address address:)
		('dd' definitionData definitionData:)
		('dl' definitionList definitionList:)
		('dt' definitionTerm definitionTerm:)

		('code' code code:)
		('pre' preformatted preformatted:)
		('em' emphasis emphasis:)
		('small' small small:)
		('big' big big:)
		('strong' strong strong:)
		('label' label label:)
		('legend' legend legend:)
		('fieldset' fieldSet fieldSet:)
		
		('abbr' abbreviated abbreviated:)
		('acronym' acronym acronym:)
		('code' code code:)
		('cite' citation citation:)
		('dfn' definition definition:)
		('samp' sampleOutput sampleOutput:)
		('kbd' keyboardInput keyboardInput:)
		('q' quote quote:)
		('var' variable variable:)
						
		('ul' unorderedList unorderedList:)
		('ol' orderedList orderedList:)
		('li' listItem listItem:)
		
		('br' break)
		('hr' horizontalRule)
		
		('form' form form:)
		('img' image image:)
		
		('table' table table:)
		('th' tableHeading tableHeading:)
		('tr' tableRow tableRow:)
		('td' tableData tableData:)
		('tbody' tableBody tableBody:)
		('thead' tableHead tableHead:)
		('tfoot' tableFoot tableFoot:)
		
		('script' script script:)
		
		('ruby' ruby ruby:)
		('rbc' rubyBaseContainer rubyBaseContainer:)
		('rtc' rubyTextContainer rubyTextContainer:)
		('rb' rubyBase rubyBase:)
		('rt' rubyText rubyText:)
		('rp' rubyParentheses rubyParentheses:)
		)! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 9/30/2006 20:07'!
abbreviated
	"abbreviations like 'M.', 'Inc.', 'et al.', 'etc.'"
	^ self tag: 'abbr'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 9/30/2006 20:06'!
abbreviated: aBlock
	self abbreviated with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 9/30/2006 20:07'!
acronym
	"acronyms such as 'GmbH', 'NATO', and 'F.B.I.', "
	^ self tag: 'acronym'
! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 3/24/2006 13:42'!
acronym: aBlock
	self acronym with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 12/24/2005 17:43'!
address
	^ self tag: 'address'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 12/24/2005 17:44'!
address: aBlock
	self address with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'dwj 6/11/2005 06:04'!
anchor
	^ self brush: WAAnchorTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'ac 2/21/2006 14:36'!
big
	^ self tag: 'big'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'ac 2/21/2006 14:36'!
big: aBlock
	self big with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
blockquote
	^ self tag: 'blockquote'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
blockquote: aBlock
	self blockquote with: aBlock! !

!WAHtmlCanvas methodsFor: 'deprecated' stamp: 'lr 11/16/2006 15:34'!
bold
	self deprecatedApi.
	^ self tag: 'b'! !

!WAHtmlCanvas methodsFor: 'deprecated' stamp: 'lr 11/16/2006 19:03'!
bold: aBlock
	self deprecatedApi.
	self bold with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
break
	^ self tag: 'br'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'lr 5/18/2006 08:55'!
canvas
	^ self brush: WACanvasTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'lr 5/18/2006 08:55'!
canvas: aBlock
	^ self canvas with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 9/30/2006 20:06'!
citation
	^ self tag: 'cite'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 9/30/2006 20:06'!
citation: aBlock
	self citation with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
code
	^ self tag: 'code'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
code: aBlock
	self code with: aBlock! !

!WAHtmlCanvas methodsFor: 'public api' stamp: 'lr 10/3/2006 08:51'!
comment: aString
	self flush.
	self document comment: aString displayString
! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 9/30/2006 20:06'!
definition
	^ self tag: 'dfn'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 9/30/2006 20:06'!
definition: aBlock
	self definition with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 5/31/2006 20:26'!
definitionData
	^ self tag: 'dd'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 5/31/2006 20:26'!
definitionData: aBlock
	self definitionData with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 12/24/2005 17:39'!
definitionList
	^ self tag: 'dl'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 12/24/2005 17:42'!
definitionList: aBlock
	self definitionList with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 12/24/2005 17:42'!
definitionTerm
	^ self tag: 'dt'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 12/24/2005 17:42'!
definitionTerm: aBlock
	self definitionTerm with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
div
	^ self brush: WADivTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
div: aBlock
	self div with: aBlock! !

!WAHtmlCanvas methodsFor: 'accessing' stamp: 'avi 6/13/2004 00:57'!
document
	self subclassResponsibility! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 3/8/2006 17:14'!
emphasis
	^ self tag: 'em'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 3/8/2006 17:14'!
emphasis: aBlock
	self emphasis with: aBlock! !

!WAHtmlCanvas methodsFor: 'encoding' stamp: 'mb 1/5/2006 18:27'!
encode: anObject
	"This is needed by the SeasideAsync package"
	^WAAbstractHtmlBuilder encode: anObject! !

!WAHtmlCanvas methodsFor: 'encoding' stamp: 'mbany 4/14/2005 12:26'!
encodeCharacter: aCharacter
	self html: ('&#', aCharacter asInteger displayString, ';').  ! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'ac 2/21/2006 17:15'!
fieldSet
	^ self brush: WAFieldSetTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 3/24/2006 13:45'!
fieldSet: aBlock
	self fieldSet with: aBlock! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'avi 1/9/2006 21:56'!
form
	^ self tag: 'form'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
form: aBlock
	self form with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'ac 3/16/2005 14:14'!
heading
	^ self brush: WAHeadingTag new! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'ac 3/16/2005 14:14'!
heading: aBlock
	self heading with: aBlock! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'pmm 12/24/2005 17:38'!
heading: aBlock level: aNumber
	self heading
		level: aNumber;
		with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
horizontalRule
	^ self tag: 'hr'! !

!WAHtmlCanvas methodsFor: 'public api' stamp: 'lr 10/3/2006 08:51'!
html: aString
	self flush.
	self document text: aString displayString
! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/8/2006 10:56'!
iframe
	^ self brush: WAIframeTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'ac 3/16/2005 12:01'!
image
	^ self brush: WAImageTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 3/24/2006 13:51'!
image: aBlock
	self image with: aBlock! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'lr 9/14/2005 22:22'!
imageForm: aForm
	self image form: aForm.! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'mb 9/12/2006 10:28'!
imageMap
	^ self brush: WAImageMapTag new! !

!WAHtmlCanvas methodsFor: 'deprecated' stamp: 'lr 11/16/2006 15:34'!
italic
	self deprecatedApi.
	^ self tag: 'i'! !

!WAHtmlCanvas methodsFor: 'deprecated' stamp: 'lr 11/16/2006 19:03'!
italic: aBlock
	self deprecatedApi.
	self italic with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 9/30/2006 20:15'!
keyboardInput
	^ self tag: 'kbd'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 9/30/2006 20:06'!
keyboardInput: aBlock
	self keyboardInput with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'ac 7/9/2005 04:37'!
label
	^ self brush: WALabelTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
label: aBlock
	self label with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 3/8/2006 17:59'!
legend
	^ self tag: 'legend'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 3/8/2006 18:00'!
legend: aBlock
	self legend with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
listItem
	^ self tag: 'li'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
listItem: aBlock
	self listItem with: aBlock! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'lr 9/25/2005 11:52'!
orderedList
	^ self brush: WAListTag new beOrdered.! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'lr 9/25/2005 11:52'!
orderedList: aBlock
	self orderedList with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
paragraph
	^ self tag: 'p'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
paragraph: aBlock
	self paragraph with: aBlock! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'ac 7/3/2005 15:46'!
popupAnchor
	^ self brush: WAPopupAnchorTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
preformatted
	^ self tag: 'pre'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
preformatted: aBlock
	self preformatted with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 9/30/2006 20:06'!
quote
	^ self tag: 'q'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 9/30/2006 20:06'!
quote: aBlock
	self quote with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 9/21/2006 16:26'!
ruby
	^ self tag: 'ruby'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 9/21/2006 16:26'!
ruby: aBlock
	self ruby with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 9/21/2006 16:26'!
rubyBase
	^ self tag: 'rb'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 9/21/2006 16:26'!
rubyBase: aBlock
	self rubyBase with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 9/21/2006 16:26'!
rubyBaseContainer
	^ self tag: 'rbc'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 9/21/2006 16:26'!
rubyBaseContainer: aBlock
	self rubyBaseContainer with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 9/21/2006 16:26'!
rubyParentheses
	^ self tag: 'rp'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 9/21/2006 16:26'!
rubyParentheses: aBlock
	self rubyParentheses with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 9/21/2006 16:26'!
rubyText
	^ self brush: WARubyTextTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 9/21/2006 16:26'!
rubyText: aBlock
	self rubyText with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 9/21/2006 16:26'!
rubyTextContainer
	^ self tag: 'rtc'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 9/21/2006 16:26'!
rubyTextContainer: aBlock
	self rubyTextContainer with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 9/30/2006 20:06'!
sampleOutput
	^ self tag: 'samp'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 9/30/2006 20:06'!
sampleOutput: aBlock
	self sampleOutput with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 3/24/2006 13:53'!
script
	^ self brush: WAScriptTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
script: aBlock
	self script with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
small
	^ self tag: 'small'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
small: aBlock
	self small with: aBlock! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'mb 10/31/2006 16:13'!
space
	self html: self spaceEntity! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'mb 2/6/2006 10:48'!
space: n
	n timesRepeat: [self space].
! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'mb 11/4/2006 10:23'!
spaceEntity
	"To be subclassed as needed"
	^'&nbsp;'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
span
	^ self tag: 'span'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
span: aBlock
	self span with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'ac 3/20/2005 01:24'!
strong
	^ self tag: 'strong'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'ac 3/20/2005 01:24'!
strong: aBlock
	self strong with: aBlock! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'avi 1/9/2006 22:05'!
submitButton
	^ self brush: WASubmitButtonTag new.! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
table
	^ self brush: WATableTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
table: aBlock
	self table with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableBody
	^ self tag: 'tbody'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableBody: aBlock
	self tableBody with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableData
	^ self brush: WATableDataTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableData: aBlock
	self tableData with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableFoot
	^ self tag: 'tfoot'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableFoot: aBlock
	self tableFoot with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableHead
	^ self tag: 'thead'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableHead: aBlock
	self tableHead with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'ac 3/17/2005 22:10'!
tableHeading
	^ self brush: WATableHeadingTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'ac 3/16/2005 16:15'!
tableHeading: aBlock
	self tableHeading with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableRow
	^ self tag: 'tr'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableRow: aBlock
	self tableRow with: aBlock! !

!WAHtmlCanvas methodsFor: 'public api' stamp: 'avi 6/17/2004 12:19'!
tag: aString
	^ self brush: (WAGenericTag tag: aString)! !

!WAHtmlCanvas methodsFor: 'public api' stamp: 'lr 6/14/2006 08:05'!
text: anObject
	self html: (self encode: anObject)! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'avi 1/9/2006 22:07'!
textInput
	^ self brush: WATextInputTag new! !

!WAHtmlCanvas methodsFor: 'deprecated' stamp: 'lr 11/16/2006 15:34'!
underline
	self deprecatedApi.
	^ self tag: 'u'! !

!WAHtmlCanvas methodsFor: 'deprecated' stamp: 'lr 11/16/2006 19:03'!
underline: aBlock
	self deprecatedApi.
	self underline with: aBlock! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'lr 9/25/2005 11:51'!
unorderedList
	^ self brush: WAListTag new beUnordered.! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
unorderedList: aBlock
	self unorderedList with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 9/30/2006 20:06'!
variable
	^ self tag: 'var'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 9/30/2006 20:06'!
variable: aBlock
	self variable with: aBlock! !

!WAHtmlCanvas methodsFor: 'encoding' stamp: 'avi 2/17/2006 20:36'!
withLineBreaks: aString
	| stream |
	stream := aString readStream.
	[stream atEnd] whileFalse:
		[self text: stream nextLine.
		stream atEnd ifFalse: [self break]]! !

!WAHtmlCanvas methodsFor: 'encoding' stamp: 'avi 6/23/2006 10:16'!
withLineBreaksAndUrls: aString
	| stream |
	aString ifNil: [^ self].
	stream := aString readStream.
	[stream atEnd] whileFalse:
		[self withUrls: stream nextLine.
		stream atEnd ifFalse: [self break]]! !

!WAHtmlCanvas methodsFor: 'encoding' stamp: 'lr 11/16/2006 18:12'!
withUrls: aString
	| stream url |
	stream := aString readStream.
	[stream atEnd] whileFalse:
		[self text: (stream upToAll: 'http://').
		stream atEnd ifFalse:
			[url := 'http://', (stream upTo: $ ).
			self anchor url: url; with: url.
			self text: ' ']]! !

WAHtmlCanvas subclass: #WARenderCanvas
	instanceVariableNames: 'context callbacks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WARenderCanvas class methodsFor: 'as yet unclassified' stamp: 'avi 6/13/2004 00:59'!
context: aRenderingContext callbacks: aCallbackStore
	^ self basicNew initializeWithContext: aRenderingContext callbacks: aCallbackStore! !

!WARenderCanvas methodsFor: 'form-buttons' stamp: 'lr 9/23/2005 18:07'!
button
	^ self brush: WAButtonTag new.! !

!WARenderCanvas methodsFor: 'accessing' stamp: 'avi 6/13/2004 01:01'!
callbacks
	^ callbacks! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'avi 4/28/2005 14:01'!
checkbox
	^ self brush: WACheckboxTag new	! !

!WARenderCanvas methodsFor: 'private' stamp: 'avi 7/5/2004 11:56'!
close
	self flush.! !

!WARenderCanvas methodsFor: 'accessing' stamp: 'avi 6/13/2004 01:01'!
context
	^ context! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'mb 2/6/2006 10:09'!
dateInput
	^ self brush: WADateInput new! !

!WARenderCanvas methodsFor: 'accessing' stamp: 'avi 6/13/2004 01:08'!
document
	^ self context document! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'avi 6/8/2005 21:49'!
fileUpload
	^ self brush: WAFileUploadTag new	! !

!WARenderCanvas methodsFor: 'form-buttons' stamp: 'avi 1/9/2006 21:52'!
form
	^ self brush: WAFormTag new! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'lr 9/23/2005 18:09'!
hiddenInput
	^ self brush: WAHiddenInputTag new.! !

!WARenderCanvas methodsFor: 'form-buttons' stamp: 'lr 9/14/2005 22:01'!
imageButton
	^ self brush: WAImageButtonTag new.! !

!WARenderCanvas methodsFor: 'initialize-release' stamp: 'avi 6/13/2004 01:01'!
initializeWithContext: aRenderingContext callbacks: aCallbackStore
	context := aRenderingContext.
	callbacks := aCallbackStore! !

!WARenderCanvas methodsFor: 'public api' stamp: 'lr 3/28/2006 20:16'!
nextId
	^ 'id' , context advanceKey! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 3/17/2005 17:13'!
option
	^ self brush: WAOptionTag new.! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 3/17/2005 17:14'!
option: aBlock
	^ self option with: aBlock! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'lr 9/23/2005 18:09'!
passwordInput
	^ self brush: WAPasswordInputTag new.! !

!WARenderCanvas methodsFor: 'public api' stamp: 'mb 3/31/2006 11:38'!
peekNextId
	^ 'id' , context nextKey! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 7/6/2005 10:45'!
radioButton
	^ self brush: WARadioButtonTag new.! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 7/6/2005 10:46'!
radioButton: aBlock
	^ self radioButton with: aBlock! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 7/6/2005 11:29'!
radioGroup
	^ WARadioGroup canvas: self! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 7/6/2005 10:44'!
radioGroup: aBlock
	^ aBlock value: self radioGroup! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 3/17/2005 17:15'!
select
	^ self brush: WASelectTag new	! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 3/22/2005 17:50'!
textArea
	^ self brush: WATextAreaTag new! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'mb 2/6/2006 10:10'!
timeInput
	^ self brush: WATimeInput new! !

WAHtmlCanvas subclass: #WAStaticHtmlCanvas
	instanceVariableNames: 'document'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WAStaticHtmlCanvas class methodsFor: 'instance creation' stamp: 'avi 9/10/2005 17:20'!
document: aDocument
	^ self basicNew initializeWithDocument: aDocument! !

!WAStaticHtmlCanvas class methodsFor: 'instance creation' stamp: 'avi 9/10/2005 17:28'!
root: anHtmlRoot
	^ self document: (WAHtmlStreamDocument root: anHtmlRoot)! !

!WAStaticHtmlCanvas methodsFor: 'accessing' stamp: 'avi 9/10/2005 17:20'!
document
	^ document! !

!WAStaticHtmlCanvas methodsFor: 'accessing' stamp: 'ac 6/9/2006 12:42'!
document: aDocument
	document := aDocument! !

!WAStaticHtmlCanvas methodsFor: 'initialize-release' stamp: 'avi 9/10/2005 17:20'!
initializeWithDocument: aDocument
	document := aDocument! !

!WAStaticHtmlCanvas methodsFor: 'form-elements' stamp: 'ac 6/10/2006 18:52'!
textArea
	^ self brush: WATextAreaTag new! !

Object subclass: #WAClosingConditionalComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document-Elements'!

!WAClosingConditionalComment methodsFor: 'writing' stamp: 'pmm 10/11/2006 17:11'!
writeOn: aStream
	aStream nextPutAll: '<!![endif]-->'.! !

Object subclass: #WAConditionalComment
	instanceVariableNames: 'condition root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document-Elements'!

!WAConditionalComment class methodsFor: 'instance creation' stamp: 'pmm 10/11/2006 17:37'!
root: anHtmlRoot
	^self new initializeWithRoot: anHtmlRoot! !

!WAConditionalComment methodsFor: 'private' stamp: 'pmm 10/11/2006 17:13'!
addToCondition: aString
	condition := condition, aString! !

!WAConditionalComment methodsFor: 'flow-control' stamp: 'pmm 10/11/2006 17:46'!
do: aBlock
	root addHeadElement: (WAOpeningConditionalComment condition: condition).
	aBlock value.
	root addHeadElement: (WAClosingConditionalComment new).! !

!WAConditionalComment methodsFor: 'operators' stamp: 'pmm 10/11/2006 17:19'!
equal
	"implicit of nothing else"! !

!WAConditionalComment methodsFor: 'operators' stamp: 'pmm 10/11/2006 17:14'!
greaterThan
	self addToCondition: ' gt'! !

!WAConditionalComment methodsFor: 'operators' stamp: 'lr 11/16/2006 19:11'!
greaterThanOrEqual
	self deprecatedApi.
	self greaterThan; orEqual! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 10/11/2006 17:16'!
ie
	self addToCondition: ' IE'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 10/11/2006 17:16'!
ie5
	self addToCondition: ' IE 5'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 10/11/2006 17:16'!
ie50
	self addToCondition: ' IE 5.0'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 10/11/2006 17:16'!
ie55
	self addToCondition: ' IE 5.5'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 10/11/2006 17:16'!
ie6
	self addToCondition: ' IE 6'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 10/11/2006 17:16'!
ie7
	self addToCondition: ' IE 7'! !

!WAConditionalComment methodsFor: 'initialize-release' stamp: 'pmm 10/11/2006 17:36'!
initializeWithRoot: anHtmlRoot
	root := anHtmlRoot.
	condition := 'if'! !

!WAConditionalComment methodsFor: 'operators' stamp: 'pmm 10/11/2006 17:15'!
lessThan
	self addToCondition: ' lt'! !

!WAConditionalComment methodsFor: 'operators' stamp: 'lr 11/16/2006 19:11'!
lessThanOrEqual
	self deprecatedApi.
	self lessThan; orEqual! !

!WAConditionalComment methodsFor: 'operators' stamp: 'pmm 10/19/2006 20:19'!
orEqual
	self addToCondition: 'e'! !

Object subclass: #WAConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WAConfiguration class methodsFor: 'instance creation' stamp: 'avi 1/30/2004 16:39'!
new
	^ self basicNew initialize! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/5/2004 16:27'!
addAncestorsTo: tempCollection linearization: linearCollection
	(linearCollection includes: self)
		ifTrue: [tempCollection do: [:ea | linearCollection add: ea before: self].
				tempCollection removeAllSuchThat: [:ea | true]]
		ifFalse: [tempCollection add: self.
				self ancestors isEmpty
					ifTrue: [linearCollection addAll: tempCollection.
							tempCollection removeAllSuchThat: [:ea | true]]
					ifFalse: [self ancestors do: [:ea | ea addAncestorsTo: tempCollection linearization: linearCollection]]]! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/5/2004 17:16'!
allAncestors
	| temp linear |
	temp := OrderedCollection new.
	linear := OrderedCollection new.
	self addAncestorsTo: temp linearization: linear.
	^ linear allButFirst asArray! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/5/2004 17:16'!
allAncestorsDo: aBlock
	self allAncestors do: aBlock! !

!WAConfiguration methodsFor: 'attributes' stamp: 'avi 2/1/2004 14:53'!
allAttributes
	^ Array streamContents:
		[:s | 
		self withAllAncestorsDo: [:ea | s nextPutAll: ea attributes]]
! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 3/24/2004 11:59'!
allPotentialAncestors
	^ #()! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/2/2004 14:43'!
ancestors
	^ #()! !

!WAConfiguration methodsFor: 'attributes' stamp: 'avi 2/1/2004 14:54'!
attributeNamed: aSymbol
	^ self allAttributes
		detect: [:ea | ea key = aSymbol]
		ifNone: [self error: 'No attribute named ', aSymbol printString]
! !

!WAConfiguration methodsFor: 'attributes' stamp: 'jf 2/1/2004 17:34'!
attributes
	^ #()! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 1/30/2004 16:32'!
attributesAndValuesDo: keyValueBlock
	^ self allAttributes do:
		[:ea |
		keyValueBlock value: ea value: (self valueForAttribute: ea)]! !

!WAConfiguration methodsFor: 'attributes' stamp: 'avi 2/5/2004 13:21'!
groupedAttributes
	| dict sorted |
	dict := Dictionary new.
	sorted := SortedCollection sortBlock: [:a :b | a key <= b key].
	self allAttributes do:
		[:ea |
		(dict at: ea group ifAbsentPut: [SortedCollection sortBlock: [:a :b | a key <= b key]])
			add: ea].
	dict associationsDo:
		[:assoc |
		sorted add: assoc].
	^ sorted
		! !

!WAConfiguration methodsFor: 'testing' stamp: 'avi 1/30/2004 16:21'!
hasAttributeNamed: aSymbol
	^ self allAttributes anySatisfy: [:ea | ea key = aSymbol]! !

!WAConfiguration methodsFor: 'testing' stamp: 'avi 2/3/2004 22:59'!
hasLocalValueForAttribute: anAttribute
	self localValueAt: anAttribute key ifAbsent: [^ false].
	^ true! !

!WAConfiguration methodsFor: 'testing' stamp: 'avi 3/23/2004 14:53'!
hasMutableAncestry
	^ false! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 3/23/2004 12:40'!
inheritedValueAndSourceAt: aSymbol do: aBlock
	self allAncestorsDo:
		[:ea |
		(ea localValueAt: aSymbol ifAbsent: [])
			ifNotNilDo: [:val | ^ aBlock value: val value: ea]].
	^ nil! !

!WAConfiguration methodsFor: 'testing' stamp: 'jf 2/1/2004 18:03'!
inheritsFrom: aConfiguration
	^ self allAncestors anySatisfy: [:ea | ea = aConfiguration]
	
	! !

!WAConfiguration methodsFor: 'initializing' stamp: 'avi 2/2/2004 14:34'!
initialize
	! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 2/3/2004 22:58'!
localValueAt: aSymbol ifAbsent: absentBlock
	self subclassResponsibility! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 3/23/2004 12:40'!
lookupValueAt: aSymbol
	^ self inheritedValueAndSourceAt: aSymbol do: [:value :source | value]! !

!WAConfiguration methodsFor: 'accessing' stamp: 'avi 3/24/2004 11:55'!
name
	^ self subclassResponsibility! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 3/23/2004 14:47'!
potentialAncestors
	^ self allPotentialAncestors reject: [:ea | ea = self or: [(self inheritsFrom: ea) or: [ea inheritsFrom: self]]]! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 2/3/2004 22:58'!
valueAt: aSymbol
	^ self localValueAt: aSymbol ifAbsent: [self lookupValueAt: aSymbol]! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 2/3/2004 22:59'!
valueForAttribute: anAttribute
	^ self valueAt: anAttribute key! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/5/2004 16:28'!
withAllAncestorsDo: aBlock
	aBlock value: self.
	^ self allAncestorsDo: aBlock! !

WAConfiguration subclass: #WASystemConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

WASystemConfiguration class
	instanceVariableNames: 'instance'!

WASystemConfiguration class
	instanceVariableNames: 'instance'!

WASystemConfiguration subclass: #WAAuthConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAAuthConfiguration methodsFor: 'ancestry' stamp: 'avi 11/16/2005 23:32'!
ancestors
	^ Array with: (WARenderLoopConfiguration new)! !

!WAAuthConfiguration methodsFor: 'attributes' stamp: 'avi 4/13/2004 21:12'!
attributes
	^ Array
		with: (WAStringAttribute key: #login group: #authentication)
		with: (WAStringAttribute key: #password group: #authentication)
		
! !

!WAAuthConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 21:07'!
mainClass
	^ WAAuthMain! !

WASystemConfiguration subclass: #WAGlobalConfiguration
	instanceVariableNames: ''
	classVariableNames: 'DeploymentMode'
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WAGlobalConfiguration class methodsFor: 'initialization' stamp: 'avi 3/16/2006 23:39'!
initialize
	DeploymentMode ifNil: [self setDevelopmentMode]! !

!WAGlobalConfiguration class methodsFor: 'configuration' stamp: 'avi 3/16/2006 23:35'!
setDeploymentMode
	DeploymentMode := true! !

!WAGlobalConfiguration class methodsFor: 'configuration' stamp: 'avi 3/16/2006 23:36'!
setDevelopmentMode
	DeploymentMode := false! !

!WAGlobalConfiguration methodsFor: 'attributes' stamp: 'avi 9/11/2005 13:00'!
attributes
	^ Array 
		with: ((WAListAttribute key: #serverProtocol group: #server) options: #(http https))
		with: (WAStringAttribute key: #serverHostname group: #server)
		with: (WANumberAttribute key: #serverPort group: #server)
		with: (WABooleanAttribute key: #deploymentMode)! !

!WAGlobalConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2006 23:35'!
deploymentMode
	^ DeploymentMode! !

!WAGlobalConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:00'!
serverPort
	^ 80! !

!WAGlobalConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:00'!
serverProtocol
	^ #http! !

WASystemConfiguration subclass: #WARenderLoopConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RenderLoop'!

!WARenderLoopConfiguration methodsFor: 'ancestry' stamp: 'avi 11/16/2005 23:33'!
ancestors
	^ Array with: (WASessionConfiguration new)! !

!WARenderLoopConfiguration methodsFor: 'attributes' stamp: 'avi 9/11/2005 14:30'!
attributes
	^ Array
		with: ((WAListAttribute key: #rootComponent) options: self rootComponents)
		with: (WAStringAttribute key: #resourceBaseUrl group: #server)! !

!WARenderLoopConfiguration methodsFor: 'error handling' stamp: 'avi 2/2/2004 17:02'!
errorHandler
	^ WAWalkbackErrorHandler! !

!WARenderLoopConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 20:24'!
mainClass
	^ WARenderLoopMain! !

!WARenderLoopConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/29/2004 19:09'!
rootComponents
	^ (WAComponent allSubclasses select: [:ea | ea canBeRoot]) asSortedCollection: [:a :b | a name <= b name]! !

WASystemConfiguration subclass: #WASessionConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WASessionConfiguration methodsFor: 'ancestry' stamp: 'avi 11/16/2005 23:33'!
ancestors
	^ Array with: WAGlobalConfiguration new! !

!WASessionConfiguration methodsFor: 'attributes' stamp: 'avi 11/27/2005 17:57'!
attributes
	^ Array
		with: (WANumberAttribute key: #sessionExpirySeconds)
		with: ((WAListAttribute key: #sessionClass) options: self sessionClasses)
		with: ((WAListAttribute key: #mainClass) options: self mainClasses)
		with: ((WAListAttribute key: #errorHandler) options: self errorHandlerClasses)
		with: (WABooleanAttribute key: #useSessionCookie)! !

!WASessionConfiguration methodsFor: 'error handling' stamp: 'avi 4/13/2004 20:10'!
errorHandler
	^ WASimpleErrorHandler! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 4/7/2004 13:59'!
errorHandlerClasses
	^ WAErrorHandler allSubclasses! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 12:20'!
mainClasses
	^ WAMain allSubclasses! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:05'!
sessionClass
	^ WASession! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:04'!
sessionClasses
	^ WASession withAllSubclasses! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:05'!
sessionExpirySeconds
	^ 600! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/12/2005 21:42'!
useSessionCookie
	^ false! !

!WASystemConfiguration class methodsFor: 'accessing' stamp: 'lr 5/3/2006 09:44'!
instance
	^ instance ifNil: [ instance := self basicNew initialize ]! !

!WASystemConfiguration class methodsFor: 'instance creation' stamp: 'avi 11/16/2005 23:33'!
new
	^ self instance! !

!WASystemConfiguration methodsFor: 'attributes' stamp: 'avi 2/2/2004 14:01'!
attributes
	self subclassResponsibility ! !

!WASystemConfiguration methodsFor: 'values' stamp: 'avi 2/3/2004 23:00'!
localValueAt: aSymbol ifAbsent: absentBlock
	^ (self respondsTo: aSymbol)
		ifTrue: [self perform: aSymbol]
		ifFalse: [absentBlock value]! !

!WASystemConfiguration methodsFor: 'accessing' stamp: 'avi 11/16/2005 23:31'!
name
	^ self class name! !

WAConfiguration subclass: #WAUserConfiguration
	instanceVariableNames: 'values ancestors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WAUserConfiguration class methodsFor: 'initialization' stamp: 'avi 11/17/2005 00:27'!
initialize
	self allInstances do: [:ea | ea instVarNamed: 'ancestors' put: (ea ancestors collect: [:c  | [c instVarNamed: 'parent'] ifError: [c]])] 
	! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:39'!
addAncestor: aConfiguration
	(self inheritsFrom: aConfiguration)
		ifFalse: [ancestors add: aConfiguration]! !

!WAUserConfiguration methodsFor: 'ancestry' stamp: 'avi 11/16/2005 23:39'!
allPotentialAncestors
	^ WASystemConfiguration allSubclasses collect: [:ea | ea new]! !

!WAUserConfiguration methodsFor: 'accessing' stamp: 'avi 11/16/2005 23:39'!
ancestors
	^ ancestors! !

!WAUserConfiguration methodsFor: 'menu' stamp: 'avi 3/23/2004 14:51'!
clear
	values := Dictionary new.! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
clearValueForAttribute: anAttribute
	values removeKey: anAttribute key ifAbsent: []! !

!WAUserConfiguration methodsFor: 'testing' stamp: 'avi 11/16/2005 23:39'!
hasMutableAncestry
	^ true! !

!WAUserConfiguration methodsFor: 'initialization' stamp: 'avi 11/16/2005 23:39'!
initialize
	super initialize.
	values := Dictionary new.
	ancestors := OrderedCollection new.! !

!WAUserConfiguration methodsFor: 'values' stamp: 'avi 3/23/2004 14:51'!
localValueAt: aSymbol ifAbsent: errorBlock
	^ values at: aSymbol ifAbsent: errorBlock! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
localValues
	| dict |
	dict := Dictionary new.
	self allAttributes do:
		[:attr | (self localValueAt: attr key ifAbsent: [nil])
			ifNotNilDo: [:value | dict at: attr key put: (attr stringForValue: value)]].
		
	^ dict! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
localValues: aDictionary
	self allAttributes do:
		[:attr | (aDictionary at: attr key ifAbsent: [nil])
			ifNotNilDo: [:string | self valueAt: attr key put: (attr valueFromString: string)]]! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
overrideAttribute: anAttribute
	self takeValue: (self valueForAttribute: anAttribute) forAttribute: anAttribute! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:39'!
removeAncestor: aConfiguration
	ancestors remove: aConfiguration ifAbsent: []! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 15:21'!
takeValue: anObject forAttribute: anAttribute
	^ anObject ifNotNil: [values at: anAttribute key put: anObject]! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
valueAt: aSymbol put: anObject
	^ self takeValue: anObject forAttribute: (self attributeNamed: aSymbol)! !

Object subclass: #WAConfigurationAttribute
	instanceVariableNames: 'key group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

WAConfigurationAttribute subclass: #WABooleanAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WABooleanAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:11'!
accept: aVisitor with: anObject
	^ aVisitor visitBooleanAttribute: self with: anObject! !

!WABooleanAttribute methodsFor: 'as yet unclassified' stamp: 'avi 4/26/2004 14:42'!
valueFromString: aString
	^ aString = 'true'
		ifTrue: [true]
		ifFalse: [aString = 'false'
				 ifTrue: [false]
				 ifFalse: [self error: 'Invalid value for boolean attribute']]
! !

!WAConfigurationAttribute class methodsFor: 'accessing' stamp: 'avi 2/5/2004 13:15'!
key: aSymbol
	^ self key: aSymbol group: nil! !

!WAConfigurationAttribute class methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 13:14'!
key: keySymbol group: groupSymbol
	^ self basicNew initializeWithKey: keySymbol group: groupSymbol! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/30/2004 17:12'!
accept: aVisitor with: anObject
	self subclassResponsibility ! !

!WAConfigurationAttribute methodsFor: 'accessing' stamp: 'avi 2/5/2004 13:21'!
group
	^ group ifNil: [#general]! !

!WAConfigurationAttribute methodsFor: 'initialization' stamp: 'avi 2/5/2004 13:14'!
initializeWithKey: keySymbol group: groupSymbol
	key := keySymbol.
	group := groupSymbol! !

!WAConfigurationAttribute methodsFor: 'accessing' stamp: 'avi 1/30/2004 16:40'!
key
	^ key! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: 'mbany 4/14/2005 12:28'!
stringForValue: anObject
	^ anObject displayString! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: 'jf 2/8/2004 17:07'!
valueFromString: aString
	self subclassResponsibility ! !

WAConfigurationAttribute subclass: #WAListAttribute
	instanceVariableNames: 'options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WAListAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:13'!
accept: aVisitor with: anObject
	^ aVisitor visitListAttribute: self with: anObject! !

!WAListAttribute methodsFor: 'accessing' stamp: 'avi 1/31/2004 12:12'!
options
	^ options! !

!WAListAttribute methodsFor: 'accessing' stamp: 'avi 1/31/2004 12:11'!
options: aCollection
	options := aCollection! !

!WAListAttribute methodsFor: 'as yet unclassified' stamp: 'mbany 4/14/2005 12:29'!
valueFromString: aString
	^ self options
		detect: [:ea | ea displayString = aString]
		ifNone: [self error: 'No matching list option']! !

WAConfigurationAttribute subclass: #WANumberAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WANumberAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:13'!
accept: aVisitor with: anObject
	^ aVisitor visitNumberAttribute: self with: anObject! !

!WANumberAttribute methodsFor: 'as yet unclassified' stamp: 'jf 2/8/2004 17:10'!
valueFromString: aString
	^ Number readFrom: aString! !

WAConfigurationAttribute subclass: #WAStringAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

WAStringAttribute subclass: #WAPasswordAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WAPasswordAttribute methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 21:02'!
accept: aVisitor with: anObject
	^ aVisitor visitPasswordAttribute: self with: anObject! !

!WAStringAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/30/2004 17:12'!
accept: aVisitor with: anObject
	^ aVisitor visitStringAttribute: self with: anObject! !

!WAStringAttribute methodsFor: 'as yet unclassified' stamp: 'lr 5/3/2006 09:56'!
valueFromString: aString
	^ aString isEmptyOrNil ifFalse: [ aString ]! !

Object subclass: #WACookie
	instanceVariableNames: 'key value path expiry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-HTTP'!

!WACookie class methodsFor: 'accessing' stamp: 'avi 5/18/2004 22:59'!
key: keyString value: valueString
	^ self new
		key: keyString;
		value: valueString;
		yourself! !

!WACookie methodsFor: 'comparing' stamp: 'pmm 10/12/2006 16:53'!
= other
	^(other isKindOf: WACookie)
		and: [ self key = other key
		and: [ self path = other path ] ]! !

!WACookie methodsFor: 'api' stamp: 'avi 5/18/2004 23:13'!
expireIn: aDuration
	self expiry: DateAndTime now + aDuration! !

!WACookie methodsFor: 'accessing' stamp: 'avi 5/18/2004 22:53'!
expiry
	^ expiry! !

!WACookie methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:22'!
expiry: aDateTime
	expiry := aDateTime asUTC! !

!WACookie methodsFor: 'private' stamp: 'mbany 4/14/2005 12:18'!
expiryString
	^ String streamContents:
		[:s |
		s
			nextPutAll: (expiry dayOfWeekName first: 3);
			nextPutAll: ', ';
			nextPutAll: expiry dayOfMonth displayString;
			nextPut: $-;
			nextPutAll: expiry monthName;
			nextPut: $-;
			nextPutAll: expiry year displayString;
			space;
			nextPutAll: expiry hour24 displayString;
			nextPut: $:;
			nextPutAll: expiry minute displayString; 
			nextPut: $:;
			nextPutAll: expiry second displayString;
			nextPutAll: ' GMT']! !

!WACookie methodsFor: 'comparing' stamp: 'pmm 10/12/2006 16:53'!
hash
	^self key hash
		bitXor: self path hash! !

!WACookie methodsFor: 'accessing' stamp: 'avi 5/18/2004 13:21'!
key
	^ key! !

!WACookie methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:22'!
key: aString
	key := aString! !

!WACookie methodsFor: 'accessing' stamp: 'avi 5/18/2004 22:53'!
path
	^ path ifNil: ['/']! !

!WACookie methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:22'!
path: aString
	path := aString! !

!WACookie methodsFor: 'accessing' stamp: 'avi 5/18/2004 13:21'!
value
	^ value! !

!WACookie methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:22'!
value: aString
	value := aString! !

!WACookie methodsFor: 'api' stamp: 'mb 2/27/2006 08:02'!
valueWithExpiry
	^ expiry
		ifNil: [self value]
		ifNotNil: [(self value ifNil: ['']), '; expires=', self expiryString]! !

Object subclass: #WAErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

WAErrorHandler subclass: #WADebugErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WADebugErrorHandler methodsFor: 'actions' stamp: 'lr 6/7/2006 10:06'!
handleError: anError
	SeasidePlatformSupport openDebuggerOn: anError! !

!WAErrorHandler class methodsFor: 'actions' stamp: 'avi 3/28/2004 21:22'!
handleError: anError
	^ self new handleError: anError! !

!WAErrorHandler class methodsFor: 'actions' stamp: 'avi 3/28/2004 21:23'!
handleWarning: aWarning
	^ self new handleWarning: aWarning! !

!WAErrorHandler methodsFor: 'actions' stamp: 'avi 2/2/2004 16:54'!
handleError: anError
	anError pass! !

!WAErrorHandler methodsFor: 'actions' stamp: 'avi 2/2/2004 16:54'!
handleWarning: aWarning
	self handleError: aWarning! !

WAErrorHandler subclass: #WASimpleErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WASimpleErrorHandler methodsFor: 'actions' stamp: 'avi 5/18/2004 16:16'!
handleError: anError
	WACurrentSession value returnResponse: (WAResponse internalError: anError)! !

WAErrorHandler subclass: #WAWalkbackErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RenderLoop'!

!WAWalkbackErrorHandler methodsFor: 'actions' stamp: 'mb 1/13/2006 09:55'!
handleError: anError
	WARenderLoop new
		call: (WAWalkback new exception: anError) 
		withToolFrame: false.
	SeasidePlatformSupport openDebuggerOn: anError.
! !

!WAWalkbackErrorHandler methodsFor: 'actions' stamp: 'avi 3/29/2004 19:07'!
handleWarning: aWarning
	WARenderLoop new call: (WAFormDialog new addMessage: aWarning messageText).
	aWarning resume.! !

Object subclass: #WAFile
	instanceVariableNames: 'contents contentType fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-HTTP'!

!WAFile methodsFor: 'accessing' stamp: 'avi 4/28/2004 11:13'!
contentType
	^ contentType! !

!WAFile methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:21'!
contentType: aString
	contentType := aString! !

!WAFile methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:39'!
contents
	"Answer a ByteArray"
	^ contents! !

!WAFile methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:37'!
contents: aByteArray
	contents := aByteArray! !

!WAFile methodsFor: 'accessing' stamp: 'ab 10/31/2002 10:39'!
fileName
	"compensate for windows explorer behavior"
	^ ('#:\*' match: fileName)
		ifTrue: [fileName copyAfterLast: $\]
		ifFalse: [fileName]! !

!WAFile methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:21'!
fileName: aString
	fileName := aString! !

Object subclass: #WAFileLibrary
	instanceVariableNames: ''
	classVariableNames: 'MimeTypes'
	poolDictionaries: ''
	category: 'Seaside-Libraries'!

!WAFileLibrary commentStamp: 'pmm 10/6/2006 10:56' prior: 0!
How to use FileLibrary

What does FileLibrary do
It allows to serve static files directly from seaside without the need for a standalone server like Apache or to configure Kom. These files can reference each other (say a CSS references an image) and can be distrubuted the same way as normal Smalltalk code (Monticello, SqueakMap, ...).

How to create a FileLibrary
- First create the static files and put them in some directory. From there they can reference the other files in the same directory normally with their filenames.
- Make sure you have a "Static File Library" that serves your files. This is a normal entry point type that you can find in your /seaside/config application. If you don't already have one, you can create it if you select "Static File Library" in the type field of the "add entry point" dialog. For the rest of this text we assume you chose "files" as the path.
- Create a subclass of WAFileLibrary, for the rest of this text I assume its name is MyFileLibrary.
- To add the files to your file library there are two ways.
1. Programmatically with MyFileLibrary class >> #addAllFilesIn: / #addFileNamed:. For example MyFileLibrary addAllFilesIn: '/path/to/directory/with/files' or MyFileLibrary addFileNamed: '/path/to/background.png'.
2. Via the web interface. Go to your /seaside/config application and there click configure for your "Static File Library". Select  MyFileLibrary in the "Add Library:" drop down and click add. Then click "configure" behind MyFileLibrary. There you can add a file by uploading it (select the file, then click "Add")

How to integrate a FileLibrary into your existing application
Files from a FileLibrary are ingetrated the same way other static files are integrated. They have a constant path that is '/seaside/<Static File Library>/<FileLibrary class name>/<filename>' so for example. '/seaside/files/MyFileLibrary/background.png'.
So for CSS and JS files you would add a link in an #updateRoot: method whereas for images you would pass the path to an #url: method.

Note that a "Static File Library" can consist of several file libraries and can even have tradional script or style libraries.!

!WAFileLibrary class methodsFor: 'adding-files' stamp: 'pmm 10/4/2006 20:31'!
addAllFilesIn: aPathString
	"adds all files in the directory specified by aPathString to the current file library"
	(SeasidePlatformSupport filesIn: aPathString)
		do: [ :each | self addFileAt: each ]! !

!WAFileLibrary class methodsFor: 'adding-files' stamp: 'pmm 10/5/2006 18:29'!
addFileAt: aPath
	"adds the file specified by aFilename to the current file library"
	self
		addFileAt: aPath
		contents: (SeasidePlatformSupport
			contentsOfFile: aPath
			binary: (self isBinaryAt: aPath))! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 10/4/2006 20:29'!
addFileAt: aPath contents: aByteArrayOrString
	self
		addFileNamed: (SeasidePlatformSupport localNameOf: aPath)
		contents: aByteArrayOrString! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 10/5/2006 18:37'!
addFileNamed: aFilename contents: aByteArrayOrString
	| selector |
	selector := self asSelector: aFilename.
	(self isBinary: aFilename)
		ifTrue: [ self compileBinary: aByteArrayOrString selector: selector ]
		ifFalse: [ self compileText: aByteArrayOrString selector: selector ]! !

!WAFileLibrary class methodsFor: 'vw port-squeak' stamp: 'mb 10/18/2006 11:58'!
adjustForVisualWorks
	| newSource oldSource badCode goodCode |
	badCode := 'xxxCache := #(nil).'.
	goodCode := 'xxxCache := #(nil) beMutable.'.
	self selectors do: [:selector |
		oldSource := self sourceCodeAt: selector.
		(oldSource indexOfSubCollection: badCode startingAt: 1) > 0 ifTrue:
			[newSource := oldSource copyReplaceAll: badCode with: goodCode.
			self compile: newSource classified: self methodCategory]].! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 10/8/2006 19:57'!
asSelector: aFilename
	| mainPart extentsion |
	mainPart := (aFilename copyUpToLast: $.) reject: [ :each |
		each isAlphaNumeric not ].
	mainPart first isDigit ifTrue: [
		mainPart := mainPart allButFirst ].
	extentsion := (aFilename copyAfterLast: $.) capitalized.
	^(mainPart, extentsion) asSymbol
	! !

!WAFileLibrary class methodsFor: 'private' stamp: 'mb 10/17/2006 13:18'!
compileBinary: aByteArrayOrString selector: aSymbol	
	| code |
	code := SeasidePlatformSupport asMethodReturningByteArray: aByteArrayOrString named: aSymbol.
	SeasidePlatformSupport compile: code into: self classified: self methodCategory! !

!WAFileLibrary class methodsFor: 'private' stamp: 'mb 10/17/2006 13:18'!
compileText: aByteArrayOrString selector: aSymbol	
	| code |
	code := String streamContents: [ :stream |
		stream nextPutAll: aSymbol; cr.
		stream tab; nextPutAll: '^ '''.
		aByteArrayOrString asString do: [ :each |
			each = $' ifTrue: [ stream nextPut: $' ].
			stream nextPut: each ].
		stream nextPutAll: '''' ].
	SeasidePlatformSupport compile: code into: self classified: self methodCategory! !

!WAFileLibrary class methodsFor: 'accessing-defaults' stamp: 'pmm 4/20/2006 20:52'!
defaultMimeType
	^ 'application/octet-stream'! !

!WAFileLibrary class methodsFor: 'accessing-defaults' stamp: 'pmm 4/22/2006 00:35'!
defaultMimeTypes
	^ #( 'ai' 'application/postscript' 'aif' 'audio/x-aiff' 'aifc' 'audio/x-aiff' 'aiff' 'audio/x-aiff' 'asc' 'text/plain' 'au' 'audio/basic' 'avi' 'video/x-msvideo' 'bcpio' 'application/x-bcpio' 'bin' 'application/octet-stream' 'c' 'text/plain' 'cc' 'text/plain' 'ccad' 'application/clariscad' 'cdf' 'application/x-netcdf' 'class' 'application/octet-stream' 'cpio' 'application/x-cpio' 'cpt' 'application/mac-compactpro' 'csh' 'application/x-csh' 'css' 'text/css' 'dcr' 'application/x-director' 'dir' 'application/x-director' 'dms' 'application/octet-stream' 'doc' 'application/msword' 'drw' 'application/drafting' 'dvi' 'application/x-dvi' 'dwg' 'application/acad' 'dxf' 'application/dxf' 'dxr' 'application/x-director' 'eps' 'application/postscript' 'etx' 'text/x-setext' 'exe' 'application/octet-stream' 'ez' 'application/andrew-inset' 'f' 'text/plain' 'f90' 'text/plain' 'fli' 'video/x-fli' 'gif' 'image/gif' 'gtar' 'application/x-gtar' 'gz' 'application/x-gzip' 'h' 'text/plain' 'hdf' 'application/x-hdf' 'hh' 'text/plain' 'hqx' 'application/mac-binhex40' 'htm' 'text/html' 'html' 'text/html' 'ice' 'x-conference/x-cooltalk' 'ief' 'image/ief' 'iges' 'model/iges' 'igs' 'model/iges' 'ips' 'application/x-ipscript' 'ipx' 'application/x-ipix' 'jpe' 'image/jpeg' 'jpeg' 'image/jpeg' 'jpg' 'image/jpeg' 'js' 'text/javascript' 'kar' 'audio/midi' 'latex' 'application/x-latex' 'lha' 'application/octet-stream' 'lsp' 'application/x-lisp' 'lzh' 'application/octet-stream' 'm' 'text/plain' 'man' 'application/x-troff-man' 'me' 'application/x-troff-me' 'mesh' 'model/mesh' 'mid' 'audio/midi' 'midi' 'audio/midi' 'mif' 'application/vnd.mif' 'mime' 'www/mime' 'mov' 'video/quicktime' 'movie' 'video/x-sgi-movie' 'mp2' 'audio/mpeg' 'mp3' 'audio/mpeg' 'mpe' 'video/mpeg' 'mpeg' 'video/mpeg' 'mpg' 'video/mpeg' 'mpga' 'audio/mpeg' 'ms' 'application/x-troff-ms' 'msh' 'model/mesh' 'nc' 'application/x-netcdf' 'oda' 'application/oda' 'pbm' 'image/x-portable-bitmap' 'pdb' 'chemical/x-pdb' 'pdf' 'application/pdf' 'pgm' 'image/x-portable-graymap' 'pgn' 'application/x-chess-pgn' 'png' 'image/png' 'pnm' 'image/x-portable-anymap' 'pot' 'application/mspowerpoint' 'ppm' 'image/x-portable-pixmap' 'pps' 'application/mspowerpoint' 'ppt' 'application/mspowerpoint' 'ppz' 'application/mspowerpoint' 'pre' 'application/x-freelance' 'prt' 'application/pro_eng' 'ps' 'application/postscript' 'qt' 'video/quicktime' 'ra' 'audio/x-realaudio' 'ram' 'audio/x-pn-realaudio' 'ras' 'image/cmu-raster' 'rgb' 'image/x-rgb' 'rm' 'audio/x-pn-realaudio' 'roff' 'application/x-troff' 'rpm' 'audio/x-pn-realaudio-plugin' 'rtf' 'text/rtf' 'rtx' 'text/richtext' 'scm' 'application/x-lotusscreencam' 'set' 'application/set' 'sgm' 'text/sgml' 'sgml' 'text/sgml' 'sh' 'application/x-sh' 'shar' 'application/x-shar' 'silo' 'model/mesh' 'sit' 'application/x-stuffit' 'skd' 'application/x-koan' 'skm' 'application/x-koan' 'skp' 'application/x-koan' 'skt' 'application/x-koan' 'smi' 'application/smil' 'smil' 'application/smil' 'snd' 'audio/basic' 'sol' 'application/solids' 'spl' 'application/x-futuresplash' 'src' 'application/x-wais-source' 'step' 'application/STEP' 'stl' 'application/SLA' 'stp' 'application/STEP' 'sv4cpio' 'application/x-sv4cpio' 'sv4crc' 'application/x-sv4crc' 'swf' 'application/x-shockwave-flash' 't' 'application/x-troff' 'tar' 'application/x-tar' 'tcl' 'application/x-tcl' 'tex' 'application/x-tex' 'texi' 'application/x-texinfo' 'texinfo' 'application/x-texinfo' 'tif' 'image/tiff' 'tiff' 'image/tiff' 'tr' 'application/x-troff' 'tsi' 'audio/TSP-audio' 'tsp' 'application/dsptype' 'tsv' 'text/tab-separated-values' 'txt' 'text/plain' 'unv' 'application/i-deas' 'ustar' 'application/x-ustar' 'vcd' 'application/x-cdlink' 'vda' 'application/vda' 'viv' 'video/vnd.vivo' 'vivo' 'video/vnd.vivo' 'vrml' 'model/vrml' 'wav' 'audio/x-wav' 'wrl' 'model/vrml' 'xbm' 'image/x-xbitmap' 'xlc' 'application/vnd.ms-excel' 'xll' 'application/vnd.ms-excel' 'xlm' 'application/vnd.ms-excel' 'xls' 'application/vnd.ms-excel' 'xlw' 'application/vnd.ms-excel' 'xml' 'text/xml' 'xpm' 'image/x-xpixmap' 'xwd' 'image/x-xwindowdump' 'xyz' 'chemical/x-pdb' 'zip' 'application/zip' )! !

!WAFileLibrary class methodsFor: 'class initialization' stamp: 'pmm 4/20/2006 20:52'!
initialize
	"self initialize"
	MimeTypes := Dictionary new.
	1 to: self defaultMimeTypes size by: 2 do: [ :index |
		MimeTypes
			at: (self defaultMimeTypes at: index)
			put: (self defaultMimeTypes at: index + 1) ]! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 10/5/2006 18:27'!
isBinary: aFilename
	| contentType |
	contentType := self mimetypeFor: (aFilename copyAfterLast: $.).
	^(contentType beginsWith: 'text/') not! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 10/5/2006 18:37'!
isBinaryAt: aPath
	^self isBinary: (SeasidePlatformSupport localNameOf: aPath)! !

!WAFileLibrary class methodsFor: 'private' stamp: 'mb 10/17/2006 13:23'!
methodCategory
	^#uploaded! !

!WAFileLibrary class methodsFor: 'accessing' stamp: 'pmm 4/20/2006 20:52'!
mimetypeFor: aString
	^ self mimetypes at: aString ifAbsent: [ self defaultMimeType ]! !

!WAFileLibrary class methodsFor: 'accessing' stamp: 'pmm 4/20/2006 20:51'!
mimetypes
	^ MimeTypes! !

!WAFileLibrary class methodsFor: 'convenience' stamp: 'pmm 10/28/2006 23:02'!
register
	(WADispatcher default entryPointAt: 'files')
		addLibrary: self new! !

!WAFileLibrary methodsFor: 'actions' stamp: 'pmm 10/5/2006 19:23'!
addFile: aFile
	| contents |
	contents := (self class isBinary: aFile fileName)
		ifTrue: [ aFile contents ]
		ifFalse: [ SeasidePlatformSupport convertToSmalltalkNewlines: aFile contents ].
	self class addFileNamed: aFile fileName contents: contents! !

!WAFileLibrary methodsFor: 'private' stamp: 'pmm 4/20/2006 20:58'!
asFilename: aSelector
	| dotIndex extension |
	dotIndex := self lastUpperCaseIndexIn: aSelector.
	extension := (aSelector last:  aSelector size - dotIndex + 1) asLowercase.
	^(aSelector first: dotIndex - 1), '.', extension! !

!WAFileLibrary methodsFor: 'private' stamp: 'pmm 4/22/2006 00:07'!
asSelector: aFilename
	^self class asSelector: aFilename
	! !

!WAFileLibrary methodsFor: 'private' stamp: 'pmm 4/22/2006 00:03'!
compileBinary: aString selector: aSymbol	
	| code |
	code := String streamContents: [ :stream |
		stream nextPutAll: aSymbol; cr.
		stream tab; nextPutAll: '^ #('.
		aString asByteArray
			do: [ :each | each printOn: stream ]
			separatedBy: [ stream space ].
		stream nextPutAll: ') asByteArray' ].
	SeasidePlatformSupport compile: code into: self class classified: aSymbol
	! !

!WAFileLibrary methodsFor: 'private' stamp: 'pmm 4/22/2006 00:03'!
compileText: aString selector: aSymbol	
	| code |
	code := String streamContents: [ :stream |
		stream nextPutAll: aSymbol; cr.
		stream tab; nextPutAll: '^ '''.
		aString do: [ :each |
			each = $' ifTrue: [ stream nextPut: $' ].
			stream nextPut: each ].
		stream nextPutAll: '''' ].
	SeasidePlatformSupport compile: code into: self class classified: aSymbol
	! !

!WAFileLibrary methodsFor: 'accessing' stamp: 'pmm 4/22/2006 00:41'!
configurationComponent
	^ WAFileLibraryEditor new
		library: self;
		yourself! !

!WAFileLibrary methodsFor: 'accessing' stamp: 'lr 11/16/2006 19:10'!
documentAt: aFilename ifAbsent: aBlock
	| selector |
	selector := self asSelector: aFilename.
	^ (self fileSelectors includes: selector)
		ifTrue: [ WAResponse
			document: (self perform: selector)
			mimeType: (self class mimetypeFor: (aFilename copyAfterLast: $.))
			fileName: aFilename	 ]
		ifFalse: [ aBlock value ]! !

!WAFileLibrary methodsFor: 'private' stamp: 'mb 10/17/2006 13:15'!
fileSelectors
	^self class selectors select: [ :each |
		self isFileSelector: each ]! !

!WAFileLibrary methodsFor: 'accessing' stamp: 'pmm 4/20/2006 21:03'!
filenames
	^self fileSelectors collect: [ :each |
		self asFilename: each ]! !

!WAFileLibrary methodsFor: 'private' stamp: 'mb 10/17/2006 13:16'!
isFileSelector: aSymbol
	| last |
	^aSymbol isUnary
		and: [
			last := self lastUpperCaseIndexIn: aSymbol.
			last ~= 0 and: [ last ~= 1 ] ]! !

!WAFileLibrary methodsFor: 'private' stamp: 'pmm 4/20/2006 20:58'!
lastUpperCaseIndexIn: aString
	^aString findLast: [ :each | each isUppercase ]! !

!WAFileLibrary methodsFor: 'accessing' stamp: 'pmm 4/21/2006 23:20'!
name
	^self class name! !

!WAFileLibrary methodsFor: 'actions' stamp: 'pmm 4/21/2006 23:57'!
removeFile: aFilename
	SeasidePlatformSupport
		removeSelector: (self asSelector: aFilename)
		from: self class! !

WAFileLibrary subclass: #WAFileLibraryDemo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAFileLibraryDemo methodsFor: 'accessing' stamp: 'mb 10/17/2006 14:09'!
mainCss
	^'/* Pier

   Copyright (c) 2003-2006 Lukas Renggli
   Copyright (c) 2005-2006 Software Composition Group, University of Berne
*/

* {
	margin: 0px;
	padding: 0px;
}

body { 
	font-family: Verdana, Arial, Helvetica, sans-serif;
	font-size: 12px;
	color: #111111;
	margin: 10px;
}

img {
	border: none; 
}

td, 
th { 
	text-align: left; 
	vertical-align: top; 
}

a {
	text-decoration: none; 
	color: #092565; 
}

a:hover {
	text-decoration: underline;
}

.broken {
    color: #aa0000;
}

.protected {
    color: #aaaaaa;
}'! !

!WAFileLibraryDemo methodsFor: 'accessing' stamp: 'pmm 4/13/2006 20:20'!
mainJpg
	^ #(255 216 255 224 0 16 74 70 73 70 0 1 1 1 0 72 0 72 0 0 255 225 0 22 69 120 105 102 0 0 77 77 0 42 0 0 0 8 0 0 0 0 0 0 255 219 0 67 0 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 255 219 0 67 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 255 192 0 17 8 0 4 2 152 3 1 34 0 2 17 1 3 17 1 255 196 0 24 0 1 0 3 1 0 0 0 0 0 0 0 0 0 0 0 0 0 1 7 9 10 255 196 0 38 16 0 2 3 0 1 1 8 3 1 0 0 0 0 0 0 0 0 1 17 81 145 7 2 6 8 9 40 49 54 116 195 65 103 129 183 255 196 0 20 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 255 196 0 20 17 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 255 218 0 12 3 1 0 2 17 3 17 0 63 0 235 191 191 103 181 250 190 7 87 216 85 254 17 73 62 9 229 249 83 230 63 181 191 230 188 74 0 26 177 10 150 33 10 150 32 0 66 165 136 66 165 136 0 16 169 98 16 169 98 0 4 42 88 132 42 88 128 1 10 150 33 10 150 32 0 66 165 136 66 165 136 0 16 169 98 16 169 98 0 4 42 88 132 42 88 128 1 10 150 33 10 150 32 0 66 165 136 66 165 136 0 16 169 98 16 169 98 0 4 42 88 132 42 88 128 1 10 150 33 10 150 32 0 66 165 136 66 165 136 0 16 169 98 16 169 98 0 4 42 88 132 42 88 128 1 10 150 33 10 150 32 0 66 165 136 66 165 136 0 16 169 98 16 169 98 0 4 42 88 132 42 88 128 1 10 150 33 10 150 32 0 66 165 136 66 165 136 0 16 169 98 16 169 98 0 4 42 88 132 42 88 128 1 10 150 33 10 150 32 0 66 165 136 66 165 136 0 16 169 98 16 169 98 0 4 42 88 132 42 88 128 1 10 150 33 10 150 32 0 66 94 137 47 225 32 0 0 0 0 0 132 253 84 145 10 150 32 0 66 165 136 66 165 136 0 16 169 98 16 169 98 0 4 42 88 132 42 88 128 1 10 150 33 10 150 32 0 66 165 136 66 165 136 0 16 169 98 16 169 98 0 4 42 88 140 168 241 117 73 112 55 16 66 75 204 143 100 255 0 31 173 121 108 0 44 254 226 126 215 233 248 29 63 88 0 15 255 217) asByteArray.! !

Object subclass: #WAHtmlAttributes
	instanceVariableNames: 'attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document'!

!WAHtmlAttributes methodsFor: 'convenience' stamp: 'lr 11/16/2006 19:02'!
addClass: aString
	aString ifNotNil: [ self at: 'class' append: aString ]! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'lr 11/16/2006 19:02'!
addMeasurementStyle: aString withValue: aValue
	| styleValue |
	self deprecatedApi.
	styleValue := aValue isNumber
		ifTrue: [ aValue px ]
		ifFalse: [ aValue displayString ].
	self addStyle: aString , ': ' , styleValue! !

!WAHtmlAttributes methodsFor: 'convenience' stamp: 'lr 11/16/2006 19:02'!
addScript: aString
	aString ifNotNil: [ self at: 'script' append: aString separator: ';' ]! !

!WAHtmlAttributes methodsFor: 'convenience' stamp: 'lr 11/16/2006 19:02'!
addStyle: aString
	aString ifNotNil: [ self at: 'style' append: aString separator: ';' ]! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'lr 11/16/2006 19:00'!
align
	self deprecatedApi
! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'lr 11/16/2006 19:00'!
align: aValue
	self deprecatedApi! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'lr 11/16/2006 19:00'!
alignBottom
	self deprecatedApi.
	self at: 'valign' put: 'bottom'! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'lr 11/16/2006 19:01'!
alignCenter
	self deprecatedApi.
	self addStyle: 'text-align: center'! !

!WAHtmlAttributes methodsFor: 'private' stamp: 'avi 6/22/2005 01:55'!
associations
	^ self attributes associations! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'avi 9/10/2005 16:02'!
at: keyString
	^ (self at: keyString ifAbsent: [keyString -> nil]) value! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'ac 9/25/2005 18:11'!
at: keyString append: aString
	^ self at: keyString append: aString separator: ' '! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'mb 3/16/2006 23:48'!
at: keyString append: aString separator: separatorString
	aString ifNil: [^ self at: keyString].
	^ self at: keyString put: 
		(String streamContents:
			[:stream |
			self at: keyString ifPresent: 
				[:s | stream nextPutAll: s; nextPutAll: separatorString].
			stream nextPutAll: aString displayString])! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'ac 3/16/2005 11:49'!
at: keyString ifAbsent: aBlock
	^ self associations
		detect: [:ea | ea key = keyString]
		ifNone: aBlock! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'mb 3/16/2006 23:55'!
at: keyString ifAbsentPut: errBlock
	"What if errBlock evaluates to nil ?"
	^ self at: keyString ifAbsent: [self attributes add: keyString -> errBlock value]! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'ac 9/25/2005 17:50'!
at: keyString ifPresent: aBlock
	^ aBlock value: (self at: keyString ifAbsent: [^ nil]) value! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'mb 3/16/2006 23:47'!
at: keyString put: valueString
	valueString ifNotNil: [self attributes at: keyString put: valueString]! !

!WAHtmlAttributes methodsFor: 'private' stamp: 'avi 6/22/2005 01:49'!
attributes
	^ attributes ifNil: [attributes := Dictionary new]! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'lr 11/16/2006 19:01'!
background: aValue
	self deprecatedApi.
	self addStyle: 'background-image: url(' , aValue displayString , ')'
! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'lr 11/16/2006 19:01'!
backgroundColor: aValue
	self deprecatedApi.
	self addStyle: 'background-color: ' , aValue displayString! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'lr 11/16/2006 19:12'!
bgcolor
	self deprecatedApi! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'lr 11/16/2006 19:12'!
bgcolor: aValue
	self deprecatedApi! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'lr 11/16/2006 19:01'!
border: aValue
	| cssValue |
	self deprecatedApi.
	cssValue := 'none'.
	aValue displayString = '1' ifTrue: [cssValue := 'solid 1px black'].
	aValue displayString = '2' ifTrue: [cssValue := 'solid 2px black'].
	self addStyle: 'border: ' , cssValue.
! !

!WAHtmlAttributes methodsFor: 'dnu' stamp: 'ab 5/24/2003 00:42'!
doesNotUnderstand: aMessage
	| argCount |
	argCount := aMessage arguments size.
	argCount = 0 ifTrue: [^ self at: aMessage selector put: true].
	argCount = 1 ifTrue: [^ self at: aMessage selector allButLast put: aMessage argument].
	^ super doesNotUnderstand: aMessage! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'lr 11/16/2006 19:01'!
height: aValue	
	self deprecatedApi.
	self addMeasurementStyle: 'height' withValue: aValue! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'lr 11/16/2006 19:01'!
noBorder
	self deprecatedApi.
	self border: 0! !

!WAHtmlAttributes methodsFor: 'copying' stamp: 'lr 11/8/2005 21:58'!
postCopy
	super postCopy.
	attributes := attributes copy.! !

!WAHtmlAttributes methodsFor: 'javascript' stamp: 'avi 3/12/2004 17:25'!
submitOnChange
	self at: 'onChange' put: 'submit()'! !

!WAHtmlAttributes methodsFor: 'javascript' stamp: 'avi 2/7/2004 02:18'!
submitOnClick
	self at: 'onClick' put: 'submit()'! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'lr 11/16/2006 19:02'!
width: aValue
	self deprecatedApi.
	self addMeasurementStyle: 'width' withValue: aValue! !

!WAHtmlAttributes methodsFor: 'printing' stamp: 'lr 6/14/2006 07:59'!
writeKey: aKey value: aValue on: aStream
	aValue = false ifFalse: [
		aStream nextPut: $ ; nextPutAll: aKey; nextPutAll: '="'.
		aValue = true
			ifFalse: [ WAAbstractHtmlBuilder encode: aValue to: aStream ]
			ifTrue: [ aStream nextPutAll: aKey ].
		aStream nextPut: $" ]! !

!WAHtmlAttributes methodsFor: 'printing' stamp: 'lr 6/14/2006 08:17'!
writeOn: aStream
	attributes ifNil: [ ^ self ].
	attributes keysAndValuesDo: [ :key :value |
		self 
			writeKey: key asLowercase 
			value: value on: aStream ]! !

Object subclass: #WAHtmlDocument
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document'!

!WAHtmlDocument class methodsFor: 'instance creation' stamp: 'mb 3/30/2006 12:32'!
new
	^ self root: self newRoot! !

!WAHtmlDocument class methodsFor: 'instance creation' stamp: 'mb 3/30/2006 12:32'!
newRoot
	^ self rootClass new! !

!WAHtmlDocument class methodsFor: 'instance creation' stamp: 'avi 6/18/2004 18:22'!
root: anHtmlRoot
	^ self basicNew initializeWithRoot: anHtmlRoot! !

!WAHtmlDocument class methodsFor: 'instance creation' stamp: 'mb 3/30/2006 12:27'!
rootClass
	^ WAHtmlRoot! !

!WAHtmlDocument methodsFor: 'public' stamp: 'avi 7/8/2004 00:02'!
close! !

!WAHtmlDocument methodsFor: 'public' stamp: 'avi 5/18/2004 13:29'!
closeTag: aString
	self subclassResponsibility! !

!WAHtmlDocument methodsFor: 'public' stamp: 'lr 10/3/2006 09:10'!
comment: aString
	"Display aString as comment in the resulting HTML document, the default implementation doesn't bother rendering comments."! !

!WAHtmlDocument methodsFor: 'initialization' stamp: 'avi 6/19/2004 18:04'!
initializeWithRoot: aRoot
	root := aRoot! !

!WAHtmlDocument methodsFor: 'public' stamp: 'avi 5/18/2004 13:28'!
openTag: aString attributes: anAttributes
	self subclassResponsibility! !

!WAHtmlDocument methodsFor: 'accessing' stamp: 'avi 6/18/2004 18:24'!
root
	^ root! !

!WAHtmlDocument methodsFor: 'testing' stamp: 'lr 10/3/2006 08:54'!
shouldPrintCloseTagFor: aString
	^ (#('hr' 'br' 'input' 'img' 'link') includes: aString asString) not! !

!WAHtmlDocument methodsFor: 'public' stamp: 'pmm 4/19/2006 17:44'!
text: aString
	self subclassResponsibility ! !

WAHtmlDocument subclass: #WAHtmlStreamDocument
	instanceVariableNames: 'state stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document'!

!WAHtmlStreamDocument methodsFor: 'accessing' stamp: 'avi 7/8/2004 00:40'!
bodyStream
	state = #head ifTrue:
		[state := #body.
		root writeOn: stream].
	^ stream! !

!WAHtmlStreamDocument methodsFor: 'public' stamp: 'avi 7/8/2004 00:41'!
close
	self bodyStream nextPutAll: '</body></html>'! !

!WAHtmlStreamDocument methodsFor: 'public' stamp: 'avi 7/8/2004 00:39'!
closeTag: aString
	self writeCloseTag: aString on: self bodyStream! !

!WAHtmlStreamDocument methodsFor: 'initialization' stamp: 'avi 7/8/2004 00:38'!
initializeWithRoot: anHtmlRoot
	super initializeWithRoot: anHtmlRoot.
	stream := String new writeStream.
	state := #head! !

!WAHtmlStreamDocument methodsFor: 'public' stamp: 'avi 7/8/2004 00:39'!
openTag: aString attributes: anAttributes
	self writeOpenTag: aString attributes: anAttributes on: self bodyStream! !

!WAHtmlStreamDocument methodsFor: 'accessing' stamp: 'avi 7/8/2004 00:39'!
stream
	^ stream! !

!WAHtmlStreamDocument methodsFor: 'accessing' stamp: 'avi 7/8/2004 00:38'!
stream: aStream
	stream := aStream! !

!WAHtmlStreamDocument methodsFor: 'public' stamp: 'mb 3/13/2006 15:48'!
text: aString
	self bodyStream nextPutAll: aString displayString! !

!WAHtmlStreamDocument methodsFor: 'private' stamp: 'avi 5/18/2004 13:52'!
writeCloseTag: aString on: aStream
	(self shouldPrintCloseTagFor: aString)
		ifTrue: [aStream nextPutAll: '</'; nextPutAll: aString; nextPut: $>]! !

!WAHtmlStreamDocument methodsFor: 'private' stamp: 'avi 6/13/2004 01:04'!
writeOpenTag: aString attributes: anAttributes on: aStream
	aStream
		nextPut: $<;
		nextPutAll: aString.
	anAttributes ifNotNil: [anAttributes writeOn: aStream].
	(self shouldPrintCloseTagFor: aString) ifFalse: [aStream nextPutAll: ' /'].
	aStream nextPut: $>! !

WAHtmlDocument subclass: #WAPrettyPrintedDocument
	instanceVariableNames: 'html indentLevel indentCloseTags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAPrettyPrintedDocument class methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 12:40'!
renderer: aRenderer
	^ self basicNew initializeWithRenderer: aRenderer! !

!WAPrettyPrintedDocument methodsFor: 'private' stamp: 'lr 9/6/2006 11:20'!
attribute: anAssociation
	| attr value |
	attr := anAssociation key asLowercase.
	value := anAssociation value.
	
	value = false ifFalse:
		[html space.
		html span class: (self cssClassForAttribute: attr); with:
			[html text: attr].
		html text: '='.
		html span class: 'attribute-value'; with:
			[html text: '"'.
			attr = 'href'
				ifTrue: [value ifNotNil: [html anchor url: value; with: value displayString]]
				ifFalse:
					[value = true
						ifFalse: [html text: value displayString]
						ifTrue: [html text: attr]].
			html text: '"']]! !

!WAPrettyPrintedDocument methodsFor: 'private' stamp: 'avi 6/19/2004 21:07'!
attributes: anAttributes
	anAttributes ifNotNil: [anAttributes associations do: [:ea | self attribute: ea]]! !

!WAPrettyPrintedDocument methodsFor: 'public' stamp: 'lr 10/3/2006 08:58'!
closeTag: aString
	indentLevel := indentLevel - 1.
	indentCloseTags removeLast 
		ifTrue: [ self indent ].

	(self shouldPrintCloseTagFor: aString) ifTrue:
		[html text: '</'.
		html span class: (self cssClassFor: aString); with: aString.
		html text: '>']! !

!WAPrettyPrintedDocument methodsFor: 'public' stamp: 'lr 10/3/2006 09:06'!
comment: aString
	self indent.
	html span 
		class: 'comment';
		with: [ html text: '<!!-- '; text: aString; text: ' -->' ]! !

!WAPrettyPrintedDocument methodsFor: 'testing' stamp: 'lr 10/3/2006 08:59'!
cssClassFor: aString
	^ (self isKnownTag: aString)
		ifTrue: [ 'tag-known' ]
		ifFalse: [ 'tag-unknown' ]! !

!WAPrettyPrintedDocument methodsFor: 'testing' stamp: 'lr 10/3/2006 08:59'!
cssClassForAttribute: aString
	^ (self isKnownAttribute: aString)
		ifTrue: [ 'attribute-known' ]
		ifFalse: [ 'attribute-unknown' ]! !

!WAPrettyPrintedDocument methodsFor: 'private' stamp: 'lr 10/3/2006 09:11'!
indent
	html break.
	indentLevel timesRepeat: [ html space ]! !

!WAPrettyPrintedDocument methodsFor: 'initialization' stamp: 'avi 6/3/2004 19:25'!
initializeWithRenderer: aRenderer
	html := aRenderer.
	indentCloseTags := OrderedCollection with: false.
	indentLevel := 0! !

!WAPrettyPrintedDocument methodsFor: 'testing' stamp: 'avi 4/2/2005 22:20'!
isKnownAttribute: aString
	^ self knownAttributes includes: aString asLowercase asSymbol! !

!WAPrettyPrintedDocument methodsFor: 'testing' stamp: 'avi 4/2/2005 22:20'!
isKnownTag: aString
	^ self knownTags includes: aString asSymbol! !

!WAPrettyPrintedDocument methodsFor: 'testing' stamp: 'avi 5/22/2004 12:40'!
knownAttributes
	^ #(abbr
accept-charset
accept
accesskey
action
align
alink
alt
archive
axis
background
bgcolor
bgproperties
border
cellpadding
cellspacing
char
charoff
charset
checked
cite
class
classid
clear
code
codebase
codetype
color
cols
colspan
compact
content
coords
data
datetime
declare
defer
dir
direction
disabled
encoding
enctype
face
for
frame
frameborder
framespacing
gutter
headers
height
href
hreflang
hspace
http-equiv
id
ismap
label
lang
leftmargin
link
longdesc
loop
lowsrc
marginheight
marginwidth
maxlength
media
method
methods
multiple
name
nohref
noresize
noshade
nowrap
object
onabort
onblur
onchange
onclick
ondblclick
onerror
onfocus
onkeydown
onkeypress
onkeyup
onload
onmousedown
onmousemove
onmouseout
onmouseover
onmouseup
onreset
onselect
onsubmit
onunload
prompt
PUBLIC
readonly
rel
rev
rows
rowspan
rules
scheme
scope
scrolling
selected
shape
size
span
src
standby
style
summary
tabindex
target
text
title
type
urn
usemap
valign
value
valuetype
version
vlink
vspace
width
wrap
xml:lang
xmlns)! !

!WAPrettyPrintedDocument methodsFor: 'testing' stamp: 'avi 5/22/2004 12:40'!
knownTags
	^ #(?xml
!!doctype
!!dt
a
abbr
acronym
address
applet
area
attach
b
base
basefont
bdo
big
blink
blockquote
body
br
button
caption
center
cite
code
col
colgroup
comment
component
dd
del
dfn
dir
div
dl
dt
em
fieldset
font
form
frame
frameset
h
h1
h2
h3
h4
h5
h6
head
hr
html
i
iframe
img
input
ins
isindex
kbd
label
legend
li
link
listing
map
menu
meta
multicol
nextid
nobr
noframes
noscript
object
ol
optgroup
option
p
param
plaintext
pre
q
s
samp
script
select
small
span
strike
strong
style
sub
sup
table
tbody
td
textarea
textflow
tfoot
th
thead
title
tr
tt
u
ul
var
wbr
xmp)! !

!WAPrettyPrintedDocument methodsFor: 'public' stamp: 'lr 11/6/2006 11:00'!
openTag: aString attributes: anAttributes
	Continuation currentDo: [ :cc |
		self indent.
		html text: '<'.
		html anchor 
			class: (self cssClassFor: aString);
			callback: [ cc value ];
			with: aString.
		self attributes: anAttributes.
		(self shouldPrintCloseTagFor: aString)
			ifFalse: [ html space; text: '/' ].
		html text: '>'.
		indentLevel := indentLevel + 1.
		indentCloseTags removeLast; addLast: true; addLast: false.
		^ self ].
	self halt: 'Inspect rendering context'.
	WACurrentSession value returnResponse: (WAResponse 
		redirectTo: html context actionUrl displayString)! !

!WAPrettyPrintedDocument methodsFor: 'accessing' stamp: 'ac 9/23/2005 22:08'!
root
	^ html context document root! !

!WAPrettyPrintedDocument methodsFor: 'public' stamp: 'lr 10/3/2006 08:55'!
text: aString
	html text: aString! !

Object subclass: #WAHtmlElement
	instanceVariableNames: 'children name attributes isClosed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document-Elements'!

WAHtmlElement subclass: #WABaseElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document-Elements'!

!WABaseElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:43'!
target: aString
	self attributeAt: 'target' put: aString! !

!WABaseElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:43'!
url: aString
	self attributeAt: 'href' put: aString! !

!WAHtmlElement class methodsFor: 'as yet unclassified' stamp: 'ab 5/12/2003 11:17'!
named: aString
	^ self named: aString attributes: (WAHtmlAttributes new)! !

!WAHtmlElement class methodsFor: 'as yet unclassified' stamp: 'ab 5/12/2003 11:17'!
named: aString attributes: anAttributes
	^ self new initializeWithName: aString attributes: anAttributes! !

!WAHtmlElement methodsFor: 'commands' stamp: 'ab 1/11/2003 13:47'!
add: anElement
	children ifNil: [children := OrderedCollection new].
	children add: anElement.! !

!WAHtmlElement methodsFor: 'accessing' stamp: 'rjl 8/4/2006 11:36'!
attributeAt: aString
    ^attributes at: aString! !

!WAHtmlElement methodsFor: 'accessing' stamp: 'pmm 10/11/2006 19:57'!
attributeAt: aString ifAbsent: aBlock
    ^(attributes at: aString ifAbsent: [ nil -> aBlock value ]) value
	! !

!WAHtmlElement methodsFor: 'accessing' stamp: 'ab 5/12/2003 11:14'!
attributeAt: aString put: anObject
	attributes at: aString put: anObject! !

!WAHtmlElement methodsFor: 'accessing' stamp: 'avi 5/18/2004 13:49'!
beClosed
	isClosed := true! !

!WAHtmlElement methodsFor: 'commands' stamp: 'ab 3/29/2003 00:10'!
childrenDo: aBlock
	children ifNotNil: [children do: aBlock]! !

!WAHtmlElement methodsFor: 'initialize-release' stamp: 'avi 5/18/2004 13:49'!
initializeWithName: aString attributes: anAttributes
	name := aString.
	attributes := anAttributes.
	isClosed := true.! !

!WAHtmlElement methodsFor: 'accessing' stamp: 'JF 6/11/2003 14:47'!
name
	^ name asLowercase! !

!WAHtmlElement methodsFor: 'accessing' stamp: 'pmm 9/20/2006 20:47'!
notClosed
	isClosed := false! !

!WAHtmlElement methodsFor: 'printing' stamp: 'ac 6/9/2006 12:58'!
prettyPrintHtmlOn: aStream
	self prettyPrintHtmlOn: aStream indentLevel: 0.! !

!WAHtmlElement methodsFor: 'printing' stamp: 'ac 6/9/2006 13:00'!
prettyPrintHtmlOn: aStream indentLevel: anInteger
	aStream cr.
	anInteger timesRepeat: [aStream tab].
	self printOpenTagOn: aStream.
	self childrenDo: [:ea | ea prettyPrintHtmlOn: aStream indentLevel: anInteger + 1].
	self shouldPrintCloseTag ifTrue: [self printCloseTagOn: aStream].! !

!WAHtmlElement methodsFor: 'printing' stamp: 'JF 6/11/2003 14:44'!
printCloseTagOn: aStream 
	aStream
		nextPutAll: '</';
		nextPutAll: self name;
		nextPut: $>! !

!WAHtmlElement methodsFor: 'printing' stamp: 'avi 5/22/2004 15:17'!
printHtmlOn: aStream
	self printOpenTagOn: aStream.
	self childrenDo: [:ea | ea writeOn: aStream].
	self shouldPrintCloseTag ifTrue: [self printCloseTagOn: aStream].! !

!WAHtmlElement methodsFor: 'printing' stamp: 'avi 6/19/2004 18:07'!
printOpenTagOn: aStream 
	aStream
		nextPut: $<;
		nextPutAll: self name.
	attributes ifNotNil: [attributes writeOn: aStream].
	self shouldPrintCloseTag ifFalse: [aStream nextPutAll: ' /'].
	aStream nextPut: $>! !

!WAHtmlElement methodsFor: 'accessing' stamp: 'avi 5/18/2004 13:51'!
shouldPrintCloseTag
	^ isClosed! !

!WAHtmlElement methodsFor: 'commands' stamp: 'avi 6/19/2004 18:10'!
writeOn: aStream
	self printOpenTagOn: aStream.
	self childrenDo: [:ea | ea isString ifTrue: [aStream nextPutAll: ea] ifFalse: [ea writeOn: aStream]].
	self shouldPrintCloseTag ifTrue: [self printCloseTagOn: aStream].! !

WAHtmlElement subclass: #WAMetaElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document-Elements'!

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:20'!
beLeftToRight
	self textDirection: 'LTR'! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:20'!
beRightToLeft
	self textDirection: 'RTL'! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:17'!
content: aString
	self attributeAt: 'content' put: aString! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:27'!
contentType: aString
	self responseHeaderName: 'Content-Type'.
	self content: aString! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:29'!
contentType: aConentTypeString charset: aCharsetString
	self contentType: aConentTypeString, '; charset=', aCharsetString! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:18'!
language: aString
	self attributeAt: 'lang' put: aString! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:17'!
name: aString
	self attributeAt: 'name' put: aString! !

!WAMetaElement methodsFor: 'attributes' stamp: 'mb 10/13/2006 10:12'!
redirectAfter: seconds to: aString
	self responseHeaderName: 'refresh'.
	self content: seconds displayString , ';URL=' , aString! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:25'!
responseHeaderName: aString
	self attributeAt: 'http-equiv' put: aString! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:17'!
scheme: aString
	self attributeAt: 'scheme' put: aString! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:19'!
textDirection: aString
	self attributeAt: 'dir' put: aString! !

WAHtmlElement subclass: #WARootedElement
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document-Elements'!

WARootedElement subclass: #WALinkElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document-Elements'!

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:36'!
addAll
	self addMedia: 'all'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:36'!
addAural
	self addMedia: 'aural'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:36'!
addBraille
	self addMedia: 'braille'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:35'!
addHandheld
	self addMedia: 'handheld'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:34'!
addMedia: aString
	| media |
	media :=	(((attributes at: 'media' ifAbsent: [ '' ])
		findTokens: $,)
			collect: [ :each | each withBlanksTrimmed ])
				asSet.
	
	media add: aString.
	
	self media: (String streamContents: [ :stream |
		media
			do: [ :each | stream nextPutAll: each ]
			separatedBy: [ stream nextPutAll: ', ' ] ])
	! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:36'!
addPrint
	self addMedia: 'print'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:35'!
addProjection
	self addMedia: 'projection'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:35'!
addScreen
	self addMedia: 'screen'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:35'!
addTeletype
	self addMedia: 'tty'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:35'!
addTelevision
	self addMedia: 'tv'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:13'!
beAlternate
	self relationship: 'alternate'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:14'!
beAlternateStylesheet
	self relationship: 'alternate stylesheet'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:12'!
beAppendix
	self relationship: 'appendix'! !

!WALinkElement methodsFor: 'type' stamp: 'pmm 10/7/2006 18:34'!
beAtom
	self type: 'application/atom+xml'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:18'!
beAuthor
	self relationship: 'author'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:12'!
beBookmark
	self relationship: 'bookmark'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:11'!
beChapter
	self relationship: 'chapter'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:11'!
beClossary
	self relationship: 'lossary'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:11'!
beCopyright
	self relationship: 'copyright'! !

!WALinkElement methodsFor: 'type' stamp: 'pmm 10/7/2006 17:40'!
beCss
	self type: 'text/css'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:18'!
beFirst
	self relationship: 'first'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:17'!
beFontDefinition
	self relationship: 'fontdef'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:12'!
beHelp
	self relationship: 'help'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:10'!
beIndex
	self relationship: 'index'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:18'!
beLast
	self relationship: 'last'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:58'!
beMicrosummary
	"http://wiki.mozilla.org/Microsummaries"
	self relationship: 'microsummary'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:06'!
beNext
	self relationship: 'next'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:10'!
bePrevious
	self relationship: 'previous'! !

!WALinkElement methodsFor: 'type' stamp: 'pmm 10/7/2006 18:34'!
beRss
	self type: 'application/rss+xml'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:17'!
beSearch
	self relationship: 'search'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:11'!
beSection
	self relationship: 'section'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:16'!
beShortcutIcon
	self relationship: 'shortcut icon'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:05'!
beStart
	self relationship: 'start'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:04'!
beStylesheet
	self relationship: 'stylesheet'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:12'!
beSubsection
	self relationship: 'subsection'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:10'!
beTableOfContents
	self relationship: 'contents'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:18'!
beTop
	self relationship: 'top'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:18'!
beUp
	self relationship: 'up'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:01'!
media: aString
	self attributeAt: 'media' put: aString! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:04'!
relationship: aString
	self attributeAt: 'rel' put: aString! !

!WALinkElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 17:09'!
title: aString
	self attributeAt: 'title' put: aString! !

!WALinkElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:10'!
url: aString
	self attributeAt: 'href' put: aString! !

!WARootedElement class methodsFor: 'instance creation' stamp: 'pmm 10/7/2006 17:49'!
named: aString root: anHtmlRoot
	^(self named: aString)
		setRoot: anHtmlRoot;
		yourself! !

!WARootedElement class methodsFor: 'instance creation' stamp: 'pmm 10/7/2006 17:48'!
root: anHtmlRoot
	^self new
		setRoot: anHtmlRoot;
		yourself! !

!WARootedElement methodsFor: 'attributes' stamp: 'pmm 10/10/2006 23:12'!
document: aDocument
	self document: aDocument mimeType: self typeOrNil! !

!WARootedElement methodsFor: 'attributes' stamp: 'pmm 10/10/2006 23:22'!
document: aDocument fileName: fileName
	self document: aDocument mimeType: self typeOrNil fileName: fileName! !

!WARootedElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 17:54'!
document: aDocument mimeType: mimeType
	self document: aDocument mimeType: mimeType fileName: nil! !

!WARootedElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 17:54'!
document: aDocument mimeType: mimeType fileName: fileName
	self url: (root context urlForDocument: aDocument mimeType: mimeType fileName: fileName)! !

!WARootedElement methodsFor: 'attributes' stamp: 'lr 10/12/2006 10:55'!
resourceUrl: aString
	self url: (root absoluteUrlForResource: aString)! !

!WARootedElement methodsFor: 'initialize-release' stamp: 'pmm 10/7/2006 17:40'!
setRoot: anHtmlRoot
	root := anHtmlRoot! !

!WARootedElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 16:53'!
type: aString
	self attributeAt: 'type' put: aString! !

!WARootedElement methodsFor: 'private' stamp: 'pmm 10/11/2006 19:54'!
typeOrNil
	^self attributeAt: 'type' ifAbsent:  [ nil ]! !

!WARootedElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:15'!
url: aString
	self subclassResponsibility ! !

WARootedElement subclass: #WAScriptElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document-Elements'!

!WAScriptElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:05'!
beJavascript
	self type: 'text/javascript'! !

!WAScriptElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:11'!
url
	^self attributeAt: 'src' ifAbsent: [ nil ]! !

!WAScriptElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:10'!
url: aString
	self attributeAt: 'src' put: aString! !

Object subclass: #WAHtmlRoot
	instanceVariableNames: 'docType title htmlAttrs headAttrs bodyAttrs headElements scripts styles resourceBaseUrl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document'!

!WAHtmlRoot class methodsFor: 'instance creation' stamp: 'avi 6/19/2004 18:05'!
new
	^ self basicNew initialize! !

!WAHtmlRoot methodsFor: 'api' stamp: 'avi 9/11/2005 14:39'!
absoluteUrlForResource: aString
	(aString beginsWith: 'http') ifTrue: [^ aString].
	resourceBaseUrl ifNil: [^ aString].
	^ resourceBaseUrl, aString! !

!WAHtmlRoot methodsFor: 'api' stamp: 'lr 10/12/2006 08:50'!
addHeadElement: anHtmlElement
	^ headElements add: anHtmlElement! !

!WAHtmlRoot methodsFor: 'initialize-release' stamp: 'mb 2/9/2006 18:45'!
addHtmlNameSpace
	htmlAttrs
		at: 'xmlns' put: 'http://www.w3.org/1999/xhtml';
		at: 'xml:lang' put: 'en';
		at: 'lang' put: 'en'.
! !

!WAHtmlRoot methodsFor: 'initialize-release' stamp: 'pmm 10/7/2006 18:36'!
addMetaContentType
	self meta contentType: self contentType charset: self charSet
! !

!WAHtmlRoot methodsFor: 'javascript' stamp: 'avi 6/18/2004 17:02'!
addScript: aString
	(scripts includes: aString) ifFalse: [scripts add: aString]! !

!WAHtmlRoot methodsFor: 'css' stamp: 'avi 6/18/2004 17:02'!
addStyle: aString
	(styles includes: aString) ifFalse: [styles add: aString]! !

!WAHtmlRoot methodsFor: 'new-api' stamp: 'pmm 10/7/2006 18:44'!
base
	^self addHeadElement: (WABaseElement named: 'base')
! !

!WAHtmlRoot methodsFor: 'accessing' stamp: 'avi 6/17/2004 15:56'!
bodyAttributes
	^ bodyAttrs! !

!WAHtmlRoot methodsFor: 'accessing' stamp: 'mb 2/9/2006 18:48'!
charSet
	^'utf-8'! !

!WAHtmlRoot methodsFor: 'api' stamp: 'pmm 10/7/2006 18:44'!
contentBase: urlString
	self base url: urlString! !

!WAHtmlRoot methodsFor: 'accessing' stamp: 'mb 3/30/2006 12:28'!
contentType
	^'text/html'! !

!WAHtmlRoot methodsFor: 'accessing' stamp: 'avi 6/17/2004 15:53'!
docType
	^ docType! !

!WAHtmlRoot methodsFor: 'accessing' stamp: 'mb 9/21/2006 17:06'!
docType: aString
	docType := aString! !

!WAHtmlRoot methodsFor: 'deprecated' stamp: 'pmm 10/19/2006 20:20'!
forIE5Do: aBlock
	self deprecatedApi.
	self if  greaterThan; orEqual; ie5; do: aBlock! !

!WAHtmlRoot methodsFor: 'deprecated' stamp: 'lr 10/12/2006 08:21'!
forIE6Do: aBlock
	self deprecatedApi.
	self if ie6; do: aBlock! !

!WAHtmlRoot methodsFor: 'deprecated' stamp: 'lr 10/12/2006 08:21'!
forIE7Do: aBlock
	self deprecatedApi.
	self if ie7; do: aBlock! !

!WAHtmlRoot methodsFor: 'accessing' stamp: 'avi 6/17/2004 15:57'!
headAttributes
	^ headAttrs! !

!WAHtmlRoot methodsFor: 'accessing' stamp: 'avi 6/17/2004 15:54'!
htmlAttributes
	^ htmlAttrs! !

!WAHtmlRoot methodsFor: 'new-api' stamp: 'pmm 10/11/2006 17:35'!
if
	^WAConditionalComment root: self
! !

!WAHtmlRoot methodsFor: 'initialize-release' stamp: 'mb 2/10/2006 11:26'!
initialize
	htmlAttrs := WAHtmlAttributes new.
	headAttrs := WAHtmlAttributes new.
	bodyAttrs := WAHtmlAttributes new.
	headElements := OrderedCollection new.
	scripts := OrderedCollection new.
	styles := OrderedCollection new.
	docType := '<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">'.
	title := 'Seaside'.

	self addHtmlNameSpace.
	self addMetaContentType.! !

!WAHtmlRoot methodsFor: 'new-api-convenience' stamp: 'pmm 10/10/2006 23:05'!
javascript
	^self script
		beJavascript;
		yourself! !

!WAHtmlRoot methodsFor: 'new-api' stamp: 'pmm 10/7/2006 17:51'!
link
	^self addHeadElement: (WALinkElement named: 'link' root: self)
! !

!WAHtmlRoot methodsFor: 'javascript' stamp: 'pmm 10/7/2006 18:12'!
linkToScript: url 
	"only link to script if it's not already been linked too, necessary when lists of child components try to link to dependant scripts, a google map for example"

	| fullUrl |
	fullUrl := self absoluteUrlForResource: url asString.
	headElements 
		detect: [ :each | each name = 'script' and: [ each url = fullUrl ] ]
		ifNone: [ self scriptElementWithSrc: fullUrl ]! !

!WAHtmlRoot methodsFor: 'deprecated' stamp: 'lr 10/12/2006 09:08'!
linkToStyle: url
	self deprecatedApi.
	self stylesheet resourceUrl: url asString
! !

!WAHtmlRoot methodsFor: 'deprecated' stamp: 'lr 10/12/2006 08:49'!
linkToStyle: url titled: aString
	self deprecatedApi.
	self stylesheet
		resourceUrl: url asString;
		title: aString
! !

!WAHtmlRoot methodsFor: 'deprecated' stamp: 'lr 10/12/2006 08:49'!
linkToStyle: url titled: aString media: aMediaString
	self deprecatedApi.
	self stylesheet
		resourceUrl: url asString;
		title: aString;
		media: aMediaString
! !

!WAHtmlRoot methodsFor: 'new-api' stamp: 'pmm 10/7/2006 19:05'!
meta
	^self addHeadElement: ((WAMetaElement named: 'meta')
		notClosed;
		yourself)
! !

!WAHtmlRoot methodsFor: 'api' stamp: 'pmm 10/7/2006 18:41'!
redirectTo: locationString delay: aNumber
	self meta redirectAfter: aNumber to: locationString! !

!WAHtmlRoot methodsFor: 'api' stamp: 'lr 10/12/2006 08:50'!
removeHeadElement: anHtmlElement
	^ headElements remove: anHtmlElement! !

!WAHtmlRoot methodsFor: 'accessing' stamp: 'avi 9/11/2005 14:39'!
resourceBaseUrl
	^ resourceBaseUrl! !

!WAHtmlRoot methodsFor: 'accessing' stamp: 'avi 9/11/2005 14:38'!
resourceBaseUrl: aString
	resourceBaseUrl := aString! !

!WAHtmlRoot methodsFor: 'new-api' stamp: 'pmm 10/7/2006 18:03'!
script
	^self addHeadElement: (WAScriptElement named: 'script' root: self)
! !

!WAHtmlRoot methodsFor: 'deprecated' stamp: 'lr 10/12/2006 09:07'!
scriptElementWithSrc: aString
	self deprecatedApi.
	^ self javascript
		url: aString;
		yourself! !

!WAHtmlRoot methodsFor: 'deprecated' stamp: 'lr 10/12/2006 08:52'!
styleElementWithHref: aString
	self deprecatedApi.
	^ self removeHeadElement: (self stylesheet
		url: aString)! !

!WAHtmlRoot methodsFor: 'deprecated' stamp: 'lr 10/12/2006 08:51'!
styleElementWithHref: anUrlString titled: aTitleString
	self deprecatedApi.
	^ self removeHeadElement: (self stylesheet
		url: anUrlString;
		title: aTitleString)
! !

!WAHtmlRoot methodsFor: 'deprecated' stamp: 'lr 10/12/2006 08:52'!
styleElementWithHref: anUrlString titled: aTitleString media: aMediaString
	self deprecatedApi.
	^ self removeHeadElement: (self stylesheet
		url: anUrlString;
		title: aTitleString;
		media: aMediaString)! !

!WAHtmlRoot methodsFor: 'new-api-convenience' stamp: 'lr 10/12/2006 08:49'!
stylesheet
    ^self link beStylesheet; beCss; notClosed; yourself! !

!WAHtmlRoot methodsFor: 'accessing' stamp: 'avi 6/17/2004 15:53'!
title
	^ title! !

!WAHtmlRoot methodsFor: 'accessing' stamp: 'avi 6/17/2004 15:54'!
title: aString
	title := aString! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'mb 2/10/2006 11:26'!
writeHeadOn: aStream
	aStream nextPutAll: '<title>', title, '</title>'.
	headElements do: [:ea | ea writeOn: aStream].
	styles do: [:ea | self writeStyle: ea on: aStream].
	scripts do: [:ea | self writeScript: ea on: aStream].
! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'avi 7/5/2004 11:45'!
writeOn: aStream
	aStream nextPutAll: docType.
	aStream nextPutAll: '<html'.
	htmlAttrs writeOn: aStream.
	aStream nextPutAll: '><head'.
	headAttrs writeOn: aStream.
	aStream nextPutAll: '>'.
	self writeHeadOn: aStream. 
	aStream nextPutAll: '</head><body'.
	bodyAttrs writeOn: aStream.
	aStream nextPutAll: '>'.! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'lr 11/21/2006 20:43'!
writeScript: aString on: aStream
	aStream
		nextPutAll: '<script type="text/javascript">/*<!![CDATA[*/';
		nextPutAll: aString;
		nextPutAll: '/*]]>*/</script>'! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'avi 6/18/2004 18:37'!
writeStyle: aString on: aStream
	aStream
		nextPutAll: '<style>';
		nextPutAll: aString;
		nextPutAll: '</style>'! !

WAHtmlRoot subclass: #WARenderedHtmlRoot
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WARenderedHtmlRoot class methodsFor: 'accessing' stamp: 'avi 6/24/2004 01:21'!
context: aRenderingContext
	^ self basicNew initializeWithContext: aRenderingContext! !

!WARenderedHtmlRoot methodsFor: 'accessing' stamp: 'avi 3/27/2005 20:29'!
context
	^ context! !

!WARenderedHtmlRoot methodsFor: 'initialize-release' stamp: 'mb 9/21/2006 17:15'!
initializeWithContext: aRenderingContext
	context := aRenderingContext.
	self initialize.! !

!WARenderedHtmlRoot methodsFor: 'deprecated' stamp: 'lr 10/12/2006 08:21'!
linkWithScript: aString
	self deprecatedApi.
	self javascript
		document: aString
! !

!WARenderedHtmlRoot methodsFor: 'deprecated' stamp: 'lr 10/12/2006 08:51'!
linkWithStyle: aString
	self deprecatedApi.
	self stylesheet
		document: aString
! !

!WARenderedHtmlRoot methodsFor: 'deprecated' stamp: 'lr 10/12/2006 08:51'!
linkWithStyle: aString titled: aTitleString
	self deprecatedApi.
	self stylesheet
		title: aString;
		document: aString! !

!WARenderedHtmlRoot methodsFor: 'deprecated' stamp: 'lr 10/12/2006 08:51'!
linkWithStyle: aString titled: aTitleString media: aMediaString
	self deprecatedApi.
	self stylesheet
		title: aString;
		media: aMediaString;
		document: aString
! !

!WARenderedHtmlRoot methodsFor: 'writing' stamp: 'pmm 10/11/2006 00:02'!
writeScript: aString on: aStream
	"this is ugly code, but at least you know can see that at first glance"
	| script |
	script := self javascript document: aString; yourself.
	script writeOn: aStream.
	self removeHeadElement: script ! !

!WARenderedHtmlRoot methodsFor: 'writing' stamp: 'lr 10/12/2006 08:51'!
writeStyle: aString on: aStream
	"this is ugly code, but at least you know can see that at first glance"
	| style |
	style := self stylesheet document: aString; yourself.
	style writeOn: aStream.
	self removeHeadElement: style! !

Object subclass: #WAKom
	instanceVariableNames: 'entryPoint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

WAKom class
	instanceVariableNames: 'port service'!

!WAKom commentStamp: 'pmm 10/14/2006 14:34' prior: 0!
I provide an adapter between Seaside and the Comanche web server. To start a new server on port 8080, evaluate

	WAKom startOn: 8080.
	
and to stop it, evaluate

	WAKom stop.

I don't work on Squeak 3.9 for non-ASCII characters.
	
The state of the service (running or stopped) is automatically restored when quitting and reopening an image.

If you want to reset the password of the config application (reachable at /seaside/config) evaluate

	WADispatcherEditor initialize.!

WAKom class
	instanceVariableNames: 'port service'!

!WAKom class methodsFor: 'service' stamp: 'avi 4/2/2005 22:18'!
createService
   Smalltalk at: #HttpService ifPresent:
       [:hs |
       ^ (hs on: port named: 'seaside') plug: self default].
   Smalltalk at: #ComancheNetService ifPresent:
       [:cns |
       ^ (cns named: 'seaside' onPort: port) module: self default].
   self error: 'Comanche is not installed.  Install Comanche from
SqueakMap and try again.'
! !

!WAKom class methodsFor: 'accessing' stamp: 'avi 1/14/2004 22:44'!
default
	^ self entryPoint: WADispatcher default! !

!WAKom class methodsFor: 'as yet unclassified' stamp: 'avi 11/20/2003 01:13'!
entryComponent: aClass path: aString
	^ self dispatcher: (aClass applicationWithPath: aString)! !

!WAKom class methodsFor: 'as yet unclassified' stamp: 'avi 11/20/2003 01:13'!
entryPoint: anEntryPoint
	^ self new entryPoint: anEntryPoint! !

!WAKom class methodsFor: 'service' stamp: 'ab 10/10/2002 11:42'!
initialize
		Smalltalk addToStartUpList: self after: AutoStart.
		Smalltalk addToShutDownList: self! !

!WAKom class methodsFor: 'service' stamp: 'avi 9/26/2003 23:52'!
pause
	service ifNotNil:
		[service unregister.
		service := nil]! !

!WAKom class methodsFor: 'accessing' stamp: 'avi 10/6/2005 21:26'!
port
	^ port! !

!WAKom class methodsFor: 'service' stamp: 'ac 12/2/2003 12:32'!
setDebugMode
	service setDebugMode.! !

!WAKom class methodsFor: 'service' stamp: 'ac 12/2/2003 12:33'!
setDeploymentMode
	service setDeploymentMode.! !

!WAKom class methodsFor: 'service' stamp: 'ac 12/2/2003 12:32'!
setVerboseMode
	service setVerboseMode.! !

!WAKom class methodsFor: 'service' stamp: 'avi 10/30/2005 16:40'!
shutDown
	self pause! !

!WAKom class methodsFor: 'service' stamp: 'avi 9/26/2003 23:52'!
startOn: aPort
	self stop.
	port := aPort.
	service := self createService.
	service start.
! !

!WAKom class methodsFor: 'service' stamp: 'avi 10/7/2005 16:23'!
startUp
	port := (SmalltalkImage current extractParameters at: 'PORT' ifAbsent: [port]).
	port ifNotNil: [self startOn: port asNumber]! !

!WAKom class methodsFor: 'service' stamp: 'ab 10/10/2002 11:41'!
stop
	self pause.
	port := nil.
! !

!WAKom methodsFor: 'private' stamp: 'pmm 10/14/2006 14:28'!
contentsOfResponse: aResponse
	^aResponse contents! !

!WAKom methodsFor: 'converting' stamp: 'pmm 10/14/2006 14:24'!
convertRequest: aKomRequest
	| request |
	self processMultipartFields: aKomRequest.

	request := WARequest
		method: aKomRequest method
		url: aKomRequest url unescapePercents 
		headers: aKomRequest header
		fields: (self fieldsOf: aKomRequest)
		cookies: aKomRequest cookies
		nativeRequest: aKomRequest.

	aKomRequest method = 'PUT'
		ifTrue: [request fields
					at: 'PUTData'
					put: (aKomRequest stream next: aKomRequest contentLength)].
	^ request! !

!WAKom methodsFor: 'converting' stamp: 'pmm 10/14/2006 14:30'!
convertResponse: aResponse
	| komResponse |
	aResponse ifNil: [^ HttpResponse fromString: 'Request handling aborted; reload to retry'].

	komResponse :=  HttpResponse new.

	aResponse cookies do:
		[:assoc | komResponse setCookieName: assoc key value: assoc valueWithExpiry path: assoc path].
		
	aResponse headers associationsDo: [:assoc | komResponse fieldAt: assoc key put: assoc value].
	(HttpResponse classPool at: #StatusCodes) associationsDo:
		[:assoc |
		assoc value key = aResponse status ifTrue: [komResponse status: assoc key]].
	komResponse contents: (self contentsOfResponse: aResponse).
	komResponse contentType: aResponse contentType.

	^ komResponse
! !

!WAKom methodsFor: 'accessing' stamp: 'avi 11/20/2003 01:13'!
entryPoint: anEntryPoint
	entryPoint := anEntryPoint! !

!WAKom methodsFor: 'private' stamp: 'pmm 10/14/2006 14:23'!
fieldsOf: aKomRequest
	^aKomRequest method = 'POST'
		ifTrue: [ aKomRequest postFields ]
		ifFalse: [ aKomRequest getFields ]! !

!WAKom methodsFor: 'actions' stamp: 'cwp 3/26/2004 23:03'!
handleRequest: aRequest
	^ (entryPoint handlerForRequest: aRequest) handleRequest: aRequest! !

!WAKom methodsFor: 'actions' stamp: 'avi 11/20/2003 00:43'!
log: aRequest
	Transcript cr; show: aRequest url! !

!WAKom methodsFor: 'actions' stamp: 'avi 11/28/2005 00:22'!
process: komRequest
	|request response komResponse |
	^ WAReadWriteLock global read:
		[self log: komRequest.
		request := self convertRequest: komRequest.

		response := self handleRequest: request.
		komResponse := self convertResponse: response.

		response release.
		komResponse]! !

!WAKom methodsFor: 'kom 6.1' stamp: 'ab 5/18/2003 13:53'!
processHttp
	HttpResponse current: (self process: HttpRequest current).
	^ true! !

!WAKom methodsFor: 'kom 6.1' stamp: 'ab 5/18/2003 11:24'!
processHttpRequest: aRequest
	^ self process: aRequest! !

!WAKom methodsFor: 'actions' stamp: 'mb 4/23/2006 15:25'!
processMultipartFields: aRequest
	aRequest multipartFormFieldsDo:
		[:chunk |
		chunk fileName isEmptyOrNil ifFalse:
			[|stream file|
			stream := WriteStream on: String new.
			chunk saveToStream: stream.
			file := WAFile new
				fileName: chunk fileName;
				contents: stream contents;
				contentType: chunk contentType;
				yourself.
			aRequest postFields at: chunk fieldName put: file]].! !

!WAKom methodsFor: 'kom 6.1' stamp: 'ab 5/18/2003 14:11'!
validateForStack: anArray! !

WAKom subclass: #WAKomEncoded39
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

!WAKomEncoded39 commentStamp: 'pmm 10/14/2006 14:34' prior: 0!
I have the same resposibility like WAKomEncoded except that I'm for Squeak 3.9.!

WAKomEncoded39 subclass: #WAKomEncoded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

!WAKomEncoded commentStamp: 'pmm 10/14/2006 14:11' prior: 0!
I provide an adapter between Seaside and the Comanche web server with response/request conversion from UTF-8 to WideString and back in Squeak 3.8.

see WAKom!

!WAKomEncoded methodsFor: 'private' stamp: 'pmm 10/14/2006 14:36'!
fieldsOf: aKomRequest
	^(super fieldsOf: aKomRequest) associationsDo: [ :association |
		(association value isKindOf: OrderedCollection) ifTrue: [
			association value: (association value collect: [ :s |
			| multiString |	
			multiString := (MultiByteBinaryOrTextStream with: s) reset.
			multiString converter: UTF8TextConverter new.
			multiString contents] ) ] ]! !

!WAKomEncoded39 methodsFor: 'private' stamp: 'mb 11/1/2006 18:32'!
contentsOfResponse: aResponse
	| responseStream tokens type subTypes  |
	responseStream := aResponse.
	tokens := aResponse contentType findTokens: '/'.
	type := tokens first.
	subTypes := tokens second findTokens: '+'.
	(type = 'text' or: [subTypes includes: 'xml']) ifTrue: [
		responseStream := MultiByteBinaryOrTextStream on: WideString new encoding: #utf8.
		responseStream nextPutAll: aResponse contents.
		responseStream binary reset ].
	^responseStream contents readStream! !

Object subclass: #WALRUCache
	instanceVariableNames: 'table ageTable max'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Utilities'!

!WALRUCache class methodsFor: 'instance creation' stamp: 'pmm 4/18/2006 20:17'!
new
	^ self basicNew initialize! !

!WALRUCache class methodsFor: 'instance creation' stamp: 'ab 7/15/2002 00:10'!
new: max
	^ self new capacity: max! !

!WALRUCache methodsFor: 'accessing' stamp: 'ab 2/15/2003 21:18'!
at: key
	^ self at: key ifAbsent: [self error: 'No entry for ', key]! !

!WALRUCache methodsFor: 'accessing' stamp: 'ab 2/15/2003 21:28'!
at: key ifAbsent: errorBlock
	|val|
	val := table at: key ifAbsent: [^ errorBlock value].
	ageTable at: val put: 0.
	^ val.! !

!WALRUCache methodsFor: 'accessing' stamp: 'ab 5/24/2003 00:37'!
at: key put: val
	|removals|
	table at: key put: val.
	ageTable at: val put: 0.
	removals := OrderedCollection new.
	ageTable associationsDo:
		[:assoc |
		assoc value > max ifTrue: [removals add: assoc key].
		assoc value: assoc value + 1].
	removals do: [:ea | self remove: ea].
	! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'ab 7/15/2002 00:10'!
capacity: aNumber
	max := aNumber! !

!WALRUCache methodsFor: 'initialize-release' stamp: 'ab 2/18/2003 19:07'!
initialize
	max := 20.
	table := Dictionary new.
	ageTable := Dictionary new.! !

!WALRUCache methodsFor: 'testing' stamp: 'avi 1/31/2004 17:45'!
isEmpty
	^ table isEmpty! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'mbany 4/14/2005 12:44'!
nextKey
	|key|
	[table includesKey: (key := WAExternalID new displayString)] whileTrue.
	^ key! !

!WALRUCache methodsFor: 'removing' stamp: 'ab 7/10/2003 11:48'!
remove: anObject
	ageTable removeKey: anObject.
	table removeKey: (table keyAtValue: anObject)! !

!WALRUCache methodsFor: 'printing' stamp: 'ab 2/15/2003 21:23'!
store: anObject
	|key|
	key := self nextKey.
	self at: key put: anObject.
	^ key! !

Object subclass: #WAListener
	instanceVariableNames: 'port process dispatcher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

WAListener class
	instanceVariableNames: 'default'!

WAListener class
	instanceVariableNames: 'default'!

!WAListener class methodsFor: 'accessing' stamp: 'lr 6/28/2006 15:19'!
default
	^ default! !

!WAListener class methodsFor: 'accessing' stamp: 'avi 1/6/2006 14:19'!
dispatcher
	^ WADispatcher default! !

!WAListener class methodsFor: 'initialization' stamp: 'lr 6/28/2006 14:37'!
initialize
	Smalltalk addToStartUpList: self after: AutoStart.
	Smalltalk addToShutDownList: self! !

!WAListener class methodsFor: 'instance-creation' stamp: 'avi 1/6/2006 14:18'!
port: aNumber
	^ self basicNew initializeWithPort: aNumber! !

!WAListener class methodsFor: 'initialization' stamp: 'lr 6/28/2006 14:39'!
shutDown
	default ifNotNil: [ default stop ]! !

!WAListener class methodsFor: 'public' stamp: 'lr 6/28/2006 14:39'!
startOn: aNumber
	default ifNotNil: [ default stop ].
	default := self port: aNumber.
	default dispatcher: self dispatcher.
	default start! !

!WAListener class methodsFor: 'initialization' stamp: 'lr 6/28/2006 14:39'!
startUp
	default ifNotNil: [ default start ]! !

!WAListener class methodsFor: 'public' stamp: 'lr 6/28/2006 14:39'!
stop
	default ifNotNil: [ default stop ].
	default := nil! !

!WAListener methodsFor: 'private' stamp: 'pmm 10/14/2006 14:35'!
convertRequest: aKomRequest
	| request |
	request := WARequest
		method: aKomRequest method
		url: aKomRequest url unescapePercents 
		headers: aKomRequest header
		fields: (self fieldsOf: aKomRequest)
		cookies: aKomRequest cookies
		nativeRequest: aKomRequest.

	aKomRequest method = 'PUT'
		ifTrue: [request fields
					at: 'PUTData'
					put: (aKomRequest stream next: aKomRequest contentLength)].
	^ request! !

!WAListener methodsFor: 'accessing' stamp: 'avi 1/6/2006 14:19'!
dispatcher
	^dispatcher! !

!WAListener methodsFor: 'accessing' stamp: 'avi 1/6/2006 14:19'!
dispatcher: anObject
	dispatcher := anObject! !

!WAListener methodsFor: 'private' stamp: 'pmm 10/14/2006 14:35'!
fieldsOf: aKomRequest
	^aKomRequest method = 'POST'
		ifTrue: [ aKomRequest postFields ]
		ifFalse: [ aKomRequest getFields ]! !

!WAListener methodsFor: 'initialization' stamp: 'avi 1/6/2006 14:18'!
initializeWithPort: aNumber
	port := aNumber.! !

!WAListener methodsFor: 'private' stamp: 'lr 10/15/2006 11:42'!
listenLoop
	| socket |
	socket := Socket newTCP.
	socket listenOn: port backlogSize: 50.
	socket isValid 
		ifFalse: [ self error: 'Cannot create socket on port ' , port asString ].
	[ [ socket isValid ifFalse: [
			"will trigger #ifCurtailed: block and destroy socket"
			^self listenLoop ].
		self waitForConnectionOn: socket ] repeat ]
		ifCurtailed: [
			"probably copy pasted from ConnectionQueue >> #listenLoop"
			(Delay forMilliseconds: 10) wait.
			socket destroy ].! !

!WAListener methodsFor: 'private' stamp: 'pmm 10/14/2006 14:17'!
outputStreamFor: aSocketStream
	^aSocketStream! !

!WAListener methodsFor: 'private' stamp: 'pmm 10/14/2006 14:19'!
processConnection: aSocket
	| stream |
	stream := SocketStream on: aSocket.
	stream autoFlush: true.
	[ [ [ self
			writeResponseForRequest: (HttpRequest readFromStream: stream)
			on: (self outputStreamFor: stream). ]
		ensure: [ stream close ] ]
		ifCurtailed: [ aSocket destroy ] ]
		forkAt: Processor userBackgroundPriority! !

!WAListener methodsFor: 'private' stamp: 'avi 1/6/2006 14:18'!
responseForRequest: aRequest
	^ HTTPResponse notFound! !

!WAListener methodsFor: 'public' stamp: 'lr 6/28/2006 14:16'!
start
	self stop.
	process := [ [ self listenLoop ] repeat ] 
		forkAt: Processor highIOPriority! !

!WAListener methodsFor: 'public' stamp: 'avi 1/6/2006 14:18'!
stop
	process ifNotNil: [process terminate. process := nil]! !

!WAListener methodsFor: 'private' stamp: 'lr 6/28/2006 14:12'!
waitForConnectionOn: aSocket
	| connection |
	connection := (aSocket waitForAcceptFor: 10)
		ifNil: [ ^ self ].
	self processConnection: connection! !

!WAListener methodsFor: 'private' stamp: 'lr 7/3/2006 16:27'!
writeResponseForRequest: aRequest on: aStream
	| request response |
	request := self convertRequest: aRequest.
	request responseStream: aStream.
	response := dispatcher handleRequest: request.	
	response ifNil: [ ^ self ].
	response writeOn: aStream.
	response release! !

Object subclass: #WAMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WAMain methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 20:37'!
application
	^ self session application! !

!WAMain methodsFor: 'user authentication' stamp: 'avi 4/13/2004 20:31'!
session
	^ WACurrentSession value! !

!WAMain methodsFor: 'accessing' stamp: 'avi 2/2/2004 01:25'!
start: aRequest
	self subclassResponsibility! !

WAMain subclass: #WARenderLoopMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RenderLoop'!

WARenderLoopMain subclass: #WAAuthMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAAuthMain methodsFor: 'as yet unclassified' stamp: 'avi 5/19/2004 14:16'!
createRoot
	| root |
	root := super createRoot.
	root addDecoration: (WABasicAuthentication new authenticator: self).
	^ root! !

!WAAuthMain methodsFor: 'password verification' stamp: 'pmm 9/12/2006 18:10'!
verifyPassword: password forUser: username
	^self application login = username
		and: [ self application password = password ]! !

!WARenderLoopMain methodsFor: 'as yet unclassified' stamp: 'avi 2/10/2004 16:09'!
call: aComponent
	^ WARenderLoop new call: aComponent! !

!WARenderLoopMain methodsFor: 'as yet unclassified' stamp: 'avi 4/22/2004 14:59'!
createRoot
	^ self rootClass new! !

!WARenderLoopMain methodsFor: 'as yet unclassified' stamp: 'mb 5/26/2006 09:17'!
rootClass
	^ self application rootComponent! !

!WARenderLoopMain methodsFor: 'accessing' stamp: 'avi 11/7/2005 11:51'!
start: aRequest
	| root |
	root := self createRoot.
	root visiblePresentersDo: [:ea | ea initialRequest: aRequest].
	(WARenderLoop new root: root) run
! !

Object subclass: #WAModelProxy
	instanceVariableNames: 'cache model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Utilities'!

!WAModelProxy commentStamp: '<historical>' prior: 0!
I am a fake object that can be interposed between the real model object and the client, so that the data can be validated or collected before commiting to the real model.

If you have a model instance like

	model := WAStoreAddress new.
	model street: 'Rathausgasse 34'.

create a model proxy by evaluating the following code:

	proxy := WAModelProxy on: model.
	
Then use the accessors of the proxy as you would do with your model:

	proxy country: 'Switzerland'.
	proxy street -> 'Rathausgasse 34'
	...
	
To propagate the values into your model send #commit :

	proxy commit.
	model country -> 'Switzerland'!

!WAModelProxy class methodsFor: 'instance creation' stamp: 'ab 11/26/2002 17:21'!
on: anObject
	^ self new setModel: anObject! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 12/12/2002 00:18'!
commit
	cache keysAndValuesDo:
		[:key :value |
		self performRealWrite: key with: value].

	cache := Dictionary new.
! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'pmm 9/12/2006 18:37'!
doesNotUnderstand: aMessage
	^ aMessage selector isUnary
		ifTrue: [self performRead: aMessage selector]
		ifFalse: [
			(aMessage selector isKeyword and: [aMessage arguments size = 1])
				ifTrue: [self performWrite: aMessage selector allButLast with: aMessage argument]
				ifFalse: [super doesNotUnderstand: aMessage]]! !

!WAModelProxy methodsFor: 'accessing' stamp: 'ab 11/26/2002 17:22'!
model
	^ model! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 11/26/2002 17:24'!
name
	^ model name! !

!WAModelProxy methodsFor: 'private' stamp: 'pmm 9/12/2006 18:36'!
performRead: aSymbol
	^ cache
		at: aSymbol asSymbol
		ifAbsent: [ model perform: aSymbol ]! !

!WAModelProxy methodsFor: 'private' stamp: 'mb 1/5/2006 13:51'!
performRealWrite: aSymbol with: anObject
	model perform: aSymbol asSymbol asMutator with: anObject! !

!WAModelProxy methodsFor: 'private' stamp: 'mb 1/5/2006 13:51'!
performWrite: aSymbol with: anObject
	cache at: aSymbol asSymbol put: anObject! !

!WAModelProxy methodsFor: 'initializing' stamp: 'ab 12/12/2002 00:18'!
setModel: anObject
	model := anObject.
	cache := Dictionary new.! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 11/26/2002 17:24'!
value
	^ model value! !

Object subclass: #WAOpeningConditionalComment
	instanceVariableNames: 'condition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document-Elements'!

!WAOpeningConditionalComment class methodsFor: 'instance creation' stamp: 'pmm 10/11/2006 17:38'!
condition: aString
	^self new
		condition: aString;
		yourself! !

!WAOpeningConditionalComment methodsFor: 'accessing' stamp: 'pmm 10/11/2006 17:31'!
condition
	^condition! !

!WAOpeningConditionalComment methodsFor: 'accessing' stamp: 'pmm 10/11/2006 17:31'!
condition: aString
	condition := aString! !

!WAOpeningConditionalComment methodsFor: 'writing' stamp: 'pmm 10/11/2006 17:33'!
writeOn: aStream
	aStream
		nextPutAll: '<!!--[';
		nextPutAll: self condition;
		nextPutAll: ']>'
	! !

Object subclass: #WAPluggableSelectBox
	instanceVariableNames: 'changeSelected model selected size list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAPluggableSelectBox class methodsFor: 'instance creation' stamp: 'ab 2/15/2003 18:28'!
on: anObject list: listSelector selected: selectedSelector changeSelected: changeSelectedSelector
	^ self 
		on: anObject
		list: listSelector
		selected: selectedSelector
		changeSelected: changeSelectedSelector
		size: 10! !

!WAPluggableSelectBox class methodsFor: 'instance creation' stamp: 'pmm 4/19/2006 17:42'!
on: anObject list: listSelector selected: selectedSelector changeSelected: changeSelectedSelector size: aNumber
	^ self new
		model: anObject;
		list: listSelector;
		selected: selectedSelector;
		changeSelected: changeSelectedSelector;
		size: aNumber;
		yourself! !

!WAPluggableSelectBox methodsFor: 'accessing' stamp: 'ab 10/1/2002 14:16'!
changeSelected: aSymbol
	changeSelected := aSymbol! !

!WAPluggableSelectBox methodsFor: 'accessing' stamp: 'ab 10/1/2002 14:16'!
list: aSymbol
	list := aSymbol! !

!WAPluggableSelectBox methodsFor: 'accessing' stamp: 'ab 2/15/2003 18:24'!
model: anObject
	model := anObject! !

!WAPluggableSelectBox methodsFor: 'rendering' stamp: 'pmm 4/23/2006 21:30'!
renderOn: html
	|array|
	array := (model perform: list) asArray.
	html div
		class: 'column-choice';
		with: [
			html form: [
				html select
					beSubmitOnChange;
					size: size;
					list: array;
					selected: (array at: (model perform: selected) ifAbsent: []);
					callback: [ :item |
						model perform: changeSelected with: (array indexOf: item) ] ] ].	! !

!WAPluggableSelectBox methodsFor: 'accessing' stamp: 'ab 10/1/2002 14:16'!
selected: aSymbol
	selected := aSymbol! !

!WAPluggableSelectBox methodsFor: 'accessing' stamp: 'ab 2/15/2003 18:25'!
size: aNumber
	size := aNumber! !

Object subclass: #WAPresenter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

WAPresenter subclass: #WAComponent
	instanceVariableNames: 'decoration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

!WAComponent commentStamp: '<historical>' prior: 0!
I am a class representing a graphical element of a seaside application. A component has state (instance variables, that might be backtracked using #registerObjectForBacktracking:), behavior decorations, children and an appearance that is specified in #renderContentOn:. A component might chose to display another component with #call:.

Child Components:
It is common for a component to display instances of other components while rendering itself.  It does this by passing them into the #render: method of WAHtmlRenderer.  For example, this #renderContentOn: method simply renders a heading and then displays a counter component 
immediately below it:

	renderContentOn: html
		html heading: 'My Counter' level: 3.
		html render: myCounter.

It's important that you use #render:, rather than directly calling the #renderContentOn: method of the subcomponent. The following is *not* correct:

	renderContentOn: html
		html heading: 'My Counter' level: 3.
		myCounter renderContentOn: html.   "DON'T DO THIS".

These subcomponents are usually instance variables of the component that is "embedding" them.  They are commonly created as part of the components #initialize method:

	initialize
		myCounter := WACounter new.

They may also be stored in a collection. One fairly common pattern is to keep a lazily initialized dictionary of subcomponents that match a collection of model items. For example, if you wanted a BudgetItemRow subcomponent for each member of budgetItems, you might do something like this:

	initialize
		budgetRows := Dictionary new.

	rowForItem: anItem
		^budgetRows at: anItem ifAbsentPut: [ BudgetItemRow item: anItem ].

	renderContentOn: html
		self budgetItems
			do: [ :each | html render: (self rowForItem: each) ]
			separatedBy: [ html horizontalLine ].

Each parent component *must* implement a #children method that returns a collection of all of the subcomponents that it might display on the next render. For the above two examples, #children might look like this:

	children
		^Array with: myCounter

or this:

	children
		^self budgetItems collect: [ :each | self rowForItem: each ].
		
Call/Answer:
If a subcomponent makes a #call: to another component, that component will appear in place of the subcomponent.  In the first example, if myCounter made a #call: to DateSelector, that DateSelector would appear in the context of the counter's parent, with the 'My Counter' heading 
above it.

Since a subcomponent has not been #call:'d, in general #answer: is a no-op.  However, the parent may attach an #onAnswer: block to the subcomponent to be notified if it sends #answer:. This allows one component to be used both from #call: and through embedding. For example:

	initialize
		dateSelector := WADateSelector new 
			onAnswer: [ :date | self dateChosen: date ].!

WAComponent subclass: #WAAlphabeticBatchedList
	instanceVariableNames: 'items currentPage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WAAlphabeticBatchedList methodsFor: 'accessing-calculated' stamp: 'avi 12/18/2004 18:26'!
allPages
	^ $A to: $Z! !

!WAAlphabeticBatchedList methodsFor: 'accessing-calculated' stamp: 'mbany 4/14/2005 12:37'!
batch
	^ items select: [:ea | ea displayString asUppercase first = self currentPage]! !

!WAAlphabeticBatchedList methodsFor: 'accessing' stamp: 'avi 12/18/2004 18:20'!
currentPage
	^ currentPage ifNil: [currentPage := self validPages first]! !

!WAAlphabeticBatchedList methodsFor: 'accessing' stamp: 'avi 12/18/2004 18:16'!
currentPage: aCharacter
	currentPage := aCharacter! !

!WAAlphabeticBatchedList methodsFor: 'initialization' stamp: 'pmm 11/2/2005 22:49'!
initialize
	super initialize.
	self session registerObjectForBacktracking: self.! !

!WAAlphabeticBatchedList methodsFor: 'testing' stamp: 'avi 12/18/2004 18:21'!
isOnFirstPage
	^ self validPages first = self currentPage! !

!WAAlphabeticBatchedList methodsFor: 'testing' stamp: 'avi 12/18/2004 18:21'!
isOnLastPage
	^ self validPages last = self currentPage! !

!WAAlphabeticBatchedList methodsFor: 'accessing' stamp: 'avi 12/18/2004 18:13'!
items
	^ items! !

!WAAlphabeticBatchedList methodsFor: 'accessing' stamp: 'avi 12/18/2004 18:20'!
items: aCollection
	items := aCollection! !

!WAAlphabeticBatchedList methodsFor: 'actions' stamp: 'avi 12/18/2004 18:19'!
nextPage
	self isOnLastPage ifFalse: [currentPage := self validPages after: currentPage]! !

!WAAlphabeticBatchedList methodsFor: 'actions' stamp: 'avi 12/18/2004 18:19'!
previousPage
	self isOnFirstPage ifFalse: [currentPage := self validPages before: currentPage]
! !

!WAAlphabeticBatchedList methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:14'!
renderContentOn: html
	items isEmpty ifFalse: [
		html div
			id: 'batch';
			with: [
				self renderPreviousOn: html.
				self renderPagesOn: html. 
				self renderNextOn: html ] ]! !

!WAAlphabeticBatchedList methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:14'!
renderNextOn: html
	html space.
	self isOnLastPage
		ifFalse: [ html anchor callback: [ self nextPage ]; with: '>>' ]
		ifTrue: [ html text: '>>' ]		! !

!WAAlphabeticBatchedList methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:15'!
renderPagesOn: html
	self allPages
		do: [ :char |
			currentPage = char
				ifFalse: [
					(self validPages includes: char)
						ifTrue: [ html anchor callback: [self currentPage: char]; with: char]
						ifFalse: [ html text: char ] ]
				ifTrue: [ html strong: char ] ]
		separatedBy: [ html space ]! !

!WAAlphabeticBatchedList methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:16'!
renderPreviousOn: html
	self isOnFirstPage
		ifFalse: [ html anchor callback: [ self previousPage ]; with: '<<' ]
		ifTrue: [ html text: '<<' ].
	html space.! !

!WAAlphabeticBatchedList methodsFor: 'accessing-calculated' stamp: 'mbany 4/14/2005 12:37'!
validPages
	^ (items collect: [:ea | ea displayString asUppercase first]) asSet asSortedCollection! !

WAComponent subclass: #WABatchSelection
	instanceVariableNames: 'batcher linkSelector textSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WABatchSelection class methodsFor: 'as yet unclassified' stamp: 'pmm 4/19/2006 17:39'!
items: aCollection link: linkSelector text: textSelector
	^ self new
		items: aCollection;
		linkSelector: linkSelector;
		textSelector: textSelector;
		yourself! !

!WABatchSelection methodsFor: 'accessing' stamp: 'rjl 8/4/2006 11:35'!
batchSize
    ^batcher batchSize! !

!WABatchSelection methodsFor: 'accessing' stamp: 'rjl 8/4/2006 11:34'!
batchSize: aSize
    batcher batchSize: aSize! !

!WABatchSelection methodsFor: 'accessing' stamp: 'avi 2/10/2004 20:43'!
children
	^ Array with: batcher! !

!WABatchSelection methodsFor: 'commands' stamp: 'avi 12/9/2003 13:17'!
choose: anItem
	self answer: anItem! !

!WABatchSelection methodsFor: 'accessing' stamp: 'pmm 9/12/2006 18:10'!
items: aCollection
	batcher := WABatchedList new 
		items: aCollection;
		batchSize: 8;
		yourself! !

!WABatchSelection methodsFor: 'accessing' stamp: 'avi 12/9/2003 13:22'!
linkSelector: aSymbol
	linkSelector := aSymbol! !

!WABatchSelection methodsFor: 'rendering' stamp: 'al 9/7/2006 16:41'!
renderContentOn: html
	html unorderedList: [
		batcher batch do: [ :each |
			html anchor
				callback: [self choose: each ];
				with: (each perform: linkSelector).
			html break.
			html text: (each perform: textSelector).
			html paragraph ] ].
	html div
		style: 'text-align: center';
		with: batcher.! !

!WABatchSelection methodsFor: 'accessing' stamp: 'avi 12/9/2003 13:22'!
textSelector: aSymbol
	textSelector := aSymbol! !

WAComponent subclass: #WABatchTest
	instanceVariableNames: 'batcher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WABatchTest methodsFor: 'accessing' stamp: 'avi 12/18/2004 18:33'!
children
	^ Array with: batcher! !

!WABatchTest methodsFor: 'initialization' stamp: 'pmm 9/12/2006 18:10'!
initialize
	super initialize.
	batcher := WAAlphabeticBatchedList new items: Collection allSubclasses! !

!WABatchTest methodsFor: 'rendering' stamp: 'dc 7/21/2006 21:16'!
renderContentOn: html
	html render: batcher.
	html unorderedList
		list: batcher batch! !

WAComponent subclass: #WABatchedList
	instanceVariableNames: 'items batchSize currentPage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WABatchedList class methodsFor: 'accessing' stamp: 'avi 12/18/2004 18:13'!
example
	^self new
		items: (1 to: 100);
		yourself.
		! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'rjl 8/9/2006 14:30'!
batch
	^ self items copyFrom: self startIndex to: self endIndex! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
batchSize
	^ batchSize! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:09'!
batchSize: aNumber
	batchSize := aNumber! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
currentPage
	^ currentPage! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
currentPage: aNumber
	currentPage := aNumber! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'rjl 8/9/2006 14:30'!
endIndex
	^ self currentPage * self batchSize min: self items size! !

!WABatchedList methodsFor: 'initialization' stamp: 'rjl 8/9/2006 14:31'!
initialize
	super initialize.
	self batchSize: 10.
	self currentPage: 1.
	self session registerObjectForBacktracking: self.! !

!WABatchedList methodsFor: 'testing' stamp: 'rjl 8/9/2006 14:32'!
isOnFirstPage
	^ self currentPage = 1! !

!WABatchedList methodsFor: 'testing' stamp: 'rjl 8/9/2006 14:32'!
isOnLastPage
	^ self currentPage = self maxPages! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
items
	^ items! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 22:57'!
items: aCollection
	items := aCollection! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'rjl 8/9/2006 14:30'!
maxPages
	^ (self items size / self batchSize) ceiling! !

!WABatchedList methodsFor: 'actions' stamp: 'rjl 8/9/2006 14:31'!
nextPage
	self isOnLastPage ifFalse: [self currentPage: self currentPage + 1]! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'lr 9/3/2003 10:44'!
pageRange
	^ self pageRangeStart to: self pageRangeEnd! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'lr 9/3/2003 10:50'!
pageRangeEnd
	^ self maxPages min: self currentPage + 9! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'lr 9/3/2003 10:51'!
pageRangeStart
	^ 1 max: self currentPage - 9! !

!WABatchedList methodsFor: 'actions' stamp: 'rjl 8/9/2006 14:31'!
previousPage
	self isOnFirstPage ifFalse: [self currentPage: self currentPage - 1]! !

!WABatchedList methodsFor: 'rendering' stamp: 'al 9/7/2006 17:05'!
renderContentOn: html
	self maxPages > 0 ifTrue: [
		html div
			id: 'batch';
			with: [
				self renderPreviousOn: html.
				self renderPagesOn: html. 
				self renderNextOn: html ] ]! !

!WABatchedList methodsFor: 'rendering' stamp: 'al 9/7/2006 17:06'!
renderNextOn: html
	html space.
	self isOnLastPage
		ifFalse: [ html anchor callback: [ self nextPage ]; with: '>>' ]
		ifTrue: [ html text: '>>' ]		! !

!WABatchedList methodsFor: 'rendering' stamp: 'al 9/7/2006 17:07'!
renderPagesOn: html
	self pageRange
		do: [ :index |
			self currentPage = index
				ifFalse: [html anchor callback: [self currentPage: index]; with: index]
				ifTrue: [html strong: index ] ]
		separatedBy: [ html space ]! !

!WABatchedList methodsFor: 'rendering' stamp: 'al 9/7/2006 17:07'!
renderPreviousOn: html
	self isOnFirstPage
		ifFalse: [ html anchor callback: [ self previousPage ]; with: '<<' ]
		ifTrue: [ html text: '<<' ].
	html space.! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'rjl 8/9/2006 14:30'!
startIndex
	^ (self currentPage - 1) * self batchSize + 1! !

WAComponent subclass: #WABrowser
	instanceVariableNames: 'contents model message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WABrowser class methodsFor: 'as yet unclassified' stamp: 'mb 10/28/2006 16:45'!
appName
	^'tools/classbrowser'.! !

!WABrowser class methodsFor: 'instance-creation' stamp: 'lr 11/3/2006 13:50'!
fullOnClass: aClass
	^ self fullOnClass: aClass selector: nil! !

!WABrowser class methodsFor: 'instance-creation' stamp: 'lr 11/3/2006 13:50'!
fullOnClass: aClass selector: aSelector
	^ self new model: (Browser new setClass: aClass selector: aSelector)! !

!WABrowser class methodsFor: 'initialization' stamp: 'mb 10/28/2006 16:45'!
initialize
	self registerAsApplication: self appName! !

!WABrowser methodsFor: 'actions' stamp: 'avi 4/28/2004 11:40'!
accept
	|save|
	SeasidePlatformSupport ensureAuthorInitials: [self request: 'Please enter your initials:'].
	message := nil.
	save := contents.
	model contents: contents notifying: self.
	contents := save.
! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 10/8/2002 19:41'!
columnView: columnName
	^WAPluggableSelectBox
		on: model
		list: (columnName, 'List') asSymbol
		selected: (columnName, 'ListIndex') asSymbol
		changeSelected: (columnName, 'ListIndex:') asSymbol! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 10/10/2002 23:50'!
contents
	^contents! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 10/10/2002 23:54'!
contents: aString
	contents := aString! !

!WABrowser methodsFor: 'initialize-release' stamp: 'mb 10/28/2006 22:38'!
initialRequest: aRequest
	| theClass |
	aRequest fields at: 'class' ifPresent:
		[:className | 
		Smalltalk at: className asSymbol ifPresent:
			[:class |
			theClass := (aRequest fields includesKey: 'meta')
					ifTrue: [class class]
					ifFalse: [class].
			self model setClass: theClass selector: nil.
			aRequest fields at: 'method' ifPresent:
				[:selector |
				self model setClass: theClass selector: selector asSymbol]]]! !

!WABrowser methodsFor: 'initialize-release' stamp: 'pmm 11/2/2005 22:48'!
initialize
	super initialize.
	self model: Browser new.! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 10/8/2002 22:13'!
model
	^model 
! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 2/18/2003 19:07'!
model: aBrowserModel
	model := aBrowserModel.
	model addDependent: self.
	self session registerObjectForBacktracking: model.
	contents := model contents.! !

!WABrowser methodsFor: 'notifying' stamp: 'ab 10/10/2002 23:36'!
notify: aString at: location in: sourceStream
	message := aString allButLast: 3! !

!WABrowser methodsFor: 'rendering' stamp: 'ab 11/26/2002 14:08'!
renderColumnsOn: html
	|cols|
	cols := #(systemCategory class messageCategory message)
				collect: [:sel | self columnView: sel].

	html table: [
		html tableRow: [
			cols do: [:ea | html tableData: [html render: ea]].
		]
	]! !

!WABrowser methodsFor: 'rendering' stamp: 'ab 6/15/2003 12:57'!
renderContentOn: html
	self
		renderColumnsOn: html;
		renderModeButtonsOn: html;
		renderMessageOn: html;
		renderContentPaneOn: html
	! !

!WABrowser methodsFor: 'rendering' stamp: 'mb 11/1/2006 18:58'!
renderContentPaneOn: html
	html form: [
		html textArea
			id: 'contents';
			columns: 80;
			rows: 12;
			on: #contents of: self.
		html break.
		html submitButton on: #accept of: self ]! !

!WABrowser methodsFor: 'rendering' stamp: 'lr 11/16/2006 15:35'!
renderMessageOn: html
	message ifNotNil: [ html strong: message ]! !

!WABrowser methodsFor: 'rendering' stamp: 'pmm 4/23/2006 21:30'!
renderModeButtonsOn: html
	html form: [
		html submitButton callback: [ self showInstance ]; value: 'instance'.
		html submitButton callback: [ self showHelp ]; value: 'help'.
		html submitButton callback: [ self showClass ]; value: 'class' ]! !

!WABrowser methodsFor: 'notifying' stamp: 'ab 10/11/2002 00:00'!
select! !

!WABrowser methodsFor: 'actions' stamp: 'ab 10/11/2002 00:00'!
selectFrom: aPos to: anotherPos
! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 10/10/2002 23:44'!
selectionInterval
	^ 1 to: 1! !

!WABrowser methodsFor: 'actions' stamp: 'LR 9/13/2002 20:38'!
showClass
	self model indicateClassMessages! !

!WABrowser methodsFor: 'actions' stamp: 'LR 9/13/2002 20:42'!
showHelp
	self model plusButtonHit! !

!WABrowser methodsFor: 'actions' stamp: 'LR 9/13/2002 20:39'!
showInstance
	self model indicateInstanceMessages! !

!WABrowser methodsFor: 'rendering' stamp: 'mb 11/1/2006 19:03'!
style

	^ '

	#contents {width: 65em; height: 20em; font-family: Tahoma, Arial, Helvetica, Sans;}

	.column-choice select {width: 15em;; font-size: 90%}

	'! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 10/10/2002 23:44'!
text
	^ Text fromString: ''! !

!WABrowser methodsFor: 'notifying' stamp: 'ab 10/10/2002 01:45'!
update: aSymbol
	contents := model contents! !

WAComponent subclass: #WACacheTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WACacheTest methodsFor: 'rendering' stamp: 'avi 10/26/2004 15:41'!
renderContentOn: html
	Smalltalk garbageCollect.  
	html heading: ResponseContinuation allInstances size.
	html heading: AnswerContinuation allInstances size.
	html heading: EscapeContinuation allInstances size.
	html anchorWithAction: [self inform: 'answer'] text: 'call'.
	html break.
	html anchorWithAction: [self call: self class new] text: 'keep calling'.! !

!WACacheTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 18:55'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

WAComponent subclass: #WACallbackTest
	instanceVariableNames: 'transcript counter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WACallbackTest methodsFor: 'accessing' stamp: 'mb 2/17/2005 17:50'!
children

	^ Array with: counter.! !

!WACallbackTest methodsFor: 'initialization' stamp: 'mb 4/23/2006 15:09'!
initialize
	super initialize.
	transcript := String new writeStream.
	counter := WACounter new.! !

!WACallbackTest methodsFor: 'rendering' stamp: 'mb 2/17/2005 17:50'!
renderContentOn: html
	html anchorWithCallback: [] do: 'Idempotent'.
	html space.
	html anchorWithAction: [] do: 'Side Effect'.
	
	html form: [
		html defaultAction: [transcript cr; nextPutAll: 'default action'].
		html textInputWithValue: '' callback: [:v | transcript cr; nextPutAll: 'text: ', v printString].
		html textInputWithValue: '' callback: [:v | transcript cr; nextPutAll: 'text2: ', v printString].
		html break.
		html submitButton.
		html space.
		html submitButtonWithAction: [transcript cr; nextPutAll: 'go'] text: 'Go'.
		html space.
		html cancelButtonWithAction: [transcript cr; nextPutAll: 'cancel'].
	].
	html preformatted: transcript contents.
	html horizontalRule.
	html render: counter.! !

!WACallbackTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 18:55'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

WAComponent subclass: #WACanvasDateTimeTest
	instanceVariableNames: 'data numericData date time data1 data2 msg'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WACanvasDateTimeTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:25'!
data1
	^data1! !

!WACanvasDateTimeTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:26'!
data1: aString
	data1 := aString! !

!WACanvasDateTimeTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:25'!
data2
	^data2! !

!WACanvasDateTimeTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:26'!
data2: aString
	data2 := aString! !

!WACanvasDateTimeTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:22'!
date
	^date! !

!WACanvasDateTimeTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:23'!
date: aDate 
	date := aDate! !

!WACanvasDateTimeTest methodsFor: 'initialize-release' stamp: 'pmm 7/19/2006 19:48'!
initialize
	super initialize.
	data1 := 'Harry'.
	data2 := 'Covert'.
	data := String new.
	msg := String new.
	numericData := 12.! !

!WACanvasDateTimeTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:26'!
numericData
	^numericData! !

!WACanvasDateTimeTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:26'!
numericData: aString
	numericData := aString! !

!WACanvasDateTimeTest methodsFor: 'rendering' stamp: 'mb 2/6/2006 10:44'!
renderContentOn: html

	self renderSubmitFormOn: html.
	self renderDateTimeOn: html.
! !

!WACanvasDateTimeTest methodsFor: 'rendering' stamp: 'pmm 7/19/2006 19:25'!
renderDateTimeOn: html
	html heading: 'Form with #dateInput and #timeInput'.
	html form
		style: 'border: 1px green solid; width: 50%';
		id: 'f2';
		defaultAction: [msg := 'Default action: ' , date displayString , ' ' , time displayString];
		with: [
			html dateInput
				id: 'date-input';
				on: #date of: self.
			html space: 10.
			html timeInput
				id: 'time-input';
				value: time;
				withSeconds;
				on: #time of: self.
			html	
				break;
				text: msg;
				break.
			html submitButton
				callback: [msg := 'Button action: ' , date displayString , ' ' , time displayString]].
! !

!WACanvasDateTimeTest methodsFor: 'rendering' stamp: 'lr 11/16/2006 16:47'!
renderSubmitFormOn: html
	html heading: 'Form with #submitFormNamed:'.
	(html form)
		style: 'border: 1px red solid; width: 50%';
		id: 'f1';
		defaultAction: [data := 'Default action : '
			, data1 printString , ' ' 
			, data2 printString , ' ' 
			, numericData printString];
		with: [
			html textInput
				on: #data1 of: self.
			html textInput
				on: #data2 of: self.
			html textInput
				on: #numericData of: self.
			html break.
			html text: data.
			html break.
			html anchor
				callback: [data := 'Anchor action : '
					, data1 printString , ' ' 
					, data2 printString , ' ' 
					, numericData printString];
				submitFormNamed: 'f1';
				with: 'Click me'].
! !

!WACanvasDateTimeTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:23'!
time
	^time! !

!WACanvasDateTimeTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:23'!
time: aTime
	time := aTime! !

WAComponent subclass: #WACanvasDefaultFormTest
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WACanvasDefaultFormTest methodsFor: 'rendering' stamp: 'mb 4/5/2006 07:12'!
renderContentOn: html
	html form
		defaultAction: [self inform: 'Default: ', value displayString]; with:
		[
		html submitButton 
				callback: [self inform: 'Before: ', value displayString];
				text: 'Before'.
		html break.
		html textInput
				value: '';
				callback: [:v | value := v].
		html submitButton
				callback: [self inform: 'Go: ', value displayString];
				text: 'Go'.
		html break.
		html submitButton
				callback: [self inform: 'After: ', value displayString];
				text: 'After']! !

WAComponent subclass: #WACanvasHtmlTest
	instanceVariableNames: 'booleanList message number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WACanvasHtmlTest methodsFor: 'accessing' stamp: 'mb 10/12/2006 19:43'!
allSelectors
	^ (self class selectors asSortedCollection select: [:s | s beginsWith: 'render'])
		remove: #renderContentOn:;
		yourself! !

!WACanvasHtmlTest methodsFor: 'accessing' stamp: 'mb 3/8/2006 14:00'!
initialMessage
	^'Hello world!!'.
! !

!WACanvasHtmlTest methodsFor: 'initialize-release' stamp: 'pmm 7/19/2006 19:49'!
initialize
	super initialize.
	message := self initialMessage.
	booleanList := #(a b c d) collect: [:key | key -> ((Array with: true with: false) atRandom)].
	number := 10 atRandom.! !

!WACanvasHtmlTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:33'!
message
	^message! !

!WACanvasHtmlTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:33'!
message: aString
	message := aString! !

!WACanvasHtmlTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:32'!
number
	^number! !

!WACanvasHtmlTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:32'!
number: anInteger
	number := anInteger! !

!WACanvasHtmlTest methodsFor: 'rendering' stamp: 'pmm 7/19/2006 19:37'!
renderCheckboxesOn: html
	html text: booleanList.
	html paragraph.
	html form: [
		booleanList do: [:association |
			html text: association key; space.
			html checkbox
				addShortcut: 'Ctrl-' , association key asUppercase;
				on: #value of: association.
			html break].
		html submitButton]! !

!WACanvasHtmlTest methodsFor: 'rendering' stamp: 'mb 1/31/2006 11:32'!
renderContentOn: html
	self allSelectors pairsDo:
		[:selA :selB |
		(html div)
			class: 'row';
			with: 
				[(html div)
					class: 'left';
					with: [self perform: selA with: html].
				(html div)
					class: 'left';
					with: [self perform: selB with: html]]
		]
! !

!WACanvasHtmlTest methodsFor: 'rendering' stamp: 'pmm 7/19/2006 19:39'!
renderRadioButtonsOn: html
	html text: booleanList.
	html paragraph.
	html form: [
		booleanList do: [ :association |
			| group |
			group := html radioGroup.
			html text: association key; space.
			html radioButton
				addShortcut: 'Ctrl-' , association key;
				group: group;
				selected: association value;
				callback: [association value: true].
			html radioButton
				addShortcut: 'Alt-' , association key;
				group: group;
				selected: association value not;
				callback: [association value: false].
			html break].
		html submitButton]! !

!WACanvasHtmlTest methodsFor: 'rendering' stamp: 'pmm 7/19/2006 19:39'!
renderSelectsOn: html
	html text: number.
	html paragraph.
	html form: [
		html select
			list: (1 to: 10);
			on: #number of: self.
		html submitButton]! !

!WACanvasHtmlTest methodsFor: 'rendering' stamp: 'pmm 7/19/2006 19:42'!
renderSubmitButtonsOn: html
	html text: number.
	html paragraph.
	html form: [
		1 to: 10 do: [ :index |
			html submitButton
				addShortcut: 'F' , index asString;
				callback: [number := index];
				text: index.
			html space]]! !

!WACanvasHtmlTest methodsFor: 'rendering' stamp: 'pmm 7/19/2006 19:42'!
renderTextAreaOn: html
	| position |
	position := message = self initialMessage 
			ifTrue: [6] 
			ifFalse: ['End'].
	html form: [
		html text: message.
		html paragraph.
		html textArea
			setCursorPosition: position;
			on: #message of: self.
		html break.
		html submitButton]! !

!WACanvasHtmlTest methodsFor: 'rendering' stamp: 'pmm 7/19/2006 19:34'!
renderTextInputOn: html
	html form: [
		html text: message.
		html paragraph.
		html textInput
			on: #message of: self.
		html submitButton]! !

!WACanvasHtmlTest methodsFor: 'rendering' stamp: 'lr 11/16/2006 15:36'!
renderVFieldSetOn: html
	(html fieldSet)
		legend: 'Various text rendering in a fieldset';
		with:
			[html
				strong: 'Bold';
				break;
				emphasis: 'Italic';
				break;
				underline: 'Underline';
				break.
			(html acronym)
				title: 'United States of America';
				with: 'USA'.
			html
				break;
				emphasis: 'Emphasis';
				break.	

			(html div)
				addStyle: 'color: red';
				addStyle: 'background-color: lightgreen';
				addStyle: 'padding: 1em';
				addStyle: 'border: solid 2px black';
				addStyle: 'font-weight: bold';
				addStyle: 'font-size: 150%';
				addStyle: 'height: 3em';
				addStyle: 'text-align: center';
				with: 'Large bold red in a green div'.
			html
				break]! !

!WACanvasHtmlTest methodsFor: 'rendering' stamp: 'mb 6/12/2006 14:33'!
renderZFieldSetOn: html
	| url1 |
	url1 := html context
				urlForDocument: (ScriptingSystem formAtKey: 'Halo-Debug') 
				mimeType: 'image/jpg' 
				fileName: 'Debug.jpg'.
	(html fieldSet)
		legend: 'Various images in a fieldset';
		with:
			[html image url: url1; altText: 'Halo-Debug'.
			html space.
			html image form: (ScriptingSystem formAtKey: 'Halo-View'); altText: 'Halo-View'.
			html space.
			html image
					fileName: 'Paint.png'; 
					mimeType: 'image/png';
					document: (ScriptingSystem formAtKey: 'Halo-Paint'); 
					altText: 'Halo-Paint'.
			html break.
			html image border: 1; url: 'http://www.netstyle.ch/include/seaside/pics/top.jpg'; width: '80%'; altText: 'Seaside'.
			html break.
			html image border: 2; url: 'http://www.netstyle.ch/include/seaside/pics/top.jpg'; height: '50px'; altText: 'Seaside'.
			html break.
			html image border: 0; url: 'http://www.netstyle.ch/include/seaside/pics/top.jpg'; width: '250px'; height: '60px'; altText: 'Seaside'.

		]
! !

!WACanvasHtmlTest methodsFor: 'accessing' stamp: 'mb 1/31/2006 11:18'!
style
^ '
	div.row {clear: both}
	div.left {float: left; width: 45%; margin: 1%}
'! !

WAComponent subclass: #WACanvasImageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WACanvasImageTest methodsFor: 'rendering' stamp: 'mb 6/8/2006 15:54'!
renderContentOn: html
	html form: [
		html imageButton 
			callback: [self inform: 'ok'];
			form: (ScriptingSystem formAtKey: 'Halo-Debug')]! !

WAComponent subclass: #WACanvasInputTest
	instanceVariableNames: 'nilString emptyString integer fraction lastName address selection multiSelection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WACanvasInputTest methodsFor: 'accessing' stamp: 'mb 10/10/2006 23:21'!
address
	"Answer the value of address"

	^ address! !

!WACanvasInputTest methodsFor: 'accessing' stamp: 'pmm 10/12/2006 22:11'!
address: anObject
	"Set the value of address"

	address := anObject! !

!WACanvasInputTest methodsFor: 'accessing' stamp: 'mb 1/31/2006 11:03'!
emptyString
	"Answer the value of emptyString"

	^ emptyString! !

!WACanvasInputTest methodsFor: 'accessing' stamp: 'mb 1/31/2006 11:03'!
emptyString: anObject
	"Set the value of emptyString"

	emptyString := anObject! !

!WACanvasInputTest methodsFor: 'accessing' stamp: 'mb 1/31/2006 11:03'!
fraction
	"Answer the value of fraction"

	^ fraction! !

!WACanvasInputTest methodsFor: 'accessing' stamp: 'mb 1/31/2006 11:03'!
fraction: anObject
	"Set the value of fraction"

	fraction := anObject! !

!WACanvasInputTest methodsFor: 'initialize-release' stamp: 'mb 11/3/2006 14:34'!
initialize
	super initialize.
	nilString := nil.
	emptyString := ''.
	integer := 42.
	fraction := 1/3.
	selection := nil.
	multiSelection := Set new.! !

!WACanvasInputTest methodsFor: 'accessing' stamp: 'mb 1/31/2006 11:03'!
integer
	"Answer the value of integer"

	^ integer! !

!WACanvasInputTest methodsFor: 'accessing' stamp: 'mb 1/31/2006 11:03'!
integer: anObject
	"Set the value of integer"

	integer := anObject! !

!WACanvasInputTest methodsFor: 'accessing' stamp: 'mb 10/10/2006 23:04'!
lastName
	"Answer the value of lastName"

	^ lastName! !

!WACanvasInputTest methodsFor: 'accessing' stamp: 'pmm 10/12/2006 22:11'!
lastName: anObject
	"Set the value of lastName"

	lastName := anObject! !

!WACanvasInputTest methodsFor: 'accessing' stamp: 'mb 11/3/2006 14:50'!
multiSelection
	^ multiSelection! !

!WACanvasInputTest methodsFor: 'accessing' stamp: 'mb 11/3/2006 14:50'!
multiSelection: anObject
	multiSelection := anObject! !

!WACanvasInputTest methodsFor: 'accessing' stamp: 'mb 1/31/2006 11:03'!
nilString
	"Answer the value of nilString"

	^ nilString! !

!WACanvasInputTest methodsFor: 'accessing' stamp: 'mb 1/31/2006 11:03'!
nilString: anObject
	"Set the value of nilString"

	nilString := anObject! !

!WACanvasInputTest methodsFor: 'rendering' stamp: 'mb 11/3/2006 14:56'!
renderContentOn: html
	html form: [
		html table: [
			html tableRow: [
				html tableHeading:  'Name'.
				html tableHeading: 'Value'.
				html tableHeading: 'PrintString'].
			html tableRow: [
				html tableData: 'Nil String'.
				html tableData: [html textInput on: #nilString of: self].
				html tableData: [html text: nilString printString]].
			html tableRow: [
				html tableData: 'Empty String'.
				html tableData: [html textInput on: #emptyString of: self].
				html tableData: [html text: emptyString printString]].
			html tableRow: [
				html tableData: 'Integer'.
				html tableData: [html textInput setFocus; on: #integer of: self].
				html tableData: [html text: integer printString]].
			html tableRow: [
				html tableData: 'Fraction'.
				html tableData: [html textInput on: #fraction of: self].
				html tableData: [html text: fraction printString]].
			html tableRow: [
				html tableData: 'Text input with example'.
				html tableData: [
					html textInput
						value: self lastName;
						exampleText: 'Your name';
						callback: [:v | self lastName: v]].
				html tableData: ''].
			html tableRow: [
				html tableData: 'Text area with example'.
				html tableData: [
					html textArea
						value: self address;
						exampleText: 'Your address';
						callback: [:v | self address: v]].
				html tableData: ''].
			html tableRow: [
				html tableData: 'Selection'.
				html tableData: [html select
									list: #(Quito Dakar Sydney Bamako);
									on: #selection of: self].
				html tableData: [html text: selection]].
			html tableRow: [
				html tableData: 'Multi Selection'.
				html tableData: [html select
									beMultiple;
									list: #(Breakfast Lunch Dinner);
									on: #multiSelection of: self].
				html tableData: [html text: multiSelection]].
			html tableRow with: [
				html tableData: 'Input elements with no callback'.
				html tableData with: [
					html select
						size: 10; 
						list: Collection subclasses].
				html tableData with: [
					html unorderedList
						beMultiple;
						selected: #();
						list: Collection subclasses ]].
		].
		html submitButton.
	]! !

!WACanvasInputTest methodsFor: 'accessing' stamp: 'mb 11/3/2006 14:49'!
selection
	^ selection! !

!WACanvasInputTest methodsFor: 'accessing' stamp: 'mb 11/3/2006 14:50'!
selection: anObject
	selection := anObject! !

WAComponent subclass: #WACanvasLinkSubmitTest
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WACanvasLinkSubmitTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:45'!
count
	^count! !

!WACanvasLinkSubmitTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:46'!
count: anInteger
	count := anInteger! !

!WACanvasLinkSubmitTest methodsFor: 'initialize-release' stamp: 'pmm 7/19/2006 19:46'!
initialize
	super initialize.
	count := 0
! !

!WACanvasLinkSubmitTest methodsFor: 'rendering' stamp: 'lr 11/16/2006 16:47'!
renderContentOn: html
	| formId |
	formId := #myform.
	html form
		id: formId;
		with: [
			html textInput
				on: #count of: self.
			html break.
			html anchor
				id: #decreaseLink;
				addShortcut: 'Ctrl-Down';
				callback: [count := count - 1];
				submitFormNamed: formId;
				with: '--'.
			html space.
			html anchor
				id: #increaseLink;
				addShortcut: 'Ctrl-Up';
				callback: [count := count + 1];
				submitFormNamed: formId;
				with: '++'.
			html break; break.
			count = 0 ifFalse:
				[(html checkbox)
					addShortcut: 'Ctrl-Z';
					addShortcut: 'Ctrl-z';
					value: (count = 0);
					callback: [ :value | value ifTrue: [count := 0]];
					submitFormNamed: formId.
				html space.
				html text: 'Reset']].
	html emphasis: 'Handy shortcuts : Ctrl-Up, Ctrl-Down and Ctrl-Z'
! !

WAComponent subclass: #WACanvasModelTest
	instanceVariableNames: 'state user pass test'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WACanvasModelTest methodsFor: 'actions' stamp: 'mb 2/9/2006 15:25'!
logoff
	state := #OFF.
	test ifTrue: [self inform: 'Logged off']! !

!WACanvasModelTest methodsFor: 'actions' stamp: 'mb 2/9/2006 15:26'!
logon
	user isEmptyOrNil
		ifTrue:
			[self inform: 'Nope !!']
		ifFalse:
			[state := #ON.
			test ifTrue: [self inform: 'Logged on']]! !

!WACanvasModelTest methodsFor: 'accessing' stamp: 'mb 2/9/2006 15:04'!
pass
	"Answer the value of pass"

	^ pass! !

!WACanvasModelTest methodsFor: 'accessing' stamp: 'mb 2/9/2006 15:04'!
pass: anObject
	"Set the value of pass"

	pass := anObject! !

!WACanvasModelTest methodsFor: 'rendering' stamp: 'pmm 7/19/2006 19:55'!
renderContentOn: html
	| formId |
	formId := 'myform'.
	(html form)
		id: formId;
		with:
			[(html label)
				for: #userid; with:
					[html text: 'User name'; space.
					(html textInput) id: #userid; on: #user of: self].
			html break.
			(html label)
				for: #pass; with:
					[html text: 'Password'; space.
					(html passwordInput) on: #pass of: self].
			html break.
			(html label)
				for: #test; with:
					[html text: 'With feedback'; space.
					(html checkbox) on: #test of: self].
			html break.
			state == #ON
				ifFalse:
					[(html submitButton)
						callback: [self logon];
						text: 'Logon']
				ifTrue:
					[(html submitButton)
						callback: [self logoff];
						text: 'Logoff']].	! !

!WACanvasModelTest methodsFor: 'accessing' stamp: 'mb 2/9/2006 15:04'!
test
	"Answer the value of test"

	^ test! !

!WACanvasModelTest methodsFor: 'accessing' stamp: 'mb 2/9/2006 15:04'!
test: anObject
	"Set the value of test"

	test := anObject! !

!WACanvasModelTest methodsFor: 'accessing' stamp: 'mb 2/9/2006 15:10'!
user
	"Answer the value of user"

	^ user! !

!WACanvasModelTest methodsFor: 'accessing' stamp: 'mb 2/9/2006 15:10'!
user: anObject
	"Set the value of user"

	user := anObject! !

WAComponent subclass: #WACanvasTest
	instanceVariableNames: 'count selected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WACanvasTest methodsFor: 'actions' stamp: 'avi 6/13/2004 01:06'!
decrease
	count := count - 1! !

!WACanvasTest methodsFor: 'actions' stamp: 'avi 6/13/2004 01:06'!
increase
	count := count + 1! !

!WACanvasTest methodsFor: 'initialize-release' stamp: 'pmm 7/19/2006 19:49'!
initialize
	super initialize.
	count := 0.
	selected := Array new.! !

!WACanvasTest methodsFor: 'rendering' stamp: 'mb 11/3/2006 14:54'!
renderContentOn: html
	html div style: 'background-color: lightblue'; with: [
		html text: count; break.
		html anchor callback: [self increase]; with: '++'.
		html space.
		html anchor callback: [self decrease]; with: '--'.
	].

	html table with: [
		html tableRow with: [
			html tableData with: [
				html form: [
					html select
						size: 10; 
						beMultiple; 
						beSubmitOnChange;
						list: Collection subclasses;
						on: #selected of: self ] ].
			html tableData with: [
				html unorderedList
					beMultiple;
					list: Collection subclasses;
					on: #selected of: self ] ] ].

! !

!WACanvasTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:59'!
selected
	^selected! !

!WACanvasTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 20:00'!
selected: aClass
	selected := aClass! !

WAComponent subclass: #WACanvasUploadTest
	instanceVariableNames: 'file'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WACanvasUploadTest methodsFor: 'rendering' stamp: 'lr 11/16/2006 16:48'!
renderContentOn: html
	html heading: 'Upload File'.

	html form
		multipart;
		with: [
			html fileUpload callback: [ :f | file := f].
			html submitButton text: 'Load'].

	file ifNotNil: [
		html anchor
			document: file contents mimeType: file contentType fileName: file fileName;
			with: file fileName , ' (' , file contentType , ')'.
		html break.
		html anchor
			document: file contents;
			with: file fileName.

		html preformatted: file contents ]! !

WAComponent subclass: #WAChangePassword
	instanceVariableNames: 'username password confirmation authenticator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAChangePassword methodsFor: 'accessing' stamp: 'avi 2/6/2004 22:37'!
authenticator: anAuthenticator
	authenticator := anAuthenticator! !

!WAChangePassword methodsFor: 'actions' stamp: 'avi 2/6/2004 23:10'!
cancel
	self answer: false! !

!WAChangePassword methodsFor: 'actions' stamp: 'avi 2/6/2004 23:09'!
changePassword
	password = confirmation
		ifFalse: [^ self inform: 'Sorry, the password and confirmation did not match.'].
	authenticator setPassword: password forUser: username.
	self answer: true
	! !

!WAChangePassword methodsFor: 'rendering' stamp: 'avi 2/6/2004 23:10'!
renderContentOn: html

	html form: [
		html table: [
			html
				tableRowWithLabel: 'Username'
				column: username.
			html
				tableRowWithLabel: 'Password'
				column: [html passwordInputWithCallback: [:v | password := v]].
			html
				tableRowWithLabel: 'Confirm Password'
				column: [html passwordInputWithCallback: [:v | confirmation := v]].
			html spacerRow.
			html attributes alignCenter.
			html tableRowWith: [
				html submitButtonOn: #changePassword of: self.
				html space.
				html submitButtonOn: #cancel of: self
			] span: 2.
		]
	]! !

!WAChangePassword methodsFor: 'accessing' stamp: 'avi 2/6/2004 22:37'!
username: aString
	username := aString! !

WAComponent subclass: #WAClosureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAClosureTest methodsFor: 'actions' stamp: 'avi 1/23/2004 19:43'!
ensure
	[self go] ensure: [self inform: 'ensure']! !

!WAClosureTest methodsFor: 'actions' stamp: 'mb 10/12/2006 18:58'!
go
	#(a b c) keysAndValuesDo: [:i :each |
		self inform: each displayString, ' ', i displayString]! !

!WAClosureTest methodsFor: 'rendering' stamp: 'avi 1/23/2004 19:47'!
renderContentOn: html
	html anchorWithAction: [self go] text: 'go'.
	html space.
	html anchorWithAction: [self ensure] text: 'go with ensure'.! !

!WAClosureTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 18:57'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

!WAComponent class methodsFor: 'utilities' stamp: 'avi 11/16/2005 23:33'!
applicationWithPath: aString
	| app |
	app := WAApplication path: aString.
	app configuration addAncestor: WARenderLoopConfiguration new.
	app preferenceAt: #rootComponent put: self.
	^ app! !

!WAComponent class methodsFor: 'testing' stamp: 'lr 11/29/2004 16:16'!
canBeRoot
	"When returning true, the component can be registered as a standalone application from the config interface."
	
	^ false! !

!WAComponent class methodsFor: 'accessing' stamp: 'mb 5/26/2006 12:02'!
description
	^self name! !

!WAComponent class methodsFor: 'testing' stamp: 'mb 5/26/2006 11:01'!
isDeployed
	"When returning true, the component is to be kept in a deployed system,
	otherwise it is disabled"
	
	^ false

"
	Usage:

	1. 	Implement #isDeployed on the class side of
		the deployed root components

	2.	Evaluate the following

		WADispatcher default trimForDeployment

"! !

!WAComponent class methodsFor: 'instance creation' stamp: 'avi 9/22/2004 13:57'!
new
	^ self basicNew initializeDecoration initialize! !

!WAComponent class methodsFor: 'registration' stamp: 'mb 6/14/2006 15:14'!
registerAsApplication: appName
	^WADispatcher default
		registerEntryPoint: (self applicationWithPath: appName)
		path: appName
! !

!WAComponent class methodsFor: 'registration' stamp: 'mb 5/30/2006 12:28'!
registerAsAuthenticatedApplication: appName
	| app user password |
	app := self registerAsApplication: appName.
	app configuration addAncestor: WAAuthConfiguration new.
	
	[user := SeasidePlatformSupport
		request: ('Please choose an administrator\username for the application ''', appName displayString , '''') withCRs.

		" Or can we do this instead ????

		request: ('Please choose an administrator\username for the application ', appName printString) withCRs.

		"
	user = ''] whileTrue.
		
	[password := SeasidePlatformSupport
		request: 'Please enter a password for ', user printString.
	password = ''] whileTrue.
		
	app preferenceAt: #login put: user.
	app preferenceAt: #password put: password.
	
	^ app
	! !

!WAComponent class methodsFor: 'utilities' stamp: 'pmm 9/12/2006 19:26'!
renderSampleInstance: aBlock
	|session root context docRoot document|
	session := WASession application: WAApplication new.
	^ WACurrentSession
		use: session
		during: [
			root := self new.
			aBlock value: root.
			context := WARenderingContext new request: WARequest new.
			context actionUrl: (WAUrl new addToPath: 'action').
			docRoot := session outputDocumentClass newRoot.
			root visiblePresentersDo: [:ea | ea updateRoot: docRoot].
			document := session outputDocumentClass root: docRoot.
			context document: document.
			root decorationChainDo: [ :each | each renderWithContext: context].
			document close.
			document stream contents ]! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 5/19/2004 14:18'!
activeComponent
	self visiblePresentersDo: [:ea | ea isDecoration ifFalse: [^ ea]]! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'avi 6/2/2004 22:16'!
addDecoration: newDecoration
	| prev dec |
	prev := nil.
	dec := self decoration.
	[dec ~~ self and: [self decoration: dec shouldWrap: newDecoration]] whileTrue:
		[prev := dec.
		dec := dec owner].
	newDecoration owner: dec.
	prev
		ifNil: [self decoration: newDecoration]
		ifNotNil: [prev owner: newDecoration].
	^ newDecoration! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/27/2004 00:53'!
addMessage: aString
	self addDecoration: (WAMessageDecoration new message: aString)! !

!WAComponent methodsFor: 'iterating' stamp: 'avi 10/19/2004 15:55'!
allDecorationsDo: aBlock
	| ea |
	ea := self decoration.
	[ea notNil and: [ea ~~ self]] whileTrue:
		[aBlock value: ea.
		ea := ea owner]! !

!WAComponent methodsFor: 'call/answer' stamp: 'avi 3/27/2004 00:55'!
answer
	self answer: self! !

!WAComponent methodsFor: 'call/answer' stamp: 'avi 6/8/2004 01:13'!
answer: anObject
	self decorationChainDo: [:ea | ea handleAnswer: anObject]! !

!WAComponent methodsFor: 'convenience' stamp: 'ac 3/22/2006 15:04'!
asComponent
	^ self! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2004 00:55'!
authenticateWith: anAuthenticator during: aBlock
	^ self decorateWith: (WABasicAuthentication new authenticator: anAuthenticator) during: aBlock
! !

!WAComponent methodsFor: 'call/answer' stamp: 'avi 10/26/2004 15:40'!
call: aComponent
	^ AnswerContinuation currentDo: [:cc | self show: aComponent onAnswer: cc]! !

!WAComponent methodsFor: 'accessing' stamp: 'lr 11/29/2004 16:17'!
children
	"This method is really important. It should return a collection of all subcomponents of the current component that will be rendered in #renderContentOn:. Components that are displayed using #call: are *not* children."
	
	^ #()! !

!WAComponent methodsFor: 'iterating' stamp: 'avi 6/8/2004 00:57'!
childrenDo: aBlock
	self children do: [:ea | ea ifNotNil: [aBlock value: ea]]! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/29/2004 19:07'!
confirm: aString
	^ self call: (WAYesOrNoDialog new addMessage: aString)! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2004 19:53'!
decorateWith: aDecoration during: aBlock
	| val |
	self addDecoration: aDecoration.
	val := aBlock value.
	self removeDecoration: aDecoration.
	^ val! !

!WAComponent methodsFor: 'accessing' stamp: 'avi 4/13/2004 20:36'!
decoration
	decoration ifNil: [decoration := WAStateHolder new contents: self].
	^ decoration contents! !

!WAComponent methodsFor: 'accessing' stamp: 'avi 9/22/2004 13:59'!
decoration: aDecoration
	decoration contents: aDecoration! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'avi 3/28/2004 20:49'!
decoration: oldDecoration shouldWrap: newDecoration
	^ (oldDecoration isGlobal and: [newDecoration isGlobal not])
		or: [oldDecoration isDelegation and: [newDecoration isLocal]]! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'avi 4/22/2004 14:50'!
decorationChainDo: aBlock
	aBlock value: self decoration! !

!WAComponent methodsFor: 'accessing' stamp: 'avi 10/19/2004 15:57'!
delegations
	| delegations |
	delegations := OrderedCollection new.
	self allDecorationsDo: [:ea | ea isDelegation ifTrue: [delegations add: ea]].
	^ delegations! !

!WAComponent methodsFor: 'call/answer' stamp: 'avi 6/8/2004 01:13'!
handleAnswer: anObject
	^ false! !

!WAComponent methodsFor: 'accessing' stamp: 'avi 10/19/2004 15:56'!
home
	self delegations do: [:ea | self removeDecoration: ea]! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/29/2004 19:07'!
inform: aString
	self call: (WAFormDialog new addMessage: aString)
! !

!WAComponent methodsFor: 'initialization' stamp: 'avi 9/22/2004 13:59'!
initializeDecoration
	decoration := WAStateHolder new contents: self! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/27/2004 00:56'!
isolate: aBlock
	|txn val |
	txn := WATransaction new.
	val := self decorateWith: txn during: aBlock.
	txn close.
	^ val! !

!WAComponent methodsFor: 'iterating' stamp: 'avi 6/8/2004 00:59'!
nextPresentersDo: aBlock
	self childrenDo: [:ea | ea decorationChainDo: aBlock]! !

!WAComponent methodsFor: 'call/answer' stamp: 'avi 6/8/2004 01:14'!
onAnswer: aBlock
	^ self addDecoration: (WAAnswerHandler new block: aBlock)! !

!WAComponent methodsFor: 'convenience' stamp: 'pmm 10/8/2006 21:06'!
registerForBacktracking
	self session registerObjectForBacktracking: self! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'avi 7/6/2004 10:40'!
removeDecoration: aDecoration
	| dec |
	dec := self decoration.
	dec = aDecoration ifTrue:
		[self decoration: dec owner.
		^ self].
	
	[dec notNil] whileTrue:
		[dec owner = aDecoration
			ifTrue: [dec owner: aDecoration owner.  ^ self]
			ifFalse: [dec := dec owner]]! !

!WAComponent methodsFor: 'rendering' stamp: 'lr 11/29/2004 16:19'!
renderOn: aRenderer
	"Do not override this methods on your component, override instead #renderContentOn: and in addition to not invoke directly renderContentOn: on subcomponent in such method but use instead html render: subcomponent."

	self decorationChainDo: [ :each | each renderWithContext: aRenderer context ].! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/27/2004 00:56'!
request: aString
	^ self request: aString default: ''! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/27/2004 00:56'!
request: aString default: initialString
	^ self request: aString label: nil default: initialString! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/27/2004 00:56'!
request: requestString label: labelString
	^ self request: requestString label: labelString default: ''! !

!WAComponent methodsFor: 'convenience' stamp: 'pmm 11/2/2005 23:45'!
request: requestString label: labelString default: initialString
	^ self call:
		((WAInputDialog new
			label: labelString;
			default: initialString;
			yourself)
				addMessage: requestString)! !

!WAComponent methodsFor: 'call/answer' stamp: 'mb 4/23/2006 10:43'!
show: aComponent
	self 
		show: aComponent
		onAnswer: [:value | ]! !

!WAComponent methodsFor: 'call/answer' stamp: 'lr 4/19/2006 00:36'!
show: aComponent onAnswer: aBlock
	self 
		show: aComponent 
		onAnswer: aBlock 
		delegation: (WADelegation new 
			delegate: aComponent;
			yourself)! !

!WAComponent methodsFor: 'call/answer' stamp: 'mb 4/23/2006 10:43'!
show: aComponent onAnswer: aBlock delegation: aDelegation
	| event |
	event := nil.
	event := aComponent onAnswer: [:value |
		aDelegation remove. 
		event remove. 
		aBlock value: value].
	self addDecoration: aDelegation.
	WARenderNotification raiseSignal! !

!WAComponent methodsFor: 'convenience' stamp: 'cds 7/25/2005 10:24'!
validateWith: aBlock
	^self addDecoration: (WAValidationDecoration new validateWith: aBlock)! !

!WAComponent methodsFor: 'iterating' stamp: 'avi 6/8/2004 00:58'!
visiblePresentersDo: aBlock
	self decorationChainDo: [:ea | ea withNextPresentersDo: aBlock]! !

WAComponent subclass: #WAConfigurationEditor
	instanceVariableNames: 'configuration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

WAConfigurationEditor subclass: #WAApplicationEditor
	instanceVariableNames: 'application library'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAApplicationEditor methodsFor: 'actions' stamp: 'avi 6/24/2004 00:30'!
addLibrary
	application libraries add: library! !

!WAApplicationEditor methodsFor: 'accessing' stamp: 'pmm 4/23/2006 20:54'!
allLibraries
	^ (WAStyleLibrary subclasses, WAScriptLibrary subclasses)
		asSortedCollection: [ :a :b | a name <= b name ]! !

!WAApplicationEditor methodsFor: 'accessing' stamp: 'avi 3/23/2004 14:32'!
application: anApplication
	application := anApplication.
	configuration := application configuration.! !

!WAApplicationEditor methodsFor: 'accessing' stamp: 'avi 6/24/2004 00:23'!
libraryOptions
	^ self allLibraries difference: application libraries! !

!WAApplicationEditor methodsFor: 'rendering' stamp: 'avi 3/23/2004 14:37'!
renderContentOn: html
	html heading: 'Application: ', application name.

	super renderContentOn: html.! !

!WAApplicationEditor methodsFor: 'rendering' stamp: 'pmm 6/28/2006 09:45'!
renderFormOn: html
	html text: 'Base Path: '.
	html textInput on: #basePath of: application.
	
	html heading level2 with: 'Libraries'.
	self libraryOptions isEmpty ifFalse: [
		html text: 'Add Library: '.
		html select
			list: self libraryOptions;
			selected: nil;
			callback: [:v | library := v].
		html space.
		html submitButton callback: [self addLibrary]; text: 'Add'.].

	html unorderedList: [
		application libraries do: [ :each |
			html listItem: [
				html text: each.
				html space.
				html anchor
					callback: [application libraries remove: each];
					with: '(remove)' ] ] ].
	
	super renderFormOn: html! !

!WAConfigurationEditor methodsFor: 'accessing' stamp: 'avi 3/23/2004 14:30'!
configuration
	^ configuration! !

!WAConfigurationEditor methodsFor: 'accessing' stamp: 'avi 1/31/2004 12:02'!
configuration: aConfiguration
	configuration := aConfiguration! !

!WAConfigurationEditor methodsFor: 'actions' stamp: 'avi 3/23/2004 15:06'!
done
	self answer! !

!WAConfigurationEditor methodsFor: 'initialization' stamp: 'mb 4/23/2006 15:13'!
initialize
	super initialize.
	configuration := WAConfiguration new! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'pmm 4/23/2006 20:01'!
renderAncestryListFor: aConfiguration seen: aSet on: html
	aConfiguration ancestors isEmpty ifTrue: [^ self].
	
	html unorderedList: [
		aConfiguration ancestors do: [ :each |
			html listItem: [
				self renderParent: each on: html.
				(aSet includes: each) ifFalse: [
					aSet add: each.
					self renderAncestryListFor: each seen: aSet on: html ] ] ] ]! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'pmm 4/23/2006 20:02'!
renderAncestryOn: html
	html div
		style: 'border: 1px solid black; background: lightgrey';
		with: [
			html table: [
				html heading level2; with: 'Configuration Ancestors' .

				configuration potentialAncestors isEmpty ifFalse: [
					html text: 'Add ancestor: '.
					self renderParentSelectorOn: html ].

				self renderAncestryListFor: configuration seen: Set new on: html ] ].! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'mb 2/17/2005 10:47'!
renderAttribute: anAttribute on: html
	html tableRow: [
		html tableData: (self labelForSelector: anAttribute key).
		html tableData: [
			(configuration valueForAttribute: anAttribute)
				ifNil: [self renderUnspecifiedAttribute: anAttribute on: html]
				ifNotNil: 
					[(configuration hasLocalValueForAttribute: anAttribute)
						ifTrue: [self renderOverridenAttribute: anAttribute on: html]
						ifFalse: [self renderInheritedAttribute: anAttribute on: html]]
		].
		self renderInheritanceForAttribute: anAttribute on: html]! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'pmm 4/23/2006 21:11'!
renderContentOn: html
	html form: [
		self renderFormOn: html.
		
		html break.
		html submitButton on: #save of: self.
		html submitButton on: #done of: self ]! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'pmm 4/23/2006 20:06'!
renderFormOn: html
	self renderAncestryOn: html.
	html break.
	html div
		style: 'border: 1px solid black';
		with: [
			html table: [
				configuration groupedAttributes do: [ :associaction |
						html tableRow: [
							html tableData colSpan: 2; with: [ html heading level3; with: (self labelForSelector: associaction key) ] ].
						associaction value do: [ :attribute |
							self renderAttribute: attribute on: html ] ] ] ]! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'pmm 4/23/2006 20:10'!
renderInheritanceForAttribute: anAttribute on: html
	configuration inheritedValueAndSourceAt: anAttribute key do: [:value :source |
		(configuration hasLocalValueForAttribute: anAttribute)
			ifTrue: [
				html tableData: [
					html anchor callback: [configuration clearValueForAttribute: anAttribute]; with: 'revert'.
					html text: ' to: ', value printString].
				html tableData: 'overriden from ', source name ]
			ifFalse: [
				html tableData: [
					html anchor callback: [configuration overrideAttribute: anAttribute]; with: 'override'].
				html tableData: 'inherited from ', source name ].
		^ self ].
	(configuration hasLocalValueForAttribute: anAttribute)
		ifTrue: [
			html tableData: [
				html anchor callback: [configuration clearValueForAttribute: anAttribute]; with: 'clear']]
		ifFalse: [
			html tableData: [
				html span
					style: 'color: #ff0000';
					with: '(unspecified)' ] ]! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'avi 3/23/2004 12:35'!
renderInheritedAttribute: anAttribute on: html
	html text: (configuration valueForAttribute: anAttribute) printString! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'pmm 4/23/2006 20:11'!
renderInheritedValueForAttribute: anAttribute on: html
	| inheritedValue |
	inheritedValue := (configuration lookupValueAt: anAttribute key).
	inheritedValue isNil
		ifTrue: [
			html span
				style: 'color: #ff0000';
				with: '(unspecified)' ]
		ifFalse: [ html text: inheritedValue printString ]! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'pmm 4/23/2006 20:12'!
renderLinkToAncestor: aConfiguration on: html
	"html anchor callback: [self call: (WAConfigurationEditor new configuration: aConfiguration)]; with: aConfiguration"
	html text: aConfiguration! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'pmm 4/23/2006 20:12'!
renderOverrideForAttribute: anAttribute on: html
	html anchor callback: [configuration overrideAttribute: anAttribute]; with: 'edit'! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'avi 3/23/2004 12:34'!
renderOverridenAttribute: anAttribute on: html
	anAttribute accept: self with: html! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'pmm 4/23/2006 20:15'!
renderParent: aConfiguration on: html
	html text: aConfiguration name.
	html space.
	(configuration hasMutableAncestry and: [configuration ancestors includes: aConfiguration]) ifTrue: [
		html anchor
			callback: [configuration removeAncestor: aConfiguration];
			with: '(remove)' ]! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'pmm 4/23/2006 20:13'!
renderParentSelectorOn: html
	|selectedAncestor|
	selectedAncestor := ValueHolder new.
	html select
		list: configuration potentialAncestors;
		selected: nil;
		callback: [:v | selectedAncestor contents: v];
		labels: [:ea | ea name].
	html space.
	html submitButton
		callback: [configuration addAncestor: selectedAncestor contents];
		text: 'Add'. ! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'pmm 4/23/2006 20:15'!
renderRevertForAttribute: anAttribute on: html
	html anchor callback: [configuration clearValueForAttribute: anAttribute]; with: 'clear'! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'avi 3/23/2004 12:35'!
renderUnspecifiedAttribute: anAttribute on: html
	anAttribute accept: self with: html! !

!WAConfigurationEditor methodsFor: 'actions' stamp: 'avi 3/23/2004 14:36'!
save! !

!WAConfigurationEditor methodsFor: 'actions' stamp: 'avi 3/23/2004 14:34'!
select: aConfiguration
	self call: (WAConfigurationEditor new configuration: aConfiguration)! !

!WAConfigurationEditor methodsFor: 'accessing' stamp: 'avi 3/23/2004 14:40'!
trailName
	^ configuration name! !

!WAConfigurationEditor methodsFor: 'rendering-visitors' stamp: 'pmm 4/23/2006 20:18'!
visitBooleanAttribute: anAttribute with: html
	html select
		list: (Array with: true with: false);
		selected: (configuration valueForAttribute: anAttribute);
		callback: [:v | configuration takeValue: v forAttribute: anAttribute];
		labels: [ :b | b ifTrue: [ 'true' ] ifFalse: [ 'false' ] ]! !

!WAConfigurationEditor methodsFor: 'rendering-visitors' stamp: 'pmm 4/23/2006 20:19'!
visitListAttribute: anAttribute with: html
	html select
		list: (Array with: nil), anAttribute options asArray;
		selected: (configuration valueForAttribute: anAttribute);
		callback: [ :value | (configuration takeValue: value forAttribute: anAttribute ) ];
		labels: [ :each | each ifNil: ['None'] ifNotNil: [ each displayString] ]! !

!WAConfigurationEditor methodsFor: 'rendering-visitors' stamp: 'pmm 4/23/2006 20:20'!
visitNumberAttribute: anAttribute with: html
	html textInput
		size: 5;
		callback: [ :value | configuration takeValue: value asNumber forAttribute: anAttribute ];
		value: (configuration valueForAttribute: anAttribute)! !

!WAConfigurationEditor methodsFor: 'rendering-visitors' stamp: 'lr 5/3/2006 09:57'!
visitPasswordAttribute: anAttribute with: html
	html passwordInput 
		callback: [ :value | configuration takeValue: (anAttribute valueFromString: value) forAttribute: anAttribute ]! !

!WAConfigurationEditor methodsFor: 'rendering-visitors' stamp: 'lr 5/3/2006 09:58'!
visitStringAttribute: anAttribute with: html
	html textInput
		callback: [ :value | configuration takeValue: (anAttribute valueFromString: value) forAttribute: anAttribute ];
		value: (configuration valueForAttribute: anAttribute)! !

WAComponent subclass: #WACounter
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WACounter class methodsFor: 'testing' stamp: 'avi 2/5/2004 12:58'!
canBeRoot
	^ true! !

!WACounter class methodsFor: 'accessing' stamp: 'mb 5/26/2006 12:26'!
description
	^'A very simple Seaside application'! !

!WACounter class methodsFor: 'examples' stamp: 'ab 6/14/2003 19:02'!
example
	^ self new! !

!WACounter class methodsFor: 'class initialization' stamp: 'ab 1/15/2003 01:07'!
initialize
	(self registerAsApplication: 'counter')
! !

!WACounter methodsFor: 'accessing' stamp: 'avi 2/3/2004 00:59'!
count
	^ count! !

!WACounter methodsFor: 'actions' stamp: 'pmm 7/19/2006 18:49'!
decrease
	count := count - 1! !

!WACounter methodsFor: 'actions' stamp: 'pmm 7/19/2006 18:49'!
increase
	count := count + 1! !

!WACounter methodsFor: 'initialize-release' stamp: 'mb 10/12/2006 19:01'!
initialize
	super initialize.
	self registerForBacktracking.
	count := 0! !

!WACounter methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:11'!
renderContentOn: html
	html heading: count.
	html anchor 
		callback: [ self increase ];
		with: '++'.
	html space.
	html anchor
		callback: [ self decrease ];
		with: '--'! !

WAComponent subclass: #WADateSelector
	instanceVariableNames: 'day month year startYear endYear'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/22/2006 08:02'!
date
	(self privateIsValidDay: day monthNumber: month year: year)
		ifFalse: [self error: 'Invalid date'].
	^ self dateClass year: year month: month day: day! !

!WADateSelector methodsFor: 'accessing' stamp: 'ab 2/17/2003 13:52'!
date: aDate
	day := aDate dayOfMonth.
	month := aDate monthIndex.
	year := aDate year.! !

!WADateSelector methodsFor: 'private' stamp: 'pmm 10/22/2006 07:59'!
dateClass
	^ Date! !

!WADateSelector methodsFor: 'testing' stamp: 'ab 2/17/2003 13:53'!
dateIsValid
	[self date] on: Error do: [:e | ^ false].
	^ true! !

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:01'!
day
	^day! !

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:01'!
day: anObject
	^day := anObject! !

!WADateSelector methodsFor: 'accessing' stamp: 'ac 11/25/2003 12:06'!
days
	^ 1 to: 31! !

!WADateSelector methodsFor: 'accessing' stamp: 'JF 8/14/2003 14:44'!
endYear
	^ endYear! !

!WADateSelector methodsFor: 'accessing' stamp: 'JF 8/14/2003 14:41'!
endYear: anInteger
	endYear := anInteger! !

!WADateSelector methodsFor: 'initialize-release' stamp: 'pmm 10/22/2006 08:00'!
initialize
	super initialize.
	startYear := Date today year - 1.
	endYear := Date today year + 5.
	self date: self dateClass today.! !

!WADateSelector methodsFor: 'accessing' stamp: 'ac 11/25/2003 12:34'!
labelForDay: aNumber
	^ aNumber! !

!WADateSelector methodsFor: 'accessing' stamp: 'ac 11/25/2003 12:33'!
labelForMonth: aNumber
	^ Date nameOfMonth: aNumber! !

!WADateSelector methodsFor: 'accessing' stamp: 'ac 11/25/2003 12:34'!
labelForYear: aNumber
	^ aNumber! !

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:01'!
month
	^month! !

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:01'!
month: anObject
	^month := anObject! !

!WADateSelector methodsFor: 'accessing' stamp: 'ac 11/25/2003 12:06'!
months
	^ 1 to: 12! !

!WADateSelector methodsFor: 'private' stamp: 'avi 7/11/2005 12:44'!
privateIsValidDay: theDay monthNumber: theMonth year: theYear
	| maxDay |
	theMonth > 0 & (theMonth <= 12) ifFalse: [^false].
	maxDay := Month daysInMonth: theMonth forYear: theYear.
	^theDay > 0 & (theDay <= maxDay)! !

!WADateSelector methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:05'!
renderContentOn: html
	html select
		list: self months;
		on: #month of: self;
		labels: [ :each | self labelForMonth: each ].
		
	html select
		list: self days;
		on: #day of: self;
		labels: [ :each | self labelForDay: each ].
		
	html select
		list: self yearRange;
		on: #year of: self;
		labels: [ :each | self labelForYear: each ].
	
	self dateIsValid ifFalse: [self renderValidationErrorOn: html].! !

!WADateSelector methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:00'!
renderValidationErrorOn: html
	html span
		class: 'error';
		with: 'invalid date'! !

!WADateSelector methodsFor: 'accessing' stamp: 'JF 8/14/2003 14:44'!
startYear
	^ startYear! !

!WADateSelector methodsFor: 'accessing' stamp: 'JF 8/14/2003 14:40'!
startYear: anInteger
	startYear := anInteger! !

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:02'!
year
	^year! !

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:02'!
year: anObject
	^year := anObject! !

!WADateSelector methodsFor: 'accessing' stamp: 'JF 8/14/2003 14:43'!
yearRange
	^ self startYear to: self endYear! !

WAComponent subclass: #WADateSelectorTest
	instanceVariableNames: 'beginDate endDate beginTime endTime beginDAT endDAT'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WADateSelectorTest class methodsFor: 'examples' stamp: 'mb 2/10/2006 13:18'!
example
	^self new.! !

!WADateSelectorTest class methodsFor: 'class initialization' stamp: 'lr 6/13/2006 16:10'!
initialize
	self registerAsApplication: 'tests/dateselector'! !

!WADateSelectorTest methodsFor: 'accessing' stamp: 'mb 4/21/2006 17:13'!
children
	^(OrderedCollection new)
		add: beginDate;
		add: endDate;
		add: beginTime;
		add: endTime;
		add: beginDAT;
		add: endDAT;
		yourself.! !

!WADateSelectorTest methodsFor: 'initialization' stamp: 'pmm 7/19/2006 19:51'!
initialize
	super initialize.
	beginDate := WADateSelector new.
	endDate := WADateSelector new.
	endDate date: (Date today addDays: 1).

	beginTime := WATimeSelector new.
	beginTime time: Time now.
	endTime := WATimeSelector new.
	endTime time: (beginTime time addSeconds: 3600).

	beginDAT := WADateTimeSelector new.
	endDAT := WADateTimeSelector new.
	endDAT dateAndTime: beginDAT dateAndTime + 1 day + 1 hour! !

!WADateSelectorTest methodsFor: 'rendering' stamp: 'dc 7/21/2006 21:11'!
renderContentOn: html

	self renderDateSelectorsOn: html.
	html horizontalRule.
	self renderTimeSelectorsOn: html.
	html horizontalRule.
	self renderDateTimeSelectorsOn: html.
! !

!WADateSelectorTest methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:09'!
renderDateSelectorsOn: html
	html heading level: 3; with: 'Dates'.
	html form: [
		html table: [
			html tableRow: [
				html tableData: 'From'; tableData: beginDate].
			html tableRow: [
				html tableData: 'To'; tableData: endDate]].
		html submitButton
			callback: [self inform: (endDate date - beginDate date) days printString , ' day(s)'];
			text: 'Compute duration'].
! !

!WADateSelectorTest methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:08'!
renderDateTimeSelectorsOn: html
	html heading level: 3; with: 'Dates and Times'.
	html form: [
		html table: [
			html tableRow: [
				html tableData: 'From'; tableData: beginDAT ].
			html tableRow: [
				html tableData: 'To'; tableData: endDAT ] ].
		html submitButton
			callback: [
				| dateDiff |
				dateDiff := (endDAT dateAndTime asDate - beginDAT dateAndTime asDate) days.
				dateDiff isZero 
					ifFalse: [ self inform: dateDiff printString , ' day(s)' ]
					ifTrue: [ self inform: (endDAT dateAndTime asTime
										subtractTime: beginDAT dateAndTime asTime) asSeconds printString ,
										' second(s)']];
			text: 'Compute duration'].
! !

!WADateSelectorTest methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:07'!
renderTimeSelectorsOn: html
	html heading level: 3; with: 'Times'.
	html form: [
		html table: [
			html tableRow: [
				html tableData: 'From'; tableData: beginTime].
			html tableRow: [
				html tableData: 'To'; tableData: endTime ] ].
		html submitButton
			callback: [self inform: (endTime time subtractTime: beginTime time) asSeconds printString , ' seconds(s)'];
			text: 'Compute duration'].
! !

WAComponent subclass: #WADateTable
	instanceVariableNames: 'rows startDate endDate datesCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WADateTable methodsFor: 'enumerating' stamp: 'ab 2/18/2003 14:52'!
datesDo: aBlock separatedBy: monthlyBlock
	| month|
	month := datesCache first monthIndex.
	datesCache do:
		[:date |
		date monthIndex = month ifFalse: [month := date monthIndex. monthlyBlock value].
		aBlock value: date].
	monthlyBlock value.! !

!WADateTable methodsFor: 'accessing' stamp: 'ab 2/17/2003 20:56'!
endDate: aDate
	endDate := aDate.
	self updateDatesCache.! !

!WADateTable methodsFor: 'enumerating' stamp: 'ab 2/17/2003 16:19'!
monthsAndLengthsDo: aBlock
	|count last|
	count := 0.
	self
		datesDo: [:ea | count := count + 1. last := ea]
		separatedBy: [aBlock value: last month value: count.
						count := 0]! !

!WADateTable methodsFor: 'rendering' stamp: 'ab 2/17/2003 16:59'!
renderCellForDate: aDate row: anObject index: aNumber on: html
	html tableData: [html space]! !

!WADateTable methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:17'!
renderContentOn: html
	html table
		class: 'DateTable';
		border: 1;
		with: [
			html tableRow: [ self renderMonthHeadingsOn: html ].
			html tableRow: [ self renderDayHeadingsOn: html ].
			rows withIndexDo: [ :each :index |
				html tableRow: [self renderRow: each index: index on: html ] ] ]! !

!WADateTable methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:19'!
renderDayHeadingsOn: html
	self renderHeadingSpacerOn: html.
	self
		datesDo: [:date |
			html tableHeading
				class: 'DayHeading';
				with: date dayOfMonth ]
		separatedBy: [ self renderHeadingSpacerOn: html ]! !

!WADateTable methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:20'!
renderHeadingForRow: anObject on: html
	html tableHeading
		class: 'RowHeading';
		with: anObject! !

!WADateTable methodsFor: 'rendering' stamp: 'ab 2/17/2003 16:22'!
renderHeadingSpacerOn: html
	html tableData: []! !

!WADateTable methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:21'!
renderMonthHeadingsOn: html
	self monthsAndLengthsDo: [ :month :length |
		self renderHeadingSpacerOn: html.
		html tableHeading
			colSpan: length;
			class: 'MonthHeading';
			with: [
				html text: month name.
				html space.
				html text: month year ] ]! !

!WADateTable methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:22'!
renderRow: anObject index: aNumber on: html
	self renderHeadingForRow: anObject on: html.
	self
		datesDo: [ :date | self renderCellForDate: date row: anObject index: aNumber on: html]	
		separatedBy: [ self renderHeadingSpacerOn: html ]! !

!WADateTable methodsFor: 'accessing' stamp: 'ab 2/17/2003 14:11'!
rows: aCollection
	rows := aCollection! !

!WADateTable methodsFor: 'accessing' stamp: 'ab 2/17/2003 20:56'!
startDate: aDate
	startDate := aDate.
	self updateDatesCache.! !

!WADateTable methodsFor: 'actions' stamp: 'ab 2/17/2003 20:58'!
updateDatesCache
	| date |
	(startDate isNil or: [endDate isNil]) ifTrue: [^ self].
	
	datesCache := OrderedCollection new.
	date := startDate.
	[date > endDate] whileFalse:
		[datesCache add: date.
		date := date next]! !

WADateTable subclass: #WASelectionDateTable
	instanceVariableNames: 'cellBlock dateSelectionStart dateSelectionEnd rowSelectionStart rowSelectionEnd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WASelectionDateTable methodsFor: 'selecting' stamp: 'ab 2/17/2003 17:23'!
clearSelection
	dateSelectionStart := dateSelectionEnd := rowSelectionStart := rowSelectionEnd := nil! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:19'!
colorForDate: aDate rowIndex: aNumber
	^ (self hasSelection
		and: [self selectionContainsDate: aDate rowIndex: aNumber])
			ifTrue: ['lightgrey']
			ifFalse: ['white']! !

!WASelectionDateTable methodsFor: 'accessing' stamp: 'ab 2/17/2003 19:56'!
endDate: aDate
	self clearSelection.
	super endDate: aDate! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:22'!
endDateSelection
	^ dateSelectionStart ifNotNil: [dateSelectionStart max: dateSelectionEnd]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 19:40'!
endRow
	^ rowSelectionStart max: rowSelectionEnd! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:27'!
endRowSelection
	^ rowSelectionStart ifNotNil: [rows at: (rowSelectionStart max: rowSelectionEnd)]! !

!WASelectionDateTable methodsFor: 'testing' stamp: 'ab 2/17/2003 17:02'!
hasSelection
	^ dateSelectionStart notNil! !

!WASelectionDateTable methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:27'!
renderCellForDate: aDate row: anObject index: aNumber on: html
	| text |
	html tableData
		style: 'background-color: ', (self colorForDate: aDate rowIndex: aNumber);
		align: 'center';
		with: [
			text := cellBlock value: anObject value: aDate.
			html anchor callback: [self selectDate: aDate rowIndex: aNumber]; with: text ]! !

!WASelectionDateTable methodsFor: 'accessing' stamp: 'ab 2/17/2003 19:56'!
rows: aCollection
	self clearSelection.
	super rows: aCollection! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 16:48'!
rowsAndDatesDisplay: aBlock
	cellBlock := aBlock! !

!WASelectionDateTable methodsFor: 'editor access' stamp: 'ab 2/17/2003 20:04'!
selectAll
	dateSelectionStart := startDate.
	dateSelectionEnd := endDate.
	rowSelectionStart := 1.
	rowSelectionEnd := rows size.! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:05'!
selectDate: aDate rowIndex: rowIndex
	self hasSelection
		ifFalse: [dateSelectionStart := dateSelectionEnd := aDate. rowSelectionStart := rowSelectionEnd := rowIndex]
		ifTrue: [dateSelectionEnd := aDate. rowSelectionEnd := rowIndex]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 19:40'!
selectedRows
	^ rows copyFrom: self startRow to: self endRow! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:18'!
selectionContainsDate: aDate rowIndex: aNumber
	^ ((aDate between: dateSelectionStart and: dateSelectionEnd) or: [aDate between: dateSelectionEnd and: dateSelectionStart])
		and: [(aNumber between: rowSelectionStart and: rowSelectionEnd) or: [aNumber between: rowSelectionEnd and: rowSelectionStart]]! !

!WASelectionDateTable methodsFor: 'accessing' stamp: 'ab 2/17/2003 19:56'!
startDate: aDate
	self clearSelection.
	super startDate: aDate! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:22'!
startDateSelection
	^ dateSelectionStart ifNotNil: [dateSelectionStart min: dateSelectionEnd]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 19:40'!
startRow
	^ rowSelectionStart min: rowSelectionEnd! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:27'!
startRowSelection
	^ rowSelectionStart ifNotNil: [rows at: (rowSelectionStart min: rowSelectionEnd)]! !

!WASelectionDateTable methodsFor: 'rendering' stamp: 'ab 2/17/2003 22:43'!
style
	^ 'td a {text-decoration: none}'! !

WAComponent subclass: #WADateTimeSelector
	instanceVariableNames: 'dateSelector timeSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WADateTimeSelector methodsFor: 'accessing' stamp: 'jlr 4/5/2006 00:19'!
children

	^ Array with: dateSelector with: timeSelector! !

!WADateTimeSelector methodsFor: 'accessing' stamp: 'jlr 4/5/2006 00:22'!
dateAndTime

	^ DateAndTime date: dateSelector date time: timeSelector time! !

!WADateTimeSelector methodsFor: 'accessing' stamp: 'mb 4/21/2006 17:22'!
dateAndTime: anObject

	dateSelector date: anObject asDate.
	timeSelector time: anObject asTime.! !

!WADateTimeSelector methodsFor: 'initialize-release' stamp: 'mb 5/6/2006 16:07'!
initialize
	super initialize.
	dateSelector := WADateSelector new.
	timeSelector := WATimeSelector new.! !

!WADateTimeSelector methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:29'!
renderContentOn: html

	html span: dateSelector.
	html span: [html strong: ' : '].
	html span: timeSelector.! !

WAComponent subclass: #WADefaultFormTest
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WADefaultFormTest methodsFor: 'rendering' stamp: 'mb 4/5/2006 07:21'!
renderContentOn: html
	html formWithDefaultAction: [self inform: 'Default: ', value displayString] do: 
		[
		html submitButtonWithAction: [self inform: 'Before: ', value displayString] text: 'Before'.
		html break.
		html textInputWithValue: '' callback: [:v | value := v].
		html submitButtonWithAction: [self inform: 'Go: ' , value displayString] text: 'Go'.
		html break.
		html submitButtonWithAction: [self inform: 'After: ', value displayString] text: 'After']! !

!WADefaultFormTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:01'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

WAComponent subclass: #WADelayTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WADelayTest methodsFor: 'actions' stamp: 'avi 3/27/2005 20:39'!
go
	self call: (WAComponent new
				addMessage: '3 seconds';
				addDecoration: (WADelayedAnswerDecoration new delay: 3);
				yourself)! !

!WADelayTest methodsFor: 'rendering' stamp: 'avi 3/27/2005 20:35'!
renderContentOn: html
	html anchorWithAction: [self go] text: 'go'! !

!WADelayTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:02'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

WAComponent subclass: #WADispatcherEditor
	instanceVariableNames: 'path dispatcher type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

WADispatcherEditor class
	instanceVariableNames: 'plugins'!

WADispatcherEditor class
	instanceVariableNames: 'plugins'!

!WADispatcherEditor class methodsFor: 'plugins' stamp: 'pmm 9/12/2006 19:26'!
actionsFor: anEntryPoint inEditor: anEditor
	| actions |
	"Answer an OrderedCollectionn of associations"
	actions := OrderedCollection new.
	self plugins do: [:each |
		actions addAll: (each editorActionsFor: anEntryPoint inEditor: anEditor)].
	^actions.! !

!WADispatcherEditor class methodsFor: 'plugins' stamp: 'mb 6/18/2006 22:12'!
addPlugin: aClass
	(self plugins includes: aClass) ifFalse:
		[self plugins add: aClass]! !

!WADispatcherEditor class methodsFor: 'testing' stamp: 'avi 2/5/2004 12:56'!
canBeRoot 
	^ true! !

!WADispatcherEditor class methodsFor: 'accessing' stamp: 'mb 5/26/2006 12:27'!
description
	^'Seaside configuration tool (Requires authentication)'! !

!WADispatcherEditor class methodsFor: 'plugins' stamp: 'pmm 9/12/2006 19:26'!
editorActionsFor: anEntryPoint inEditor: anEditor
	^OrderedCollection new
		add: (Dictionary new
				at: #label put: 'configure';
				at: #action put: [anEditor configure: anEntryPoint];
				yourself);
		add: (Dictionary new
				at: #label put: 'remove';
				at: #action put: [anEditor remove: anEntryPoint];
				yourself);
		yourself
! !

!WADispatcherEditor class methodsFor: 'initialization' stamp: 'avi 4/13/2004 21:08'!
initialize
	self registerAsAuthenticatedApplication: 'config'! !

!WADispatcherEditor class methodsFor: 'testing' stamp: 'mb 5/26/2006 09:23'!
isDeployed
	^ true! !

!WADispatcherEditor class methodsFor: 'plugins' stamp: 'mb 6/16/2006 18:16'!
plugins
	^plugins ifNil: [plugins := self standardPlugins].! !

!WADispatcherEditor class methodsFor: 'plugins' stamp: 'mb 6/16/2006 18:20'!
standardPlugins
	^OrderedCollection with: self! !

!WADispatcherEditor methodsFor: 'actions' stamp: 'lr 11/16/2006 18:52'!
actionsFor: anEntryPoint
	^ self class actionsFor: anEntryPoint inEditor: self! !

!WADispatcherEditor methodsFor: 'actions' stamp: 'lr 11/16/2006 18:52'!
addEntryPoint
	| entryPoint |
	path isEmpty ifTrue: [ ^ self inform: 'You must enter a path.' ].
	entryPoint := type new.
	dispatcher registerEntryPoint: entryPoint path: path.
	self configure: entryPoint! !

!WADispatcherEditor methodsFor: 'actions' stamp: 'JF 9/22/2003 20:15'!
clearCaches
	WARegistry clearAllHandlers.
	Smalltalk garbageCollect! !

!WADispatcherEditor methodsFor: 'actions' stamp: 'lr 11/16/2006 18:52'!
configure: anEntryPoint
	anEntryPoint configurationComponent
		ifNotNilDo: [ :component | self call: component ]! !

!WADispatcherEditor methodsFor: 'accessing' stamp: 'lr 11/16/2006 18:28'!
dispatcher
	^ dispatcher! !

!WADispatcherEditor methodsFor: 'accessing' stamp: 'ab 8/26/2003 21:13'!
dispatcher: aDispatcher
	dispatcher := aDispatcher! !

!WADispatcherEditor methodsFor: 'accessing' stamp: 'ab 8/26/2003 21:52'!
entryPointClasses
	^ WAEntryPoint concreteSubclasses! !

!WADispatcherEditor methodsFor: 'initialization' stamp: 'lr 11/16/2006 18:51'!
initialize
	super initialize.
	dispatcher := WADispatcher default.
	type := WAApplication.
	path := ''! !

!WADispatcherEditor methodsFor: 'actions' stamp: 'ab 8/26/2003 21:34'!
remove: anEntryPoint
	dispatcher removeEntryPoint: anEntryPoint! !

!WADispatcherEditor methodsFor: 'rendering-settings' stamp: 'lr 11/16/2006 18:47'!
renderAddEntryPointOn: html
	html heading level: 3; with: 'Add entry point'.
	html form: [
		html table: [
			html tableRow: [
				html tableData class: 'label'; with: 'Path: '.
				html tableData: [ 
					html textInput 
						value: '';
						callback: [ :value | path := value ] ] ].
			html tableRow: [
				html tableData class: 'label'; with: 'Type: '.
				html tableData: [
					html select 
						list: self entryPointClasses;
						on: #type of: self;
						labels: [ :each | each description ].
				html space.
				html submitButton
					callback: [ self addEntryPoint ];
					text: 'Add' ] ] ] ]
! !

!WADispatcherEditor methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:48'!
renderContentOn: html
	self renderHeadingOn: html.
	self renderDispatcherOn: html.
	self renderSettingsOn: html.
	self renderStatisticsOn: html! !

!WADispatcherEditor methodsFor: 'rendering-settings' stamp: 'lr 11/16/2006 18:47'!
renderDefaultEntryPointOn: html.
	html heading
		level: 3;
		with: 'Default entry point'.
	html form: [
		html select
			beOptional;
			optionalLabel: '(none)';
			list: self dispatcher entryPoints keysSortedSafely;
			on: #defaultPath of: dispatcher.
		html space.
		html submitButton ]! !

!WADispatcherEditor methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:48'!
renderDispatcherOn: html
	html heading level: 2; with: self dispatcher basePath.
	html table: [
		self dispatcher isRoot
			ifFalse: [ self renderRow: self dispatcher named: '..' on: html ].
		self dispatcher genuineEntryPoints keysSortedSafely
			do: [ :each | self renderRow: (dispatcher entryPointAt: each) named: each on: html ] ]! !

!WADispatcherEditor methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:48'!
renderHeadingOn: html.
	html heading level: 1; with: 'Seaside'.
	html div: SeasidePlatformSupport versionString! !

!WADispatcherEditor methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:37'!
renderRow: anEntryPoint named: aString on: html
	html tableRow: [
		html tableData: [
			anEntryPoint = self dispatcher
				ifTrue: [ html anchor callback: [ self answer ]; with: '..' ]
				ifFalse: [
					anEntryPoint isApplication
						ifTrue: [ html anchor url: anEntryPoint basePath; with: aString ]
						ifFalse: [ html anchor callback: [ self configure: anEntryPoint ]; with: aString ] ] ].
		html tableData: anEntryPoint class description.
		html tableData: [
			(self actionsFor: anEntryPoint)
				do: [ :each | html anchor callback: (each at: #action); with: (each at: #label) ]
				separatedBy: [ html space ] ] ]! !

!WADispatcherEditor methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:47'!
renderSettingsOn: html
	html heading level: 2; with: 'Settings'.
	self renderDefaultEntryPointOn: html.
	self renderAddEntryPointOn: html! !

!WADispatcherEditor methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:49'!
renderStatisticsOn: html
	html heading level: 2; with: 'Statistics'.
	html preformatted: SeasidePlatformSupport vmStatisticsReportString.
	html anchor callback: [ self clearCaches ]; with: 'Clear Caches'! !

!WADispatcherEditor methodsFor: 'accessing' stamp: 'pmm 4/23/2006 19:53'!
type
	^type! !

!WADispatcherEditor methodsFor: 'accessing' stamp: 'pmm 4/23/2006 19:53'!
type: aClass 
	type := aClass! !

WAComponent subclass: #WADispatcherNavigator
	instanceVariableNames: 'dispatcher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WADispatcherNavigator class methodsFor: 'as yet unclassified' stamp: 'mb 11/8/2006 16:12'!
appName
	^'browse'.
! !

!WADispatcherNavigator class methodsFor: 'testing' stamp: 'mb 5/26/2006 11:53'!
canBeRoot 
	^ true! !

!WADispatcherNavigator class methodsFor: 'initialization' stamp: 'mb 11/8/2006 16:12'!
initialize
	self registerAsApplication: self appName.
	WADispatcher default defaultPath: self appName.! !

!WADispatcherNavigator class methodsFor: 'testing' stamp: 'mb 5/26/2006 11:54'!
isDeployed
	^ true! !

!WADispatcherNavigator methodsFor: 'actions' stamp: 'mb 5/26/2006 12:07'!
browse: anEntryPoint
	self call: (WADispatcherNavigator new dispatcher: anEntryPoint)! !

!WADispatcherNavigator methodsFor: 'initialization' stamp: 'mb 5/26/2006 12:08'!
dispatcher: aDispatcher
	dispatcher := aDispatcher! !

!WADispatcherNavigator methodsFor: 'initialization' stamp: 'lr 11/16/2006 19:13'!
initialize
	super initialize.
	dispatcher := WADispatcher default! !

!WADispatcherNavigator methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:12'!
renderContentOn: html
	| entryPoints |
	self renderTopOn: html.
	html heading: 'Seaside'.
	html div
		style: 'font-size: 75%; margin-top: -2em; margin-bottom: 2em';
		with: SeasidePlatformSupport versionString.
	
	html strong: dispatcher basePath.
	dispatcher isRoot ifFalse:
		[html break; break.
		html text: '['.
		html anchor callback: [self answer]; with: [html strong: '..'].
		html text: '] Up folder'].
	html break; break.
	entryPoints := dispatcher genuineEntryPoints select: 
		[:each |
		each isDispatcher or: [each isApplication]].
	html table:
		[entryPoints keysSortedSafely do:
			[:name |
			| entryPoint |
			entryPoint := dispatcher entryPointAt: name.
			(entryPoint isDispatcher or: [entryPoint rootComponent ~~ self class]) ifTrue:
				[self
					renderRowForEntryPoint: entryPoint
					named: name
					on: html]]].
! !

!WADispatcherNavigator methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:12'!
renderRowForEntryPoint: anEntryPoint named: aString on: html
	html tableRow: [
		html tableData: [
			anEntryPoint isApplication
				ifTrue: [ html anchor url: anEntryPoint basePath; with: aString ]
				ifFalse: [
					html text: '['.
					html anchor callback: [self browse: anEntryPoint]; with: aString.
					html text: ']'] ].

		html tableData
			addStyle: 'padding-left: 1em';
			with: anEntryPoint description ]
! !

!WADispatcherNavigator methodsFor: 'rendering' stamp: 'mb 6/12/2006 14:32'!
renderTopOn: html
	html image
		fileName: 'seaside-top.jpg';
		mimeType: 'image/jpeg';
		document: SeasidePlatformSupport seasideBanner
! !

WAComponent subclass: #WAEmailConfirmation
	instanceVariableNames: 'from to subject body notice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAEmailConfirmation methodsFor: 'accessing' stamp: 'avi 3/10/2004 15:40'!
body: aString
	body := aString! !

!WAEmailConfirmation methodsFor: 'accessing' stamp: 'avi 3/10/2004 15:40'!
from: fromString
	from := fromString! !

!WAEmailConfirmation methodsFor: 'accessing' stamp: 'avi 3/10/2004 15:40'!
notice: aString
	notice := aString! !

!WAEmailConfirmation methodsFor: 'rendering' stamp: 'avi 3/10/2004 15:41'!
renderContentOn: html
	| url |
	url := html urlForAction: [self answer].
	self sendMessageWithUrl: url.
	html divClass: 'notice' with: notice! !

!WAEmailConfirmation methodsFor: 'as yet unclassified' stamp: 'lr 3/27/2006 09:04'!
sendMessageWithUrl: urlString
	SeasidePlatformSupport
		deliverMailFrom: from
		to: (Array with: to)
		text: ('Subject: ' , subject , '

' , urlString , '
		
' , body)! !

!WAEmailConfirmation methodsFor: 'accessing' stamp: 'avi 3/10/2004 15:40'!
subject: aString
	subject := aString! !

!WAEmailConfirmation methodsFor: 'accessing' stamp: 'avi 3/10/2004 15:40'!
to: toString
	to := toString! !

WAComponent subclass: #WAEncodingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAEncodingTest methodsFor: 'rendering' stamp: 'jf 2/18/2004 15:15'!
renderContentOn: html
	| w allChars r |

	w := WriteStream on: String new.
	32 to: 255 do: [ :c |  w nextPut: c asCharacter ].
	allChars := w contents.

	html code: [ 
		html text: 'Start'; break.
		r := ReadStream on: allChars.

		[ r atEnd ] whileFalse: [ 
			html text: (r next: 14);
			break.
		].
		html text: 'End'; 
			  break.
	].
	html text: 'Characters Encoded: '.
	'Hello World' do: [ :c | html encodeCharacter: c ]. 
	html break.
! !

!WAEncodingTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:05'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

WAComponent subclass: #WAErrorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAErrorTest methodsFor: 'rendering' stamp: 'avi 3/28/2004 21:24'!
renderContentOn: html
	html anchorWithAction: [1/0] text: 'Raise error'.
	html break.
	html anchorWithAction: [self notify: 'Really?'. self inform: 'Ok!!'] text: 'Raise warning'.! !

!WAErrorTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:07'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

WAComponent subclass: #WAExampleBrowser
	instanceVariableNames: 'class selector component hasAnswer answer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAExampleBrowser commentStamp: '<historical>' prior: 0!
I browse all the examples available in the system ie all the results of class methods beginning with #example... 

point your browser to localhost:xxx/seaside/examples

If you want to see these examples

/seaside/config app:
- add a new application named "examples"
- choose WAExampleBrowser as the root component
!

!WAExampleBrowser class methodsFor: 'testing' stamp: 'avi 2/5/2004 12:58'!
canBeRoot
	^ true! !

!WAExampleBrowser class methodsFor: 'accessing' stamp: 'mb 5/26/2006 12:29'!
description
	^'Browse through Seaside examples'! !

!WAExampleBrowser class methodsFor: 'class initialization' stamp: 'mb 6/13/2006 17:02'!
initialize
	self registerAsApplication: 'examples/examplebrowser'.! !

!WAExampleBrowser methodsFor: 'helper' stamp: 'ab 6/14/2003 19:01'!
allClasses
	^ (WAComponent allSubclasses select: [:ea | ea class selectors anySatisfy: [:s | s beginsWith: self selectorPrefix]])
		asSortedCollection: [:a :b | a name < b name]! !

!WAExampleBrowser methodsFor: 'helper' stamp: 'ab 6/14/2003 19:01'!
allSelectors
	^ (class class selectors select: [:s | s beginsWith: self selectorPrefix])
		asSortedCollection! !

!WAExampleBrowser methodsFor: 'accessing' stamp: 'lr 11/29/2004 16:21'!
children
	^ Array with: component! !

!WAExampleBrowser methodsFor: 'accessing' stamp: 'pmm 6/23/2005 08:52'!
class: aClass
	class := aClass.
	self selector: self allSelectors first! !

!WAExampleBrowser methodsFor: 'accessing' stamp: 'ab 6/15/2003 12:33'!
component: aComponent
	component := aComponent.
	hasAnswer := false.
	answer := nil.
	component onAnswer: [:v | hasAnswer := true. answer := v].
! !

!WAExampleBrowser methodsFor: 'initialize' stamp: 'pmm 11/2/2005 22:35'!
initialize
	super initialize.
	self class: self allClasses first! !

!WAExampleBrowser methodsFor: 'rendering' stamp: 'lr 11/16/2006 15:36'!
renderContentOn: html
	html table id: 'test-forms'; with: [
		html tableRow: [
			html tableData: [
				html form: [
					html select
						list: self allClasses;
						selected: class;
						callback: [ :value | self class: value ].
					html submitButton text: 'OK' ] ].
			html tableData: [
				html form: [
					html select
						list: self allSelectors;
						selected: selector;
						callback: [ :value | self selector: value ].
			 		html submitButton text: 'OK' ] ] ] ].
	html horizontalRule.
	html render: component.
	hasAnswer ifTrue: [
		html horizontalRule.
		html strong: 'Answer '; text: answer printString ]! !

!WAExampleBrowser methodsFor: 'accessing' stamp: 'ab 6/14/2003 19:04'!
selector: aSymbol
	selector := aSymbol.
	self component: (class perform: selector)! !

!WAExampleBrowser methodsFor: 'helper' stamp: 'ab 6/14/2003 19:02'!
selectorPrefix
	^ 'example'! !

WAComponent subclass: #WAExpiryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAExpiryTest class methodsFor: 'services' stamp: 'mb 6/13/2006 17:03'!
install
	(self registerAsApplication: 'tests/expiry')
		 preferenceAt: #sessionClass put: WAExpirySession! !

!WAExpiryTest methodsFor: 'rendering' stamp: 'mb 5/26/2006 09:15'!
renderContentOn: html
	html table: [
		html tableRowWithLabel: 'Live session instances' column: WAExpirySession allInstances size.
		html tableRowWithLabel: 'Live component instances' column: self class allInstances size.
		html tableRowWithLabel: 'Sessions created' column: WAExpirySession created.
		html tableRowWithLabel: 'Sessions unregistered' column: WAExpirySession unregistered.
	].
	html anchorWithUrl: self session newSessionUrl do: 'New Session'.
	html break.
	html anchorWithAction: [self session expire] text: 'Expire'.
	html break.
	html anchorWithAction: [WAExpirySession resetCounters] text: 'Reset Counters'.
	html break.
	html anchorWithAction: [Smalltalk garbageCollect] text: 'Garbage Collect'.
	html break.
	html anchorWithAction: [self session application clearHandlers. Smalltalk garbageCollect] text: 'Clear Handlers'.
	html break.
	html anchorWithAction: [self session application clearHandlers. WAExpirySession resetCounters. 	Smalltalk garbageCollect.
] text: 'Reset All'.
	html form: [
		html text: 'Expiry seconds:'.
		html
			textInputWithValue: self session application sessionExpirySeconds
			callback: [:v | self session application preferenceAt: #sessionExpirySeconds put: v].
		html space.
		html submitButton]
	! !

!WAExpiryTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:09'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

WAComponent subclass: #WAFileHandlerEditor
	instanceVariableNames: 'fileHandler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAFileHandlerEditor methodsFor: 'actions' stamp: 'pmm 10/28/2006 23:02'!
addLibrary: aLibraryClass
	^self fileHandler addLibrary: aLibraryClass new! !

!WAFileHandlerEditor methodsFor: 'accessing' stamp: 'pmm 4/20/2006 21:42'!
basePath
	^self fileHandler basePath! !

!WAFileHandlerEditor methodsFor: 'actions' stamp: 'pmm 4/21/2006 23:24'!
configureLibrary: aLibrary
	self call: (aLibrary configurationComponent
		basePath: self basePath;
		yourself)! !

!WAFileHandlerEditor methodsFor: 'accessing' stamp: 'pmm 4/18/2006 21:57'!
fileHandler
	^fileHandler! !

!WAFileHandlerEditor methodsFor: 'accessing' stamp: 'pmm 4/18/2006 21:57'!
fileHandler: aFilehandler 
	fileHandler := aFilehandler! !

!WAFileHandlerEditor methodsFor: 'accessing' stamp: 'pmm 4/20/2006 21:43'!
libraries
	^self fileHandler libraries! !

!WAFileHandlerEditor methodsFor: 'accessing' stamp: 'mb 10/17/2006 13:41'!
libraryClasses
	| classes |
	classes := (WAFileLibrary allSubclasses)
		addAll: WAStyleLibrary allSubclasses;
		addAll: WAScriptLibrary allSubclasses;
		yourself.
	^(classes
		reject: [ :each |
			self libraries anySatisfy: [ :library |
				library class = each ] ])
		asSortedCollection: [ :a :b | a name <= b name ]! !

!WAFileHandlerEditor methodsFor: 'actions' stamp: 'pmm 4/20/2006 21:45'!
removeLibrary: aLibrary
	^self libraries remove: aLibrary! !

!WAFileHandlerEditor methodsFor: 'actions' stamp: 'lr 11/16/2006 18:12'!
renderContentOn: html
	html heading: WAFileHandler description.

	html text: 'Base Path: '.
	html text: self basePath.
	
	html heading level2; with: 'Libraries'.

	html form: [
		html text: 'Add Library: '.
		html select
			list: self libraryClasses;
			callback: [ :value | self addLibrary: value ].
		html space.
		html submitButton text: 'Add' ].
	
	html table: [
		self libraries do: [ :each |
			html tableRow: [
				html tableData: each name.
				html tableData: [ html anchor callback: [ self configureLibrary: each ]; with: 'configure' ].
				html tableData: [ html anchor callback: [ self removeLibrary: each ]; with: 'remove' ] ] ] ].
	
	html form: [
		html submitButton callback: [ self answer ]; text: 'Done' ] ! !

WAComponent subclass: #WAFileLibraryExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAFileLibraryExample class methodsFor: 'testing' stamp: 'mb 10/17/2006 14:10'!
canBeRoot
	^true! !

!WAFileLibraryExample class methodsFor: 'testing' stamp: 'mb 10/17/2006 14:41'!
description
	^'A component with a static stylesheet and a static background image'! !

!WAFileLibraryExample class methodsFor: 'testing' stamp: 'mb 10/17/2006 14:42'!
example
	^self new! !

!WAFileLibraryExample methodsFor: 'accessing' stamp: 'mb 10/17/2006 14:43'!
basePath
	^WADispatcher default basePath! !

!WAFileLibraryExample methodsFor: 'rendering' stamp: 'mb 10/17/2006 14:38'!
renderContentOn: html
	html div
		class: 'desc';
		with:
			[html heading: 'This page has' level: 3.
			html unorderedList:
				[html listItem: 'a static stylesheet (main.css)'.
				html listItem: 'a static background image (main.jpg) named in a dynamic stylesheet']].! !

!WAFileLibraryExample methodsFor: 'rendering' stamp: 'mb 10/17/2006 14:44'!
style
	^'

body { 
	background: url(' , self basePath , '/files/WAFileLibraryDemo/main.jpg);
}
div.desc {
	padding: 2em;
}
'
! !

!WAFileLibraryExample methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:20'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot stylesheet 
		url: self basePath , '/files/WAFileLibraryDemo/main.css'.
! !

WAComponent subclass: #WAFormDialog
	instanceVariableNames: 'validationError form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

WAFormDialog subclass: #WAChoiceDialog
	instanceVariableNames: 'options selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAChoiceDialog class methodsFor: 'accessing' stamp: 'avi 3/21/2004 00:59'!
options: aCollection
	^ self new options: aCollection! !

!WAChoiceDialog methodsFor: 'accessing' stamp: 'avi 3/21/2004 01:00'!
buttons
	^ #(ok cancel)! !

!WAChoiceDialog methodsFor: 'actions' stamp: 'avi 3/21/2004 01:00'!
cancel
	self answer: nil! !

!WAChoiceDialog methodsFor: 'actions' stamp: 'avi 3/21/2004 01:00'!
ok
	self answer: selection! !

!WAChoiceDialog methodsFor: 'accessing' stamp: 'avi 3/21/2004 00:59'!
options
	^ options! !

!WAChoiceDialog methodsFor: 'accessing' stamp: 'avi 3/21/2004 00:59'!
options: aCollection
	options := aCollection! !

!WAChoiceDialog methodsFor: 'rendering' stamp: 'al 9/7/2006 16:01'!
renderContentOn: html
	html select
		list: options;
		selected: nil;
		callback: [ :value | selection := value ]! !

!WAFormDialog methodsFor: 'actions' stamp: 'avi 3/16/2004 13:45'!
addForm
	form := WAFormDecoration new buttons: self buttons.
	self addDecoration: form! !

!WAFormDialog methodsFor: 'testing' stamp: 'avi 3/16/2004 14:05'!
addFormByDefault
	^ true! !

!WAFormDialog methodsFor: 'accessing' stamp: 'avi 3/12/2004 16:37'!
buttons
	^ #(ok)! !

!WAFormDialog methodsFor: 'accessing' stamp: 'mb 4/4/2006 13:41'!
defaultButton
	^self buttons first! !

!WAFormDialog methodsFor: 'accessing' stamp: 'avi 3/12/2004 20:41'!
divClass
	^ self class name! !

!WAFormDialog methodsFor: 'initialization' stamp: 'pmm 11/2/2005 22:51'!
initialize
	super initialize.
	self addFormByDefault ifTrue: [self addForm]! !

!WAFormDialog methodsFor: 'testing' stamp: 'avi 3/12/2004 16:35'!
isValid
	^ validationError isNil! !

!WAFormDialog methodsFor: 'accessing' stamp: 'avi 3/12/2004 16:35'!
model
	^ self! !

!WAFormDialog methodsFor: 'actions' stamp: 'avi 3/12/2004 16:37'!
ok
	self answer! !

!WAFormDialog methodsFor: 'actions' stamp: 'avi 3/27/2004 16:59'!
removeForm
	form ifNotNil: [self removeDecoration: form]! !

!WAFormDialog methodsFor: 'rendering' stamp: 'al 9/7/2006 15:54'!
renderContentOn: html
	html hiddenInput callback: [ validationError := nil ].
	validationError ifNotNil: [
		self renderValidationError: validationError on: html ].
	html div
		class: self divClass;
		with: [ self renderDialogOn: html ]! !

!WAFormDialog methodsFor: 'rendering' stamp: 'avi 3/12/2004 20:37'!
renderDialogOn: html! !

!WAFormDialog methodsFor: 'rendering' stamp: 'avi 3/13/2004 21:20'!
renderSpacerRowOn: html
	html divClass: 'dialog-spacer' with: [html space]! !

!WAFormDialog methodsFor: 'rendering' stamp: 'avi 3/13/2004 21:28'!
renderValidationError: aString on: html
	html spanClass: 'dialog-validation' with: aString! !

!WAFormDialog methodsFor: 'validation' stamp: 'avi 3/12/2004 16:35'!
validationError: aString
	validationError := aString! !

WAFormDialog subclass: #WAGridDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAGridDialog methodsFor: 'accessing' stamp: 'avi 3/12/2004 16:47'!
columns
	^ #()! !

!WAGridDialog methodsFor: 'accessing' stamp: 'avi 3/17/2004 15:05'!
cssClassForItem: anObject
	^ 'dialog-row'! !

!WAGridDialog methodsFor: 'accessing' stamp: 'avi 3/12/2004 16:47'!
items
	^ #()! !

!WAGridDialog methodsFor: 'rendering' stamp: 'avi 3/12/2004 16:59'!
renderColumn: aSymbol for: anObject on: html
	| renderSelector |
	renderSelector := self renderingSelectorFor: aSymbol.
	(self respondsTo: renderSelector)
		ifTrue: [self perform: renderSelector with: anObject with: html]
		ifFalse: [self renderDefaultColumn: aSymbol for: anObject on: html]! !

!WAGridDialog methodsFor: 'rendering' stamp: 'avi 3/12/2004 17:00'!
renderDefaultColumn: aSymbol for: anObject on: html
	html text: (anObject perform: aSymbol)! !

!WAGridDialog methodsFor: 'rendering' stamp: 'al 9/7/2006 16:04'!
renderDialogOn: html
	html table: [
		self renderHeadingsOn: html.
		self items do: [ :each | 
			self renderRowForItem: each on: html ] ]! !

!WAGridDialog methodsFor: 'rendering' stamp: 'avi 3/12/2004 16:51'!
renderHeadingForSelector: aSymbol on: html
	html text: (self labelForSelector: aSymbol)! !

!WAGridDialog methodsFor: 'rendering' stamp: 'al 9/7/2006 16:05'!
renderHeadingsOn: html
	self columns do: [ :each |
		html tableHeading
			class: each;
			with: [ self renderHeadingForSelector: each on: html ] ]! !

!WAGridDialog methodsFor: 'rendering' stamp: 'al 9/7/2006 16:07'!
renderRowForItem: anObject on: html
	html tableRow
		class: (self cssClassForItem: anObject);
		with: [
			self columns do:  [:each |
				html tableData
					class: each;
					with: [self renderColumn: each for: anObject on: html ] ] ]! !

!WAGridDialog methodsFor: 'rendering' stamp: 'avi 3/12/2004 16:59'!
renderingSelectorFor: aSymbol
	^ ('render', aSymbol capitalized, 'For:on:') asSymbol! !

!WAGridDialog methodsFor: 'accessing' stamp: 'avi 3/12/2004 21:03'!
style
	^ '
	.dialog-buttons {text-align: center}
	'! !

WAFormDialog subclass: #WALabelledFormDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

WALabelledFormDialog subclass: #WAEditDialog
	instanceVariableNames: 'model snapshot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAEditDialog class methodsFor: 'instance creation' stamp: 'avi 3/13/2004 14:21'!
model: anObject
	^ self new model: anObject! !

!WAEditDialog methodsFor: 'accessing' stamp: 'avi 3/13/2004 14:10'!
buttons
	^ #(save cancel)! !

!WAEditDialog methodsFor: 'actions' stamp: 'avi 3/12/2004 17:46'!
cancel
	self rollback.
	self answer: false! !

!WAEditDialog methodsFor: 'accessing' stamp: 'avi 3/12/2004 17:49'!
model
	^ model! !

!WAEditDialog methodsFor: 'accessing' stamp: 'avi 3/12/2004 17:46'!
model: anObject
	model := anObject.
	self snapshot.! !

!WAEditDialog methodsFor: 'actions' stamp: 'avi 3/12/2004 17:49'!
rollback
	model copyFrom: snapshot! !

!WAEditDialog methodsFor: 'actions' stamp: 'avi 3/12/2004 17:46'!
save
	self validate.
	self isValid ifTrue: [self answer: true]! !

!WAEditDialog methodsFor: 'actions' stamp: 'avi 3/12/2004 17:49'!
snapshot
	snapshot := model clone! !

!WAEditDialog methodsFor: 'actions' stamp: 'avi 3/13/2004 14:10'!
validate
	! !

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'al 9/7/2006 16:08'!
renderDefaultFieldForSelector: aSymbol on: html
	html textInput
		on: aSymbol of: self model! !

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'avi 3/12/2004 20:37'!
renderDialogOn: html
	self rows do:
		[:ea |
		ea = #-
			ifTrue: [self renderSpacerRowOn: html]
			ifFalse: [self renderRowForSelector: ea on: html]].
! !

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'avi 3/12/2004 21:06'!
renderFieldForSelector: aSymbol on: html
	| renderSelector |
	renderSelector := self renderingSelectorFor: aSymbol.
	(self respondsTo: renderSelector)
		ifTrue: [self perform: renderSelector with: html]
		ifFalse: [self renderDefaultFieldForSelector: aSymbol on: html]! !

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'avi 3/12/2004 20:41'!
renderLabelForSelector: aSymbol on: html
	html text: (self labelForSelector: aSymbol)! !

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'al 9/7/2006 16:09'!
renderRowForSelector: aSymbol on: html
	html div
		id: 'dialog-row-' , aSymbol;
		class: 'dialog-row';
		with: [
			html span 
				class: 'dialog-form-label';
				with: [self renderLabelForSelector: aSymbol on: html].
			html span 
				class: 'dialog-form-field';
				with: [self renderFieldForSelector: aSymbol on: html]].
! !

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'avi 3/12/2004 16:39'!
renderTableRowsOn: html
	self rows do:
		[:ea |
		ea = #-
			ifTrue: [self renderSpacerRowOn: html]
			ifFalse: [self renderRowForSelector: ea on: html]].
! !

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'avi 3/12/2004 20:37'!
renderingSelectorFor: aSymbol
	^ ('render', aSymbol capitalized, 'On:') asSymbol! !

!WALabelledFormDialog methodsFor: 'accessing' stamp: 'avi 3/10/2004 18:00'!
rows
	^ #()! !

!WALabelledFormDialog methodsFor: 'accessing' stamp: 'avi 3/16/2004 16:29'!
style
	^ '
.dialog-row {
	clear: both;
	/*set position: relative to handle the ie disappearing text bug*/
	position: relative;
	margin-top: 3px;
}

.dialog-form-label {
	width: 100px;
	float: left;
	text-align: right;
	padding: 2px 6px;
	margin-right: 4px;
	margin-top: 2px;
}

.dialog-form-field {
	text-align: left;
	padding: 2px;
	margin-top: 2px;
	float: left;
}

.dialog-buttons {
	clear: both;
	padding: 10px;
	text-align: center
}

.dialog-spacer {
	clear: both;
	height: 10px;
}
	'! !

WALabelledFormDialog subclass: #WAStoreAddressEditor
	instanceVariableNames: 'address'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreAddressEditor commentStamp: 'avi 1/1/2004 09:56' prior: 0!
A component for editing WAStoreAddress instances.  When called, it will create a new address instance, present a form for the user to modify it, and then answer the instance on submit.  Used by WAStoreTask>>getBillingAddress and getShippingAddress.!

!WAStoreAddressEditor methodsFor: 'accessing' stamp: 'avi 12/8/2003 13:55'!
countries
	^ #(Canada USA)! !

!WAStoreAddressEditor methodsFor: 'initialize-release' stamp: 'al 9/7/2006 16:12'!
initialize
	super initialize.
	address := WAStoreAddress new! !

!WAStoreAddressEditor methodsFor: 'accessing' stamp: 'mb 2/17/2005 11:14'!
labelForSelector: aSymbol

	aSymbol == #name ifTrue: [^'Your name'].
	aSymbol == #street ifTrue: [^'The street'].
	aSymbol == #city ifTrue: [^'The city'].
	aSymbol == #ok ifTrue: [^'Continue'].
	^ super labelForSelector: aSymbol! !

!WAStoreAddressEditor methodsFor: 'accessing' stamp: 'avi 5/1/2004 14:38'!
model
	^ address! !

!WAStoreAddressEditor methodsFor: 'actions' stamp: 'avi 12/10/2003 13:04'!
ok
	self answer: address! !

!WAStoreAddressEditor methodsFor: 'rendering' stamp: 'al 9/7/2006 16:11'!
renderCountryOn: html
	html select
		list: self countries;
		on: #country of: address! !

!WAStoreAddressEditor methodsFor: 'accessing' stamp: 'avi 5/1/2004 14:11'!
rows
	^ #(name street city country)
! !

!WAStoreAddressEditor methodsFor: 'path' stamp: 'mb 2/10/2006 12:05'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'Seaside Sushi Store : Your address'.! !

WALabelledFormDialog subclass: #WAStorePaymentEditor
	instanceVariableNames: 'name cardType cardNumber month year'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStorePaymentEditor commentStamp: 'avi 1/1/2004 09:58' prior: 0!
A component for editing WAStoreCreditCard instances.  When called, it presents a form for the user to choose credit card type, and enter name, number, and expiry date.  On submit, it will create and answer an instance of the appropiate credit card subclass.  Note the difference with WAStoreAddressEditor, where the form modifies the address instance directly.  Used by WAStoreTask>>getPaymentInfo.!

!WAStorePaymentEditor methodsFor: 'accessing' stamp: 'al 9/7/2006 16:14'!
cardNumber
	^cardNumber! !

!WAStorePaymentEditor methodsFor: 'accessing' stamp: 'al 9/7/2006 16:15'!
cardNumber: aString
	cardNumber := aString! !

!WAStorePaymentEditor methodsFor: 'accessing' stamp: 'al 9/7/2006 16:17'!
cardType
	^cardType! !

!WAStorePaymentEditor methodsFor: 'accessing' stamp: 'al 9/7/2006 16:22'!
cardType: aCreditCardClass
	cardType := aCreditCardClass! !

!WAStorePaymentEditor methodsFor: 'accessing' stamp: 'avi 12/10/2003 14:06'!
cardTypes
	^ WAStoreCreditCard subclasses! !

!WAStorePaymentEditor methodsFor: 'accessing' stamp: 'mb 2/10/2006 12:29'!
labelForSelector: aSymbol

	aSymbol == #ok ifTrue: [^'OK to pay'].
	^ super labelForSelector: aSymbol! !

!WAStorePaymentEditor methodsFor: 'accessing' stamp: 'al 9/7/2006 16:22'!
month
	^month! !

!WAStorePaymentEditor methodsFor: 'accessing' stamp: 'al 9/7/2006 16:23'!
month: anInteger
	month := anInteger! !

!WAStorePaymentEditor methodsFor: 'accessing' stamp: 'avi 12/10/2003 13:59'!
months
	^ (1 to: 12)! !

!WAStorePaymentEditor methodsFor: 'accessing' stamp: 'al 9/7/2006 16:25'!
name
	^name! !

!WAStorePaymentEditor methodsFor: 'accessing' stamp: 'al 9/7/2006 16:25'!
name: aString
	name := aString! !

!WAStorePaymentEditor methodsFor: 'actions' stamp: 'pmm 11/2/2005 23:42'!
ok
	self answer:
		(cardType new
			name: name;
			number: cardNumber;
			expiry: (Date newDay: 1 monthNumber: month year: year);
			yourself)! !

!WAStorePaymentEditor methodsFor: 'rendering' stamp: 'al 9/7/2006 17:10'!
renderCardNumberOn: html
	html textInput on: #cardNumber of: self! !

!WAStorePaymentEditor methodsFor: 'rendering' stamp: 'al 9/7/2006 17:10'!
renderCardTypeOn: html
	html select
		list: self cardTypes;
		on: #cardType of: self;
		labels: [ :each | each abbreviation]! !

!WAStorePaymentEditor methodsFor: 'rendering' stamp: 'al 9/7/2006 16:25'!
renderExpirationDateOn: html 
	html select
		list: self months;
		on: #month of: self.
	html select
		list: self years;
		on: #year of: self! !

!WAStorePaymentEditor methodsFor: 'rendering' stamp: 'al 9/7/2006 16:26'!
renderNameOn: html
	html textInput on: #name of: self! !

!WAStorePaymentEditor methodsFor: 'accessing' stamp: 'avi 5/1/2004 14:14'!
rows
	^ #(cardType name cardNumber expirationDate)! !

!WAStorePaymentEditor methodsFor: 'path' stamp: 'mb 2/10/2006 12:08'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'Seaside Sushi Store : Payment'.! !

!WAStorePaymentEditor methodsFor: 'accessing' stamp: 'al 9/7/2006 16:23'!
year
	^year! !

!WAStorePaymentEditor methodsFor: 'accessing' stamp: 'al 9/7/2006 16:23'!
year: anInteger
	year := anInteger! !

!WAStorePaymentEditor methodsFor: 'accessing' stamp: 'avi 12/10/2003 13:45'!
years
	^ (Date today year to: Date today year + 5)! !

WALabelledFormDialog subclass: #WAViewer
	instanceVariableNames: 'presenter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAViewer class methodsFor: 'instance creation' stamp: 'avi 3/13/2004 01:13'!
on: aPresenter
	^ self new presenter: aPresenter! !

!WAViewer methodsFor: 'accessing' stamp: 'avi 3/13/2004 01:14'!
buttons
	^ #(save)! !

!WAViewer methodsFor: 'accessing' stamp: 'avi 3/13/2004 01:14'!
model
	^ presenter! !

!WAViewer methodsFor: 'accessing' stamp: 'avi 3/13/2004 01:13'!
presenter: aPresenter
	presenter := aPresenter! !

!WAViewer methodsFor: 'rendering' stamp: 'al 9/7/2006 16:30'!
renderContentOn: html
	html heading level: 3; with: presenter displayString.
	super renderContentOn: html! !

!WAViewer methodsFor: 'rendering' stamp: 'al 9/7/2006 15:57'!
renderCssOn: html
	html textArea
		rows: 20;
		columns: 80;
		value: presenter style;
		callback: [ :css |
			presenter class compile: 'style ^ ', css printString]! !

!WAViewer methodsFor: 'accessing' stamp: 'avi 3/13/2004 01:14'!
rows
	^ #(css)! !

!WAViewer methodsFor: 'actions' stamp: 'avi 3/13/2004 01:23'!
save
	! !

!WAViewer methodsFor: 'accessing' stamp: 'avi 3/13/2004 01:22'!
script
	^ 'self.opener.location=self.opener.location'! !

WAFormDialog subclass: #WANoteDialog
	instanceVariableNames: 'note'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WANoteDialog methodsFor: 'accessing' stamp: 'avi 3/16/2004 16:48'!
buttons
	^ #(ok cancel)! !

!WANoteDialog methodsFor: 'actions' stamp: 'avi 3/16/2004 16:48'!
cancel
	self answer: nil! !

!WANoteDialog methodsFor: 'accessing' stamp: 'al 9/7/2006 16:27'!
note
	^note! !

!WANoteDialog methodsFor: 'accessing' stamp: 'al 9/7/2006 16:27'!
note: aString
	note := aString! !

!WANoteDialog methodsFor: 'actions' stamp: 'avi 3/16/2004 16:46'!
ok
	self answer: note! !

!WANoteDialog methodsFor: 'rendering' stamp: 'al 9/7/2006 16:28'!
renderDialogOn: html
	html textArea
		id: 'dialog-note';
		on: #note of: self! !

!WANoteDialog methodsFor: 'accessing' stamp: 'avi 3/16/2004 16:50'!
style
	^ ' 
	#dialog-note {width: 80%; height: 200px}
	'! !

WAFormDialog subclass: #WAYesOrNoDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAYesOrNoDialog methodsFor: 'accessing' stamp: 'avi 3/13/2004 21:40'!
buttons
	^ #(yes no)! !

!WAYesOrNoDialog methodsFor: 'accessing' stamp: 'avi 3/13/2004 21:40'!
no
	self answer: false! !

!WAYesOrNoDialog methodsFor: 'accessing' stamp: 'avi 3/13/2004 21:40'!
yes
	self answer: true! !

WAComponent subclass: #WAFrameComponent
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Frames'!

WAFrameComponent subclass: #WAAllCanvasTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAAllCanvasTests class methodsFor: 'testing' stamp: 'mb 1/31/2006 11:07'!
canBeRoot
	^ true! !

!WAAllCanvasTests class methodsFor: 'class initialization' stamp: 'lr 6/13/2006 16:09'!
initialize
	self registerAsApplication: 'tests/allcanvastests'.! !

!WAAllCanvasTests methodsFor: 'initialize-release' stamp: 'mb 10/12/2006 19:05'!
initialize
	super initialize.
	self contents:
	 (WASimpleNavigation new
		add: WACanvasInputTest new label: 'Input';
		add: WACanvasHtmlTest new label: 'Html';
		add: WACanvasTest new label: 'Canvas';
		add: WACanvasLinkSubmitTest new label: 'Submit';
		add: WACanvasDateTimeTest new label: 'More tests';
		add: WACanvasModelTest new label: 'Model';
		add: WACanvasUploadTest new label: 'Upload';
		add: WACanvasDefaultFormTest new label: 'Default Form';
		add: WACanvasImageTest new label: 'Image';
		add: WAIframeTest new label: 'Iframe';
		add: WARubyTest new label: 'Ruby';
		add: WAPhraseElementsTest new label: 'Phrase';
		yourself)
! !

!WAAllCanvasTests methodsFor: 'rendering' stamp: 'mb 10/31/2006 16:14'!
renderContentOn: html
	html div
		id: 'all-tests';
		with: [
			html heading: 'Test Canvas Components'.
			html space.
			html render: contents]! !

!WAAllCanvasTests methodsFor: 'path' stamp: 'mb 6/21/2006 13:28'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'Seaside Canvas Tests: ', contents selection displayString.
"	anHtmlRoot linkToStyle: 'http://www.netstyle.ch/include/seaside/include/style.css'."
	anHtmlRoot linkWithStyle: 'h1 {color: #efb321} body {font-family: tahoma, arial, helvetica; font-size: 80%}'.
"	anHtmlRoot linkToScript: 'http://www.xxxx.yyy/scripts.js'."
	anHtmlRoot linkWithScript: 'var example = "abc";'.
! !

WAFrameComponent subclass: #WAAllTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAAllTests commentStamp: 'sd 11/28/2004 14:42' prior: 0!
If you want to see these examples:

/seaside/config app:
- add a new application named "tests"
- choose WAAllTests as the root component
!

!WAAllTests class methodsFor: 'testing' stamp: 'avi 2/5/2004 12:58'!
canBeRoot
	^ true! !

!WAAllTests class methodsFor: 'initialize' stamp: 'lr 6/13/2006 16:09'!
initialize
	self registerAsApplication: 'tests/alltests'.! !

!WAAllTests methodsFor: 'initialize-release' stamp: 'mb 10/12/2006 19:20'!
initialize
	super initialize.
	self contents:
	 (WASimpleNavigation new
		add: WAInputTest new label: 'Input';
		add: WAHtmlTest new label: 'Html';
		add: WAEncodingTest new label: 'Encoding';
		add: WAErrorTest new label: 'Error';
		add: WAExceptionTest new label: 'Exception';
		add: WAClosureTest new label: 'Closure';
		add: WATransactionTest new label: 'Transaction';
		add: WAUploadTest new label: 'Upload';
		add: (WAParentTest new parent: self) label: 'Parent';
		add: WAPathTest new label: 'Path';
		add: WATaskTest new label: 'Task';
		add: WACookieTest new label: 'Cookies';
		add: WACallbackTest new label: 'Callbacks';
		add: WAImageTest new label: 'Images';
		add: WAHomeTest new label: 'Home';
		add: WACacheTest new label: 'Cache';
		add: WADefaultFormTest new label: 'Default Form';
		add: WALinkSubmitTest new label: 'Submit';
		add: WAJavascriptTest new label: 'Javascript';
		add: WADelayTest new label: 'Delay';
		add: WALotsaLinks new label: 'Lot of links';
		add: WAPopupTest new label: 'Popup';
		yourself)! !

!WAAllTests methodsFor: 'rendering' stamp: 'mb 10/31/2006 16:14'!
renderContentOn: html
	html divNamed: 'all-tests'
		with: [
			html heading: 'Test Components'.
			html space.
			html render: contents]! !

!WAAllTests methodsFor: 'updating' stamp: 'mb 10/12/2006 18:54'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

!WAAllTests methodsFor: 'updating' stamp: 'mb 6/21/2006 13:11'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'Seaside Tests: ', contents selection displayString.
"	anHtmlRoot linkToStyle: 'http://www.netstyle.ch/include/seaside/include/style.css'."
	anHtmlRoot linkWithStyle: 'h1 {color: #efb321} body {font-family: tahoma, arial, helvetica; font-size: 80%}'.
"	anHtmlRoot linkToScript: 'http://www.xxxx.yyy/scripts.js'."
	anHtmlRoot linkWithScript: 'var example = "abc";'.

! !

!WAFrameComponent class methodsFor: 'instance creation' stamp: 'avi 2/2/2004 20:01'!
on: aComponent
	^ self new contents: aComponent! !

!WAFrameComponent methodsFor: 'accessing' stamp: 'avi 2/2/2004 19:58'!
children
	^ Array with: contents! !

!WAFrameComponent methodsFor: 'accessing' stamp: 'avi 2/2/2004 19:58'!
contents
	^ contents! !

!WAFrameComponent methodsFor: 'accessing' stamp: 'avi 4/14/2004 23:56'!
contents: aComponent
	contents := aComponent! !

!WAFrameComponent methodsFor: 'rendering' stamp: 'avi 2/2/2004 19:58'!
renderContentOn: html
	html render: contents! !

WAFrameComponent subclass: #WAPathTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAPathTest methodsFor: 'initialization' stamp: 'pmm 11/2/2005 22:53'!
initialize
	super initialize.
	self contents: WACounter new! !

!WAPathTest methodsFor: 'rendering' stamp: 'avi 4/15/2004 12:06'!
renderContentOn: html
	html anchorWithName: contents count.
	html render: contents.! !

!WAPathTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:19'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

!WAPathTest methodsFor: 'path' stamp: 'mbany 4/14/2005 11:58'!
updateUrl: aUrl
	aUrl addToPath: contents count displayString.
	aUrl fragment: contents count displayString.! !

WAFrameComponent subclass: #WAToolFrame
	instanceVariableNames: 'showHalos processTime renderTime deprecated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAToolFrame methodsFor: 'accessing' stamp: 'lr 11/20/2006 23:38'!
actions
	^ #( configure toggleHalos )! !

!WAToolFrame methodsFor: 'actions' stamp: 'ab 3/29/2003 00:20'!
configure
	self call: (WAApplicationEditor new application: self session application)! !

!WAToolFrame methodsFor: 'accessing' stamp: 'lr 11/21/2006 00:05'!
deprecated
	^ deprecated! !

!WAToolFrame methodsFor: 'private' stamp: 'lr 11/21/2006 00:19'!
deprecatedApi: aBlock on: html
	aBlock on: WADeprecatedApi do: [ :notification |
		Continuation currentDo: [ :cc |
			deprecated at: notification messageText put: cc.
			notification resume ].
		self halt: notification messageText.
		self session returnResponse: (WAResponse 
			redirectTo: html context actionUrl displayString) ]! !

!WAToolFrame methodsFor: 'actions' stamp: 'lr 11/21/2006 00:11'!
deprecatedCode
	| result |
	result := self confirm: [ :html | 
		html heading: 'Clear deprecated warnings?'.
		html unorderedList: [
			self deprecated keysAndValuesDo: [ :message :cc |
				html listItem: [
					html anchor
						callback: [ cc value ];
						with: message ] ] ] ].
	result ifTrue: [ deprecated := Dictionary new ]! !

!WAToolFrame methodsFor: 'initialization' stamp: 'lr 11/21/2006 00:05'!
initialize
	super initialize.
	showHalos := WAStateHolder new contents: false.
	deprecated := Dictionary new! !

!WAToolFrame methodsFor: 'actions' stamp: 'lr 11/20/2006 23:35'!
openTool: aToolClass
	self call: (aToolClass new
		root: contents;
		addDecoration: (WAWindowDecoration new 
			title: aToolClass title;
			yourself);
		yourself)! !

!WAToolFrame methodsFor: 'processing' stamp: 'avi 5/5/2005 12:30'!
processCallbackStream: aCallbackStream
	processTime := Time millisecondClockValue.
	super processCallbackStream: aCallbackStream! !

!WAToolFrame methodsFor: 'rendering' stamp: 'lr 11/21/2006 00:17'!
renderChildOn: html
	showHalos contents 
		ifTrue: [ html context debugMode ].
	processTime := processTime
		ifNil: [ 0 ] ifNotNil: [ Time millisecondClockValue - processTime ].
	renderTime := Time millisecondsToRun: [
		self 
			deprecatedApi: [ html render: contents ]
			on: html ].
	html context clearMode! !

!WAToolFrame methodsFor: 'rendering' stamp: 'mb 8/10/2006 07:58'!
renderContentOn: html 
	html div
		id: 'frameContent';
		with: [self renderChildOn: html].
	html div: [html space]. "Compensate for Mozilla: bottom of contents hidden by toolbar"
	self renderToolbarOn: html.! !

!WAToolFrame methodsFor: 'rendering' stamp: 'lr 11/21/2006 00:11'!
renderToolbarOn: html
	html paragraph.
	html div id: 'toolbar'; with: [
		html anchor
			callback: [self session expire; redirectTo: self session newSessionUrl];
			with: 'New Session'.
		html space.
		self actions do: [ :each |
			html anchor on: each of: self.
			html space ].
		self tools do: [ :each |
			html anchor
				callback: [ self openTool: each ]; 
				with: each title.
			html space ].
		html anchor
			url: (html context actionUrl withParameter: 'terminate' value: '1');
			with: 'Terminate'.
		html space.
		html anchor
			url: 'http://validator.w3.org/check/referer';
			with: 'XHTML'.
		self deprecated isEmpty ifFalse: [
			html space.
			html anchor
				style: 'color: red';
				callback: [ self deprecatedCode ];
				with: 'Deprecated' ].
		html space.
		html text: renderTime displayString , '/' , processTime displayString , ' ms' ].
	processTime := nil! !

!WAToolFrame methodsFor: 'rendering' stamp: 'pmm 12/23/2005 16:23'!
style
^'
	#toolbar {position: fixed; bottom: 0; left: 0; right: 0; margin-top: 40px; padding: 3px; clear: both; background: #d3d3d3; font-size: 10pt; z-index: 20}
	#toolbar-profile {margin-top: 40px; padding: 3px; clear: both; background: #d3d3d3; font-size: 10pt}
	.halo {border-style: solid; border-width: 1px; margin: 4px; border-color: #aaaaaa}
	.halo-header {font-size: 10pt; background-color: #cccccc; margin-bottom: 4px}
	.halo-mode {float: right}
	.halo-icons {float: left}
	.halo-contents {clear: both} 
'
! !

!WAToolFrame methodsFor: 'actions' stamp: 'avi 9/30/2004 16:55'!
toggleHalos
	WAHalo initialize.
	showHalos contents: showHalos contents not.
! !

!WAToolFrame methodsFor: 'accessing' stamp: 'lr 11/20/2006 23:37'!
tools
	^ WATool allSubclasses! !

!WAToolFrame methodsFor: 'processing' stamp: 'lr 11/21/2006 00:18'!
visiblePresentersDo: aBlock
	super visiblePresentersDo: aBlock! !

WAComponent subclass: #WAHalo
	instanceVariableNames: 'target mode'
	classVariableNames: 'Halos'
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

WAHalo class
	instanceVariableNames: 'plugins'!

WAHalo class
	instanceVariableNames: 'plugins'!

!WAHalo class methodsFor: 'plugins' stamp: 'mb 6/18/2006 22:12'!
addPlugin: aClass
	(self plugins includes: aClass) ifFalse:
		[self plugins add: aClass]! !

!WAHalo class methodsFor: 'instance-creation' stamp: 'avi 9/30/2004 16:46'!
for: aComponent
	^ Halos at: aComponent ifAbsentPut: [self new target: aComponent]! !

!WAHalo class methodsFor: 'plugins' stamp: 'cds 6/20/2006 10:06'!
haloElementsFor: aTarget inHalo: aHalo
	^OrderedCollection new
		add: ((Dictionary new)
				at: #image put: 'Halo-Debug';
				at: #action put: [WABrowser fullOnClass: aTarget class];
				at: #title put: 'System Browser';
				yourself);
		add: ((Dictionary new)
				at: #image put: 'Halo-View';
				at: #action put: [WAInspector on: aTarget];
				at: #title put: 'Inspector';
				yourself);
		add: ((Dictionary new)
				at: #image put: 'Halo-Paint';
				at: #action put: [WAViewer on: aTarget];
				at: #title put: 'Style Editor';
				yourself);
		yourself

! !

!WAHalo class methodsFor: 'plugins' stamp: 'mb 6/16/2006 19:13'!
haloImageLinksFor: aTarget inHalo: aHalo
	| actions |
	"Answer an OrderedCollection of dictionaries"
	actions := OrderedCollection new.
	self plugins do:
		[:each | actions addAll: (each haloElementsFor: aTarget inHalo: aHalo)].
	^actions.! !

!WAHalo class methodsFor: 'class initialization' stamp: 'avi 9/30/2004 16:46'!
initialize
	Halos := SeasidePlatformSupport weakDictionaryOfSize: 20.
! !

!WAHalo class methodsFor: 'plugins' stamp: 'mb 6/16/2006 18:38'!
plugins
	^plugins ifNil: [plugins := self standardPlugins].! !

!WAHalo class methodsFor: 'plugins' stamp: 'mb 6/16/2006 18:51'!
standardPlugins
	^OrderedCollection with: self! !

!WAHalo methodsFor: 'plugins' stamp: 'mb 6/16/2006 19:12'!
haloImageLinksFor: aTarget
	^self class haloImageLinksFor: aTarget inHalo: self.! !

!WAHalo methodsFor: 'initialization' stamp: 'lr 9/6/2006 11:17'!
initialize
	super initialize.
	mode := WAStateHolder new contents: #render:! !

!WAHalo methodsFor: 'private' stamp: 'avi 9/30/2004 16:48'!
render: html
	self target renderContentOn: html! !

!WAHalo methodsFor: 'rendering' stamp: 'pmm 9/26/2006 19:23'!
renderContentOn: html
	| haloHtml |
	haloHtml := self rendererClass 
					context: html context 
					callbacks: html callbacks. 
	haloHtml div class: 'halo'; with: [
		haloHtml div class: 'halo-header'; with: [
			haloHtml div class: 'halo-icons'; with: [
				haloHtml text: self target class name.
				haloHtml space.
				(self haloImageLinksFor: self target) do:
					[:each |
					self
						renderHalo: (each at: #title)
						icon: (each at: #image)
						window: (each at: #action)
						on: haloHtml]].
			haloHtml div class: 'halo-mode'; with: [
				haloHtml text: '['.
				haloHtml anchor 
					title: 'View Output';
					callback: [self renderMode]; with: 'R'.
				haloHtml text: '|'.
				haloHtml anchor 
					title: 'View Source';
					callback: [self sourceMode]; with: 'S'.
				haloHtml text: ']'].
			haloHtml div class: 'halo-contents'; with:''	 "Use clear:both to give header box a height."
		].
		haloHtml div with: [self perform: mode contents with: html].
	].
	haloHtml close.
	html close! !

!WAHalo methodsFor: 'rendering' stamp: 'pmm 9/26/2006 19:23'!
renderHalo: aString icon: anIconKey callback: aBlock on: html
	html anchor
		title: aString;
		callback: aBlock;
		with: [ html image form: (ScriptingSystem formAtKey: anIconKey) ]
! !

!WAHalo methodsFor: 'rendering' stamp: 'lr 9/6/2006 11:18'!
renderHalo: aString icon: anIconKey window: aComponentBlock on: html
	self 
		renderHalo:	aString
		icon: anIconKey
		callback: [
			WARenderLoop new 
				call: (aComponentBlock value
					addDecoration: (WAWindowDecoration new 
						title: aString);
					yourself) ]
		on: html! !

!WAHalo methodsFor: 'actions' stamp: 'avi 4/16/2004 17:33'!
renderMode
	mode contents: #render:! !

!WAHalo methodsFor: 'private' stamp: 'lr 9/6/2006 11:22'!
source: html
	| context haloHtml | 
	haloHtml := self rendererClass
					context: html context
					callbacks: html callbacks. 
	context := haloHtml context copy.	
	context clearMode.
	context document: (WAPrettyPrintedDocument renderer: haloHtml).
	haloHtml div class: 'halo-source'; with: [self target renderWithContext: context]. 
	haloHtml close. 
	html context count: context count! !

!WAHalo methodsFor: 'actions' stamp: 'avi 3/16/2004 18:07'!
sourceMode
	mode contents: #source:! !

!WAHalo methodsFor: 'accessing' stamp: 'avi 9/30/2004 16:54'!
target
	^ target! !

!WAHalo methodsFor: 'accessing' stamp: 'avi 9/30/2004 16:54'!
target: aComponent
	target := aComponent! !

WAComponent subclass: #WAHomeTest
	instanceVariableNames: 'main'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAHomeTest methodsFor: 'accessing' stamp: 'avi 10/19/2004 15:53'!
children
	^ Array with: main! !

!WAHomeTest methodsFor: 'initialize-release' stamp: 'mb 4/23/2006 15:23'!
initialize
	super initialize.
	main := WATaskTest new.
	! !

!WAHomeTest methodsFor: 'rendering' stamp: 'avi 10/19/2004 15:53'!
renderContentOn: html
	html anchorWithAction: [main home] text: 'Home'.
	html div: main! !

!WAHomeTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:07'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

WAComponent subclass: #WAHtmlTest
	instanceVariableNames: 'booleanList message number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAHtmlTest methodsFor: 'private' stamp: 'mb 10/12/2006 19:42'!
allSelectors
	^ (self class selectors asSortedCollection select: [:s | s beginsWith: 'render'])
		removeAll: #(renderContentOn: rendererClass);
		yourself! !

!WAHtmlTest methodsFor: 'accessing' stamp: 'cds 6/24/2004 00:41'!
booleanList
	^booleanList! !

!WAHtmlTest methodsFor: 'initialize' stamp: 'mb 3/8/2006 14:10'!
initialMessage
	^'Hello world!!'.
! !

!WAHtmlTest methodsFor: 'initialize' stamp: 'pmm 7/19/2006 19:52'!
initialize
	super initialize.
	message := self initialMessage.
	booleanList := #(a b c d) collect: [:key | key -> ((Array with: true with: false) atRandom)].
	number := 10 atRandom.! !

!WAHtmlTest methodsFor: 'accessing' stamp: 'cds 6/25/2004 17:18'!
message
	^message! !

!WAHtmlTest methodsFor: 'accessing' stamp: 'cds 6/25/2004 16:54'!
number
	^number! !

!WAHtmlTest methodsFor: 'rendering' stamp: 'cds 6/24/2004 10:30'!
renderCheckboxesOn: html 
	html text: booleanList.
	html paragraph.
	html cssId: 'checkbox-form'.
	html
		form: [booleanList
				do: [:assoc | 
					html text: assoc key;
						 space.
					html cssId: 'cb-' , assoc key asString.
					html
						checkboxWithValue: assoc value
						callback: [:b | assoc value: b].
					html break].
			html submitButton]! !

!WAHtmlTest methodsFor: 'rendering' stamp: 'mb 2/9/2006 17:55'!
renderContentOn: html
	self allSelectors pairsDo:
		[:selA :selB |
		html divClass: 'row' with: [
			html divClass: 'left' with: [self perform: selA with: html].
			html divClass: 'right' with: [self perform: selB with: html]
		]]
! !

!WAHtmlTest methodsFor: 'rendering' stamp: 'mb 6/21/2006 13:00'!
renderRadioButtonsOn: html 
	html text: booleanList.
	html paragraph.
	html cssId: 'radio-form'.
	html
		form: [booleanList
				do: [:assoc | 
					| group | 
					group := html radioGroup.
					html text: assoc key;
						 space.
					html cssId: assoc key asString , '-on'.
					html addShortcut: 'Ctrl-' , assoc key.
					html
						radioButtonInGroup: group
						selected: assoc value
						callback: [assoc value: true].
					html cssId: assoc key asString , '-off'.
					html addShortcut: 'Alt-' , assoc key.
					html
						radioButtonInGroup: group
						selected: assoc value not
						callback: [assoc value: false].
					html break].
			html submitButton]! !

!WAHtmlTest methodsFor: 'rendering' stamp: 'cds 6/25/2004 16:45'!
renderSelectsOn: html 
	html text: number.
	html paragraph.
	html cssId: 'select-form'.
	html
		form: [html cssId: 'select-list'.
			html
				selectFromList: (1 to: 10)
				selected: number
				callback: [:i | number := i].
			html submitButton]! !

!WAHtmlTest methodsFor: 'rendering' stamp: 'pmm 7/19/2006 19:41'!
renderSubmitButtonsOn: html 
	html text: number.
	html paragraph.
	html cssId: 'button-form'.
	html form: [
		1 to: 10 do: [ :index | 
			html addShortcut:  'F' , index asString.
			html addShortcut:  'Ctrl-' , index asString.
			html
				submitButtonWithAction: [ number := index ]
				text: index.
			html space]].
	html attributes addStyle: 'font-size: 60%'.
	html attributes addStyle: 'font-style: italic'.
	html span: 'Handy shortcuts : F1..F10, Ctrl-1..Ctrl-9'.
! !

!WAHtmlTest methodsFor: 'rendering' stamp: 'mb 6/21/2006 12:55'!
renderTextAreaOn: html 
	html cssId: 'textarea-form'.
	html
		form: [html cssId: 'textarea-banner'.
			html span: message.
			html paragraph.
			html cssId: 'textarea-message'.
			html
				textAreaWithValue: message
				callback: [:v | message := v].
			html break; submitButton]! !

!WAHtmlTest methodsFor: 'rendering' stamp: 'mb 6/21/2006 12:54'!
renderTextInputOn: html 
	html cssId: 'textInput-form'.
	html
		form: [html cssId: 'textInput-banner'.
			html span: message.
			html paragraph.
			html cssId: 'text-message'.
			html
				textInputWithValue: message
				callback: [:v | message := v].
			html submitButton]! !

!WAHtmlTest methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:05'!
renderVFieldSetOn: html
	html fieldsetWithLegend: 'Various text rendering in a fieldset' do:
		[html
			strong: 'Strong';
			break;
			italic: 'Italic';
			break;
			underline: 'Underline';
			break;
			acronym: 'United States of America' do: 'USA';
			break;
			emphasis: 'Emphasis';
			break.

		html attributes
			addStyle: 'color: red';
			backgroundColor: 'lightgreen';
			addStyle: 'padding: 1em';
			border: 2;
			addStyle: 'font-weight: bold';
			addStyle: 'font-size: 150%';
			height: '3em';
			alignCenter.
		html
			div: 'Large bold red in a green div';
			break]! !

!WAHtmlTest methodsFor: 'rendering' stamp: 'mb 6/12/2006 14:38'!
renderZFieldSetOn: html
	| url1 |
	url1 := html context
				urlForDocument: (ScriptingSystem formAtKey: 'Halo-Debug') 
				mimeType: 'image/jpg' 
				fileName: 'Debug.jpg'.
	html fieldsetWithLegend: 'Various images in a fieldset' do:
		[html image: url1 altText: 'Halo-Debug'.
		html space.
		html attributeAt: 'alt' put: 'Halo-View'.
		html imageWithForm: (ScriptingSystem formAtKey: 'Halo-View').
		html space.
		html attributeAt: 'alt' put: 'Halo-Paint'.
		html
			imageWithDocument: (ScriptingSystem formAtKey: 'Halo-Paint')
			mimeType: 'image/png'
			fileName: 'Paint.png'.		
		html break.
		html attributes border: 1.
		html image: 'http://www.netstyle.ch/include/seaside/pics/top.jpg' width: '80%' altText: 'Seaside'.
		html break.
		html attributes border: 2.
		html image: 'http://www.netstyle.ch/include/seaside/pics/top.jpg' height: '50px' altText: 'Seaside'.
		html break.
		html attributes noBorder.
		html image: 'http://www.netstyle.ch/include/seaside/pics/top.jpg' width: '250px' height: '60px' altText: 'Seaside']! !

!WAHtmlTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:10'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

!WAHtmlTest methodsFor: 'rendering' stamp: 'mb 2/10/2006 10:52'!
style
^ '
	div.row {clear: both}
	div.left {float: left; width: 45%; margin: 1%}
	div.right {float: left; width: 45%; margin: 1%}

'! !

WAComponent subclass: #WAIframeTest
	instanceVariableNames: 'counter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAIframeTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 13:31'!
children
	^ Array with: counter! !

!WAIframeTest methodsFor: 'initialization' stamp: 'lr 3/9/2006 13:31'!
initialize
	super initialize.
	counter := WACounter new! !

!WAIframeTest methodsFor: 'rendering' stamp: 'lr 8/9/2006 08:38'!
renderContentOn: html
	html iframe 
		contents: counter.
	html break; break.
	html iframe 
		src: (WADispatcher default entryPointAt: WAStore entryPointName) basePath.
	html break; break.
	html iframe 
		document: SeasidePlatformSupport seasideBanner
		mimeType: 'image/jpeg'! !

!WAIframeTest methodsFor: 'rendering' stamp: 'lr 8/9/2006 08:38'!
style
	^ 'iframe { 
	border: 1px solid gray;
	width: 100%;
}'! !

WAComponent subclass: #WAImageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAImageTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:11'!
renderContentOn: html
	html form: [
		html 
			submitButtonWithAction: [self inform: 'ok']
			image: (ScriptingSystem formAtKey: 'Halo-Debug')]! !

!WAImageTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:11'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

WAComponent subclass: #WAInputDialog
	instanceVariableNames: 'label value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAInputDialog methodsFor: 'accessing' stamp: 'pmm 9/12/2006 18:32'!
default: aString
	value := aString! !

!WAInputDialog methodsFor: 'accessing' stamp: 'pmm 9/12/2006 18:34'!
label
	^label ifNil: [ label := 'OK' ]! !

!WAInputDialog methodsFor: 'accessing' stamp: 'pmm 9/12/2006 18:32'!
label: aString
	label := aString! !

!WAInputDialog methodsFor: 'accessing' stamp: 'pmm 9/12/2006 18:34'!
renderContentOn: html
	html form
		defaultAction: [ self answer: value ];
		with: [
			html textInput on: #value of: self.
		html space.
		html submitButton
			callback: [self answer: value];
			text: self label ]! !

!WAInputDialog methodsFor: 'private' stamp: 'pmm 9/12/2006 18:34'!
value
	^value! !

!WAInputDialog methodsFor: 'private' stamp: 'pmm 9/12/2006 18:34'!
value: aString
	value := aString! !

WAComponent subclass: #WAInputTest
	instanceVariableNames: 'nilString integer emptyString fraction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAInputTest class methodsFor: 'example' stamp: 'sd 11/28/2004 15:43'!
example

	^ self new! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
emptyString
	^emptyString! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
emptyString: anObject
	emptyString := anObject! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
fraction
	^fraction! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
fraction: anObject
	fraction := anObject! !

!WAInputTest methodsFor: 'initialize-release' stamp: 'pmm 7/19/2006 19:52'!
initialize
	super initialize.
	nilString := nil.
	emptyString := ''.
	integer := 42.
	fraction := 1/3.! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
integer
	^integer! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
integer: anObject
	integer := anObject! !

!WAInputTest methodsFor: 'accessing' stamp: 'mb 2/10/2006 12:49'!
labelForSelector: aSymbol

	aSymbol == #nilString ifTrue: [^'Nil string,  ' , self nilString printString].
	aSymbol == #emptyString ifTrue: [^'Empty string, ' , self emptyString printString].
	aSymbol == #integer ifTrue: [^'Integer, ' , self integer printString].
	aSymbol == #fraction ifTrue: [^'Fraction, ' , self fraction printString].
	^ super labelForSelector: aSymbol! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
nilString
	^nilString! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
nilString: anObject
	nilString := anObject! !

!WAInputTest methodsFor: 'rendering' stamp: 'mb 2/10/2006 12:39'!
renderContentOn: html
	self renderFormOneOn: html.
	self renderFormTwoOn: html.
! !

!WAInputTest methodsFor: 'rendering' stamp: 'mb 2/10/2006 12:34'!
renderFormOneOn: html
	html form: [
		html table: [
			html	
				tableHeadings: #(Name Value PrintString);
				tableRowWithLabel: 'Nil String'
					column: [html textInputOn: #nilString of: self]
					column: [html text: nilString printString];
				tableRowWithLabel: 'Empty String'
					column: [html textInputOn: #emptyString of: self]
					column: [html text: emptyString printString];
				tableRowWithLabel: 'Integer'
					column: [html textInputOn: #integer of: self]
					column: [html text: integer printString];
				tableRowWithLabel: 'Fraction'
					column: [html textInputOn: #fraction of: self]
					column: [html text: fraction printString].
		].
		html submitButton.
	]
! !

!WAInputTest methodsFor: 'rendering' stamp: 'mb 2/10/2006 12:42'!
renderFormTwoOn: html
	html form: [
		html table: [
			html	
				tableHeadings: #(Name Value);
				labelledRowForTextInputOn: #nilString of: self size: 4;
				labelledRowForTextInputOn: #emptyString of: self size: 8;
				labelledRowForTextInputOn: #integer of: self size: 12;
				labelledRowForTextInputOn: #fraction of: self size: 16.
		].
		html submitButton.
	]
! !

!WAInputTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:11'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

!WAInputTest methodsFor: 'rendering' stamp: 'mb 2/10/2006 12:52'!
style
	^'
form {
	float: left;
	margin: 0 150px 0 0;
}
'! !

WAComponent subclass: #WAInspector
	instanceVariableNames: 'path'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAInspector class methodsFor: 'instance creation' stamp: 'ab 2/15/2003 00:21'!
on: anObject
	^ self new object: anObject! !

!WAInspector methodsFor: 'testing' stamp: 'pmm 9/12/2006 18:35'!
canInspect: anObject
	^[ anObject isNumber
		or: [ (Array with: nil with: true with: false) includes: anObject ]
	] on: Error do: [ :ex | false ]! !

!WAInspector methodsFor: 'accessing' stamp: 'avi 2/10/2004 16:34'!
children
	^ Array with: path! !

!WAInspector methodsFor: 'actions' stamp: 'ab 5/31/2003 15:13'!
chooseObject: anObject named: aString
	path pushSegment: anObject name: aString! !

!WAInspector methodsFor: 'actions' stamp: 'pmm 7/4/2005 15:37'!
evaluate: aString
	^self object class evaluatorClass new
		evaluate: aString
		in: nil
		to: self object.! !

!WAInspector methodsFor: 'initialize-release' stamp: 'al 9/7/2006 15:22'!
initialize
	super initialize.
	path := WAPath new! !

!WAInspector methodsFor: 'state variables' stamp: 'ab 5/31/2003 15:12'!
object
	^ path currentSegment! !

!WAInspector methodsFor: 'state variables' stamp: 'ab 5/31/2003 15:11'!
object: anObject 
	path pushSegment: anObject name: anObject printString! !

!WAInspector methodsFor: 'rendering' stamp: 'pmm 7/4/2005 15:38'!
renderContentOn: html 
	html render: path.
	html heading: (self object printStringLimitedTo: 50).
	html text: 'Identity Hash: ', self object identityHash displayString; break; break.
	self renderMembersOn: html.
	self renderEditAreaOn: html.! !

!WAInspector methodsFor: 'rendering' stamp: 'al 9/7/2006 15:37'!
renderEditAreaOn: html
	| input |
	input := ValueHolder new.
	html break.
	html form: [
		html textArea
			rows: 6;
			columns: 60;
			callback: [ :value | input contents: value].
		html break.
		html submitButton
			callback: [ self evaluate: input contents ];
			text: 'do it'.
		html submitButton 
			callback: [ self inform: (self evaluate: input contents) ];
			text: 'print it'.
		html submitButton
			callback: [
				WARenderLoop new call:
					((self class on: (self evaluate: input contents))
					addDecoration: (WAWindowDecoration new title: 'Inspector');
					yourself) ];
			text: 'inspect it'. ].! !

!WAInspector methodsFor: 'rendering' stamp: 'al 9/7/2006 15:43'!
renderMembersOn: html 
	| members |
	members := self object inspectorFields.
	members isEmpty ifTrue: [^self].
	html strong: 'Members: '.
	html table
		border: 1;
		with: [
			members associationsDo: [ :association | 
				self
					renderRowForObject: association value
					named: association key
					on: html ] ]! !

!WAInspector methodsFor: 'rendering' stamp: 'al 9/7/2006 15:44'!
renderRowForObject: anObject named: aString on: html
	html tableRow: [
		html tableData: [ 
			(self canInspect: anObject)
				ifTrue: [html text: aString]
				ifFalse: [html anchor callback: [self chooseObject: anObject named: aString]; with: aString ] ].
		html tableData: [
			html form
				style: 'margin-bottom: 0pt';
				with: [
					html textArea
						rows: 1;
						columns: 30;
						value: (anObject printStringLimitedTo: 100);
						callback: [ :value |
							self object
								instVarNamed: aString
								put: (self evaluate: value) ].
					html submitButton text: 'accept' ] ] ]! !

WAComponent subclass: #WAJavascriptTest
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAJavascriptTest methodsFor: 'rendering' stamp: 'pmm 9/12/2006 18:36'!
renderContentOn: html
	html form: [
		html cssId: 'F0'.
		html textInputWithValue: value callback: [:v | value := v].
		html cssId: #F1.
		html autofocus: [html textInputWithValue: value callback: [:v | value := v]].
		html submitButton].
	html cssId: #D1.
	html divWithShow: 'Show' hide: 'Hide' do: 'DIV'.
	html cssId: #S1.
	html spanWithShow: 'Show' hide: 'Hide' do: 'SPAN'! !

!WAJavascriptTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:13'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

WAComponent subclass: #WALibraryBrowser
	instanceVariableNames: 'selector library hits search'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WALibraryBrowser methodsFor: 'actions' stamp: 'avi 7/2/2004 00:50'!
find: aString
	| inst |
	self libraries do:
		[:ea |
		inst := ea new.
		ea selectors do: 
			[:sel |
			((inst perform: sel) includesSubString: aString)
				ifTrue: [(hits at: (Array with: ea with: sel) ifAbsentPut: [SortedCollection new]) add: aString]]]! !

!WALibraryBrowser methodsFor: 'actions' stamp: 'avi 7/2/2004 00:49'!
findAll: aString
	hits := Dictionary new.
	(aString findTokens: ' ') do: [:ea | self find: ea].
	hits isEmpty ifFalse: [self goto: self orderedHits first]! !

!WALibraryBrowser methodsFor: 'actions' stamp: 'avi 7/2/2004 00:51'!
goto: anArray
	library := anArray first.
	selector := anArray second! !

!WALibraryBrowser methodsFor: 'accessing' stamp: 'mb 5/6/2006 16:08'!
hits
	^ hits ifNil: [ hits := Dictionary new ]! !

!WALibraryBrowser methodsFor: 'accessing' stamp: 'avi 7/2/2004 00:28'!
libraries
	^ (WAStyleLibrary subclasses, WAScriptLibrary subclasses) asSortedCollection: [:a :b | a name <= b name]! !

!WALibraryBrowser methodsFor: 'accessing' stamp: 'avi 7/2/2004 00:28'!
library
	^ library! !

!WALibraryBrowser methodsFor: 'accessing' stamp: 'avi 7/2/2004 00:28'!
library: aLibraryClass
	library := aLibraryClass.
	selector := nil.! !

!WALibraryBrowser methodsFor: 'accessing' stamp: 'lr 5/3/2006 10:05'!
orderedHits
	^ self hits keys asSortedCollection: [:a :b | (hits at: a) size >= (hits at: b) size]! !

!WALibraryBrowser methodsFor: 'rendering' stamp: 'pmm 4/23/2006 21:23'!
renderColumnsOn: html
	html select
		beSubmitOnChange;
		size: 10;
		list: self libraries;
		on: #library of: self.
	html
		select
		beSubmitOnChange;
		size: 10;
		list: self selectors;
		on: #selector of: self.! !

!WALibraryBrowser methodsFor: 'rendering' stamp: 'pmm 4/23/2006 21:17'!
renderContentOn: html
	html div
		class: 'stylebrowser-columns';
		with: [
			html form: [ self renderColumnsOn: html ] ].

	html div
		class: 'stylebrowser-search';
		with: [
			html form: [
				html textInput value: search; callback: [:v | search := v].
				html space.
				html submitButton callback: [self findAll: search]; text: 'Search' ].
		html unorderedList: [
			self orderedHits do: [:pair |
				html listItem: [
					self renderHit: pair on: html ] ] ] ].

	html div
		class: 'stylebrowser-editor';
		with: [
			html form: [
				self renderEditorOn: html.
				html paragraph.
				html submitButton callback: [self save]; text: 'Save' ] ]! !

!WALibraryBrowser methodsFor: 'rendering' stamp: 'pmm 4/23/2006 21:18'!
renderEditorOn: html
	html textArea
		rows: 20;
		columns: 80;
		on: #string of: self.
! !

!WALibraryBrowser methodsFor: 'rendering' stamp: 'pmm 4/23/2006 21:19'!
renderHit: anArray on: html
	| text |
	text := String streamContents: [ :stream |
		stream nextPutAll: anArray first name.
		stream nextPutAll: '>>'.
		stream nextPutAll: anArray second.
		stream space.
		stream nextPutAll: '('.
		(hits at: anArray)
			do: [:each | stream nextPutAll: each ]
			separatedBy: [ stream nextPutAll: ', '].
		stream nextPutAll: ')'].
	html anchor callback: [self goto: anArray]; with: text.
	! !

!WALibraryBrowser methodsFor: 'actions' stamp: 'avi 5/24/2004 14:55'!
save! !

!WALibraryBrowser methodsFor: 'actions' stamp: 'avi 7/2/2004 11:08'!
search: aString
	search := aString.
	self findAll: search! !

!WALibraryBrowser methodsFor: 'accessing' stamp: 'avi 5/24/2004 14:46'!
selector
	^ selector! !

!WALibraryBrowser methodsFor: 'accessing' stamp: 'avi 7/2/2004 00:32'!
selector: aSymbol
	(library selectors includes: aSymbol) ifTrue: [selector := aSymbol]! !

!WALibraryBrowser methodsFor: 'accessing' stamp: 'avi 7/2/2004 00:28'!
selectors
	^ library ifNil: [#()] ifNotNil: [library selectors]! !

!WALibraryBrowser methodsFor: 'accessing' stamp: 'avi 7/2/2004 10:58'!
string
	^ self selector ifNotNilDo: [:s | library new perform: s]! !

!WALibraryBrowser methodsFor: 'accessing' stamp: 'avi 7/2/2004 10:58'!
string: aString
	self selector ifNotNilDo:
		[:sel |
		library compile: (sel, '
	^ ', aString printString)]! !

!WALibraryBrowser methodsFor: 'accessing' stamp: 'mb 2/17/2005 18:32'!
style
	^ '
	.stylebrowser-search {float: left}
	.stylebrowser-columns {float: left}
	.stylebrowser-columns select {width: 250px}
	.stylebrowser-editor {clear: both}
	'! !

WAComponent subclass: #WALinkSubmitTest
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WALinkSubmitTest methodsFor: 'initialize-release' stamp: 'pmm 7/19/2006 19:52'!
initialize
	super initialize.
	count := 0! !

!WALinkSubmitTest methodsFor: 'rendering' stamp: 'lr 8/3/2006 08:43'!
renderContentOn: html
	html attributes at: 'name' put: #myform.
	html form:
		[html textInputWithValue: count callback: [:v | count := v].
		html break.
		html addShortcut: 'Ctrl-Down'.
		html anchorWithAction: [count := count - 1] text: '--' submitFormNamed: 'myform'.
		html space.
		html addShortcut: 'Ctrl-Up'.
		html anchorWithAction: [count := count + 1] text: '++' submitFormNamed: #myform.
		html break; break.
		html addShortcut: 'Ctrl-Z'.
		html addShortcut: 'Ctrl-z'.
		html checkboxWithValue: (count = 0) callback: [:v | v ifTrue: [count := 0] ] submitFormNamed: 'myform'.
		html space.
		html text: 'Reset'
		].
	html emphasis: 'Handy shortcuts : Ctrl-Up, Ctrl-Down and Ctrl-Z'
! !

!WALinkSubmitTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:15'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

WAComponent subclass: #WALoginDialog
	instanceVariableNames: 'username password authenticator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WALoginDialog methodsFor: 'accessing' stamp: 'avi 2/6/2004 16:55'!
authenticator: anAuthenticator
	authenticator := anAuthenticator! !

!WALoginDialog methodsFor: 'menu messages' stamp: 'avi 2/6/2004 16:56'!
cancel
	self answer: nil! !

!WALoginDialog methodsFor: 'menu messages' stamp: 'avi 2/6/2004 16:56'!
login
	(authenticator verifyPassword: password forUser: username) ifTrue: [self answer: username]! !

!WALoginDialog methodsFor: 'rendering' stamp: 'avi 10/25/2003 14:24'!
renderContentOn: html
	html form: [
		html table: [
			html tableRowWithLabel: 'Username:' column: [html textInputWithValue: username callback: [:v | username := v]].
			html tableRowWithLabel: 'Password:' column: [html passwordInputWithCallback: [:v | password := v]].
			html attributes alignCenter.
			html tableRowWith: [
				html submitButtonOn: #login of: self.
				html space.
				html submitButtonOn: #cancel of: self] span: 2.
		]
	]! !

WAComponent subclass: #WALotsaLinks
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WALotsaLinks methodsFor: 'rendering' stamp: 'avi 5/3/2005 21:27'!
renderContentOn: html
	html list: (1 to: 5000) do:
		[:ea |
		html anchorWithAction: [self inform: ea] text: ea]! !

!WALotsaLinks methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:16'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

WAComponent subclass: #WAMiniCalendar
	instanceVariableNames: 'month date canSelectBlock selectBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WAMiniCalendar class methodsFor: 'testing' stamp: 'dc 12/28/2005 14:20'!
canBeRoot
	^ true! !

!WAMiniCalendar class methodsFor: 'accessing' stamp: 'lr 11/29/2004 16:37'!
example
	^self new! !

!WAMiniCalendar methodsFor: 'testing' stamp: 'avi 10/24/2003 14:38'!
canSelect: aDate
	^ canSelectBlock notNil and: [canSelectBlock value: aDate]! !

!WAMiniCalendar methodsFor: 'accessing' stamp: 'avi 10/23/2003 15:16'!
canSelectBlock: aBlock
	canSelectBlock := aBlock! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'avi 10/23/2003 15:25'!
date
	^ date contents! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'avi 12/12/2004 13:39'!
date: aDate
	date contents: aDate.
	month contents: aDate month! !

!WAMiniCalendar methodsFor: 'initialization' stamp: 'mb 4/23/2006 15:26'!
initialize
	super initialize.
	month := WAStateHolder new contents: Date today month.
	date := WAStateHolder new.! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'avi 10/23/2003 22:56'!
month
	^ month contents! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'avi 10/23/2003 22:56'!
month: aMonth
	^ month contents: aMonth! !

!WAMiniCalendar methodsFor: 'private' stamp: 'mbany 4/14/2005 12:44'!
monthHeading
	^ self month name, ' ', self month year displayString! !

!WAMiniCalendar methodsFor: 'private' stamp: 'dc 12/29/2005 11:41'!
months
	^ (1 to: 12) collect: [:i | Month month: i year: self year]! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:12'!
renderCellForDate: aDate on: html 
	html tableData: [
		aDate month = self month ifTrue: [
			html span
				class: (self date = aDate ifTrue: [ 'calendarArchiveDate' ]);
				with: [
					(self canSelect: aDate)
						ifTrue: [
							html anchor
								callback: [ self select: aDate ];
								with: aDate dayOfMonth ]
						ifFalse: [ html text: aDate dayOfMonth ] ] ] ]! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:03'!
renderContentOn: html
	html div
		class: 'calendar';
		with: [
			html span
				class: 'calendarCaption';
				with: [ self renderMonthHeadingOn: html ].
			html table: [
				html tableRow
					class: 'calendarTitle';
						with: [
						self weekDays do: [ :each |
							html tableData: each ] ].
				self month weeksDo: [ :week |
					self renderRowForWeek: week on: html ] ].
			
			self renderMonthNavigationOn: html.
			html space; space.
			self renderYearNavigationOn: html ]! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:09'!
renderMonthHeadingOn: html
	html form: [
		html select
			list: self months;
			on: #month of: self;
			labels: [:eachMonth | eachMonth name].
		html textInput
			maxLength: 4;
			on: #year of: self.
		html submitButton text: 'Refresh' ]! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:23'!
renderMonthNavigationOn: html
	html span
		class: 'calendarPrevious';
		with: [
			html anchor
				callback: [self month: self month previous];
				with: (self month previous name first: 3) ].
	html space.
	html span
		class: 'calendarNext';
		with: [
			html anchor
				callback: [self month: self month next];
				with: (self month next name first: 3) ]
	! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'pmm 9/11/2006 23:28'!
renderRowForWeek: aWeek on: html
	html tableRow: [
		aWeek datesDo: [ :each | self renderCellForDate: each on: html ] ]! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:12'!
renderYearNavigationOn: html
	html span
		class: 'calendarPrevious';
		with: [
			html anchor
				callback: [self year: self year - 1];
				with: (self year - 1) ].
	html space.
	html span
		class: 'calendarNext';
		with: [
			html anchor
				callback: [self year: self year + 1];
				with: (self year + 1) ]
	! !

!WAMiniCalendar methodsFor: 'action' stamp: 'avi 10/23/2003 17:40'!
select: aDate
	self date: aDate.
	selectBlock ifNotNil: [selectBlock value: aDate]! !

!WAMiniCalendar methodsFor: 'accessing' stamp: 'avi 10/23/2003 17:39'!
selectBlock: aBlock
	selectBlock := aBlock! !

!WAMiniCalendar methodsFor: 'private' stamp: 'avi 10/23/2003 14:25'!
weekDays
	^ (1 to: 7) collect: [:i | (Date nameOfDay: i) first: 3]! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'dc 12/29/2005 11:44'!
year
	^ self month year! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'dc 12/29/2005 11:51'!
year: anInteger
	self month: (Month month: self month monthIndex year: anInteger)! !

WAComponent subclass: #WAMultiCounter
	instanceVariableNames: 'counters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAMultiCounter class methodsFor: 'testing' stamp: 'avi 2/5/2004 12:58'!
canBeRoot
	^true! !

!WAMultiCounter class methodsFor: 'accessing' stamp: 'mb 5/26/2006 12:30'!
description
	^'Multiple Seaside components on one page'! !

!WAMultiCounter class methodsFor: 'initialization' stamp: 'mb 6/13/2006 17:03'!
initialize
	self registerAsApplication: 'examples/multi'! !

!WAMultiCounter methodsFor: 'accessing' stamp: 'avi 4/15/2004 21:50'!
children
	^ counters! !

!WAMultiCounter methodsFor: 'initialize-release' stamp: 'mb 4/23/2006 15:26'!
initialize
	super initialize.
	counters := (1 to: 5) collect: [:i | WACounter new]! !

!WAMultiCounter methodsFor: 'rendering' stamp: 'avi 9/4/2003 17:07'!
renderContentOn: html
	counters 
		do: [:ea | html render: ea]
		separatedBy: [html horizontalRule]! !

WAComponent subclass: #WANavigation
	instanceVariableNames: 'selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Frames'!

!WANavigation methodsFor: 'initialize' stamp: 'mb 4/23/2006 15:27'!
initialize
	super initialize.
	selection := WAStateHolder new! !

!WANavigation methodsFor: 'query' stamp: 'mbany 4/14/2005 12:12'!
labelForOption: anObject
	^ anObject displayString! !

!WANavigation methodsFor: 'initialize' stamp: 'avi 3/15/2004 16:27'!
options
	^ #()! !

!WANavigation methodsFor: 'rendering' stamp: 'dc 7/25/2006 16:28'!
renderContentOn: html
	html div
		class: 'kalsey';
		with: [
			html div
				class: 'navigation-options';
				with: [self renderOptionsOn: html].
			html div
				class: 'navigation-content';
				with: [self renderSelectionOn: html]]! !

!WANavigation methodsFor: 'rendering' stamp: 'dc 7/25/2006 16:29'!
renderOptionsOn: html
	html unorderedList
		list: self options;
		selected: self selection;
		callback: [:v | self select: v];
		labels: [:ea | self labelForOption: ea]
! !

!WANavigation methodsFor: 'rendering' stamp: 'avi 3/15/2004 16:13'!
renderSelectionOn: html! !

!WANavigation methodsFor: 'selection' stamp: 'avi 3/15/2004 16:28'!
select: anObject
	selection contents: anObject.
	self selectionChanged! !

!WANavigation methodsFor: 'selection' stamp: 'avi 3/15/2004 16:28'!
selection
	^ selection contents! !

!WANavigation methodsFor: 'selection' stamp: 'avi 3/15/2004 16:28'!
selectionChanged
	! !

WANavigation subclass: #WASimpleNavigation
	instanceVariableNames: 'components'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Frames'!

!WASimpleNavigation commentStamp: 'lr 11/29/2004 16:30' prior: 0!
I'm a simple tab panel, that can be styled with stylesheets. New tabs can be added using #add:label:!

!WASimpleNavigation class methodsFor: 'example' stamp: 'lr 11/29/2004 16:32'!
example
	^self new
		add: WACounter example label: 'Counter'; 
		add: WAPath example label: 'Path';
		select: 'Counter';
		yourself.! !

!WASimpleNavigation methodsFor: 'behavior' stamp: 'avi 3/15/2004 19:24'!
add: aComponent label: aString
	components add: aString -> aComponent! !

!WASimpleNavigation methodsFor: 'accessing' stamp: 'lr 11/29/2004 16:27'!
children
	^Array with: self selectedComponent.! !

!WASimpleNavigation methodsFor: 'initialize' stamp: 'avi 3/15/2004 19:25'!
initialize
	super initialize.
	components := OrderedCollection new! !

!WASimpleNavigation methodsFor: 'accessing' stamp: 'lr 11/29/2004 16:28'!
labels
	"Return the tabs labels"

	^ self options! !

!WASimpleNavigation methodsFor: 'accessing' stamp: 'avi 3/16/2004 19:34'!
options
	^ components collect: [:ea | ea key]! !

!WASimpleNavigation methodsFor: 'rendering' stamp: 'sd 11/28/2004 21:15'!
renderSelectionOn: html
	html render: self selectedComponent! !

!WASimpleNavigation methodsFor: 'accessing' stamp: 'avi 3/15/2004 19:25'!
selectedComponent
	^ (components detect: [:ea | ea key = self selection] ifNone: [^ nil]) value! !

WAComponent subclass: #WANavigationBar
	instanceVariableNames: 'actionsSelector owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WANavigationBar methodsFor: 'accessing' stamp: 'ab 5/30/2003 00:15'!
actions
	^ self target perform: actionsSelector! !

!WANavigationBar methodsFor: 'accessing' stamp: 'ab 5/30/2003 00:15'!
actionsSelector: aSymbol
	actionsSelector := aSymbol! !

!WANavigationBar methodsFor: 'initialize-release' stamp: 'mb 4/23/2006 15:27'!
initialize
	super initialize.
	actionsSelector := #actions! !

!WANavigationBar methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:31'!
owner: anObject 
	owner := anObject! !

!WANavigationBar methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:32'!
renderContentOn: html
	self actions do: [ :symbol |
		symbol numArgs = 0
			ifTrue: [ self renderLink: symbol on: html ]
			ifFalse: [ self renderInput: symbol on: html ] ]! !

!WANavigationBar methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:34'!
renderInput: aSymbol on: html
	html form: [
		html strong: aSymbol capitalized.
		html space.
		html textInput
			callback: [ :value |
				self target perform: aSymbol with: value ] ]! !

!WANavigationBar methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:34'!
renderLink: aSymbol on: html
	html anchor
		on: aSymbol of: self target.
	html break! !

!WANavigationBar methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:31'!
target
	^ owner activeComponent! !

WAComponent subclass: #WAParentTest
	instanceVariableNames: 'parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAParentTest methodsFor: 'processing' stamp: 'ab 5/12/2003 22:13'!
go
	parent inform: 'foo'! !

!WAParentTest methodsFor: 'accessing' stamp: 'ab 5/12/2003 22:13'!
parent: aComponent
	parent := aComponent! !

!WAParentTest methodsFor: 'rendering' stamp: 'ab 5/12/2003 22:14'!
renderContentOn: html
	html anchorWithAction: [self go] text: 'swap parent' ! !

!WAParentTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:19'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

WAComponent subclass: #WAPath
	instanceVariableNames: 'stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WAPath commentStamp: '<historical>' prior: 0!
I represent a path navigation such as the one that is displayed on the top of the web inspector when you toggle on the halos.

Here is an example of path:

	xxx >> yyy >> zzz

Useful methods are 
	- #currentSegment returns zzz
	- pushSegment: anObject name: 'lulu'!

!WAPath class methodsFor: 'example' stamp: 'lr 11/29/2004 16:24'!
example
	^self new 
		pushSegment: 123 name: 'xxx'; 
		pushSegment: 456 name: 'yyy';
		pushSegment: 789 name: 'zzz';
		yourself.! !

!WAPath methodsFor: 'behavior' stamp: 'lr 11/29/2004 16:26'!
choose: anAssociation
	"Install a new stack of navigation from the old one and the specified association."
	
	| newStack |
	newStack := Array new writeStream.
	stack do:
		[:ea |
		newStack nextPut: ea.
		ea == anAssociation
			ifTrue: [stack := newStack contents. ^ self]]
! !

!WAPath methodsFor: 'accessing' stamp: 'ab 5/31/2003 15:06'!
currentSegment
	^ stack isEmpty
		ifTrue: [nil]
		ifFalse: [stack last value]! !

!WAPath methodsFor: 'initialize' stamp: 'mb 4/23/2006 15:27'!
initialize
	super initialize.
	stack := #().
	self session registerObjectForBacktracking: self.! !

!WAPath methodsFor: 'behavior' stamp: 'ab 5/31/2003 15:06'!
pushSegment: anObject name: aString
	stack := stack, (Array with: aString -> anObject)! !

!WAPath methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:12'!
renderContentOn: html

	stack isEmpty ifTrue: [^ self].	
		
	html div
		id: 'path';
		with: [
		stack allButLast do:
			[:assoc |
			html anchor callback: [self choose: assoc]; with: assoc key.
			html text: ' >> '].
		
		html strong: stack last key].! !

WAComponent subclass: #WAPhraseElementsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAPhraseElementsTest methodsFor: 'rendering' stamp: 'pmm 9/30/2006 20:24'!
renderAbbreviatedOn: html

	html heading level2; with: '<abbr>'.

	html abbreviated
		title: 'World Wide Web';
		with: 'WWW'! !

!WAPhraseElementsTest methodsFor: 'rendering' stamp: 'pmm 9/30/2006 20:28'!
renderAcronymOn: html

	html heading level2; with: '<acronym>'.

	html acronym
		title: 'Federal Bureau of Investigation';
		with: 'F.B.I.'! !

!WAPhraseElementsTest methodsFor: 'rendering' stamp: 'pmm 10/2/2006 21:26'!
renderAddressOn: html

	html heading level2; with: '<address>'.

	html address: [
		#(
			'Newsletter editor'
			'J.R. Brown'
			'JimquickPost News, Jimquick, CT 01234'
			'Tel (123) 456 7890')
			do: [ :each | html text: each ]
			separatedBy: [ html break ] ]! !

!WAPhraseElementsTest methodsFor: 'rendering' stamp: 'pmm 9/30/2006 20:25'!
renderCodeOn: html

	html heading level2; with: '<code>'.

	html text: 'Expressions like '.
	html code: 'a[i++] + b[i++]'.
	html text: ' should not be used, since they cause undefined behavior'! !

!WAPhraseElementsTest methodsFor: 'rendering' stamp: 'pmm 10/2/2006 21:29'!
renderContentOn: html
	self renderHarryOn: html.
	self renderAbbreviatedOn: html.
	self renderAcronymOn: html.
	self renderKeyboardInputOn: html.
	self renderVariableOn: html.
	self renderCodeOn: html.
	self renderDefinitionOn: html.
	self renderSampleOn: html.
	self renderAddressOn: html! !

!WAPhraseElementsTest methodsFor: 'rendering' stamp: 'pmm 9/30/2006 20:25'!
renderDefinitionOn: html

	html heading level2; with: '<dfn>'.

	html definition: 'Ichthyology'.
	html text: ' is the branch of natural science which
studies fish.'! !

!WAPhraseElementsTest methodsFor: 'rendering' stamp: 'pmm 9/30/2006 20:36'!
renderHarryOn: html

	html heading level2; with: '<cite>, <q>, <strong>'.

	html text: 'As '.
	html citation: 'Harry S. Truman'.
	html text: ' said, '.
	html quote: 'The buck stops here.'.
	
	html break.
	
	html text: 'More information can be found in '.
	html citation: '[ISO-0000]'.
	html text: '.'.
	
	html break.
	
	html text: 'Please refer to the following reference number in future correspondence: '.
	html strong: '1-234-55'! !

!WAPhraseElementsTest methodsFor: 'rendering' stamp: 'pmm 9/30/2006 20:25'!
renderKeyboardInputOn: html

	html heading level2; with: '<kbd>'.

	html text: 'Finally, type '.
	html keyboardInput: 'logout'.
	html text: ' and press the return key.'! !

!WAPhraseElementsTest methodsFor: 'rendering' stamp: 'pmm 10/2/2006 21:28'!
renderSampleOn: html

	html heading level2; with: '<samp>'.

	html text: 'If you select the ''champion'' option, you will receive the message '.
	html sampleOutput: 'The monkey is not a caterpillar'.
	html text: '.'! !

!WAPhraseElementsTest methodsFor: 'rendering' stamp: 'pmm 9/30/2006 20:25'!
renderVariableOn: html

	html heading level2; with: '<var>'.

	html text: 'In the simplest case, the command for deleting a file in Unix is'.
	html break.
	html keyboardInput: 'rm'.
	html space.
	html variable: 'filename'! !

WAComponent subclass: #WAPopupTest
	instanceVariableNames: 'url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAPopupTest methodsFor: 'initialize-release' stamp: 'pmm 7/19/2006 19:52'!
initialize
	super initialize.
	url := 'http://www.seaside.st'! !

!WAPopupTest methodsFor: 'rendering' stamp: 'mjr 8/17/2005 17:45'!
renderContentOn: html

	html form: [
		html text: 'URL:'.
		html space.
		html textInputWithValue: url callback: [:v | url := v].
		html submitButtonWithText: 'Update'
	].
	html anchorWithPopupUrl: url
		extent: 400@400
		text: 'popup'.
	html space.
	html text: '(', url, ')'! !

!WAPopupTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:20'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

WAComponent subclass: #WAReport
	instanceVariableNames: 'rows'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WAReport methodsFor: 'initialize' stamp: 'mb 4/23/2006 15:29'!
initialize
	super initialize.
	rows := #().
! !

!WAReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:03'!
rows: anArray
	rows := anArray! !

WAReport subclass: #WATableReport
	instanceVariableNames: 'sortColumn isReversed columns rowPeriod rowColors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

WATableReport subclass: #WACanvasTableReport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WATableReport methodsFor: 'as yet unclassified' stamp: 'ab 11/11/2002 19:04'!
chooseRow: aRow column: aColumn	
	aColumn chooseRow: aRow! !

!WATableReport methodsFor: 'as yet unclassified' stamp: 'ab 10/26/2002 22:01'!
colorForRowNumber: aNumber
	^ rowColors at: ((aNumber-1 // rowPeriod) \\ rowColors size) + 1 ifAbsent: ['white']! !

!WATableReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:29'!
columns: anArray
	columns := anArray! !

!WATableReport methodsFor: 'accessing' stamp: 'ab 2/18/2003 19:06'!
initialize
	super initialize.
	isReversed := false.
	columns := #().
	sortColumn := WAStateHolder new.
	rowColors := #('white' 'lightyellow').
	rowPeriod := 3! !

!WATableReport methodsFor: 'testing' stamp: 'AC 1/31/2003 11:24'!
isReversed
	^ isReversed! !

!WATableReport methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:12'!
renderColumn: aColumn row: aRow on: html
	| text |
	aColumn canRender ifTrue: [
		^html tableData: [aColumn renderValue: aRow on: html]].
	text := aColumn textForRow: aRow.
	text isEmpty ifTrue: [ text := ' ' ].
	html tableData: [
		aColumn canChoose
			ifFalse: [ html text: text ]
			ifTrue: [
				html anchor
					callback: [ self chooseRow: aRow column: aColumn ];
					with: text ] ]! !

!WATableReport methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:17'!
renderContentOn: html
	html table: [
		self renderTableHeaderOn: html.
		self renderRowsOn: html.
		self renderTableFooterOn: html ]! !

!WATableReport methodsFor: 'rendering' stamp: 'pmm 9/30/2006 20:47'!
renderFooterForColumn: aColumn on: html
	html tableHeading: (aColumn totalForRows: rows)
! !

!WATableReport methodsFor: 'rendering' stamp: 'lr 11/16/2006 16:46'!
renderHeaderForColumn: aColumn on: html
	html tableHeading:  [
		aColumn canSort
			ifTrue: [
				html anchor
					callback: [self sortColumn: aColumn];
					with: aColumn title]
			ifFalse: [ html text: aColumn title ] ]! !

!WATableReport methodsFor: 'rendering' stamp: 'pmm 9/30/2006 20:48'!
renderRowNumber: index item: row on: html
	html tableRow
		style: 'background-color: ' , (self colorForRowNumber: index);
		with: [
			columns do: [ :each |
				self renderColumn: each row: row on: html ] ]! !

!WATableReport methodsFor: 'rendering' stamp: 'AC 1/31/2003 11:26'!
renderRowsOn: html
	self rows withIndexDo: [:row :i | self renderRowNumber: i item: row on: html ]! !

!WATableReport methodsFor: 'rendering' stamp: 'pmm 9/30/2006 20:38'!
renderTableFooterOn: html
	html tableRow: [
		columns do: [ :each |
			self renderFooterForColumn: each on: html] ]! !

!WATableReport methodsFor: 'rendering' stamp: 'pmm 9/30/2006 20:39'!
renderTableHeaderOn: html
	html tableRow: [
			columns do: [ :each |
				self renderHeaderForColumn: each on: html] ]! !

!WATableReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:04'!
rowColors: colorArray
	rowColors := colorArray! !

!WATableReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:04'!
rowPeriod: aNumber
	rowPeriod := aNumber! !

!WATableReport methodsFor: 'accessing' stamp: 'AC 1/31/2003 11:46'!
rows
	| r |
	self sortColumn ifNil: [^ rows].
	r := self sortColumn sortRows: rows.
	^ self isReversed ifTrue: [r reversed] ifFalse: [r]! !

!WATableReport methodsFor: 'state variables' stamp: 'ab 1/16/2003 17:47'!
sortColumn
	^ sortColumn contents! !

!WATableReport methodsFor: 'state variables' stamp: 'mb 4/23/2006 18:35'!
sortColumn: anObject 
	isReversed := anObject = self sortColumn and: [isReversed not ].
	sortColumn contents: anObject! !

WAComponent subclass: #WARubyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WARubyTest commentStamp: 'pmm 9/18/2006 19:11' prior: 0!
Examples taken directly from spec:
http://www.w3.org/TR/2001/REC-ruby-20010531/
!

!WARubyTest methodsFor: 'rendering' stamp: 'pmm 9/18/2006 22:07'!
renderComplexOn: html
	html heading level2; with: 'Complex ruby markup'.
	html ruby: [
		html rubyBaseContainer: [
			html rubyBase: 10.
			html rubyBase: 31.
			html rubyBase: 2002 ].
		html rubyTextContainer: [
			html rubyText: 'Month'.
			html rubyText: 'Day'.
			html rubyText: 'Year' ].
		html rubyTextContainer: [
			html rubyText
				span: 3;
				with: 'Expiration Date' ] ]! !

!WARubyTest methodsFor: 'rendering' stamp: 'pmm 9/18/2006 22:06'!
renderContentOn: html
	self renderSimpleOn: html.
	self renderSimpleParenthesesOn: html.
	self renderComplexOn: html! !

!WARubyTest methodsFor: 'rendering' stamp: 'pmm 9/18/2006 22:07'!
renderSimpleOn: html
	html heading level2; with: 'Simple ruby markup'.
	html ruby: [
		html rubyBase: 'WWW'.
		html rubyText: 'World Wide Web' ]! !

!WARubyTest methodsFor: 'rendering' stamp: 'pmm 9/18/2006 22:08'!
renderSimpleParenthesesOn: html
	html heading level2; with: 'Simple ruby markup with parentheses'.
	html ruby: [
		html rubyBase: 'WWW'.
		html rubyParentheses: '('.
		html rubyText: 'World Wide Web'.
		html rubyParentheses: ')' ]! !

WAComponent subclass: #WAScreenshot
	instanceVariableNames: 'button zoom'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools-Squeak'!

!WAScreenshot class methodsFor: 'testing' stamp: 'avi 2/5/2004 12:57'!
canBeRoot
	^ true! !

!WAScreenshot methodsFor: 'accessing' stamp: 'pmm 9/20/2006 17:48'!
buttonCode
	^ button = #red
		ifTrue: [ 4 ]
		ifFalse: [
			button = #blue
				ifTrue: [ 2 ]
				ifFalse: [ 1 ] ]! !

!WAScreenshot methodsFor: 'actions' stamp: 'pmm 9/20/2006 17:45'!
click: aPoint
	| event |
	event := Sensor createMouseEvent.
	event at: 3 put: aPoint x.
	event at: 4 put: aPoint y.
	event at: 5 put: self buttonCode.
	Sensor processEvent: event.	
	event at: 5 put: 0.
	Sensor processEvent: event.
	button := #red.! !

!WAScreenshot methodsFor: 'accessing' stamp: 'pmm 9/20/2006 17:48'!
form
	^ zoom
		ifFalse: [ Display copy ]
		ifTrue: [ self topWindow imageForm ]! !

!WAScreenshot methodsFor: 'initialize-release' stamp: 'pmm 9/20/2006 17:45'!
initialize
	super initialize.
	button := #red.
	zoom := false! !

!WAScreenshot methodsFor: 'accessing' stamp: 'pmm 9/20/2006 17:49'!
offset
	^ zoom
		ifTrue: [ self topWindow position ]
		ifFalse: [ 0@0 ]! !

!WAScreenshot methodsFor: 'rendering' stamp: 'pmm 9/20/2006 17:59'!
renderContentOn: html
	html table: [
		html tableRow: [
			html tableData: [ self renderMouseButtonOn: html ].
			html tableData: [ self renderToggleZoomOn: html ].
			html tableData: [ self renderToggleUIProcessOn: html ] ] ].
	self renderMouseClickOn: html.
	html horizontalRule.
	! !

!WAScreenshot methodsFor: 'rendering' stamp: 'pmm 9/20/2006 17:59'!
renderMouseButtonOn: html
	| group |
	html form: [
		html table: [
			html tableRow: [
				html tableData: 'Button: '.
				group := html radioGroup.
				#(red yellow blue) do: [ :each |
					html tableData
						style: 'background-color: ' , each;
						with: [
							html radioButton
								group: group;
								selected: button = each;
								callback: [ button := each] ] ].
				html tableData: [
					html submitButton text: 'Set'] ] ] ]! !

!WAScreenshot methodsFor: 'rendering' stamp: 'pmm 9/20/2006 17:57'!
renderMouseClickOn: html
	html imageMap
		callback: [ :point | self click: point + self offset];
		title: 'Click here';
		id: #pictureMap;
		form: self form! !

!WAScreenshot methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:12'!
renderToggleUIProcessOn: html
	html anchor callback: [self toggleUIProcess]; with: self toggleUIText! !

!WAScreenshot methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:12'!
renderToggleZoomOn: html
	html anchor callback: [self toggleZoom]; with: self toggleZoomText! !

!WAScreenshot methodsFor: 'actions' stamp: 'avi 1/21/2004 02:01'!
toggleUIProcess
	Project uiProcess isSuspended
		ifTrue: [Project uiProcess resume]
		ifFalse: [Project uiProcess suspend]! !

!WAScreenshot methodsFor: 'accessing' stamp: 'avi 1/21/2004 02:01'!
toggleUIText
	^ Project uiProcess isSuspended
		ifFalse: ['Suspend UI Process']
		ifTrue: ['Resume UI Process']! !

!WAScreenshot methodsFor: 'actions' stamp: 'pmm 9/20/2006 17:47'!
toggleZoom
	zoom := zoom not! !

!WAScreenshot methodsFor: 'accessing' stamp: 'pmm 9/20/2006 17:47'!
toggleZoomText
	^ zoom
		ifTrue: ['Zoom out']
		ifFalse: ['Zoom in']! !

!WAScreenshot methodsFor: 'accessing' stamp: 'avi 2/5/2004 14:18'!
topWindow
	^ SystemWindow classPool at: #TopWindow! !

WAComponent subclass: #WASelection
	instanceVariableNames: 'items labelBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WASelection methodsFor: 'initialization' stamp: 'mb 4/23/2006 15:31'!
initialize
	super initialize.
	items := #().
	labelBlock := [:ea | ea displayString].! !

!WASelection methodsFor: 'accessing' stamp: 'avi 7/5/2004 20:24'!
items: aCollection
	items := aCollection! !

!WASelection methodsFor: 'accessing' stamp: 'avi 7/5/2004 20:24'!
labelBlock: aBlock
	labelBlock := aBlock! !

!WASelection methodsFor: 'rendering' stamp: 'avi 7/5/2004 20:25'!
renderContentOn: html
	html list: items do:
		[:ea |
		html anchorWithAction: [self answer: ea] text: (labelBlock value: ea)]! !

WAComponent subclass: #WAStore
	instanceVariableNames: 'task'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStore commentStamp: 'avi 1/1/2004 10:06' prior: 0!
This component is the entry point for the store example.  It provides the main stylesheet in its #style method, renders a simple banner at the top, and then embeds an instance of WAStoreTask, which is where the real action happens.!

!WAStore class methodsFor: 'testing' stamp: 'avi 2/5/2004 12:58'!
canBeRoot
	^ true! !

!WAStore class methodsFor: 'accessing' stamp: 'mb 5/26/2006 12:25'!
description
	^'sushiNet - Fresh, raw fish delivered to your door'! !

!WAStore class methodsFor: 'as yet unclassified' stamp: 'mb 6/14/2006 14:13'!
entryPointName
	^'examples/store'! !

!WAStore class methodsFor: 'class initialization' stamp: 'mb 6/14/2006 14:13'!
initialize
	self registerAsApplication: self entryPointName! !

!WAStore methodsFor: 'accessing' stamp: 'avi 2/10/2004 20:42'!
children
	^ Array with: task! !

!WAStore methodsFor: 'initialize-release' stamp: 'mb 4/23/2006 18:33'!
initialize
	super initialize.
	task := WAStoreTask new.! !

!WAStore methodsFor: 'rendering' stamp: 'pmm 4/19/2006 22:40'!
renderContentOn: html
	html table
		id: 'banner';
		with: [
			html tableRow: [
				html tableData: [
					html div id: 'title'; with: self title.
					html div id: 'subtitle'; with: self subtitle ] ] ].
	html div id: 'body'; with: task! !

!WAStore methodsFor: 'accessing' stamp: 'mb 1/5/2006 14:35'!
style
	^ '
body {
	margin: 0px; 
	font-family: sans-serif
}
#banner {
	width: 100%
}	
#banner tr {
	background-color: lightblue;
	text-align: right;
	padding: 10px;
	vertical-align: bottom
}
#title {
	font-size: 18pt;
	font-weight: bold
}
#subtitle {
	font-size: 9pt;
	font-style: italic
}
#body {
	padding: 5px
}
.validation-error {
	color: red;
	font-size: 15pt; 
	padding: 5px
}
'
! !

!WAStore methodsFor: 'accessing' stamp: 'avi 12/9/2003 13:58'!
subtitle
	^ 'fresh, raw fish delivered to your door'! !

!WAStore methodsFor: 'accessing' stamp: 'avi 12/9/2003 13:58'!
title
	^ 'sushiNet'! !

WAComponent subclass: #WAStoreCartConfirmation
	instanceVariableNames: 'cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreCartConfirmation commentStamp: 'avi 1/1/2004 09:58' prior: 0!
A component for confirming the contents of a WAStoreCart.  The caller must provide a cart instance with #cart: .  When called, it will display a summary of the items in the cart, along with two buttons: "Proceed with checkout" and "Modify cart".  Answers true if the user presses the first button, false if the user presses the seecond.  Used by WAStoreTask>>confirmContentsOfCart.!

!WAStoreCartConfirmation methodsFor: 'accessing' stamp: 'avi 12/9/2003 13:35'!
cart: aCart
	cart := aCart! !

!WAStoreCartConfirmation methodsFor: 'rendering' stamp: 'lr 11/21/2006 00:20'!
renderContentOn: html
	| table |
	table := html table.
	table id: 'invoice'; with: [
		html tableHead:
			[#(Item Price Count Total) do:
				[:ea | html tableHeading: ea]].
		cart countsAndItems do:
			[:assoc | |count item|
			count := assoc key.
			item := assoc value.
			html tableRow: [
				html tableData class: 'item-title'; with: item title.
				html tableData class: 'item-price'; with: item price printStringAsCents.
				html tableData class: 'item-count'; with: count displayString.
				html tableData class: 'item-total'; with: (item price * count) printStringAsCents
			]
		].
		html tableRow: [
			html tableData: nil.
			html tableData: nil.
			html tableData: nil.
			html tableData class: 'cart-total'; with:cart totalPrice printStringAsCents
		].
	].
	html paragraph.
	html form: [
		html submitButton callback: [ self answer: true ]; text: 'Proceed with checkout'.
		html break.
		html submitButton callback: [self answer: false]; text: 'Modify my order'.
	]! !

!WAStoreCartConfirmation methodsFor: 'accessing' stamp: 'mb 2/9/2006 19:09'!
style
	^'
.item-title {
	text-align: left;
	width: 15em;
}
.item-count {
	text-align: right;
	width: 5em;
}
.item-price {
	text-align: right;
	width: 5em;
}
.item-total {
	text-align: right;
	width: 5em;
}
.cart-total {
	text-align: right;
	font-weight: bold; 
}
#invoice table {
	border-collapse: collapse;
}
#invoice td {
	padding: 0.3em;
	border: 1px lightblue dotted;
}
#invoice tr {
	background-color: lightyellow;
}
'! !

!WAStoreCartConfirmation methodsFor: 'path' stamp: 'mb 2/10/2006 12:04'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'Seaside Sushi Store : Verify your cart'.! !

WAComponent subclass: #WAStoreCartView
	instanceVariableNames: 'cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreCartView commentStamp: 'avi 1/1/2004 09:57' prior: 0!
A component for displaying and modifying a WAStoreCart.  Intended to be embedded rather than called.  The parent must provide a cart instance with #cart:.  Displays a list of items in the cart, and allows individual items to be removed.  Used by WAStoreFillCart.!

!WAStoreCartView methodsFor: 'accessing' stamp: 'ab 8/15/2003 17:18'!
cart: aCart
	cart := aCart! !

!WAStoreCartView methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:05'!
renderContentOn: html
	cart hasItems ifFalse: [^ self].
	html div
		id: 'cart';
		with: [
			html small: [ html strong: 'Your cart:' ].
			html table: [
				cart countsAndItems do:
					[:assoc | self renderRowForCount: assoc key of: assoc value on: html ].
				html tableRow: [ html space].
				html tableRow: [
					html tableData: ''.
					html tableData: ''.
					html tableData: [html strong: cart totalPrice printStringAsCents] ] ] ]! !

!WAStoreCartView methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:12'!
renderRowForCount: aNumber of: anItem on: html 
	| countString |
	countString := (aNumber = 1) ifTrue: [''] ifFalse: ['(', aNumber displayString, ') '].
	html tableRow: [
		html tableData: [ html anchor callback: [ cart remove: anItem ]; with: '-'].
		html tableData: countString, anItem title.
		html tableData: (aNumber * anItem price) printStringAsCents ]! !

WAComponent subclass: #WAStoreFillCart
	instanceVariableNames: 'cart cartView main'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreFillCart commentStamp: 'avi 1/1/2004 10:10' prior: 0!
This component provides the main UI for browsing the store inventory and filling the cart.  The caller must provide a shopping cart instance with #cart:.  The component presents a navigation bar with options to browse and search on the left, and embeds a WACartView showing the cart contents on the right.  In the middle is initially embedded a WAStoreInfo.  Browsing and searching will replace this with a stock WABatchSelection component for listing items (see #displatItems:), or a WAStoreItemView for displaying individual items.  This answers back to the caller when the user chooses "checkout" from the nav bar.!

!WAStoreFillCart methodsFor: 'actions' stamp: 'avi 12/9/2003 13:13'!
browse
	self displayItems: self inventory allItems! !

!WAStoreFillCart methodsFor: 'accessing' stamp: 'avi 12/9/2003 13:10'!
cart: aCart
	cart := aCart.
	cartView cart: aCart.! !

!WAStoreFillCart methodsFor: 'actions' stamp: 'ab 8/15/2003 17:11'!
checkout
	self answer.! !

!WAStoreFillCart methodsFor: 'accessing' stamp: 'avi 2/10/2004 20:42'!
children
	^ Array with: cartView with: main! !

!WAStoreFillCart methodsFor: 'actions' stamp: 'pmm 11/2/2005 23:44'!
displayItem: anItem
	main call: (WAStoreItemView new item: anItem; cart: cart; yourself)! !

!WAStoreFillCart methodsFor: 'actions' stamp: 'avi 12/9/2003 13:25'!
displayItems: aCollection
	| list |
	aCollection size = 1 ifTrue: [^ self displayItem: aCollection first].
	list := WABatchSelection
			 items: aCollection
			 link: #title
			 text: #subtitle.
	[self displayItem: (main call: list)] repeat
	! !

!WAStoreFillCart methodsFor: 'initialize-release' stamp: 'mb 4/23/2006 18:33'!
initialize
	super initialize.
	main := WAStoreInfo new.
	cartView := WAStoreCartView new! !

!WAStoreFillCart methodsFor: 'accessing' stamp: 'avi 12/9/2003 13:13'!
inventory
	^ WAStoreInventory default! !

!WAStoreFillCart methodsFor: 'rendering' stamp: 'pmm 4/19/2006 20:06'!
renderContentOn: html
	html table: [
"		html tableRow: [ html tableData colSpan: 3; with: trail ]."
		html tableRow: [
			html tableData id: 'nav'; with: [ self renderNavBarOn: html ].
			html tableData id: 'main'; with: main.
			html tableData id: 'side'; with: cartView ] ]! !

!WAStoreFillCart methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:12'!
renderNavBarOn: html
	html form: [
		html strong: 'Search:'.
		html space.
		html textInput callback: [:v | self search: v]; value: '' ].
	html anchor callback: [self browse]; with: 'Browse'.
	cart hasItems ifTrue:  [
		html break.
		html anchor callback: [self checkout]; with: 'Checkout']! !

!WAStoreFillCart methodsFor: 'actions' stamp: 'avi 12/9/2003 13:13'!
search: aString
	| results |
	results := self inventory findItem: aString.
	results isEmpty
		ifTrue: [main inform: 'No items match ', aString printString]
		ifFalse: [self displayItems: results].! !

!WAStoreFillCart methodsFor: 'accessing' stamp: 'avi 12/9/2003 15:33'!
style
^ '
	#search {vertical-align: bottom}
	#main {width: 50%; padding: 10px}
	#side {vertical-align: top; }
	#cart {border-style: dashed; border-width: 1; padding: 5px}
	#nav {background-color: lightgrey; vertical-align: top; padding: 5px; border-width: 1; width: 15%; font-size: 12pt}
	#batch {font-size: 10pt}
'! !

!WAStoreFillCart methodsFor: 'path' stamp: 'mb 2/10/2006 12:03'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'Seaside Sushi Store : Fill your cart'.! !

WAComponent subclass: #WAStoreInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreInfo commentStamp: 'avi 1/1/2004 09:57' prior: 0!
A component that displays simple informative text about this example.  Used by WAStoreFillCart.!

!WAStoreInfo methodsFor: 'rendering' stamp: 'mb 4/23/2006 20:25'!
renderContentOn: html
	html withLineBreaks: self text! !

!WAStoreInfo methodsFor: 'accessing' stamp: 'mb 2/9/2006 19:10'!
text
	^
'Welcome to the sushiNet online store.

This is a sample Seaside application.

Use the search box at the top left to find some results.
Good searches to try might be "tuna", "saba", or "fish".
'! !

WAComponent subclass: #WAStoreItemView
	instanceVariableNames: 'item cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreItemView commentStamp: 'avi 1/1/2004 09:58' prior: 0!
A component for viewing an individual WAStoreItem.  The caller must provide #item: and also the current #cart:.  Shows the description and price info for the item, and presents two buttons: "Add to Cart", which will add the item to the cart, once, and "Done", which will answer back to the caller.  Used by WAStoreFillCart>>displayItem: and displayItems:.!

!WAStoreItemView methodsFor: 'actions' stamp: 'avi 12/9/2003 13:11'!
addToCart
	cart add: item! !

!WAStoreItemView methodsFor: 'accessing' stamp: 'avi 12/9/2003 13:11'!
cart: aCart
	cart := aCart! !

!WAStoreItemView methodsFor: 'accessing' stamp: 'ab 5/25/2003 14:47'!
item: anItem
	item := anItem! !

!WAStoreItemView methodsFor: 'rendering' stamp: 'lr 11/21/2006 00:12'!
renderContentOn: html
	html heading: item title.
	html heading level3; with: item subtitle.
	html paragraph: item description.
	html emphasis: item price printStringAsCents.
	html form: [
		html submitButton callback: [self addToCart]; text: 'Add To Cart'.
		html space.
		html submitButton callback: [self answer]; text: 'Done' ]! !

!WAStoreItemView methodsFor: 'updating' stamp: 'mb 11/27/2005 19:31'!
updateUrl: aUrl
	aUrl addToPath: item title
! !

WAComponent subclass: #WAStringLibraryEditor
	instanceVariableNames: 'library basePath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

WAStringLibraryEditor subclass: #WAFileLibraryEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAFileLibraryEditor methodsFor: 'rendering' stamp: 'pmm 4/22/2006 00:39'!
renderAddFileOn: html
	html form
		multipart
		with: [
			html text: 'Add File: '.
			html fileUpload on: #addFile of: self library.
			html space.
			html submitButton text: 'Add' ].! !

!WAFileLibraryEditor methodsFor: 'rendering' stamp: 'pmm 4/22/2006 00:41'!
renderContentOn: html
	self renderHeadingsOn: html.
	self renderAddFileOn: html.
	self renderFilesOn: html.
	self renderDoneOn: html! !

!WAStringLibraryEditor methodsFor: 'accessing' stamp: 'pmm 4/21/2006 23:24'!
basePath
	^basePath! !

!WAStringLibraryEditor methodsFor: 'accessing' stamp: 'pmm 4/21/2006 23:24'!
basePath: aString 
	basePath := aString! !

!WAStringLibraryEditor methodsFor: 'accessing' stamp: 'pmm 4/21/2006 23:00'!
library
	^library! !

!WAStringLibraryEditor methodsFor: 'accessing' stamp: 'pmm 4/21/2006 23:01'!
library: aLibrary 
	library := aLibrary! !

!WAStringLibraryEditor methodsFor: 'rendering' stamp: 'pmm 4/22/2006 00:40'!
renderContentOn: html
	self renderHeadingsOn: html.
	self renderFilesOn: html.
	self renderDoneOn: html! !

!WAStringLibraryEditor methodsFor: 'rendering' stamp: 'lr 11/16/2006 16:46'!
renderDoneOn: html
	html form: [
		html submitButton callback: [ self answer ]; text: 'Done' ]! !

!WAStringLibraryEditor methodsFor: 'rendering' stamp: 'lr 11/16/2006 16:46'!
renderFilesOn: html
	html unorderedList: [
		self library filenames do: [ :each |
			html listItem: [
				html anchor url: (self urlFor: each); with: each ] ] ].	! !

!WAStringLibraryEditor methodsFor: 'rendering' stamp: 'pmm 4/22/2006 00:39'!
renderHeadingsOn: html
	html heading: self library name.
	
	html heading level2; with: 'Files'.! !

!WAStringLibraryEditor methodsFor: 'private' stamp: 'mb 10/17/2006 13:47'!
urlFor: aFilename
	| endPath |
	endPath := self library className, '/' ,aFilename.
	^self basePath isEmptyOrNil
		ifTrue: [ endPath ]
		ifFalse: [ self basePath last = '/'
			ifTrue: [ self basePath, endPath  ]
			ifFalse: [ self basePath, '/' , endPath  ] ]! !

WAComponent subclass: #WATableReportTest
	instanceVariableNames: 'widget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

WATableReportTest subclass: #WACanvasTableReportTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WACanvasTableReportTest class methodsFor: 'examples' stamp: 'mb 2/19/2006 14:43'!
example

	^ self new! !

!WACanvasTableReportTest methodsFor: 'private' stamp: 'mb 2/19/2006 14:42'!
widgetClass
	^WACanvasTableReport! !

!WATableReportTest class methodsFor: 'accessing' stamp: 'mb 2/10/2006 13:11'!
example

	^ self new! !

!WATableReportTest methodsFor: 'accessing' stamp: 'mb 2/10/2006 13:08'!
children
	^Array with: widget.! !

!WATableReportTest methodsFor: 'initialize-release' stamp: 'mb 5/30/2006 12:14'!
initialize
	| cols rows |
	cols := OrderedCollection new
		add: (WAReportColumn
				selector: #title
				title: 'Title'
				onClick: [:v | self inform: v description]);
		add: (WAReportColumn
				selector: #subtitle
				title: 'Subtitle');
		add: (WAReportColumn
				selector: #price
				title: 'Price');
		add: (WAReportColumn
				renderBlock: [:obj :html | html emphasis: obj description]
				title: 'Description');
		yourself.
	rows := WAStoreInventory default allItems.
	widget := self widgetClass new
				columns: cols;
				rows: rows;
				rowPeriod: 1;
				rowColors: #(lightblue lightyellow);
				yourself.! !

!WATableReportTest methodsFor: 'rendering' stamp: 'mb 2/10/2006 13:07'!
renderContentOn: html
	html render: widget.! !

!WATableReportTest methodsFor: 'private' stamp: 'mb 2/19/2006 14:41'!
widgetClass
	^WATableReport! !

WAComponent subclass: #WATask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

!WATask commentStamp: '<historical>' prior: 0!
I am a subclass of WAComponent, specialized for defining workflow.  The difference between a task and a component is the following:

Both of them are reusable, embeddable, callable pieces of user interface. A component has state (instance variables), behavior (it may change its state, and it may also choose to display other components with #call:), and appearance (it renders HTML). A Task has only the first two - it doesn't render any HTML directly, but only through the components it calls. This is useful when what you want to encapsulate/embed/call is purely a process (show this component, then this one, then this one).

The key method for WATask is #go - as soon as a task is displayed, this method will get invoked, and will presumably #call: other components.

In terms of implementation, you can think of a WATask in the following way: it is a component which renders two things:
- a link whose callback invokes the #go method
- a header that immediately redirects to the URL of that link
!

WATask subclass: #WACookieTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WACookieTest methodsFor: 'actions' stamp: 'mb 2/27/2006 08:34'!
go
	[self session checkForCookies]
		whileFalse: [self inform: 'You must have cookies enabled to proceed.'].
	self session redirectWithCookies: (Array with:
		"Should get back empty cookie ?"
		(WACookie new
			key: 'nullCookie';
			expireIn: (Duration seconds: 60);
			yourself)
	with:	
		(WACookie new
			key: 'cookietest';
			value: 1000 atRandom displayString;
			expireIn: (Duration seconds: 60);
			yourself)
	with:	
		"Should get back multiple (i.e. a collection of) cookies with same key ?"
		(WACookie new
			key: 'cookietest';
			value: 1000 atRandom displayString;
			expireIn: (Duration seconds: 60);
			yourself)).
	self inform: self session currentRequest cookies displayString.! !

WATask subclass: #WAExceptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAExceptionTest methodsFor: 'processing' stamp: 'mbany 4/14/2005 12:14'!
go
	[(self confirm: 'Raise an exception?')
		ifTrue: [self error: 'foo']]
			on: Error
			do: [:e | self inform: 'Caught: ', e displayString]! !

WATask subclass: #WAStoreTask
	instanceVariableNames: 'cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreTask commentStamp: 'avi 1/1/2004 10:19' prior: 0!
This task models the main application flow of the store example.  Most of the other components in the example are called from here.  The flow is defined by the #go method.  After creating a WAStoreCart instance, this calls WAStoreFillCart to allow the user to add items to it.  It then calls WAStoreCartConfirmation, WAStoreAddressEditor, and WAStorePaymentEditor in succession for the checkout process.  Many of the components it calls are wrapped with informative messages (#withMessage:) and validation (#validateWith:).  It also makes use of WASession>>isolate: to ensure that once the checkout process starts, backtracking to modify the cart is forbidden.  Used by WAStore.!

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 21:37'!
confirmContentsOfCart
	^ self call:
		((WAStoreCartConfirmation new cart: cart)
			addMessage: 'Please verify your order:')! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:28'!
displayConfirmation
	self inform: 'Your fish is on its way.'! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 1/14/2004 22:51'!
fillCart
	self call: (WAStoreFillCart new cart: cart)! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 9/10/2005 16:35'!
getAddressWithMessage: aString
	^ self call:
		(WAStoreAddressEditor new
			validateWith: [:a | a validate];
			addMessage: aString;
			yourself)
				! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:43'!
getBillingAddress
	^ self getAddressWithMessage: 'Please enter your billing address:'.! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 9/10/2005 18:55'!
getPaymentInfo
	^ self call:
		(WAStorePaymentEditor new
			validateWith: [:p | p validate];
			addMessage: 'Please enter your payment information:';
			yourself)! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 11/6/2005 00:38'!
getShippingAddress
	^ self getAddressWithMessage: 'Please enter your shipping address:'.! !

!WAStoreTask methodsFor: 'actions' stamp: 'avi 2/2/2004 21:58'!
go
	| shipping billing creditCard |
	cart := WAStoreCart new.
	self isolate:
		[[self fillCart.
		self confirmContentsOfCart]
			whileFalse].

	self isolate:
		[shipping := self getShippingAddress.
		billing := (self useAsBillingAddress: shipping)
					ifFalse: [self getBillingAddress]
					ifTrue: [shipping].
		creditCard := self getPaymentInfo.
		self shipTo: shipping billTo: billing payWith: creditCard].

	self displayConfirmation.! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 14:04'!
shipTo: shippingAddress billTo: billingAddress payWith: aCreditCard
	"no-op"! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:44'!
useAsBillingAddress: anAddress
	^ self confirm: 'Do you wish to use ', anAddress street printString, ' as your billing address?'! !

!WATask methodsFor: 'as yet unclassified' stamp: 'avi 3/28/2004 20:50'!
decoration: oldDecoration shouldWrap: newDecoration
	^ (oldDecoration isGlobal and: [newDecoration isGlobal not])
		or: [oldDecoration isLocal and: [newDecoration isDelegation]]! !

!WATask methodsFor: 'processing' stamp: 'jf 11/10/2003 16:13'!
go
	self subclassResponsibility! !

!WATask methodsFor: 'rendering' stamp: 'lr 9/6/2006 11:27'!
renderContentOn: html
	self session redirectTo: (html context actionUrl
		withParameter: (html callbacks 
			registerActionCallback: [ [ self answer: self go ] repeat ])) displayString! !

WATask subclass: #WATransactionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WATransactionTest methodsFor: 'processing' stamp: 'avi 3/22/2004 15:16'!
go
	self inform: 'Before parent txn'.
	self isolate: 
			[self inform: 'Inside parent txn'.
			self isolate: [self inform: 'Inside child txn'].
			self inform: 'Outside child txn'].
	self inform: 'Outside parent txn'! !

WAComponent subclass: #WATaskTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WATaskTest methodsFor: 'rendering' stamp: 'avi 9/22/2004 14:05'!
renderContentOn: html
	html anchorWithAction: [self call: WAExceptionTest new] text: 'go'.
! !

!WATaskTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:27'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

WAComponent subclass: #WATimeSelector
	instanceVariableNames: 'second hour minute startHour endHour'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WATimeSelector methodsFor: 'accessing' stamp: 'jlr 4/4/2006 23:38'!
date: aDate 
	second := aDate dayOfMonth.
	hour := aDate monthIndex.
	minute := aDate year! !

!WATimeSelector methodsFor: 'accessing' stamp: 'jlr 4/4/2006 23:37'!
days
	^ 1 to: 31! !

!WATimeSelector methodsFor: 'accessing' stamp: 'jlr 4/4/2006 23:48'!
endHour
	^endHour! !

!WATimeSelector methodsFor: 'accessing' stamp: 'jlr 4/4/2006 23:48'!
endHour: anInteger 
	endHour := anInteger! !

!WATimeSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:10'!
hour
	^hour! !

!WATimeSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:10'!
hour: anObject
	^hour := anObject! !

!WATimeSelector methodsFor: 'initialize-release' stamp: 'mb 5/6/2006 16:10'!
initialize
	super initialize.
	startHour := 0.
	endHour := 23.
	self time: Time midnight! !

!WATimeSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:10'!
minute
	^minute! !

!WATimeSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:10'!
minute: anObject
	^minute := anObject! !

!WATimeSelector methodsFor: 'private' stamp: 'pmm 10/2/2006 21:13'!
privateIsValidSecond: theSecond hourNumber: theHour minuteNumber: theMinute

	^ (theHour between: 0 and: 23)
		and: [ theMinute between: 0 and: 59 ]
		and: [ theSecond between: 0 and: 59 ]! !

!WATimeSelector methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:25'!
renderContentOn: html 
	html select
		list: (0 to: 23);
		on: #hour of: self.
	html  select
		list: (0 to: 59);
		on: #minute of: self.
	html  select
		list: (0 to: 59);
		on: #second of: self.
		
	self timeIsValid ifFalse: [self renderValidationErrorOn: html]! !

!WATimeSelector methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:23'!
renderValidationErrorOn: html
	html span
		class: 'error';
		with: 'invalid time'! !

!WATimeSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:10'!
second
	^second! !

!WATimeSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:10'!
second: anObject
	^second := anObject! !

!WATimeSelector methodsFor: 'accessing' stamp: 'jlr 4/4/2006 23:48'!
startHour
	^startHour! !

!WATimeSelector methodsFor: 'accessing' stamp: 'jlr 4/4/2006 23:48'!
startHour: anInteger 
	startHour := anInteger! !

!WATimeSelector methodsFor: 'accessing' stamp: 'pmm 10/22/2006 07:22'!
time
	(self 
		privateIsValidSecond: second
		hourNumber: hour
		minuteNumber: minute) ifFalse: [self error: 'Invalid time'].
	^self timeClass 
		hour: hour
		minute: minute
		second: second! !

!WATimeSelector methodsFor: 'accessing' stamp: 'jlr 4/4/2006 23:47'!
time: aTime 
	second := aTime second.
	hour := aTime hour.
	minute := aTime minute! !

!WATimeSelector methodsFor: 'private' stamp: 'pmm 10/22/2006 07:22'!
timeClass
	^Time! !

!WATimeSelector methodsFor: 'testing' stamp: 'jlr 4/4/2006 23:46'!
timeIsValid
	[self time] on: Error do: [:e | ^ false].
	^ true! !

WAComponent subclass: #WATool
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

WATool subclass: #WAMemory
	instanceVariableNames: 'instances sizes table'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools-Squeak'!

!WAMemory class methodsFor: 'accessing' stamp: 'lr 11/20/2006 23:52'!
title
	^ 'Memory'! !

!WAMemory methodsFor: 'private' stamp: 'lr 11/20/2006 23:44'!
buildTable
	^ WATableReport new
		rowPeriod: 1;
		rowColors: #( 'lightgrey' 'white' );
		rows: sizes keys asSortedCollection;
		columns: (Array 
			with: (WAReportColumn selector: #yourself title: 'Class')
			with: (WAReportColumn new
				title: 'Instances';
				valueBlock: [:ea | instances at: ea];
				yourself)
			with: (WAReportColumn new
				title: 'Total Size';
				valueBlock: [:ea | sizes at: ea];
				yourself));
		yourself! !

!WAMemory methodsFor: 'accessing' stamp: 'avi 2/10/2004 16:15'!
children
	^ Array with: table! !

!WAMemory methodsFor: 'initialization' stamp: 'lr 11/20/2006 23:46'!
initialize
	| segment results |
	super initialize.
	segment := ImageSegment new 
		copyFromRoots: (Array with: self session)
		sizeHint: 100000.
	results := segment doSpaceAnalysis.
	instances := results first.
	sizes := results second.
	table := self buildTable! !

!WAMemory methodsFor: 'rendering' stamp: 'lr 11/20/2006 23:40'!
renderContentOn: html
	html strong: self totalInstances displayString, ' instances in ', self totalSizeString.
	html render: table! !

!WAMemory methodsFor: 'accessing' stamp: 'ab 2/18/2003 20:42'!
totalInstances
	^ instances detectSum: [:ea | ea]! !

!WAMemory methodsFor: 'accessing' stamp: 'ab 2/18/2003 20:41'!
totalSize
	^ sizes detectSum: [:ea | ea]! !

!WAMemory methodsFor: 'accessing' stamp: 'ab 2/18/2003 20:58'!
totalSizeString
	|size unit|
	size := self totalSize.
	unit := 'bytes'.
	size > 1024 ifTrue:
		[size := size / 1024.
		unit := 'kB'.
		size > 1024 ifTrue:
			[size := size / 1024.
			unit := 'MB']].
	^ (size printShowingDecimalPlaces: 1), ' ', unit! !

WATool subclass: #WAProfiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAProfiler class methodsFor: 'accessing' stamp: 'ab 7/10/2003 14:10'!
title
	^ 'Profiler'! !

!WAProfiler methodsFor: 'rendering' stamp: 'lr 11/20/2006 23:49'!
renderContentOn: html
	| profile |
	profile := SeasidePlatformSupport 
		profileSendsDuring: [ html render: self root ].
	html horizontalRule.
	html preformatted: profile! !

WATool subclass: #WASpotProfileReport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools-Squeak'!

!WASpotProfileReport class methodsFor: 'accessing' stamp: 'lr 11/20/2006 23:53'!
title
	^ 'Spot Profiler'! !

!WASpotProfileReport methodsFor: 'rendering' stamp: 'lr 11/20/2006 23:55'!
renderContentOn: html
	html table: [
		html tableRow: [
			#( 'Selector' 'Total Time' 'Time/Req' 'Readings/Req' 'Time/Reading' )
				do: [ :each | html tableHeading: each ].
			WASpotProfiler profilers keysAndValuesDo: [ :selector :profile |
				html tableHeading: selector.
				profile allReadings isEmpty ifFalse: [
					html tableData: profile totalTime.
					html tableData: profile averageRequestTime.
					html tableData: profile averageReadingsPerRequest.
					html tableData: profile averageReadingTime.
					html tableData: [
						html anchor
							callback: [ profile reset ];
							with: 'reset' ] ] ] ] ]! !

!WATool class methodsFor: 'accessing' stamp: 'ab 7/3/2003 12:43'!
title
	^ self name! !

!WATool methodsFor: 'accessing' stamp: 'lr 11/20/2006 23:35'!
root
	"Answer the root component of the application."
	
	^ root! !

!WATool methodsFor: 'accessing' stamp: 'lr 11/20/2006 23:35'!
root: aComponent
	root := aComponent! !

WAComponent subclass: #WATrail
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WATrail class methodsFor: 'instance creation' stamp: 'ab 8/26/2003 15:27'!
on: anObject
	^ self new root: anObject! !

!WATrail methodsFor: 'rendering' stamp: 'lr 11/16/2006 15:38'!
renderContentOn: html
	| last selected |
	last := nil.
	html unorderedList
		class: 'trail';
		with: [
			root visiblePresentersDo: [ :each |
				(each isDecoration and: [each isDelegation]) ifTrue: [
					(each component respondsTo: #trailName) ifTrue: [
						last := each.
						html listItem: [
							html anchor
								callback: [ each remove ];
								with: each component trailName ] ] ] ].
			selected := last ifNil: [ root ] ifNotNil: [ last delegate ].
			(selected respondsTo: #trailName) ifTrue: [
				html listItem: selected trailName ] ]
! !

!WATrail methodsFor: 'accessing' stamp: 'ab 8/26/2003 15:27'!
root: anObject
	root := anObject! !

!WATrail methodsFor: 'rendering' stamp: 'avi 4/13/2004 22:16'!
style
^'	ul.trail {
		margin-left: 0;
		padding-left: 0;
		display: inline;
		border: none;
	}
	ul.trail li {
        	margin-left: 0;
        	padding-left: 2px;
        	border: none;
        	list-style: none;
        	display: inline;
	}
	
	ul.trail  li:before {
        content: "\0020 \0020 \0020 \00BB \0020";
        }
        
	ul.trail li.first:before {
        content: " ";
        }
'! !

WAComponent subclass: #WATree
	instanceVariableNames: 'root selected expanded childrenBlock labelBlock canSelectBlock selectBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WATree class methodsFor: 'examples' stamp: 'lr 3/27/2006 11:13'!
exampleCollectionClasses
	^ self new
		root: Collection;
		labelBlock: [ :class | class name ];
		childrenBlock: [ :class | class subclasses ];
		yourself! !

!WATree class methodsFor: 'examples' stamp: 'lr 3/27/2006 11:24'!
exampleObjectExplorer
	^ self new
		root: 'dispatcher' -> WADispatcher default;
		labelBlock: [ :assoc | assoc ];
		childrenBlock: [ :assoc | assoc value inspectorFields ];
		yourself! !

!WATree class methodsFor: 'instance-creation' stamp: 'lr 3/27/2006 11:08'!
root: anObject
	^ self new
		root: anObject;
		yourself! !

!WATree class methodsFor: 'instance-creation' stamp: 'lr 3/27/2006 11:09'!
root: anObject path: anArray
	^ (self root: anObject)
		expandAll: anArray;
		selected: anArray last;
		yourself! !

!WATree methodsFor: 'testing' stamp: 'lr 3/7/2005 17:39'!
canSelect: aNode
	^self selectBlock notNil
		and: [ self canSelectBlock isNil
			or: [ self canSelectBlock value: aNode ] ].! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 12:11'!
canSelectBlock
	^canSelectBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 3/7/2005 17:40'!
canSelectBlock: aBlock
	canSelectBlock := aBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:19'!
childrenBlock
	^childrenBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:20'!
childrenBlock: aBlock
	childrenBlock := aBlock! !

!WATree methodsFor: 'accessing-nodes' stamp: 'lr 3/27/2006 09:12'!
childrenOf: aNode
	| children |
	children := self childrenBlock value: aNode.
	^ children ifNil: [ Array new ]! !

!WATree methodsFor: 'actions' stamp: 'lr 2/19/2005 16:03'!
collapse: aNode
	expanded remove: aNode.! !

!WATree methodsFor: 'actions' stamp: 'lr 2/19/2005 11:20'!
expand: aNode
	expanded add: aNode.! !

!WATree methodsFor: 'actions' stamp: 'lr 3/28/2005 21:15'!
expandAll: aCollection
	expanded addAll: aCollection.! !

!WATree methodsFor: 'testing' stamp: 'lr 2/19/2005 16:25'!
hasChildren: aNode
	^(self childrenOf: aNode) 
		isEmpty not.! !

!WATree methodsFor: 'initialization' stamp: 'lr 3/27/2006 11:25'!
initialize
	super initialize.
	self session registerObjectForBacktracking: (expanded := IdentitySet new).
	self selectBlock: [ :node | self answer: node ].
	self childrenBlock: [ :node | Array new ].
	self labelBlock: [ :node | node displayString ]! !

!WATree methodsFor: 'testing' stamp: 'lr 2/19/2005 11:18'!
isExpanded: aNode
	^expanded includes: aNode.! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:19'!
labelBlock
	^labelBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:20'!
labelBlock: aBlock
	labelBlock := aBlock! !

!WATree methodsFor: 'accessing-nodes' stamp: 'lr 2/19/2005 12:06'!
labelOf: aNode
	^self labelBlock value: aNode.! !

!WATree methodsFor: 'rendering' stamp: 'lr 2/19/2005 11:41'!
renderContentOn: html
	self renderTreeOn: html.! !

!WATree methodsFor: 'rendering-nodes' stamp: 'pmm 9/22/2006 23:27'!
renderNode: aNode on: html
	html listItem: [
		self renderNodeButton: aNode on: html.
		self renderNodeLabel: aNode on: html.
		self renderNodeChildren: aNode on: html ]! !

!WATree methodsFor: 'rendering-nodes' stamp: 'pmm 9/22/2006 23:23'!
renderNodeButton: aNode on: html
	| isExpanded |
	html span
		class: 'button';
		with: [
			(self hasChildren: aNode) ifTrue: [
				isExpanded := self isExpanded: aNode.
				self 
					renderNodeButtonLink: aNode 
					action: (MessageSend 
						receiver: self 
						selector: (isExpanded
							ifTrue: [ #collapse: ]
							ifFalse: [ #expand: ])
						argument: aNode)
					text: (isExpanded
						ifTrue: [ '-' ]
						ifFalse: [ '+' ])
					on: html ] ]! !

!WATree methodsFor: 'rendering-nodes' stamp: 'pmm 9/22/2006 23:24'!
renderNodeButtonLink: aNode action: aBlock text: anObject on: html
	html anchor callback: aBlock; with: anObject! !

!WATree methodsFor: 'rendering-nodes' stamp: 'lr 2/19/2005 16:07'!
renderNodeChildren: aNode on: html
	| children |
	children := self childrenOf: aNode.
	children isEmpty ifFalse: [
		(self isExpanded: aNode) ifTrue: [
			html unorderedList: [
				children do: [ :each |
					self renderNode: each on: html ] ] ] ].! !

!WATree methodsFor: 'rendering-nodes' stamp: 'pmm 9/22/2006 23:27'!
renderNodeLabel: aNode on: html
	| label |
	html span
		class: 'label';
		class: (self selected == aNode
			ifTrue: [ 'active' ]
			ifFalse: [ 'inactive' ]);
		with: [
			label := self labelOf: aNode.
			(self canSelect: aNode)
				ifFalse: [ html render: label ]
				ifTrue: [
					self
						renderNodeLabelLink: aNode
						action: (MessageSend
							receiver: self 
							selector: #select:
							argument: aNode)
						text: label on: html ] ].! !

!WATree methodsFor: 'rendering-nodes' stamp: 'pmm 9/22/2006 23:28'!
renderNodeLabelLink: aNode action: aBlock text: anObject on: html
	html anchor callback: aBlock; with: anObject! !

!WATree methodsFor: 'rendering' stamp: 'lr 3/7/2005 16:30'!
renderTreeOn: html
	html unorderedList: [ self renderNode: self root on: html ].! !

!WATree methodsFor: 'accessing' stamp: 'lr 2/19/2005 11:18'!
root
	^root! !

!WATree methodsFor: 'accessing' stamp: 'lr 2/19/2005 11:18'!
root: aNode
	root := aNode! !

!WATree methodsFor: 'actions' stamp: 'lr 3/28/2005 21:13'!
select: aNode
	(self canSelect: aNode) ifTrue: [
		self selected: aNode.
		self selectBlock isNil
			ifFalse: [ self selectBlock value: aNode ] ].! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:21'!
selectBlock
	^selectBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:21'!
selectBlock: aBlock
	selectBlock := aBlock! !

!WATree methodsFor: 'accessing' stamp: 'lr 2/19/2005 11:19'!
selected
	^selected! !

!WATree methodsFor: 'accessing' stamp: 'lr 2/19/2005 11:19'!
selected: aNode
	selected := aNode! !

WAComponent subclass: #WAUploadTest
	instanceVariableNames: 'file'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAUploadTest methodsFor: 'rendering' stamp: 'pmm 9/30/2006 18:18'!
renderContentOn: html
	html heading: 'Upload File'.
	
	html attributeAt: 'enctype' put: 'multipart/form-data'.
	html form: [
		html fileUploadWithCallback: [:f | file := f].
		html submitButton.
	].

	file ifNotNil: [
		html 
			anchorWithDocument: file contents 
			mimeType: file contentType
			fileName: file fileName
			text: file fileName , ' (' , file contentType , ')'. 
		html break. 
		html anchorWithDocument: file contents text:file fileName.
		html preformatted: file contents ]
! !

!WAUploadTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:27'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

WAComponent subclass: #WAVNCController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools-Squeak'!

!WAVNCController class methodsFor: 'class initialization' stamp: 'avi 10/20/2005 23:52'!
initialize
	(Smalltalk hasClassNamed: 'RFBServer') ifTrue: [self registerAsApplication: 'vnc']! !

!WAVNCController methodsFor: 'accessing' stamp: 'avi 10/20/2005 23:48'!
currentDisplay
	^ RFBServer server displayNumber asString! !

!WAVNCController methodsFor: 'accessing' stamp: 'lr 11/21/2006 00:02'!
project
	^ Smalltalk classNamed: #Project! !

!WAVNCController methodsFor: 'rendering' stamp: 'lr 11/21/2006 00:02'!
renderContentOn: html
	html heading: 'VNC Server'.
	self server
		ifNil: [ self renderStartOn: html ]
		ifNotNil: [ self renderStopOn: html ].
	html heading: 'UI Process'.
	self project uiProcess isSuspended
		ifFalse: [ self renderSuspendOn: html ]
		ifTrue: [ self renderResumeOn: html ]! !

!WAVNCController methodsFor: 'rendering' stamp: 'lr 11/21/2006 00:01'!
renderResumeOn: html
	html form: [
		html text: 'UI Process is suspended. '.
		html submitButton
			callback: [ self resume ];
			text: 'Resume' ]! !

!WAVNCController methodsFor: 'rendering' stamp: 'lr 11/20/2006 23:58'!
renderStartOn: html
	html form: [
		html text: 'Start VNC on display: '.
		html textInput
			value: 0;
			callback: [ :value | self startOn: value asNumber ].
		html submitButton
			text: 'Start' ]! !

!WAVNCController methodsFor: 'rendering' stamp: 'lr 11/21/2006 00:01'!
renderStopOn: html
	html form: [
		html text: 'Stop VNC (running on ', self currentDisplay, ') '.
		html submitButton
			callback: [ self stop ];
			text: 'Stop' ]! !

!WAVNCController methodsFor: 'rendering' stamp: 'lr 11/21/2006 00:01'!
renderSuspendOn: html
	html form: [
		html text: 'UI Process is running. '.
		html submitButton
			callback: [ self suspend ];
			text: 'Suspend' ]! !

!WAVNCController methodsFor: 'actions' stamp: 'lr 11/21/2006 00:02'!
resume
	self project uiProcess resume! !

!WAVNCController methodsFor: 'accessing' stamp: 'lr 11/21/2006 00:00'!
server
	^ Smalltalk classNamed: #RFBServer! !

!WAVNCController methodsFor: 'actions' stamp: 'lr 11/21/2006 00:02'!
startOn: aNumber
	self resume.
	self server start: aNumber! !

!WAVNCController methodsFor: 'actions' stamp: 'lr 11/21/2006 00:01'!
stop
	self server stop! !

!WAVNCController methodsFor: 'actions' stamp: 'lr 11/21/2006 00:02'!
suspend
	self project uiProcess suspend.
	self stop! !

WAComponent subclass: #WAVersionUploader
	instanceVariableNames: 'file url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools-Squeak'!

!WAVersionUploader class methodsFor: 'testing' stamp: 'avi 2/5/2004 12:57'!
canBeRoot
	^ true! !

!WAVersionUploader methodsFor: 'actions' stamp: 'avi 1/21/2004 18:58'!
loadFile
	| reader version |
	reader := MCVersionReader readerClassForFileNamed: file fileName.
	reader ifNil: [self inform: file fileName, ' is not in a known format'].
	version := reader versionFromStream: file contents asByteArray readStream.
	version load.! !

!WAVersionUploader methodsFor: 'actions' stamp: 'avi 1/21/2004 18:58'!
loadURL
	| stream version |
	stream := url asUrl retrieveContents content asByteArray readStream .
	version := (MCVersionReader readerClassForFileNamed: url) versionFromStream: stream.
	version load.! !

!WAVersionUploader methodsFor: 'rendering' stamp: 'avi 5/10/2005 14:34'!
newVersion: aWorkingCopy
	| version s |
	version := [aWorkingCopy newVersion]
				on: MCVersionNameAndMessageRequest 
				do: [:n | n resume: (Array with: n suggestedName with: '')].
	s := RWBinaryOrTextStream on: String new.
	version fileOutOn: s.
	self session respond:
		[:u |
		u addToPath: version fileName.
		WAResponse redirectTo: u displayString].
	self session returnResponse: (WAResponse new
									contentType: 'application/octet-stream';
									nextPutAll: s contents;
									yourself)! !

!WAVersionUploader methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:05'!
renderContentOn: html
	html strong: 'Loaded versions:'.
	html unorderedList 
		with: [MCWorkingCopy allManagers
				do: [:ea | 
					html listItem: [
						html anchor callback: [self newVersion: ea]; with: 'Save'.
						html space.
						html text: ea description]]].
	
	html form
		multipart;
		with: [
			html strong: 'Load version from file: '.
			html break.
			html fileUpload callback: [:f | file := f].
			html space.
			html submitButton callback: [self loadFile]; text: 'Load'.
	].
	html form
		with: [
			html strong: 'Load version from URL: '.
			html break.
			html textInput size: 60; value: 'http://'; callback: [:u | url := u].
			html space.
			html submitButton callback: [self loadURL]; text: 'Load'.
	].
	html anchor callback: [self saveImage]; with: 'Save Image'. ! !

!WAVersionUploader methodsFor: 'actions' stamp: 'ab 8/30/2003 20:55'!
saveImage
	Smalltalk snapshot: true andQuit: false! !

WAComponent subclass: #WAWalkback
	instanceVariableNames: 'exception fullstack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAWalkback methodsFor: 'actions' stamp: 'avi 11/10/2003 01:54'!
debug
	self answer! !

!WAWalkback methodsFor: 'accessing' stamp: 'avi 10/26/2004 14:05'!
exception: anException
	exception := anException! !

!WAWalkback methodsFor: 'actions' stamp: 'lr 3/28/2005 17:52'!
fullstack
	fullstack := true
	! !

!WAWalkback methodsFor: 'initialization' stamp: 'lr 3/28/2005 17:55'!
initialize
	super initialize.
	fullstack := false.! !

!WAWalkback methodsFor: 'rendering' stamp: 'lr 9/6/2006 11:13'!
renderContentOn: html
	self renderToolsOn: html.
	self renderWalkbackOn: html! !

!WAWalkback methodsFor: 'rendering' stamp: 'lr 9/6/2006 11:14'!
renderObject: anObject labelled: aString on: html
	| objectString |
	[objectString := (SeasidePlatformSupport isProxy: anObject)
					ifTrue: [anObject printString]
					ifFalse: [anObject printStringLimitedTo: 100]]
		on: Error
		do: [:err | objectString := '<font color="FF0000">&lt;error in printStringLimitedTo:&gt;</font>'].
	html tableRow: [
		html tableData: aString.
		html tableData: [ html html: objectString ] ]! !

!WAWalkback methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:05'!
renderStackFrame: aContext on: html
	| receiver |
	html listItem: [
		html text: aContext fullPrintString.
		html blockquote: [ html table: [
			receiver := aContext receiver.
			self renderObject: receiver labelled: 'self' on: html.
			html tableRow: [ html tableData colSpan: 2; with: [ html strong: 'temps' ]].
			aContext tempNames withIndexDo:
			[:name :index |
			self renderObject: (aContext tempAt: index) labelled: name on: html].
			receiver == nil ifFalse: [
				((SeasidePlatformSupport isProxy: receiver) not and: [receiver class instSize > 0]) ifTrue:
					[html tableRow: [ html tableData colSpan: 2; with: [html strong: 'inst vars']].
					receiver class allInstVarNames withIndexDo:
					[:name :index |
					self renderObject: (receiver instVarAt: index) labelled: name on: html]]].
		]]
	]
! !

!WAWalkback methodsFor: 'rendering' stamp: 'lr 9/6/2006 11:13'!
renderToolsOn: html
	html anchor
		callback: [ self debug ];
		with: 'Debug'.
	html space.
	html anchor
		callback: [ self fullstack ];
		with: 'Full Stack'! !

!WAWalkback methodsFor: 'rendering' stamp: 'lr 3/28/2005 17:56'!
renderWalkbackOn: html
	| context count |
	html heading: exception description.
	html unorderedList: [
		context := thisContext. count := 0.
		[context receiver isKindOf: Exception] whileFalse: [context := context sender].
		[context receiver isKindOf: Exception] whileTrue: [context := context sender].
		[context notNil and: [ fullstack or: [ count < 5 ] ] ] whileTrue: [
			self renderStackFrame: context on: html.
			context := context sender.
			count := count + 1].
	]! !

WAPresenter subclass: #WADecoration
	instanceVariableNames: 'next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

!WADecoration commentStamp: '<historical>' prior: 0!
I am an abstract decoration around instances of WAComponent. I can be added to aComponent by calling #addDecoration: and I change the basic behaviour or look of a component. There are several methods that can be overriden to archive this:

- #renderContentOn: to emit xhtml around the decorated component. Call #renderOwnerOn: to let the owner emit its output.

- #processChildCallbacks: to intercept the callback processing of the owner.

- #handleAnswer: to intercept the answer processing.!

WADecoration subclass: #WAAnswerHandler
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

!WAAnswerHandler methodsFor: 'accessing' stamp: 'avi 6/2/2004 21:59'!
block: aBlock
	block := aBlock! !

!WAAnswerHandler methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2004 11:03'!
handleAnswer: anObject continueWith: aBlock
	block value: anObject! !

WADecoration subclass: #WABasicAuthentication
	instanceVariableNames: 'authenticator realm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WABasicAuthentication methodsFor: 'accessing' stamp: 'avi 2/2/2004 13:03'!
authenticator: anAuthenticator
	authenticator := anAuthenticator! !

!WABasicAuthentication methodsFor: 'testing' stamp: 'avi 3/28/2004 20:51'!
isGlobal
	^ true! !

!WABasicAuthentication methodsFor: 'as yet unclassified' stamp: 'avi 6/8/2004 00:56'!
processChildCallbacks: aStream
	(self verifyRequest: self session currentRequest)
		ifTrue: [super processChildCallbacks: aStream]
		ifFalse: [self respondWithChallenge]! !

!WABasicAuthentication methodsFor: 'accessing' stamp: 'avi 3/22/2004 00:04'!
realm
	^ realm ifNil: [self session application basePath]! !

!WABasicAuthentication methodsFor: 'accessing' stamp: 'avi 2/5/2004 13:52'!
realm: aString
	realm := aString! !

!WABasicAuthentication methodsFor: 'rendering' stamp: 'lr 9/6/2006 11:16'!
renderContentOn: html
	(self verifyRequest: self session currentRequest)
		ifTrue: [self renderOwnerOn: html]
		ifFalse: [self respondWithChallenge]! !

!WABasicAuthentication methodsFor: 'as yet unclassified' stamp: 'avi 5/19/2004 14:16'!
respondWithChallenge
	self session returnResponse: (WAResponse basicAuthWithRealm: self realm)! !

!WABasicAuthentication methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 21:42'!
verifyRequest: aRequest
	^ authenticator verifyPassword: aRequest password  forUser: aRequest user! !

!WADecoration methodsFor: 'convenience' stamp: 'ac 3/22/2006 15:04'!
asComponent 
	^ self component! !

!WADecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2004 22:13'!
component
	^ self owner isDecoration
		ifTrue: [self owner component]
		ifFalse: [self owner]! !

!WADecoration methodsFor: 'call/answer' stamp: 'avi 6/22/2004 11:02'!
handleAnswer: anObject
	(self owner handleAnswer: anObject) ifFalse:
		[self handleAnswer: anObject continueWith: [^ false]].
	^ true! !

!WADecoration methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2004 11:03'!
handleAnswer: anObject continueWith: aBlock
	aBlock value! !

!WADecoration methodsFor: 'testing' stamp: 'avi 3/27/2004 19:55'!
isDecoration
	^ true! !

!WADecoration methodsFor: 'testing' stamp: 'avi 3/27/2004 22:23'!
isDelegation
	^ false! !

!WADecoration methodsFor: 'testing' stamp: 'avi 3/28/2004 20:48'!
isGlobal
	^ false! !

!WADecoration methodsFor: 'testing' stamp: 'avi 3/28/2004 20:49'!
isLocal
	^ (self isGlobal or: [self isDelegation]) not! !

!WADecoration methodsFor: 'iterating' stamp: 'avi 6/8/2004 12:43'!
nextPresentersDo: aBlock
	aBlock value: self owner! !

!WADecoration methodsFor: 'accessing' stamp: 'avi 4/13/2004 20:20'!
owner
	^ next ifNotNil: [next contents]! !

!WADecoration methodsFor: 'accessing' stamp: 'avi 4/13/2004 20:20'!
owner: aPresenter
	next ifNil: [next := WAStateHolder new].
	next contents: aPresenter! !

!WADecoration methodsFor: 'actions' stamp: 'avi 3/29/2004 16:10'!
remove
	self component removeDecoration: self! !

!WADecoration methodsFor: 'rendering' stamp: 'avi 3/27/2004 21:07'!
renderOwnerOn: html
	self owner ifNotNilDo: [:owner | owner renderWithContext: html context]! !

WADecoration subclass: #WADelayedAnswerDecoration
	instanceVariableNames: 'delay'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WADelayedAnswerDecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2005 20:34'!
delay
	^ delay ifNil: [1]! !

!WADelayedAnswerDecoration methodsFor: 'accessing' stamp: 'avi 3/27/2005 20:34'!
delay: aNumber
	delay := aNumber! !

!WADelayedAnswerDecoration methodsFor: 'path' stamp: 'pmm 10/7/2006 18:41'!
updateRoot: aRoot
	| callbacks url |
	callbacks := WACallbackRegistry context: aRoot context owner: self.
	url := aRoot context actionUrl withParameter: (callbacks registerActionCallback: [self component answer]).
	aRoot meta redirectAfter: self delay to: url asString! !

WADecoration subclass: #WADelegation
	instanceVariableNames: 'delegate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

!WADelegation methodsFor: 'accessing' stamp: 'avi 3/12/2004 20:18'!
delegate
	^ delegate! !

!WADelegation methodsFor: 'accessing' stamp: 'avi 3/12/2004 20:18'!
delegate: aComponent
	delegate := aComponent! !

!WADelegation methodsFor: 'testing' stamp: 'avi 3/27/2004 22:26'!
isDelegation
	^ true! !

!WADelegation methodsFor: 'iterating' stamp: 'avi 4/22/2004 14:51'!
nextPresentersDo: aBlock
	delegate decorationChainDo: aBlock! !

WADecoration subclass: #WAFormDecoration
	instanceVariableNames: 'buttons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WAFormDecoration methodsFor: 'accessing' stamp: 'avi 3/16/2004 13:36'!
buttons
	^ buttons! !

!WAFormDecoration methodsFor: 'accessing' stamp: 'avi 3/16/2004 13:34'!
buttons: selectorArray
	buttons := selectorArray! !

!WAFormDecoration methodsFor: 'actions' stamp: 'mb 4/4/2006 13:42'!
defaultAction
	MessageSend receiver: self owner selector: self owner defaultButton! !

!WAFormDecoration methodsFor: 'rendering' stamp: 'al 9/7/2006 17:09'!
renderButtonForSelector: aSymbol on: html

	html submitButton on: aSymbol of: self owner
! !

!WAFormDecoration methodsFor: 'rendering' stamp: 'al 9/7/2006 15:52'!
renderButtonsOn: html
	html div
		class: 'dialog-buttons';
		with: [
		self buttons do: [ :each |
			"Avoid duplicate cssId, if component used many times in the page"
			html  span
				class: 'dialog-button-' , each;
				with: [self renderButtonForSelector: each on: html ] ] ]! !

!WAFormDecoration methodsFor: 'rendering' stamp: 'al 9/7/2006 15:50'!
renderContentOn: html
	html form
		defaultAction: [ self defaultAction ];
		with: [
			self renderOwnerOn: html.
			self renderButtonsOn: html ]! !

WADecoration subclass: #WAMessageDecoration
	instanceVariableNames: 'message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WAMessageDecoration methodsFor: 'accessing' stamp: 'avi 3/12/2004 00:43'!
message: aString
	message := aString! !

!WAMessageDecoration methodsFor: 'rendering' stamp: 'avi 3/12/2004 00:49'!
renderContentOn: html
	html heading: message level: 3.
	self renderOwnerOn: html.! !

WADecoration subclass: #WASessionProtector
	instanceVariableNames: 'remoteAddress'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WASessionProtector methodsFor: 'testing' stamp: 'lr 8/31/2004 18:49'!
isGlobal
	^true! !

!WASessionProtector methodsFor: 'forwarding' stamp: 'lr 8/31/2004 19:36'!
processChildCallbacks: aStream
	(self verifyRequest: self session currentRequest)
		ifTrue: [ super processChildCallbacks: aStream ]
		ifFalse: [ self respondNotVerified ]! !

!WASessionProtector methodsFor: 'accessing' stamp: 'lr 8/31/2004 19:32'!
remoteAddressFromRequest: aRequest
	^aRequest 
		headerAt: 'x-forwarded-for'
		ifAbsent: [ aRequest nativeRequest remoteAddress ]! !

!WASessionProtector methodsFor: 'forwarding' stamp: 'lr 9/6/2006 11:16'!
renderContentOn: html
	(self verifyRequest: self session currentRequest)
		ifTrue: [ self renderOwnerOn: html ]
		ifFalse: [ self respondNotVerified ]! !

!WASessionProtector methodsFor: 'forwarding' stamp: 'lr 8/31/2004 19:37'!
respondNotVerified
	self session redirectTo: self session application basePath.! !

!WASessionProtector methodsFor: 'accessing' stamp: 'lr 8/31/2004 19:38'!
storedRemoteAddress
	remoteAddress isNil
		ifTrue: [ remoteAddress := self remoteAddressFromRequest: self session currentRequest ].
	^remoteAddress! !

!WASessionProtector methodsFor: 'testing' stamp: 'lr 8/31/2004 19:31'!
verifyRequest: aRequest
	^(self remoteAddressFromRequest: aRequest) = self storedRemoteAddress! !

WADecoration subclass: #WATransaction
	instanceVariableNames: 'active'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WATransaction methodsFor: 'open/close' stamp: 'ab 1/15/2003 21:55'!
close
	active := false! !

!WATransaction methodsFor: 'initialization' stamp: 'mb 4/23/2006 18:36'!
initialize
	super initialize.
	active := true! !

!WATransaction methodsFor: 'testing' stamp: 'avi 3/28/2004 20:51'!
isGlobal
	^ true! !

!WATransaction methodsFor: 'forwarding' stamp: 'avi 6/8/2004 00:56'!
processChildCallbacks: aStream
	^ active
		ifTrue: [super processChildCallbacks: aStream]
		ifFalse: [self session pageExpired].
	! !

!WATransaction methodsFor: 'rendering' stamp: 'avi 9/8/2004 12:18'!
renderContentOn: html
	active
		ifTrue: [ self renderOwnerOn: html ]
		ifFalse: [ self session pageExpired ]! !

WADecoration subclass: #WAValidationDecoration
	instanceVariableNames: 'message validationBlock exceptionClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WAValidationDecoration methodsFor: 'as yet unclassified' stamp: 'cds 6/3/2006 22:40'!
exceptionClass
	^exceptionClass ifNil: [exceptionClass := WAValidationNotification]! !

!WAValidationDecoration methodsFor: 'accessing' stamp: 'cds 7/25/2005 10:19'!
exceptionClass: aClass
	exceptionClass := aClass! !

!WAValidationDecoration methodsFor: 'call/answer' stamp: 'pmm 11/2/2005 23:04'!
handleAnswer: anObject
	^(super handleAnswer: anObject)
		or: [(self validate: anObject) not]! !

!WAValidationDecoration methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2004 11:03'!
handleAnswer: anObject continueWith: aBlock
	(self validate: anObject) ifTrue: [aBlock value]! !

!WAValidationDecoration methodsFor: 'initialization' stamp: 'mb 4/23/2006 18:37'!
initialize
	super initialize.
	message := WAStateHolder new! !

!WAValidationDecoration methodsFor: 'rendering' stamp: 'al 9/7/2006 17:18'!
renderContentOn: html
	message contents ifNotNilDo: [ :msg |
		html div
			class: 'validation-error';
			with: msg].
	self renderOwnerOn: html.! !

!WAValidationDecoration methodsFor: 'as yet unclassified' stamp: 'cds 6/3/2006 22:37'!
validate: anObject
	[validationBlock value: anObject.
	message contents: nil.
	^ true]
		on: self exceptionClass
		do: [:e | message contents: e messageText].
	^ false! !

!WAValidationDecoration methodsFor: 'convenience' stamp: 'avi 12/10/2003 12:49'!
validateWith: aBlock
	validationBlock := aBlock! !

WADecoration subclass: #WAWindowDecoration
	instanceVariableNames: 'title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WAWindowDecoration methodsFor: 'testing' stamp: 'avi 3/28/2004 20:52'!
isGlobal
	^ true! !

!WAWindowDecoration methodsFor: 'as yet unclassified' stamp: 'lr 9/6/2006 11:19'!
renderCloseButtonOn: html
	html anchor callback: [self component answer]; with: 'close'! !

!WAWindowDecoration methodsFor: 'rendering' stamp: 'lr 9/6/2006 11:19'!
renderContentOn: html
	html div class: 'window-titlebar'; with: [
		html span class: 'window-close'; with: [self renderCloseButtonOn: html].		
		html span class: 'window-title'; with: title.
	].
	html div class: 'window-content'; with: [self renderOwnerOn: html]! !

!WAWindowDecoration methodsFor: 'accessing' stamp: 'avi 3/28/2004 21:04'!
style
	^ '.window-titlebar {background-color: #aaaaaa; padding: 5px; margin-bottom: 5px}
	    .window-close {float: right}
	   .window-title {}
	    .window-content {clear: both}
	'! !

!WAWindowDecoration methodsFor: 'accessing' stamp: 'ab 6/15/2003 12:51'!
title: aString
	title := aString! !

!WAPresenter class methodsFor: 'instance creation' stamp: 'avi 4/13/2004 20:14'!
new
	^ self basicNew initialize! !

!WAPresenter methodsFor: 'convenience' stamp: 'dc 7/16/2006 16:41'!
application
	^ self session application! !

!WAPresenter methodsFor: 'rendering' stamp: 'avi 3/18/2005 22:36'!
classForSection: aSymbol
	^ (aSymbol copyFrom: 7 to: (aSymbol size - 1)) withFirstCharacterDownshifted ! !

!WAPresenter methodsFor: 'convenience' stamp: 'dc 11/5/2006 12:45'!
fieldsAt: key
	"Returns the string value associated to the key in the argument given to your webapplication. The argument can have been sent by a form or written at the end of the url (using ...?key=value construction). If key is not found, an error is sent."
	^ self session fieldsAt: key! !

!WAPresenter methodsFor: 'convenience' stamp: 'dc 11/5/2006 12:45'!
fieldsAt: key ifAbsent: aBlock
	"Returns the string value associated to the key in the argument given to your webapplication. The argument can have been sent by a form or written at the end of the url (using ...?key=value construction). If key is not found, aBlock is evaluated."
	^ self session fieldsAt: key ifAbsent: aBlock! !

!WAPresenter methodsFor: 'convenience' stamp: 'dc 11/5/2006 12:46'!
fieldsAt: key ifPresent: aBlock
	"Returns the string value associated to the key in the argument given to your webapplication. The argument can have been sent by a form or written at the end of the url (using ...?key=value construction). If the key is present, execute the block and give it the value as a parameter. Otherwise, answer nil."
	^ self session fieldsAt: key ifPresent: aBlock! !

!WAPresenter methodsFor: 'call/answer' stamp: 'pmm 11/2/2005 23:50'!
handleAnswer: anObject
	self subclassResponsibility ! !

!WAPresenter methodsFor: 'request processing' stamp: 'avi 11/7/2005 11:53'!
initialRequest: aRequest! !

!WAPresenter methodsFor: 'initialization' stamp: 'ab 2/13/2003 01:10'!
initialize! !

!WAPresenter methodsFor: 'decoration' stamp: 'avi 3/27/2004 19:55'!
isDecoration
	^ false! !

!WAPresenter methodsFor: 'tree' stamp: 'avi 6/8/2004 00:58'!
nextPresentersDo: aBlock
	self subclassResponsibility ! !

!WAPresenter methodsFor: 'convenience' stamp: 'dc 7/16/2006 16:48'!
preferenceAt: aSymbol
	^ self application preferenceAt: aSymbol! !

!WAPresenter methodsFor: 'convenience' stamp: 'dc 7/16/2006 16:53'!
preferenceAt: aSymbol put: anObject
	^ self application preferenceAt: aSymbol put: anObject! !

!WAPresenter methodsFor: 'request processing' stamp: 'avi 6/8/2004 02:00'!
processCallbackStream: aCallbackStream
	aCallbackStream processCallbacksWithOwner: self.
	self processChildCallbacks: aCallbackStream.
	aCallbackStream processCallbacksWithOwner: self.
! !

!WAPresenter methodsFor: 'request processing' stamp: 'avi 6/8/2004 00:54'!
processChildCallbacks: aStream
	self nextPresentersDo: [:ea | ea processCallbackStream: aStream]! !

!WAPresenter methodsFor: 'rendering' stamp: 'avi 3/27/2004 20:59'!
renderContentOn: aRenderer
	self nextPresentersDo: [:ea | ea renderWithContext: aRenderer context]! !

!WAPresenter methodsFor: 'rendering' stamp: 'avi 3/18/2005 22:11'!
renderWithContext: aRenderingContext
	| html callbacks |
	callbacks := aRenderingContext callbacksFor: self.
	html := (self rendererClass context: aRenderingContext callbacks: callbacks)
				painter: self.
	(self showHalo and: [aRenderingContext isDebugMode])
		ifTrue: [(WAHalo for: self) renderContentOn: html]
		ifFalse: [self renderContentOn: html].
	html close.! !

!WAPresenter methodsFor: 'rendering' stamp: 'lr 9/6/2006 11:12'!
rendererClass
	^ WARenderCanvas! !

!WAPresenter methodsFor: 'rendering' stamp: 'avi 6/21/2004 16:05'!
script
	^ nil! !

!WAPresenter methodsFor: 'convenience' stamp: 'avi 4/13/2004 19:48'!
session
	^ WACurrentSession value! !

!WAPresenter methodsFor: 'rendering' stamp: 'avi 3/27/2004 17:27'!
showHalo
	^ true! !

!WAPresenter methodsFor: 'rendering' stamp: 'avi 3/28/2004 20:57'!
style
	^ nil! !

!WAPresenter methodsFor: 'path' stamp: 'avi 6/21/2004 16:04'!
updateRoot: anHtmlRoot
	self script ifNotNilDo: [:script | anHtmlRoot addScript: script].
	self style ifNotNilDo: [:style | anHtmlRoot addStyle: style].
	
! !

!WAPresenter methodsFor: 'path' stamp: 'avi 3/22/2004 01:00'!
updateUrl: aUrl
! !

!WAPresenter methodsFor: 'tree' stamp: 'avi 3/27/2004 20:59'!
withNextPresentersDo: aBlock
	aBlock value: self.
	self nextPresentersDo: [:ea | ea withNextPresentersDo: aBlock]! !

Object subclass: #WAProcessMonitor
	instanceVariableNames: 'mutex process responseSem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Utilities'!

!WAProcessMonitor class methodsFor: 'instance creation' stamp: 'pmm 4/18/2006 20:17'!
new
	^ self basicNew initialize! !

!WAProcessMonitor methodsFor: 'mutual exclusion' stamp: 'avi 1/16/2005 00:38'!
critical: aBlock ifError: errorBlock
	|value|
	mutex critical:
		[responseSem := Semaphore new.
		process := [[value := aBlock on: Error do: errorBlock]
			ensure: [responseSem signal]] fork.
		responseSem wait].
	process := nil.
	^ value! !

!WAProcessMonitor methodsFor: 'initialization' stamp: 'mb 4/23/2006 21:39'!
initialize
	mutex := Semaphore forMutualExclusion! !

!WAProcessMonitor methodsFor: 'controlling' stamp: 'avi 1/16/2005 00:38'!
terminate
	process ifNotNil: [process terminate]! !

Object subclass: #WARadioGroup
	instanceVariableNames: 'canvas key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WARadioGroup class methodsFor: 'accessing' stamp: 'ac 7/6/2005 11:30'!
canvas: aRenderCanvas
	^ self basicNew initializeWithCanvas: aRenderCanvas! !

!WARadioGroup methodsFor: 'initialize-release' stamp: 'ac 7/6/2005 11:31'!
initializeWithCanvas: aRenderCanvas
	canvas := aRenderCanvas.
	key := aRenderCanvas callbacks registerDispatchCallback.! !

!WARadioGroup methodsFor: 'accessing' stamp: 'ac 7/6/2005 11:32'!
key
	^ key! !

!WARadioGroup methodsFor: 'public api' stamp: 'ac 7/6/2005 11:31'!
radioButton
	^ canvas radioButton group: self! !

Object subclass: #WAReadWriteLock
	instanceVariableNames: 'sem mutex readers'
	classVariableNames: 'Global'
	poolDictionaries: ''
	category: 'Seaside-Utilities-Squeak'!

!WAReadWriteLock class methodsFor: 'instance creation' stamp: 'avi 11/3/2005 00:38'!
global
	^ Global ifNil: [Global := self new]! !

!WAReadWriteLock class methodsFor: 'instance creation' stamp: 'lr 5/3/2006 09:30'!
new
	^ self basicNew initialize! !

!WAReadWriteLock methodsFor: 'initialization' stamp: 'avi 11/3/2005 00:37'!
initialize
	sem := Semaphore forMutualExclusion.
	mutex := Semaphore forMutualExclusion.
	readers := 0! !

!WAReadWriteLock methodsFor: 'as yet unclassified' stamp: 'avi 11/3/2005 00:33'!
lockForReading
	mutex critical:
		[readers = 0 ifTrue: [sem wait].
		readers := readers + 1]! !

!WAReadWriteLock methodsFor: 'as yet unclassified' stamp: 'avi 11/3/2005 00:34'!
lockForWriting
	sem wait! !

!WAReadWriteLock methodsFor: 'as yet unclassified' stamp: 'avi 11/3/2005 00:35'!
read: aBlock
	self lockForReading.
	^ aBlock ensure: [self unlockForReading]! !

!WAReadWriteLock methodsFor: 'accessing' stamp: 'avi 11/3/2005 00:39'!
readers
	^ readers! !

!WAReadWriteLock methodsFor: 'as yet unclassified' stamp: 'avi 11/3/2005 00:33'!
unlockForReading
	mutex critical:
		[readers := readers - 1.
		readers = 0 ifTrue: [sem signal]]! !

!WAReadWriteLock methodsFor: 'as yet unclassified' stamp: 'avi 11/3/2005 00:34'!
unlockForWriting
	sem signal! !

!WAReadWriteLock methodsFor: 'filter streaming' stamp: 'avi 11/3/2005 00:35'!
write: aBlock
	self lockForWriting.
	^ aBlock ensure: [self unlockForWriting]! !

Object subclass: #WARender
	instanceVariableNames: 'root context request url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RenderLoop'!

!WARender methodsFor: 'convenience' stamp: 'avi 11/27/2005 17:29'!
application
	^ self session application! !

!WARender methodsFor: 'rendering' stamp: 'pmm 9/12/2006 18:38'!
buildDocRoot
	| docRoot |
	docRoot := WARenderedHtmlRoot context: context.
	docRoot resourceBaseUrl: self application resourceBaseUrl.
	docRoot bodyAttributes at: 'onLoad' put: 'onLoad()'.
  	self session updateRoot: docRoot.
	root visiblePresentersDo: [:each | each updateRoot: docRoot].
	^ docRoot! !

!WARender methodsFor: 'rendering' stamp: 'mb 8/18/2006 10:28'!
buildResponse
	| response document |
	self updateUrl: url.
	context actionUrl: url. 
	response := self newResponse.
	response headerAt: 'Cache-Control' put: 'No-cache'.
	document := self session outputDocumentClass root: self buildDocRoot.
	document stream: response stream.
	context document: document.
	root decorationChainDo: [:ea | ea renderWithContext: context].		
	self writeOnLoadOn: document.
	document close.
	^ response! !

!WARender methodsFor: 'rendering' stamp: 'avi 11/27/2005 17:31'!
go
	self withPageExpiredHandler:
		[self withRenderNowHandler: [self render].
		self shouldRedirect ifTrue: [self redirect]]! !

!WARender methodsFor: 'rendering' stamp: 'avi 1/6/2006 14:02'!
newResponse
	| s |
	s := self session currentRequest ifNotNilDo: [:r | r responseStream].
	^ s
		ifNil: [WAResponse new]
		ifNotNil: [WAStreamResponse new stream: s]! !

!WARender methodsFor: 'rendering' stamp: 'avi 11/27/2005 17:48'!
processCallbacks
	| lastPosition callbackStream |
	callbackStream := context callbackStreamForRequest: request.
	lastPosition := nil.
	[callbackStream position = lastPosition] whileFalse:
		[lastPosition := callbackStream position.
		root decorationChainDo: [:ea | ea processCallbackStream: callbackStream]].
	callbackStream atEnd
		ifTrue: [WARenderNotification raiseSignal]
		ifFalse: [self unprocessedCallbacks: callbackStream upToEnd].! !

!WARender methodsFor: 'rendering' stamp: 'avi 11/27/2005 17:37'!
redirect	
	self session respond:
		[:u |
		self updateUrl: u.
		WAResponse redirectTo: u displayString]! !

!WARender methodsFor: 'rendering' stamp: 'avi 11/27/2005 17:34'!
render
	self session clearJumpTo.
	context := WARenderingContext new request: self session currentRequest.
	request := self session respond: [:u | url := u.  self buildResponse].
	self processCallbacks! !

!WARender methodsFor: 'accessing' stamp: 'avi 11/27/2005 17:30'!
root: aComponent
	root := aComponent! !

!WARender methodsFor: 'convenience' stamp: 'avi 11/27/2005 17:29'!
session
	^ WACurrentSession value! !

!WARender methodsFor: 'rendering' stamp: 'avi 11/27/2005 17:38'!
shouldRedirect
	^ request isGet not or: [(request fields includesKey: '_n') not]! !

!WARender methodsFor: 'rendering' stamp: 'avi 11/27/2005 17:29'!
unprocessedCallbacks: aCollection
	| owners |
	owners := (aCollection collect: [:ea | ea owner]) asSet asArray.
	self error: 'Components not found while processing callbacks: ', owners displayString! !

!WARender methodsFor: 'rendering' stamp: 'avi 11/27/2005 17:29'!
updateUrl: aUrl
	root visiblePresentersDo: [:c | c updateUrl: aUrl]! !

!WARender methodsFor: 'rendering' stamp: 'avi 11/27/2005 17:29'!
withPageExpiredHandler: aBlock
	^ aBlock on: WAPageExpired do: [:n |]! !

!WARender methodsFor: 'rendering' stamp: 'avi 11/27/2005 17:29'!
withRenderNowHandler: aBlock
	^ aBlock on: WARenderNotification do: [:n | n]! !

!WARender methodsFor: 'rendering' stamp: 'lr 11/21/2006 20:42'!
writeOnLoadOn: anHtmlDocument
	| attributes |
	attributes := WAHtmlAttributes new.
	attributes at: 'type' put: 'text/javascript'.
	anHtmlDocument openTag: 'script' attributes: attributes.
	anHtmlDocument text: '/*<!![CDATA[*/function onLoad(){'.
	self session onLoadScripts
		do: [ :each | anHtmlDocument text: each ]
		separatedBy: [ anHtmlDocument text: ';' ].
	anHtmlDocument text: '}/*]]>*/'.
	anHtmlDocument closeTag: 'script'.
	self session clearLoadScripts! !

Object subclass: #WARenderLoop
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RenderLoop'!

!WARenderLoop methodsFor: 'convenience' stamp: 'avi 2/5/2004 12:39'!
application
	^ self session application! !

!WARenderLoop methodsFor: 'as yet unclassified' stamp: 'avi 5/8/2004 13:58'!
basicRoot: aComponent
	root := aComponent! !

!WARenderLoop methodsFor: 'call' stamp: 'avi 5/8/2004 14:00'!
call: aComponent
	^ self call: aComponent withToolFrame: true! !

!WARenderLoop methodsFor: 'call' stamp: 'avi 5/8/2004 13:59'!
call: aComponent withToolFrame: aBoolean
	aBoolean ifTrue: [self root: aComponent] ifFalse: [self basicRoot: aComponent].
	aComponent onAnswer: [:v | ^ v].
	self run! !

!WARenderLoop methodsFor: 'accessing' stamp: 'pmm 9/12/2006 18:38'!
root: aComponent
	self basicRoot: (self application deploymentMode
		ifFalse: [ WAToolFrame on: aComponent ]
		ifTrue: [ aComponent ])! !

!WARenderLoop methodsFor: 'rendering' stamp: 'avi 11/27/2005 17:37'!
run
	[(WARender new root: root) go] repeat! !

!WARenderLoop methodsFor: 'convenience' stamp: 'avi 4/13/2004 20:28'!
session
	^ WACurrentSession value! !

Object subclass: #WARenderingContext
	instanceVariableNames: 'actionUrl count callbacks document mode request response properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WARenderingContext class methodsFor: 'instance creation' stamp: 'avi 3/25/2004 02:21'!
new
	^ self basicNew initialize! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
actionUrl
	"Answer the value of actionUrl"

	^ actionUrl! !

!WARenderingContext methodsFor: 'accessing' stamp: 'avi 11/7/2005 13:13'!
actionUrl: anObject
	actionUrl := anObject! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'avi 6/8/2004 00:42'!
advanceKey
	| key |
	key := self nextKey.
	self increaseKey.
	^ key! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'lr 4/19/2006 08:05'!
callbackAt: aString
	^ callbacks at: aString ifAbsent: [ ]! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'avi 6/8/2004 02:01'!
callbackStreamForRequest: aRequest
	^ WACallbackStream callbacks: callbacks request: aRequest! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'avi 6/7/2004 22:17'!
callbacksFor: anObject
	^ WACallbackRegistry context: self owner: anObject! !

!WARenderingContext methodsFor: 'modes' stamp: 'avi 3/13/2004 22:19'!
clearMode
	mode := nil! !

!WARenderingContext methodsFor: 'accessing' stamp: 'lr 3/27/2006 10:42'!
count
	^ count! !

!WARenderingContext methodsFor: 'accessing' stamp: 'lr 3/27/2006 10:42'!
count: anInteger
	count := anInteger! !

!WARenderingContext methodsFor: 'modes' stamp: 'avi 3/13/2004 22:19'!
debugMode
	mode := #debug! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
document
	"Answer the value of document"

	^ document! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
document: anObject
	"Set the value of document"

	document := anObject! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'mb 11/27/2005 19:22'!
increaseKey
	count contents: count contents + 1! !

!WARenderingContext methodsFor: 'initialize-release' stamp: 'mb 11/27/2005 19:22'!
initialize
	count := ValueHolder new contents: 1.
	callbacks := Dictionary new
! !

!WARenderingContext methodsFor: 'modes' stamp: 'avi 3/13/2004 22:20'!
isDebugMode
	^ mode = #debug! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'mb 3/9/2006 18:07'!
nextKey
	"See discussion on VWNC
	Some VW users have overriden #displayString to answer a Text object.
	#asString works fine here since the count held by the ValueHolder is a Number"
	^ count contents asString
! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ac 2/18/2006 17:33'!
properties
	^ properties ifNil: [properties := Dictionary new]! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ac 2/18/2006 17:33'!
propertyAt: key ifAbsent: aBlock
	^ self properties at: key ifAbsent: aBlock! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ac 2/18/2006 17:33'!
propertyAt: key put: value
	^ self properties at: key put: value! !

!WARenderingContext methodsFor: 'documents' stamp: 'avi 5/22/2004 18:52'!
registry
	^ WACurrentSession value application! !

!WARenderingContext methodsFor: 'accessing' stamp: 'avi 4/13/2004 21:43'!
request
	^ request! !

!WARenderingContext methodsFor: 'accessing' stamp: 'avi 4/13/2004 21:43'!
request: aRequest
	request := aRequest! !

!WARenderingContext methodsFor: 'accessing' stamp: 'avi 5/18/2004 14:00'!
response
	^ response! !

!WARenderingContext methodsFor: 'accessing' stamp: 'avi 5/18/2004 14:00'!
response: aResponse
	response := aResponse! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'avi 9/2/2004 14:46'!
storeCallback: aCallback	
	| key |
	key := self advanceKey.
	callbacks at: (aCallback convertKey: key) put: aCallback.
	^ key! !

!WARenderingContext methodsFor: 'documents' stamp: 'avi 5/22/2004 18:04'!
urlForDocument: anObject
	^ self urlForDocument: anObject mimeType: nil
! !

!WARenderingContext methodsFor: 'documents' stamp: 'avi 5/22/2004 18:02'!
urlForDocument: anObject mimeType: mimeString
	^ self urlForDocument: anObject mimeType: mimeString fileName: nil! !

!WARenderingContext methodsFor: 'documents' stamp: 'mbany 4/14/2005 12:14'!
urlForDocument: anObject mimeType: mimeType fileName: fileName
	^ (self registry urlForRequestHandler:
		(WADocumentHandler
			document: anObject
			mimeType: mimeType
			fileName: fileName)) displayString! !

Object subclass: #WAReportColumn
	instanceVariableNames: 'clickBlock formatBlock hasTotal title sortBlock valueBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WAReportColumn class methodsFor: 'instance creation' stamp: 'pmm 4/18/2006 20:17'!
new
	^ self basicNew initialize! !

!WAReportColumn class methodsFor: 'instance creation' stamp: 'mb 5/30/2006 12:13'!
renderBlock: aBlock title: aString
	^ self new
		title: aString;
		valueBlock: aBlock;
		yourself! !

!WAReportColumn class methodsFor: 'instance creation' stamp: 'ab 10/26/2002 22:26'!
selector: aSymbol
	^ self selector: aSymbol title: aSymbol capitalized! !

!WAReportColumn class methodsFor: 'instance creation' stamp: 'ab 10/26/2002 22:26'!
selector: aSymbol title: aString
	^ self selector: aSymbol title: aString onClick: nil! !

!WAReportColumn class methodsFor: 'instance creation' stamp: 'pmm 4/19/2006 17:42'!
selector: aSymbol title: aString onClick: aBlock
	^ self new
		title: aString;
		selector: aSymbol;
		clickBlock: aBlock;
		yourself! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/27/2002 00:05'!
canChoose
	^ clickBlock notNil! !

!WAReportColumn methodsFor: 'rendering' stamp: 'mb 5/30/2006 11:49'!
canRender
	^valueBlock numArgs > 1! !

!WAReportColumn methodsFor: 'public' stamp: 'mb 5/30/2006 12:08'!
canSort
	^self canRender not and: [sortBlock notNil].! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 1/16/2003 16:06'!
chooseRow: row
	^ clickBlock value: row! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/28/2002 14:02'!
clickBlock: aBlock
	clickBlock := aBlock! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 11/12/2002 14:03'!
columnClickBlock: aBlock
	self clickBlock: [:r | aBlock value: (self valueForRow: r)]! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
formatBlock: anObject
	formatBlock := anObject! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 11/12/2002 14:29'!
hasTotal: aBoolean
	hasTotal := aBoolean ! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:52'!
index: aNumber
	valueBlock := [:row | row at: aNumber]! !

!WAReportColumn methodsFor: 'initialize-release' stamp: 'mbany 4/14/2005 12:15'!
initialize
	formatBlock := [:x | x displayString].
	sortBlock := [:a :b | a <= b].
	valueBlock := [:row | nil].
	clickBlock := nil.
	title := 'Untitled'.
	hasTotal := false.! !

!WAReportColumn methodsFor: 'rendering' stamp: 'mb 5/30/2006 11:47'!
renderValue: anObject on: html
	valueBlock value: anObject value: html! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:52'!
selector: aSymbol
	valueBlock := [:row | row perform: aSymbol]! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
sortBlock: anObject
	sortBlock := anObject! !

!WAReportColumn methodsFor: 'public' stamp: 'avi 9/18/2003 16:43'!
sortRows: anArray
	|assocs|
	assocs := anArray collect: [:ea | ea -> (self valueForRow: ea)].
	assocs := assocs asSortedCollection: [:a :b | sortBlock value: a value value: b value].
	^ assocs collect: [:ea | ea key]! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/26/2002 21:51'!
textForRow: row
	^ formatBlock value: (self valueForRow: row)! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/26/2002 21:50'!
title
	^title! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
title: aString
	title := aString! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 11/12/2002 14:31'!
totalForRows: aCollection
	^ hasTotal
		ifFalse: ['']
		ifTrue: [formatBlock value: (aCollection detectSum: [:r | self valueForRow: r])]! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
valueBlock: aBlock
	valueBlock := aBlock! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/26/2002 21:51'!
valueForRow: row
	^ valueBlock value: row! !

Object subclass: #WARequest
	instanceVariableNames: 'url fields headers cookies method nativeRequest responseStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-HTTP'!

!WARequest class methodsFor: 'as yet unclassified' stamp: 'avi 8/29/2005 21:19'!
blankRequest
	^ self
			method: 'GET'
			url: ''
			headers: Dictionary new
			fields: Dictionary new
			cookies: Dictionary new! !

!WARequest class methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 19:34'!
method: methodString url: urlString headers: headDict fields: fieldDict cookies: cookieDict
	^ self new setMethod: methodString url: urlString headers: headDict fields: fieldDict cookies: cookieDict! !

!WARequest class methodsFor: 'as yet unclassified' stamp: 'avi 4/28/2004 10:57'!
method: methodString url: urlString headers: headDict fields: fieldDict cookies: cookieDict nativeRequest: anObject
	^ (self method: methodString url: urlString headers: headDict fields: fieldDict cookies: cookieDict)
		nativeRequest: anObject;
		yourself! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 10/12/2006 06:26'!
accept
	^ self headerAt: 'accept'! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 10/12/2006 06:28'!
acceptCharset
	^ self headerAt: 'accept-charset'! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 10/12/2006 06:27'!
acceptEncoding
	^ self headerAt: 'accept-encoding'! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 10/12/2006 06:27'!
acceptLanguage
	^ self headerAt: 'accept-language'! !

!WARequest methodsFor: 'accessing' stamp: 'ab 7/3/2002 13:37'!
at: key
	^ fields at: key! !

!WARequest methodsFor: 'accessing' stamp: 'JF 5/16/2003 09:40'!
at: key ifAbsent: aBlock
	^ fields at: key ifAbsent: aBlock! !

!WARequest methodsFor: 'accessing' stamp: 'ac 11/12/2005 00:46'!
at: key ifPresent: aBlock
	^ fields at: key ifPresent: aBlock! !

!WARequest methodsFor: 'private' stamp: 'ab 1/13/2003 22:40'!
authorization
	^ (self headerAt: 'Authorization' ifAbsent: [self headerAt: 'authorization'])
		ifNotNilDo: [:auth | self decodeAuthorization: auth]! !

!WARequest methodsFor: 'accessing' stamp: 'avi 1/6/2006 13:15'!
cookies
	^ cookies ifNil: [cookies := Dictionary new]! !

!WARequest methodsFor: 'private' stamp: 'avi 9/21/2003 18:28'!
decodeAuthorization: aString
	^ SeasidePlatformSupport base64Decode: (aString findTokens: ' ') last! !

!WARequest methodsFor: 'accessing' stamp: 'ab 7/3/2002 12:51'!
fields
	^ fields! !

!WARequest methodsFor: 'accessing' stamp: 'JF 11/18/2002 16:18'!
headerAt: aKey
	^ self headerAt: aKey ifAbsent: []! !

!WARequest methodsFor: 'accessing' stamp: 'JF 11/18/2002 16:18'!
headerAt: aKey ifAbsent: aBlock
	^ headers at: aKey ifAbsent: aBlock! !

!WARequest methodsFor: 'accessing' stamp: 'JF 11/18/2002 16:16'!
headers
	^ headers! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 10/29/2006 07:28'!
host
	^ self headerAt: 'host'! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 10/29/2006 07:28'!
hostIfAbsent: aBlock 
	^ self headerAt: 'host' ifAbsent: [ aBlock value ]! !

!WARequest methodsFor: 'testing' stamp: 'mb 3/31/2006 09:41'!
includesKey: key
	^ fields includesKey: key! !

!WARequest methodsFor: 'testing' stamp: 'pmm 9/12/2006 18:42'!
isFromIE
	"this is extremely unreliable"
	| tokens |
	tokens := (headers at: 'user-agent') findTokens: ' '.
	^(tokens includes: 'MSIE') and: [ (tokens includes: 'Opera') not ]! !

!WARequest methodsFor: 'testing' stamp: 'avi 3/22/2004 12:58'!
isGet
	^ self method asUppercase = 'GET'! !

!WARequest methodsFor: 'testing' stamp: 'avi 5/9/2005 13:13'!
isPrefetch
	^ (self headerAt: 'HTTP_X_MOZ') = 'prefetch'! !

!WARequest methodsFor: 'testing' stamp: 'lr 7/3/2006 09:25'!
isXmlHttpRequest
	^ (self headerAt: 'x-requested-with') = 'XMLHttpRequest'! !

!WARequest methodsFor: 'accessing' stamp: 'ab 8/26/2003 19:33'!
method
	^ method! !

!WARequest methodsFor: 'accessing' stamp: 'avi 4/28/2004 13:43'!
nativeRequest
	^ nativeRequest! !

!WARequest methodsFor: 'accessing' stamp: 'avi 4/28/2004 13:43'!
nativeRequest: aRequest
	nativeRequest := aRequest! !

!WARequest methodsFor: 'accessing' stamp: 'ab 12/30/2002 17:42'!
password
	^ self authorization ifNotNilDo: [:auth | auth copyAfter: $:]! !

!WARequest methodsFor: 'accessing-headers' stamp: 'ac 6/17/2006 16:28'!
referer
	^ self headerAt: 'referer'! !

!WARequest methodsFor: 'accessing' stamp: 'avi 1/6/2006 13:23'!
responseStream
	^ responseStream! !

!WARequest methodsFor: 'accessing' stamp: 'avi 1/6/2006 13:23'!
responseStream: aStream
	responseStream := aStream! !

!WARequest methodsFor: 'private' stamp: 'avi 3/19/2004 13:52'!
setMethod: methodString url: urlString headers: headDict fields: fieldDict cookies: cookieDict
	method := methodString.
	url := urlString.
	headers := headDict.
	fields := fieldDict.
	cookies := cookieDict! !

!WARequest methodsFor: 'accessing' stamp: 'ab 5/26/2003 00:54'!
url
	^ url! !

!WARequest methodsFor: 'accessing' stamp: 'ab 12/30/2002 17:42'!
user
	^ self authorization ifNotNilDo: [:auth | auth copyUpTo: $:]! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 10/12/2006 06:26'!
userAgent
	^ self headerAt: 'user-agent'! !

Object subclass: #WARequestHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RequestHandler'!

WARequestHandler subclass: #WADocumentHandler
	instanceVariableNames: 'document mimeDocument mimeType fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RequestHandler'!

!WADocumentHandler class methodsFor: 'public api' stamp: 'avi 11/3/2003 12:23'!
document: anObject mimeType: mimeString fileName: fileString
	^ self basicNew initializeWithDocument: anObject mimeType: mimeString fileName: fileString! !

!WADocumentHandler methodsFor: 'comparing' stamp: 'lr 3/27/2006 09:01'!
= other
	^ other species = self species
		and: [other document = self document
		and: [other mimeType = self mimeType]]! !

!WADocumentHandler methodsFor: 'accessing' stamp: 'ab 2/12/2003 13:41'!
document
	^ document! !

!WADocumentHandler methodsFor: 'actions' stamp: 'ab 8/17/2003 12:43'!
handleRequest: aRequest
	^ self response! !

!WADocumentHandler methodsFor: 'comparing' stamp: 'ab 8/17/2003 12:42'!
hash
	^ self document hash bitXor: self mimeType hash! !

!WADocumentHandler methodsFor: 'initialization' stamp: 'avi 4/14/2004 23:52'!
initializeWithDocument: anObject mimeType: mimeString fileName: fileString
	document := anObject.
	mimeType := mimeString.
	fileName := fileString.! !

!WADocumentHandler methodsFor: 'accessing' stamp: 'mb 6/1/2006 09:05'!
mimeDocument
	^ mimeDocument ifNil: [mimeDocument := document asMIMEDocumentType: mimeType ]! !

!WADocumentHandler methodsFor: 'accessing' stamp: 'ab 8/24/2003 18:48'!
mimeType
	^ mimeType! !

!WADocumentHandler methodsFor: 'accessing' stamp: 'lr 5/17/2005 08:38'!
response
	| response |
	response := WAResponse new.
	response contents: self mimeDocument contentStream text.
	response contentType: (mimeType ifNil: [self mimeDocument contentType]).
	response headerAt: 'Expires' put: 'Thu, 01 Jan 2095 12:00:00 GMT'.
	fileName ifNotNil: 
		[response headerAt: 'Content-Disposition' put: 'attachment; filename="' , fileName , '"'].
	^ response! !

WARequestHandler subclass: #WAEntryPoint
	instanceVariableNames: 'basePath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RequestHandler'!

WAEntryPoint subclass: #WADispatcher
	instanceVariableNames: 'entryPoints default'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RequestHandler'!

WADispatcher class
	instanceVariableNames: 'default'!

WADispatcher class
	instanceVariableNames: 'default'!

!WADispatcher class methodsFor: 'accessing' stamp: 'JF 9/15/2003 14:40'!
default
	default ifNil: [default := self new].
	default basePath ifNil: [default basePath: '/seaside'].
	
	^ default! !

!WADispatcher class methodsFor: 'accessing' stamp: 'lr 11/16/2006 18:39'!
description
	^ 'Directory'! !

!WADispatcher methodsFor: 'public' stamp: 'avi 7/5/2004 11:44'!
basePath: newPath
	| base |
	basePath := newPath.
	base := (newPath isEmpty or: [newPath last ~= $/])
				ifTrue: [newPath, '/']
				ifFalse: [newPath].
	entryPoints keysAndValuesDo: [:key :component | component basePath: base, key]! !

!WADispatcher methodsFor: 'public' stamp: 'ab 8/26/2003 21:53'!
configurationComponent
	^ WADispatcherEditor new dispatcher: self! !

!WADispatcher methodsFor: 'public' stamp: 'avi 11/12/2005 12:25'!
defaultPath
	^ default! !

!WADispatcher methodsFor: 'public' stamp: 'avi 11/12/2005 12:25'!
defaultPath: aString
	default := aString! !

!WADispatcher methodsFor: 'public' stamp: 'pmm 9/12/2006 18:20'!
entryPointAt: aString
	"WADispatcher default entryPointAt: 'examples/store'"
	^(aString findTokens: '/') inject: self into: [ :dispatcher :token |
		dispatcher entryPoints at: token ]! !

!WADispatcher methodsFor: 'public' stamp: 'ab 8/26/2003 21:35'!
entryPoints
	^ entryPoints! !

!WADispatcher methodsFor: 'public' stamp: 'pmm 9/12/2006 18:16'!
genuineEntryPoints
	"In case some of our entry points
	are non-standard RequestHandler objects"
	^self entryPoints select: [ :each | each isEntryPoint ]
! !

!WADispatcher methodsFor: 'public' stamp: 'avi 5/9/2005 13:15'!
handleRequest: aRequest
	aRequest isPrefetch ifTrue: [^ WAResponse forbidden: aRequest url].
	^ (self handlerForRequest: aRequest) handleRequest: aRequest! !

!WADispatcher methodsFor: 'private' stamp: 'mb 2/17/2005 17:55'!
handlerForRequest: aRequest
	^ self handlerForRequest: aRequest relativeTo: basePath! !

!WADispatcher methodsFor: 'private' stamp: 'lr 3/27/2006 12:17'!
handlerForRequest: aRequest relativeTo: base
	| path name relativePath |
	path := aRequest url.
	(base isEmpty or: [path beginsWith: base]) ifTrue:
		[relativePath := path allButFirst: base size.
		(relativePath notEmpty and: [relativePath first = $/]) ifTrue:
			[name := (relativePath findTokens: '/') at: 1 ifAbsent: [default].
              ^ entryPoints at: name ifAbsent: [
				entryPoints at: default ifAbsent: [
					WANotFoundHandler new ] ] ] ].
       ^ WANotFoundHandler new! !

!WADispatcher methodsFor: 'private' stamp: 'mb 4/23/2006 15:17'!
initialize
	super initialize.
	entryPoints := Dictionary new! !

!WADispatcher methodsFor: 'testing' stamp: 'pmm 9/12/2006 18:15'!
isDeployed
	"self assert: WADispatcher default isDeployed"
	^self entryPoints anySatisfy: [ :each | each isDeployed ]! !

!WADispatcher methodsFor: 'testing' stamp: 'mb 5/26/2006 08:51'!
isDispatcher
	^ true! !

!WADispatcher methodsFor: 'testing' stamp: 'mb 4/5/2006 20:55'!
isRoot
	^self == self class default.! !

!WADispatcher methodsFor: 'public' stamp: 'mb 6/14/2006 15:10'!
registerEntryPoint: entryPoint at: aString
	| path |
	entryPoints at: aString displayString put: entryPoint.
	path := (basePath isEmpty or: [basePath last ~= $/])
		ifTrue: [basePath, '/', aString]
		ifFalse: [basePath, aString].
	entryPoint basePath: path.
	^ entryPoint
! !

!WADispatcher methodsFor: 'public' stamp: 'pmm 9/12/2006 18:18'!
registerEntryPoint: aDispatcherOrApplication path: pathString
	| tokens dispatcher dispatcherEntryPoints  |
	tokens := pathString findTokens: '/'.
	dispatcher := self.
	tokens allButLast do: [ :each |
		dispatcherEntryPoints := dispatcher entryPoints.
		dispatcher := dispatcherEntryPoints
			at: each
			ifAbsent: [ dispatcher registerEntryPoint: WADispatcher new at: each ] ].	
	dispatcher registerEntryPoint: aDispatcherOrApplication at: tokens last.
	^ aDispatcherOrApplication! !

!WADispatcher methodsFor: 'public' stamp: 'dc 7/15/2006 13:33'!
removeEntryPoint: entryPoint
	entryPoints removeKey: (entryPoints keyAtValue: entryPoint).
	entryPoint unregistered! !

!WADispatcher methodsFor: 'public' stamp: 'dc 7/15/2006 13:32'!
removeEntryPointAt: aString
	| entryPoint |
	entryPoint := self entryPointAt: aString.
	self removeEntryPoint: entryPoint.! !

!WADispatcher methodsFor: 'public' stamp: 'pmm 9/30/2006 18:15'!
trimForDeployment
	"WADispatcher default trimForDeployment"

	(self entryPoints reject: [ :each | each isDeployed ])
		do: [ :each | self removeEntryPoint: each ].

	(self entryPoints select: [:ep | ep isDispatcher])
		do: [ :each | each trimForDeployment ]! !

!WAEntryPoint class methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:51'!
concreteSubclasses
	^ self allSubclasses reject: [:ea | ea isAbstract]! !

!WAEntryPoint class methodsFor: 'accessing' stamp: 'ab 8/27/2003 00:14'!
description
	^ nil! !

!WAEntryPoint class methodsFor: 'testing' stamp: 'ab 8/27/2003 00:14'!
isAbstract
	^ self description isNil! !

!WAEntryPoint methodsFor: 'accessing' stamp: 'ab 8/26/2003 21:08'!
basePath
	^ basePath! !

!WAEntryPoint methodsFor: 'accessing' stamp: 'ab 8/26/2003 21:08'!
basePath: aString
	basePath := aString! !

!WAEntryPoint methodsFor: 'public' stamp: 'avi 3/22/2004 00:48'!
baseUrl
	^ WAUrl new
		addToPath: basePath;
		yourself! !

!WAEntryPoint methodsFor: 'public' stamp: 'ab 8/26/2003 21:48'!
configurationComponent
	^ nil! !

!WAEntryPoint methodsFor: 'testing' stamp: 'mb 5/26/2006 08:50'!
isEntryPoint
	^ true! !

!WAEntryPoint methodsFor: 'printing' stamp: 'JF 9/22/2003 20:06'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: '(', self basePath, ')'! !

WAEntryPoint subclass: #WAFileHandler
	instanceVariableNames: 'libraries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RequestHandler'!

!WAFileHandler class methodsFor: 'accessing' stamp: 'lr 11/16/2006 18:39'!
description
	^ 'File Library'! !

!WAFileHandler class methodsFor: 'class initialization' stamp: 'pmm 5/26/2006 11:54'!
initialize
	self registerAsHandler: 'files'! !

!WAFileHandler class methodsFor: 'testing' stamp: 'pmm 4/18/2006 21:15'!
isAbstract
	^ false! !

!WAFileHandler class methodsFor: 'class initialization' stamp: 'pmm 5/26/2006 11:54'!
registerAsHandler: aString
	| handler |
	handler := self new basePath: aString.
	WADispatcher default registerEntryPoint: handler at: aString.
	^ handler! !

!WAFileHandler methodsFor: 'adding' stamp: 'pmm 10/28/2006 22:43'!
addLibrary: aFileLibrary
	"aFileLibrary is an instance of a subclass of WAFileLibrary, not a class"
	^self libraries add: aFileLibrary! !

!WAFileHandler methodsFor: 'accessing' stamp: 'pmm 4/18/2006 21:58'!
configurationComponent
	^ WAFileHandlerEditor new
		fileHandler: self;
		yourself! !

!WAFileHandler methodsFor: 'processing' stamp: 'pmm 10/6/2006 10:34'!
handleRequest: aRequest
	
	^self
		responseAt: (aRequest url findTokens: $/)
		ifAbsent: [ self notFound: aRequest url ]
		! !

!WAFileHandler methodsFor: 'initialize-release' stamp: 'pmm 4/20/2006 20:57'!
initialize
	super initialize.
	self libraries: OrderedCollection new! !

!WAFileHandler methodsFor: 'testing' stamp: 'mb 10/17/2006 11:24'!
isDeployed
	^true! !

!WAFileHandler methodsFor: 'accessing' stamp: 'pmm 4/20/2006 20:56'!
libraries
	^libraries! !

!WAFileHandler methodsFor: 'accessing' stamp: 'pmm 4/20/2006 20:56'!
libraries: aCollection 
	libraries := aCollection! !

!WAFileHandler methodsFor: 'accessing' stamp: 'mb 10/17/2006 13:11'!
libraryAt: aString ifAbsent: aBlock
	^self libraries
		detect: [ :each | each name == aString asSymbol ]
		ifNone: aBlock! !

!WAFileHandler methodsFor: 'private' stamp: 'pmm 4/13/2006 23:07'!
notFound: aString
	^WAResponse notFound: aString! !

!WAFileHandler methodsFor: 'private' stamp: 'pmm 10/6/2006 10:34'!
responseAt: aPath ifAbsent: aBlock
	| libraryName fileName library |
	libraryName := aPath at: aPath size - 1. "second last"
	fileName := aPath last.
	
	library := self
		libraryAt: libraryName
		ifAbsent: [ ^aBlock value ].
		
	^library
			documentAt: fileName
			ifAbsent: [ aBlock value ]! !

WAEntryPoint subclass: #WARegistry
	instanceVariableNames: 'keysByHandler handlersByKey mutex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RequestHandler'!

WARegistry subclass: #WAApplication
	instanceVariableNames: 'configuration libraries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WAApplication class methodsFor: 'accessing' stamp: 'lr 11/16/2006 18:38'!
description
	^ 'Application'! !

!WAApplication class methodsFor: 'accessing' stamp: 'ab 8/26/2003 21:45'!
path: pathString
	^ self new basePath: pathString! !

!WAApplication methodsFor: 'adding' stamp: 'pmm 10/2/2006 21:21'!
addLibrary: aClass
	^self libraries add: aClass! !

!WAApplication methodsFor: 'accessing' stamp: 'mb 5/26/2006 09:12'!
baseUrl
	^ super baseUrl
		port: self serverPort;
		hostname: self serverHostname;
		scheme: self serverProtocol;
		yourself! !

!WAApplication methodsFor: 'preferences' stamp: 'avi 11/16/2005 23:45'!
configuration
	^ configuration ifNil: [configuration := WAUserConfiguration new addAncestor: self defaultAncestor] ! !

!WAApplication methodsFor: 'accessing' stamp: 'ab 8/26/2003 21:34'!
configurationComponent
	^ WAApplicationEditor new application: self! !

!WAApplication methodsFor: 'preferences' stamp: 'avi 11/16/2005 23:32'!
defaultAncestor
	"yes, breaking layering"
	^ WARenderLoopConfiguration new! !

!WAApplication methodsFor: 'accessing' stamp: 'avi 6/24/2004 00:30'!
defaultLibraries
	^ Array with: WAStandardScripts with: WAStandardStyles! !

!WAApplication methodsFor: 'basic configuration' stamp: 'mb 5/26/2006 09:16'!
deploymentMode
	^self preferenceAt: #deploymentMode! !

!WAApplication methodsFor: 'accessing' stamp: 'mb 5/26/2006 12:01'!
description
	^self rootComponent description! !

!WAApplication methodsFor: 'basic configuration' stamp: 'mb 5/26/2006 09:18'!
errorHandler
	^self preferenceAt: #errorHandler! !

!WAApplication methodsFor: 'request handling' stamp: 'lr 2/22/2006 08:41'!
expiryPathFor: aRequest
	^ self basePath! !

!WAApplication methodsFor: 'request handling' stamp: 'avi 3/22/2004 13:06'!
handleDefaultRequest: aRequest
	|session|
	session := self sessionClass application: self.
	^ session handleRequest: aRequest! !

!WAApplication methodsFor: 'request handling' stamp: 'pmm 9/12/2006 18:10'!
handleExpiredRequest: aRequest
	| response |
	response := super handleExpiredRequest: aRequest.
	self useSessionCookie ifTrue: [
		response deleteCookieAt: self name ].
	^ response! !

!WAApplication methodsFor: 'request handling' stamp: 'pmm 9/12/2006 18:09'!
handleRequest: aRequest
	self useSessionCookie ifTrue: [
		aRequest cookies at: self name ifPresent: [ :value |
			aRequest fields at: self handlerField ifAbsentPut: [ value ] ] ].
	^ super handleRequest: aRequest! !

!WAApplication methodsFor: 'testing' stamp: 'mb 4/5/2006 20:26'!
isApplication
	^true! !

!WAApplication methodsFor: 'testing' stamp: 'mb 5/26/2006 09:23'!
isDeployed
	^self rootComponent isDeployed! !

!WAApplication methodsFor: 'accessing' stamp: 'avi 6/24/2004 00:29'!
libraries
	^ libraries ifNil: [libraries := OrderedCollection withAll: self defaultLibraries]! !

!WAApplication methodsFor: 'basic configuration' stamp: 'mb 5/26/2006 09:13'!
login
	^self preferenceAt: #login! !

!WAApplication methodsFor: 'basic configuration' stamp: 'mb 5/26/2006 09:19'!
mainClass
	^self preferenceAt: #mainClass! !

!WAApplication methodsFor: 'accessing' stamp: 'avi 7/26/2004 12:49'!
name
	| segments |
	segments := basePath findTokens: '/'.
	^ segments isEmpty
		ifTrue: ['']
		ifFalse: [segments last ]! !

!WAApplication methodsFor: 'basic configuration' stamp: 'mb 5/26/2006 09:13'!
password
	^self preferenceAt: #password! !

!WAApplication methodsFor: 'preferences' stamp: 'avi 1/31/2004 12:34'!
preferenceAt: aSymbol
	^ self configuration valueAt: aSymbol! !

!WAApplication methodsFor: 'preferences' stamp: 'avi 1/31/2004 12:34'!
preferenceAt: aSymbol put: anObject
	^ self configuration valueAt: aSymbol put: anObject! !

!WAApplication methodsFor: 'basic configuration' stamp: 'mb 5/26/2006 09:15'!
resourceBaseUrl
	^self preferenceAt: #resourceBaseUrl! !

!WAApplication methodsFor: 'basic configuration' stamp: 'mb 5/26/2006 09:17'!
rootComponent
	^self preferenceAt: #rootComponent! !

!WAApplication methodsFor: 'basic configuration' stamp: 'mb 5/26/2006 09:10'!
serverHostname
	^self preferenceAt: #serverHostname! !

!WAApplication methodsFor: 'basic configuration' stamp: 'mb 5/26/2006 09:10'!
serverPort
	^self preferenceAt: #serverPort! !

!WAApplication methodsFor: 'basic configuration' stamp: 'mb 5/26/2006 09:11'!
serverProtocol
	^self preferenceAt: #serverProtocol! !

!WAApplication methodsFor: 'basic configuration' stamp: 'mb 5/26/2006 09:11'!
sessionClass
	^self preferenceAt: #sessionClass
! !

!WAApplication methodsFor: 'basic configuration' stamp: 'mb 5/26/2006 09:15'!
sessionExpirySeconds
	^self preferenceAt: #sessionExpirySeconds! !

!WAApplication methodsFor: 'request handling' stamp: 'avi 6/24/2004 00:34'!
updateRoot: anHtmlRoot
	anHtmlRoot title = '' ifTrue: [anHtmlRoot title: self basePath].
	self libraries do: [:ea | ea updateRoot: anHtmlRoot]! !

!WAApplication methodsFor: 'basic configuration' stamp: 'mb 5/26/2006 09:12'!
useSessionCookie
	^self preferenceAt: #useSessionCookie! !

!WARegistry class methodsFor: 'as yet unclassified' stamp: 'JF 9/22/2003 20:15'!
clearAllHandlers
	self allSubInstances do: [:ea | ea clearHandlers]! !

!WARegistry methodsFor: 'private' stamp: 'avi 6/7/2005 23:17'!
clearHandlers
	self mutex critical:
		[handlersByKey ifNotNil:
			[handlersByKey do: [:ea | [ea unregistered] fixTemps fork]].

		handlersByKey := Dictionary new.
		keysByHandler := Dictionary new].! !

!WARegistry methodsFor: 'public' stamp: 'avi 11/12/2005 21:22'!
ensureKeyForHandler: anObject
	^ (self keyOrNilForHandler: anObject) ifNil: [self registerRequestHandler: anObject]! !

!WARegistry methodsFor: 'private' stamp: 'lr 2/22/2006 08:41'!
expiryPathFor: aRequest
	^ aRequest url! !

!WARegistry methodsFor: 'private' stamp: 'ab 5/18/2003 12:29'!
handleDefaultRequest: aRequest
	self subclassResponsibility! !

!WARegistry methodsFor: 'private' stamp: 'lr 7/3/2006 09:25'!
handleExpiredRequest: aRequest
	| url |
	aRequest isXmlHttpRequest
		ifTrue: [ ^ WAResponse new forbidden ].
	url := WAUrl new.
	url addToPath: (self expiryPathFor: aRequest).
	url takeServerParametersFromRequest: aRequest.
	aRequest isGet ifTrue:
		[aRequest fields keysAndValuesDo:
			[:k :v |
			(url isSeasideField: k) ifFalse: [url addParameter: k value: v]]]. 
	^ WAResponse redirectTo: url displayString! !

!WARegistry methodsFor: 'private' stamp: 'mb 1/27/2006 15:52'!
handleKeyRequest: aRequest
	| key handler keyString |
	"Under some circumstances, HTTP fields are collections of values"
	key :=	[keyString := aRequest at: self handlerField.
			(keyString isKindOf: OrderedCollection) ifTrue: [keyString := keyString first].
			WAExternalID fromString: keyString] on: Error do: [:e | nil].
	handler := handlersByKey at: key ifAbsent: [nil].
	^ (handler notNil and: [handler isActive])
		ifTrue: [handler handleRequest: aRequest]
		ifFalse: [self handleExpiredRequest: aRequest]! !

!WARegistry methodsFor: 'public' stamp: 'avi 3/19/2004 13:52'!
handleRequest: aRequest
	^ (aRequest fields includesKey: self handlerField)
		ifTrue: [self handleKeyRequest: aRequest]
		ifFalse: [self handleDefaultRequest: aRequest]
! !

!WARegistry methodsFor: 'private' stamp: 'avi 3/22/2004 13:04'!
handlerField
	^ '_s'! !

!WARegistry methodsFor: 'private' stamp: 'pmm 11/2/2005 22:39'!
initialize
	super initialize.
	self clearHandlers.! !

!WARegistry methodsFor: 'private' stamp: 'avi 3/22/2004 13:04'!
isSeasideField: aString
	^ aString first  = $_! !

!WARegistry methodsFor: 'private' stamp: 'jf 3/4/2004 19:06'!
keyOrNilForHandler: anObject
	^ self mutex critical: [keysByHandler at: anObject ifAbsent: [nil]]! !

!WARegistry methodsFor: 'private' stamp: 'jf 3/4/2004 14:48'!
mutex
	^ mutex ifNil: [mutex := Semaphore forMutualExclusion]! !

!WARegistry methodsFor: 'private' stamp: 'jf 3/4/2004 14:59'!
registerRequestHandler: anObject
	|key|
	key := WAExternalID new: 16.
	self shouldCollectHandlers ifTrue: [self unregisterExpiredHandlers].
	self mutex critical:
		[handlersByKey at: key put: anObject.
		keysByHandler at: anObject put: key].
	^ key! !

!WARegistry methodsFor: 'private' stamp: 'ab 5/18/2003 12:26'!
shouldCollectHandlers
	^ 10 atRandom = 1! !

!WARegistry methodsFor: 'private' stamp: 'avi 3/14/2005 14:56'!
unregisterExpiredHandlers
	"This method is a little ugly, but using #associationsDo: to build a new
	dictionary is 200 times faster than iterating over them with #removeKey:
	or even using #keysAndValuesRemove:"

	| expired newHandlersByKey newKeysByHandler |
	self mutex critical:
		[expired := OrderedCollection new.
		newHandlersByKey := Dictionary new.
		handlersByKey associationsDo:
			[:assoc |
			assoc value isActive
				ifTrue: [newHandlersByKey add: assoc]
				ifFalse: [expired add: assoc value]].
		newKeysByHandler := Dictionary new.
		keysByHandler associationsDo:
                       [:assoc |
                       (newHandlersByKey includesKey: assoc value) ifTrue:
						[newKeysByHandler add: assoc]].
		handlersByKey := newHandlersByKey.
		keysByHandler := newKeysByHandler].
	
	expired do: [:ea | [ea unregistered] fixTemps fork]! !

!WARegistry methodsFor: 'private' stamp: 'avi 6/7/2005 23:43'!
unregistered
	self clearHandlers ! !

!WARegistry methodsFor: 'public' stamp: 'avi 11/12/2005 21:22'!
urlForRequestHandler: anObject
	|key url |
	key := self ensureKeyForHandler: anObject.
	url := self baseUrl.
	url addParameter: self handlerField value: key displayString.
	^ url! !

WARequestHandler subclass: #WAExpiringHandler
	instanceVariableNames: 'lastAccess expired timeout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RequestHandler'!

!WAExpiringHandler methodsFor: 'defaults' stamp: 'avi 1/23/2004 12:20'!
defaultTimeoutSeconds
	^ 600! !

!WAExpiringHandler methodsFor: 'actions' stamp: 'avi 1/23/2004 12:18'!
expire
	expired := true! !

!WAExpiringHandler methodsFor: 'testing' stamp: 'avi 1/23/2004 12:18'!
expired
	^ expired ifNil: [false]! !

!WAExpiringHandler methodsFor: 'actions' stamp: 'avi 1/23/2004 14:08'!
handleRequest: aRequest
	lastAccess := Time totalSeconds.
	^ self incomingRequest: aRequest! !

!WAExpiringHandler methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 14:08'!
incomingRequest: aRequest
	self subclassResponsibility ! !

!WAExpiringHandler methodsFor: 'initialization' stamp: 'mb 4/23/2006 18:39'!
initialize
	super initialize.
	expired := false! !

!WAExpiringHandler methodsFor: 'testing' stamp: 'avi 1/23/2004 12:18'!
isActive
	^ self expired not and: [self secondsSinceLastAccess < self timeoutSeconds]! !

!WAExpiringHandler methodsFor: 'accessing' stamp: 'avi 1/23/2004 12:19'!
lastAccess
	^ lastAccess ifNil: [lastAccess := Time totalSeconds]! !

!WAExpiringHandler methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 12:19'!
secondsSinceLastAccess
	^ Time totalSeconds - self lastAccess! !

!WAExpiringHandler methodsFor: 'accessing' stamp: 'avi 1/23/2004 12:20'!
timeoutSeconds
	^ timeout ifNil: [self defaultTimeoutSeconds]! !

!WAExpiringHandler methodsFor: 'accessing' stamp: 'avi 1/23/2004 12:20'!
timeoutSeconds: aNumber
	timeout := aNumber! !

WAExpiringHandler subclass: #WASession
	instanceVariableNames: 'continuations application escapeContinuation monitor state currentRequest scripts jumpTo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WASession commentStamp: '<historical>' prior: 0!
I am a Seaside session. A new instance of me gets created when an user accesses an application for the first time and is persistent as long as the user is interacting with it.

If the session has not been used for #defaultTimeoutSeconds, it is garbage collected by the system. To manually expire a session call #expire.!

WASession subclass: #WAExpirySession
	instanceVariableNames: ''
	classVariableNames: 'Created Unregistered'
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAExpirySession class methodsFor: 'accessing' stamp: 'avi 9/30/2004 16:30'!
created
	^ Created! !

!WAExpirySession class methodsFor: 'class initialization' stamp: 'avi 9/30/2004 16:24'!
initialize
	self resetCounters! !

!WAExpirySession class methodsFor: 'actions' stamp: 'avi 9/30/2004 16:24'!
resetCounters
	Unregistered := 0.
	Created := 0.! !

!WAExpirySession class methodsFor: 'accessing' stamp: 'avi 9/30/2004 16:30'!
unregistered
	^ Unregistered! !

!WAExpirySession methodsFor: 'initialize-release' stamp: 'avi 9/30/2004 16:24'!
initialize
	super initialize.
	Created := Created + 1! !

!WAExpirySession methodsFor: 'subclass responsibilities' stamp: 'avi 9/30/2004 16:24'!
unregistered
	Unregistered := Unregistered + 1! !

!WASession class methodsFor: 'accessing' stamp: 'avi 7/2/2004 17:32'!
application: anApplication
	^ self basicNew initializeWithApplication: anApplication! !

!WASession methodsFor: 'request handling' stamp: 'avi 3/22/2004 13:04'!
actionField
	^ '_k'! !

!WASession methodsFor: 'responding' stamp: 'avi 2/3/2004 00:43'!
actionUrlForContinuation: aContinuation
	^ self actionUrlForKey: (continuations store: aContinuation)! !

!WASession methodsFor: 'responding' stamp: 'avi 11/27/2005 14:56'!
actionUrlForKey: aString
	| url |
	url := self useSessionCookie
			ifTrue: [application baseUrl]
			ifFalse: [application urlForRequestHandler: self].
	url takeServerParametersFromRequest: currentRequest.
	url addParameter: self actionField value: aString.
	jumpTo ifNotNil: [url fragment: jumpTo].
	^ url! !

!WASession methodsFor: 'scripts' stamp: 'avi 9/24/2005 18:42'!
addLoadScript: aString
	^ (scripts ifNil: [scripts := OrderedCollection new]) add: aString! !

!WASession methodsFor: 'accessing' stamp: 'ab 3/20/2003 11:43'!
application
	^ application! !

!WASession methodsFor: 'cookies' stamp: 'mbany 4/14/2005 11:56'!
checkForCookies
	| check |
	check := WAExternalID new displayString.
	self redirectWithCookie: 
		(WACookie new
			key: check;
			value: 'yes';
			expireIn: (Duration seconds: 2);
			yourself).
	^ currentRequest cookies includesKey: check! !

!WASession methodsFor: 'scripts' stamp: 'avi 9/24/2005 21:09'!
clearJumpTo
	jumpTo := nil! !

!WASession methodsFor: 'scripts' stamp: 'avi 9/24/2005 20:00'!
clearLoadScripts
	scripts := nil! !

!WASession methodsFor: 'responding' stamp: 'ac 12/23/2004 04:09'!
closePopup
	^ self respond:
		[:url |
		WAResponse new
			nextPutAll: '<html><script>';
			nextPutAll: 'self.close();';
			nextPutAll: 'self.opener.location=self.opener.location';
			nextPutAll: '</script></html>';
			yourself]! !

!WASession methodsFor: 'responding' stamp: 'mbany 4/14/2005 11:55'!
closePopupAndContinue
	^ self respond:
		[:url |
		WAResponse new
			nextPutAll: '<html><script>';
			nextPutAll: 'self.close();';
			nextPutAll: 'self.opener.location=',url displayString printString;
			nextPutAll: '</script></html>';
			yourself]! !

!WASession methodsFor: 'responding' stamp: 'ac 9/27/2005 19:40'!
closePopupWithoutReloadingOpener
	^ self respond:
		[:url |
		WAResponse new
			nextPutAll: '<html><script>';
			nextPutAll: 'self.close();';
			nextPutAll: '</script></html>';
			yourself]! !

!WASession methodsFor: 'http' stamp: 'mb 1/12/2006 10:15'!
contentType
	^WAResponse defaultValueForContentType. "text/html; charset=utf-8"! !

!WASession methodsFor: 'request handling' stamp: 'avi 4/13/2004 21:47'!
currentRequest
	^ currentRequest! !

!WASession methodsFor: 'expiring' stamp: 'mb 5/26/2006 09:18'!
defaultTimeoutSeconds
	^self application sessionExpirySeconds ifNil: [super defaultTimeoutSeconds]! !

!WASession methodsFor: 'request handling' stamp: 'mb 5/26/2006 09:18'!
errorHandler
	^ application errorHandler! !

!WASession methodsFor: 'request handling' stamp: 'dc 11/5/2006 12:29'!
fieldsAt: key
	^ self currentRequest at: key! !

!WASession methodsFor: 'request handling' stamp: 'dc 11/5/2006 12:29'!
fieldsAt: key ifAbsent: aBlock
	^ self currentRequest at: key ifAbsent: aBlock! !

!WASession methodsFor: 'request handling' stamp: 'dc 11/5/2006 12:29'!
fieldsAt: key ifPresent: aBlock
	^ self currentRequest at: key ifPresent: aBlock! !

!WASession methodsFor: 'responding' stamp: 'pmm 9/12/2006 19:05'!
hasSessionCookie
	^currentRequest cookies includesKey: self sessionCookieName
	! !

!WASession methodsFor: 'request handling' stamp: 'pmm 9/12/2006 19:06'!
incomingRequest: aRequest
	((aRequest fields includesKey: 'terminate')
		and: [self application deploymentMode not])
			ifTrue: [
				monitor terminate.
				^ WAResponse new nextPutAll: 'Process terminated'].
			
	^ monitor
		critical: [self responseForRequest: aRequest]
		ifError: [ :error | WAResponse internalError: error ]! !

!WASession methodsFor: 'initializing' stamp: 'avi 4/13/2004 20:29'!
initializeWithApplication: anApplication
	application := anApplication.
	continuations := WALRUCache new.
	monitor := WAProcessMonitor new.
	state := WAStateRegistry new.
	self initialize.! !

!WASession methodsFor: 'scripts' stamp: 'avi 9/24/2005 21:08'!
jumpToAnchor: aString
	jumpTo := aString! !

!WASession methodsFor: 'accessing' stamp: 'mb 5/26/2006 09:19'!
mainClass
	^ application mainClass! !

!WASession methodsFor: 'responding' stamp: 'avi 11/29/2005 11:20'!
newSessionUrl
	| url |
	url := self application baseUrl.
	url takeServerParametersFromRequest: currentRequest.
	^ url asString! !

!WASession methodsFor: 'scripts' stamp: 'avi 9/24/2005 20:00'!
onLoadScripts
	^ scripts ifNil: [#()]! !

!WASession methodsFor: 'responding' stamp: 'mb 8/18/2006 10:23'!
outputDocumentClass
	"To be subclassed as needed"
	^WAHtmlStreamDocument! !

!WASession methodsFor: 'expiring' stamp: 'avi 9/2/2004 16:28'!
pageExpired
	state restoreLastSnapshot.
	self redirectWithMessage: 'That page has expired.' delay: 3.
	WAPageExpired raiseSignal.
! !

!WASession methodsFor: 'responding' stamp: 'avi 5/18/2004 16:16'!
pageIntentionallyLeftBlank
	self returnResponse: WAResponse new! !

!WASession methodsFor: 'request handling' stamp: 'mb 6/8/2006 16:01'!
performRequest: aRequest
	| key continuation |
	key := aRequest fields at: self actionField ifAbsent: [^ self start: aRequest].
	"Under some circumstances, HTTP fields are collections of values"
	(key isKindOf: OrderedCollection) ifTrue: [key := key first].
	continuation := continuations at: key ifAbsent: [^ self unknownRequest: aRequest].
	continuation value: aRequest
! !

!WASession methodsFor: 'printing' stamp: 'mbany 4/14/2005 11:57'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: '(', (application urlForRequestHandler: self) displayString, ')'! !

!WASession methodsFor: 'responding' stamp: 'mbany 4/14/2005 11:55'!
redirect
	^ self respond: [:url | WAResponse redirectTo: url displayString]! !

!WASession methodsFor: 'responding' stamp: 'avi 5/18/2004 16:16'!
redirectTo: urlString
	self returnResponse: (WAResponse redirectTo: urlString)! !

!WASession methodsFor: 'cookies' stamp: 'avi 5/18/2004 22:57'!
redirectWithCookie: aCookie
	self redirectWithCookies: (Array with: aCookie)! !

!WASession methodsFor: 'cookies' stamp: 'mbany 4/14/2005 11:57'!
redirectWithCookies: aCollection
	| response |
	self respond:
		[:url |
		response := WAResponse redirectTo: url displayString.
		aCollection do: [:ea | response addCookie: ea].
		response]! !

!WASession methodsFor: 'responding' stamp: 'mbany 4/14/2005 11:56'!
redirectWithMessage: aString delay: aNumber
	self respond:
		[:url |
		WAResponse
			refreshWithMessage: aString
			location: url displayString
			delay: aNumber].
! !

!WASession methodsFor: 'state' stamp: 'ab 2/18/2003 18:51'!
registerObjectForBacktracking: anObject
	state registerObject: anObject! !

!WASession methodsFor: 'responding' stamp: 'mb 2/27/2006 13:08'!
respond: responseBlock
	|request snapshotHolder response oldEscape |
	snapshotHolder := ValueHolder new.
	oldEscape := escapeContinuation.
	escapeContinuation :=
		[:v |
		snapshotHolder contents: state snapshot.
		oldEscape value: v].
	request := 
	ResponseContinuation currentDo:
		[:cc ||url|
		url := self actionUrlForContinuation: cc.
		response := responseBlock value: url.
		self useSessionCookie
			ifTrue: 
				[response addCookie: self sessionCookie]
			ifFalse:
				[self hasSessionCookie ifTrue:
					[response deleteCookieAt: self sessionCookieName]].
		self returnResponse: response].
	state restoreSnapshot: snapshotHolder contents.
	^ request 
	! !

!WASession methodsFor: 'request handling' stamp: 'pmm 9/12/2006 19:06'!
responseForRequest: aRequest
	currentRequest := aRequest.
	^ self withEscapeContinuation: [
		WACurrentSession
			use: self
			during: [
				self withErrorHandler: [
					self performRequest: aRequest ] ] ]! !

!WASession methodsFor: 'responding' stamp: 'ab 6/15/2003 19:25'!
returnResponse: aResponse
	escapeContinuation value: aResponse! !

!WASession methodsFor: 'responding' stamp: 'avi 3/13/2004 01:21'!
script: aString
	self redirectWithMessage: '<script>', aString, '</script>' delay: 0! !

!WASession methodsFor: 'responding' stamp: 'mb 2/27/2006 13:00'!
sessionCookie
	^WACookie
		key: self sessionCookieName
		value: (self application ensureKeyForHandler: self) displayString! !

!WASession methodsFor: 'responding' stamp: 'mb 2/27/2006 13:00'!
sessionCookieName
	^self application name! !

!WASession methodsFor: 'request handling' stamp: 'avi 11/12/2005 21:37'!
start: aRequest
	self useSessionCookie ifTrue: [self redirectWithCookie: self sessionCookie].
	self mainClass new start: aRequest! !

!WASession methodsFor: 'request handling' stamp: 'avi 1/20/2006 01:41'!
unknownRequest: aRequest
	self start: aRequest! !

!WASession methodsFor: 'responding' stamp: 'avi 9/24/2005 19:56'!
updateRoot: anHtmlRoot
	self application updateRoot: anHtmlRoot! !

!WASession methodsFor: 'cookies' stamp: 'mb 2/9/2006 09:34'!
useSessionCookie
	^ self application useSessionCookie! !

!WASession methodsFor: 'request handling' stamp: 'avi 4/27/2004 14:25'!
withErrorHandler: aBlock
	^ [aBlock
		on: Error
		do: [:e | self errorHandler handleError: e. WAPageExpired raiseSignal]]
		on: Warning
		do: [:w | self errorHandler handleWarning: w. WAPageExpired raiseSignal]! !

!WASession methodsFor: 'request handling' stamp: 'avi 10/26/2004 15:40'!
withEscapeContinuation: aBlock
	^ EscapeContinuation currentDo:
			[:cc |
			escapeContinuation := cc.
			aBlock value.
			self pageIntentionallyLeftBlank]! !

WARequestHandler subclass: #WANotFoundHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RequestHandler'!

!WANotFoundHandler methodsFor: 'actions' stamp: 'avi 5/18/2004 16:16'!
handleRequest: aRequest
	^ WAResponse notFound: aRequest url! !

!WARequestHandler class methodsFor: 'instance creation' stamp: 'pmm 4/19/2006 18:00'!
new
	^ self basicNew initialize! !

!WARequestHandler methodsFor: 'subclass responsibilities' stamp: 'mb 5/26/2006 12:00'!
description
	^String new.! !

!WARequestHandler methodsFor: 'subclass responsibilities' stamp: 'ab 5/18/2003 12:33'!
handleRequest: aRequest
	self subclassResponsibility! !

!WARequestHandler methodsFor: 'initialize-release' stamp: 'pmm 11/2/2005 23:17'!
initialize! !

!WARequestHandler methodsFor: 'testing' stamp: 'avi 7/23/2004 15:11'!
isActive
	^ true! !

!WARequestHandler methodsFor: 'testing' stamp: 'mb 5/26/2006 08:49'!
isApplication
	^ false! !

!WARequestHandler methodsFor: 'testing' stamp: 'mb 5/26/2006 08:49'!
isDispatcher
	^ false! !

!WARequestHandler methodsFor: 'testing' stamp: 'mb 5/26/2006 08:48'!
isEntryPoint
	^ false! !

!WARequestHandler methodsFor: 'subclass responsibilities' stamp: 'avi 6/16/2004 22:55'!
unregistered! !

Object subclass: #WAResponse
	instanceVariableNames: 'contentType headers cookies status stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-HTTP'!

!WAResponse class methodsFor: 'instance creation' stamp: 'avi 5/18/2004 16:14'!
basicAuthWithRealm: aString
	^ self new basicAuthenticationRealm: aString! !

!WAResponse class methodsFor: 'defaults' stamp: 'mb 1/12/2006 10:13'!
defaultValueForContentType
	^'text/html; charset=utf-8'! !

!WAResponse class methodsFor: 'instance creation' stamp: 'mb 6/1/2006 09:05'!
document: anObject mimeType: mimeType
	|doc|
	doc := anObject asMIMEDocumentType: mimeType.
	^ self new
		contentType: (mimeType ifNil: [doc contentType]);
		headerAt: 'Expires' put: 'Thu, 01 Jan 2095 12:00:00 GMT';
		nextPutAll: doc content;
		yourself! !

!WAResponse class methodsFor: 'instance creation' stamp: 'avi 9/22/2004 21:02'!
document: anObject mimeType: mimeString fileName: fileString
	^ (self document: anObject mimeType: mimeString)
		attachmentWithFileName: fileString;
		yourself! !

!WAResponse class methodsFor: 'instance creation' stamp: 'avi 5/9/2005 13:14'!
forbidden: locationString
	^ self new
		forbidden;
		nextPutAll: '<h1> Error: you are forbidden to access "', locationString, '". </h1>';
		yourself! !

!WAResponse class methodsFor: 'instance creation' stamp: 'mb 3/23/2006 08:12'!
internalError: anError
	| response |
	response := self new internalError.
	response
		nextPutAll: '<h1> Internal Error</h1>';
		nextPutAll: '<h2>';
		nextPutAll: anError displayString;
		nextPutAll: '</h2>'.
	(SeasidePlatformSupport walkbackStringsFor: anError) do:
		[:eachLine | 
		response 
			nextPutAll: '<br>'; 
			nextPutAll: eachLine].
	^ response! !

!WAResponse class methodsFor: 'instance creation' stamp: 'avi 5/18/2004 16:14'!
new
	^ self basicNew initialize! !

!WAResponse class methodsFor: 'instance creation' stamp: 'avi 5/18/2004 16:15'!
notFound: locationString
	^ self new
		notFound;
		nextPutAll: '<h1> Error: "', locationString, '" not found. </h1>';
		yourself! !

!WAResponse class methodsFor: 'responding' stamp: 'avi 5/18/2004 16:15'!
redirectTo: locationString
	^ self new redirectTo: locationString! !

!WAResponse class methodsFor: 'instance creation' stamp: 'mbany 4/14/2005 12:50'!
refreshWithMessage: aString location: locationString delay: aNumber
	^ self new nextPutAll:
		 ('<html>
			<head>
			<meta http-equiv="refresh" content="',aNumber displayString,';URL=',locationString,'">
			<title>',aString,'</title>
			</head>
			<body>
			<h1>',aString,'</h1>
			You are being redirected to <a href="',locationString,'">',locationString,'</a>
			</body>
		</html>');
		yourself
	! !

!WAResponse class methodsFor: 'instance creation' stamp: 'avi 9/10/2005 17:31'!
root: anHtmlRoot render: renderBlock
	| canvas |
	canvas := WAStaticHtmlCanvas root: anHtmlRoot.
	renderBlock value: canvas.
	^ self new nextPutAll: canvas document stream contents! !

!WAResponse class methodsFor: 'public api' stamp: 'avi 9/10/2005 17:32'!
updateRoot: rootBlock render: renderBlock
	| root |
	root := WAHtmlRoot new.
	rootBlock value: root.
	^ self root: root render: renderBlock! !

!WAResponse methodsFor: 'accessing' stamp: 'pmm 10/12/2006 16:55'!
addCookie: aCookie
	cookies ifNil: [cookies := Set new].
	cookies add: aCookie! !

!WAResponse methodsFor: 'convenience' stamp: 'pmm 4/19/2006 09:30'!
attachmentWithFileName: aString
	self headerAt: 'Content-Disposition' put: 'attachment; filename="', aString, '"'! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/18/2004 14:25'!
authenticationFailed
	self status: 401! !

!WAResponse methodsFor: 'convenience' stamp: 'avi 5/18/2004 14:25'!
basicAuthenticationRealm: aString
	self headerAt: 'WWW-Authenticate' put: ('Basic realm="',aString,'"').
	self authenticationFailed! !

!WAResponse methodsFor: 'convenience' stamp: 'mb 1/19/2006 19:30'!
beXML
	contentType := contentType copyReplaceAll: '/html' with: '/xml'.! !

!WAResponse methodsFor: 'accessing' stamp: 'ab 7/3/2002 21:58'!
contentType
	^ contentType! !

!WAResponse methodsFor: 'accessing' stamp: 'ab 7/3/2002 21:58'!
contentType: mimeTypeString
	contentType := mimeTypeString! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 4/13/2004 21:21'!
contents
	^ stream reset! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 4/13/2004 21:21'!
contents: aStream
	stream := aStream! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 5/18/2004 13:23'!
cookieAt: key put: value
	self addCookie: (WACookie key: key value: value)! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 5/18/2004 14:28'!
cookies
	^ cookies ifNil: [#()]! !

!WAResponse methodsFor: 'accessing' stamp: 'mb 2/9/2006 09:29'!
deleteCookieAt: key
	"Delete the cookie in the browser"
	self addCookie: ((WACookie key: key value: '') 
						expireIn: (Duration days: -10000); 
						yourself)! !

!WAResponse methodsFor: 'convenience' stamp: 'ac 9/11/2005 12:46'!
doNotCache
	self headerAt: 'Cache-Control' put: 'no-cache'.! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/9/2005 13:14'!
forbidden
	self status: 403! !

!WAResponse methodsFor: 'accessing' stamp: 'mb 2/17/2005 18:13'!
headerAt: key put: value
	headers ifNil: [headers := OrderedCollection new].
	headers add: (Association key: key value: value).! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 5/18/2004 14:28'!
headers
	^ headers ifNil: [#()]! !

!WAResponse methodsFor: 'initialize-release' stamp: 'mb 4/23/2006 10:53'!
initialize
	| session |
	stream := SeasidePlatformSupport readWriteStream.
	status := '200'.
	session := WACurrentSession value.
	contentType := session isNil 
				ifFalse: [session contentType]
				ifTrue: [self class defaultValueForContentType]
! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/18/2004 15:57'!
internalError
	self status: 500! !

!WAResponse methodsFor: 'accessing' stamp: 'ab 7/7/2003 11:12'!
nextPut: aCharacter
	stream nextPut: aCharacter asCharacter! !

!WAResponse methodsFor: 'accessing' stamp: 'ab 7/7/2003 11:12'!
nextPutAll: aString
	aString do: [:ea | self nextPut: ea]! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/18/2004 14:25'!
notFound
	self status: 404! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/18/2004 14:26'!
redirect
	self status: 302! !

!WAResponse methodsFor: 'convenience' stamp: 'avi 11/27/2005 15:19'!
redirectTo: aString
	self headerAt: 'Location' put: aString.
	self redirect.! !

!WAResponse methodsFor: 'accessing' stamp: 'tbn 7/20/2006 17:31'!
release
	stream := cookies := headers := nil.
	super release! !

!WAResponse methodsFor: 'accessing' stamp: 'ac 3/22/2006 12:06'!
space
	stream space.! !

!WAResponse methodsFor: 'accessing' stamp: 'ab 7/3/2002 21:50'!
status
	^ status! !

!WAResponse methodsFor: 'accessing' stamp: 'mbany 4/14/2005 12:51'!
status: statusString
	status := statusString displayString! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 2/6/2004 15:28'!
stream
	^ stream! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 5/18/2004 14:28'!
stream: aStream
	stream := aStream! !

!WAResponse methodsFor: 'writing' stamp: 'avi 1/6/2006 12:53'!
writeHeadersOn: aStream
	self headers associationsDo:
		[:assoc |
		aStream nextPutAll: assoc key; nextPutAll: ': '; nextPutAll: assoc value asString.
		aStream crlf].
	aStream nextPutAll: 'Content-Type: ', self contentType.
	aStream crlf! !

!WAResponse methodsFor: 'writing' stamp: 'avi 1/6/2006 12:52'!
writeOn: aStream
	self writeStatusOn: aStream.
	self writeHeadersOn: aStream.
	aStream crlf.
	aStream nextPutAll: stream contents! !

!WAResponse methodsFor: 'writing' stamp: 'avi 1/6/2006 12:51'!
writeStatusOn: aStream
	aStream nextPutAll: 'HTTP/1.0 ', self status asString.
	aStream crlf! !

WAResponse subclass: #WAStreamResponse
	instanceVariableNames: 'writtenHeaders'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-HTTP'!

!WAStreamResponse methodsFor: 'accessing' stamp: 'pmm 4/19/2006 17:32'!
hasWrittenHeaders
	^ writtenHeaders! !

!WAStreamResponse methodsFor: 'initialize-release' stamp: 'mb 9/22/2006 12:26'!
initialize
	super initialize.
	writtenHeaders := false! !

!WAStreamResponse methodsFor: 'accessing' stamp: 'avi 1/6/2006 13:31'!
stream
	self writeOn: stream.
	^ stream! !

!WAStreamResponse methodsFor: 'private' stamp: 'pmm 9/30/2006 18:18'!
writeOn: aStream
	self hasWrittenHeaders ifFalse: [
		self writeStatusOn: aStream.
		self writeHeadersOn: aStream.
		aStream crlf.
		writtenHeaders := true ]! !

Object subclass: #WASpotProfiler
	instanceVariableNames: 'readings'
	classVariableNames: 'Profilers'
	poolDictionaries: ''
	category: 'Seaside-Utilities-Squeak'!

!WASpotProfiler class methodsFor: 'initialization' stamp: 'avi 11/7/2005 13:01'!
initialize
	Profilers := Dictionary new! !

!WASpotProfiler class methodsFor: 'instance creation' stamp: 'lr 5/3/2006 09:38'!
new
	^ self basicNew initialize! !

!WASpotProfiler class methodsFor: 'vm profiling' stamp: 'avi 11/7/2005 12:51'!
profile: aBlock
	| profiler |
	profiler := Profilers at: thisContext sender selector ifAbsentPut: [self new].
	^ profiler profile: aBlock! !

!WASpotProfiler class methodsFor: 'as yet unclassified' stamp: 'avi 11/7/2005 12:59'!
profilers
	^ Profilers! !

!WASpotProfiler methodsFor: 'private' stamp: 'avi 11/7/2005 12:56'!
allReadings
	^ readings gather: [:ea | ea]! !

!WASpotProfiler methodsFor: 'as yet unclassified' stamp: 'avi 11/7/2005 12:54'!
averageReadingTime
	^ self allReadings average! !

!WASpotProfiler methodsFor: 'as yet unclassified' stamp: 'avi 11/7/2005 12:55'!
averageReadingsPerRequest
	^ (readings collect: [:ea | ea size]) average! !

!WASpotProfiler methodsFor: 'as yet unclassified' stamp: 'avi 11/7/2005 12:53'!
averageRequestTime
	^ self requestTimes average! !

!WASpotProfiler methodsFor: 'private' stamp: 'avi 11/7/2005 12:51'!
initialize
	self reset! !

!WASpotProfiler methodsFor: 'vm profiling' stamp: 'avi 11/7/2005 12:50'!
profile: aBlock
	| time value |
	time := Time millisecondsToRun: [value := aBlock value].
	(readings at: Processor activeProcess ifAbsentPut: [OrderedCollection new]) add: time.
	^ value! !

!WASpotProfiler methodsFor: 'as yet unclassified' stamp: 'avi 11/7/2005 12:54'!
readingCount
	^ self allReadings size! !

!WASpotProfiler methodsFor: 'as yet unclassified' stamp: 'avi 11/7/2005 12:54'!
requestCount
	^ self requestTimes size! !

!WASpotProfiler methodsFor: 'private' stamp: 'avi 11/7/2005 12:53'!
requestTimes
	^ readings collect: [:ea | ea sum]! !

!WASpotProfiler methodsFor: 'sound generation' stamp: 'avi 11/7/2005 12:52'!
reset
	readings := Dictionary new! !

!WASpotProfiler methodsFor: 'as yet unclassified' stamp: 'avi 11/7/2005 12:54'!
totalTime
	^ self requestTimes sum! !

Object subclass: #WAStateHolder
	instanceVariableNames: 'hash contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-StateRegistry'!

!WAStateHolder commentStamp: '<historical>' prior: 0!
I am a ValueHolder whose contents will properly track the user's use of the back button.  Use me to wrap any values that you wish to backtrack when the back button is used.

Sometimes it might be more convenient to register your business object directly:

	WACurrentSession value registerObjectForBacktracking: businessObject.

or even to register a component for backtracking, as seen in WACounter:

	WACounter>>initialize
		self session registerObjectForBacktracking: self.!

!WAStateHolder class methodsFor: 'instance creation' stamp: 'avi 4/13/2004 19:48'!
new
	|inst|
	inst := super new.
	WACurrentSession value registerObjectForBacktracking: inst.
	^ inst! !

!WAStateHolder methodsFor: 'accessing' stamp: 'ab 2/20/2003 01:04'!
contents
	^ contents! !

!WAStateHolder methodsFor: 'accessing' stamp: 'ab 2/20/2003 01:04'!
contents: anObject
	contents := anObject! !

!WAStateHolder methodsFor: 'comparing' stamp: 'pmm 9/12/2006 19:08'!
hash
	"this is a workaround for the indentityHash limit in Squeak (4096) and VW (16384)
	this is no longer needed in Squeak 3.9"
	^ hash ifNil: [ hash := SmallInteger maxVal atRandom ]! !

!WAStateHolder methodsFor: 'printing' stamp: 'ab 2/20/2003 01:05'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	contents printOn: aStream.
	aStream nextPut: $).! !

Object subclass: #WAStateRegistry
	instanceVariableNames: 'lastSnapshot objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-StateRegistry'!

!WAStateRegistry class methodsFor: 'instance creation' stamp: 'pmm 4/18/2006 20:17'!
new
	^ self basicNew initialize! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 18:55'!
calculateFootprint
	^ (objects detectSum: [:ea | 2 + ea class instSize + (ea class isVariable ifTrue: [ea size + 1] ifFalse: [0])]) * 4! !

!WAStateRegistry methodsFor: 'initialize-release' stamp: 'mb 5/6/2006 16:09'!
initialize
	objects := SeasidePlatformSupport weakDictionaryOfSize: 10.! !

!WAStateRegistry methodsFor: 'testing' stamp: 'pmm 4/21/2006 23:26'!
isEmpty
	^self size = 0! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'avi 9/1/2004 21:17'!
registerObject: anObject
	objects at: anObject put: anObject snapshotCopy! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 17:28'!
restoreLastSnapshot
	lastSnapshot ifNotNil: [self restoreSnapshot: lastSnapshot]! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'avi 9/1/2004 21:18'!
restoreObject: object fromSnapshot: copy
	object restoreFromSnapshot: copy.
	objects at: object put: copy.! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:03'!
restoreSnapshot: aDictionary
	aDictionary keysAndValuesDo:
		[:k :v |
		self restoreObject: k fromSnapshot: v]! !

!WAStateRegistry methodsFor: 'accessing' stamp: 'ab 7/3/2003 12:03'!
size
	^ objects size! !

!WAStateRegistry methodsFor: 'accessing' stamp: 'avi 9/1/2004 21:21'!
snapshot
	lastSnapshot := SeasidePlatformSupport weakDictionaryOfSize: objects size.
	objects keysAndValuesDo:
		[:obj :copy|
		(obj isIdenticalToSnapshot: copy)
			ifTrue: [lastSnapshot at: obj put: copy]
			ifFalse: [lastSnapshot at: obj put: obj snapshotCopy]].
	^ lastSnapshot
! !

Object subclass: #WAStoreAddress
	instanceVariableNames: 'name street city country'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

!WAStoreAddress commentStamp: 'avi 1/1/2004 07:36' prior: 0!
A simple model of a billing or shipping address.  Stores strings for a person's name, street, city, and country.  Apart from accessors for these, the only behavior this provides is a #validate method which will throw errors if street, city, or country is nil.!

!WAStoreAddress methodsFor: 'accessing' stamp: 'avi 12/8/2003 13:53'!
city
	^ city! !

!WAStoreAddress methodsFor: 'accessing' stamp: 'avi 12/8/2003 13:52'!
city: aString
	city := aString! !

!WAStoreAddress methodsFor: 'accessing' stamp: 'avi 12/8/2003 13:53'!
country
	^ country! !

!WAStoreAddress methodsFor: 'accessing' stamp: 'avi 12/8/2003 13:53'!
country: aString
	country := aString! !

!WAStoreAddress methodsFor: 'accessing' stamp: 'avi 12/8/2003 13:53'!
name
	^ name! !

!WAStoreAddress methodsFor: 'accessing' stamp: 'avi 12/8/2003 13:52'!
name: aString
	name := aString! !

!WAStoreAddress methodsFor: 'accessing' stamp: 'avi 12/8/2003 13:53'!
street
	^ street! !

!WAStoreAddress methodsFor: 'accessing' stamp: 'avi 12/8/2003 13:52'!
street: aString
	street := aString! !

!WAStoreAddress methodsFor: 'actions' stamp: 'cds 7/25/2005 10:20'!
validate
	street ifNil: [self validationError: 'You must provide a street address.'].
	city ifNil: [self validationError: 'You must provide a city.'].
	country ifNil: [self validationError: 'You must provide a country.'].! !

Object subclass: #WAStoreCart
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

!WAStoreCart commentStamp: 'avi 1/1/2004 07:44' prior: 0!
A shopping cart.  This is essentially a specialized Bag: you can #add: or #remove: WAStoreItems to it, and calculate their #totalPrice.  You can also use #countsAndItems to get a collection of associations between the items and the number of times they appear in the cart, useful for summary displays.!

!WAStoreCart methodsFor: 'adding' stamp: 'ab 8/15/2003 17:36'!
add: anObject
	items ifNil: [items := Bag new].
	items add: anObject! !

!WAStoreCart methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:40'!
countsAndItems
	^ items sortedCounts! !

!WAStoreCart methodsFor: 'testing' stamp: 'avi 12/8/2003 14:01'!
hasItems
	^ items notNil and: [items isEmpty not]! !

!WAStoreCart methodsFor: 'accessing' stamp: 'ab 8/15/2003 17:21'!
items
	^ items! !

!WAStoreCart methodsFor: 'removing' stamp: 'ab 8/15/2003 17:40'!
remove: anObject
	items remove: anObject ifAbsent: []! !

!WAStoreCart methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:41'!
totalPrice
	^ items detectSum: [:ea | ea price]! !

Object subclass: #WAStoreCreditCard
	instanceVariableNames: 'name number expiry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

!WAStoreCreditCard commentStamp: 'avi 1/1/2004 07:47' prior: 0!
Models credit card information - it has accessors for #name and #number (both strings), and #expiry date.  #validate throws an error if anything is missing, or if the expiry date is in the past.

This is intended to be an abstract class - the subclasses WAStoreMasterCard and WAStoreVisaCard provide further validation.!

!WAStoreCreditCard methodsFor: 'accessing' stamp: 'avi 12/9/2003 14:02'!
expiry
	! !

!WAStoreCreditCard methodsFor: 'accessing' stamp: 'avi 12/9/2003 14:03'!
expiry: aDate
	expiry := aDate! !

!WAStoreCreditCard methodsFor: 'accessing' stamp: 'avi 12/9/2003 14:02'!
name
	^ name! !

!WAStoreCreditCard methodsFor: 'accessing' stamp: 'avi 12/9/2003 14:01'!
name: aString
	name := aString! !

!WAStoreCreditCard methodsFor: 'accessing' stamp: 'avi 12/9/2003 14:02'!
number
	^ number! !

!WAStoreCreditCard methodsFor: 'accessing' stamp: 'avi 12/9/2003 14:02'!
number: aString
	number := aString! !

!WAStoreCreditCard methodsFor: 'actions' stamp: 'cds 7/25/2005 10:20'!
validate
	name ifNil: [self validationError: 'You must provide the name of the credit card owner.'].
	number ifNil: [self validationError: 'You must provide a credit card number.'].
	expiry ifNil: [self validationError: 'You must provide an expiry date.'].
	expiry < Date today ifTrue: [self validationError: 'The expiry date must not be in the past'].
	! !

WAStoreCreditCard subclass: #WAStoreMasterCard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

!WAStoreMasterCard commentStamp: 'avi 1/1/2004 09:35' prior: 0!
Adds MasterCard-specific validation to WAStoreCreditCard.!

!WAStoreMasterCard class methodsFor: 'accessing' stamp: 'avi 12/10/2003 14:04'!
abbreviation
	^ 'MC'! !

!WAStoreMasterCard methodsFor: 'actions' stamp: 'cds 7/25/2005 10:20'!
validate
	super validate.
	number first = $5 ifFalse: [self validationError: 'Mastercard numbers must start with "5"'].
! !

WAStoreCreditCard subclass: #WAStoreVisaCard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

!WAStoreVisaCard commentStamp: 'avi 1/1/2004 09:35' prior: 0!
Adds VISA-specific validation to WAStoreCreditCard.!

!WAStoreVisaCard class methodsFor: 'accessing' stamp: 'avi 12/10/2003 14:04'!
abbreviation
	^ 'VISA'! !

!WAStoreVisaCard methodsFor: 'actions' stamp: 'cds 7/25/2005 10:20'!
validate
	super validate.
	number first = $4 ifFalse: [self validationError: 'Visa card numbers must start with "4"'].
! !

Object subclass: #WAStoreInventory
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

WAStoreInventory class
	instanceVariableNames: 'default'!

!WAStoreInventory commentStamp: 'avi 1/1/2004 09:33' prior: 0!
The list of inventory items.  In a real application, this would probably have to deal with persistence, maintaining inventory counts, etc.  In this example, it just builds a collection of WAStoreItems from a hardcoded data set, and provides #allItems and #findItem: for accessing these.!

WAStoreInventory class
	instanceVariableNames: 'default'!

!WAStoreInventory class methodsFor: 'defaults' stamp: 'avi 12/8/2003 14:26'!
default
	^ default ifNil: [default := self new]! !

!WAStoreInventory class methodsFor: 'instance creation' stamp: 'avi 12/8/2003 14:17'!
new
	^ self basicNew initialize! !

!WAStoreInventory methodsFor: 'accessing' stamp: 'ab 8/15/2003 17:19'!
allItems
	^ items! !

!WAStoreInventory methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:19'!
findItem: searchString
	^ items select: [:ea | ea matches: searchString]! !

!WAStoreInventory methodsFor: 'initialize-release' stamp: 'ab 8/15/2003 17:19'!
initialize
	items := OrderedCollection new.
	self itemSpecs do:
		[:row |
		items add: (self itemFromSpec: row)]! !

!WAStoreInventory methodsFor: 'as yet unclassified' stamp: 'pmm 11/2/2005 23:45'!
itemFromSpec: anArray
	^ WAStoreItem new
		title: anArray first;
		subtitle: anArray second;
		description: anArray third;
		price: anArray fourth;
		yourself! !

!WAStoreInventory methodsFor: 'as yet unclassified' stamp: 'avi 9/18/2003 16:43'!
itemSpecs
"adapted from http://www.thaddeus.com/ftp/database/sushi.zip"
	^ #(
#('Akami Maguro' 'Red Tuna' 'The lean meat near the spine of the tuna fish.  It comes in various shades of red--with the lighter, shinier varieties being the best.  For dieters, however, the redder the better.  Easy on the palatte.  The least expensive of the three types of maguro.' 150)
#('Chutoro Maguro' 'Fatty Tuna' 'The moderately fatty part of the tuna belly.  It''s pink, but not the faint pink of ohtoro.  Soft, butter-like texture.  Moderately expensive.' 275)
#('Geso Ika' 'Cuttlefish Tentacles' 'White in color, geso is boiled and brushed with thick teriyaki sauce before serving as sushi.  Its texture is chewy, and its mild flavor is complemented by the sweet-salty teriyaki.' 200)
#('Himo Akagai' 'Ark Shell Filaments' 'This is the thread-like edges which connect the flesh to the shell.  A delicious, soft texture and mild taste.' 200)
#('Hotategai' 'Scallop' 'The part of the scallop that is eaten is the edible adductor muscle that opens the animal''s shell.  It''s pale beige-yellow in color with a brown, crusty edging.  The taste is delicate, and melts in your mouth. ' 250)
#('Iwashi' 'Sardine' 'Shiny, slippery, and ''fishy,'' the taste of sardine sushi is slightly oily.  Sardine must be eaten shortly after it has been caught if it''s to be used in Sushi.  Often eaten with soy sauce mixed with ginger and onion.' 175)
#('Kazunoko' 'Herring Roe' 'An expensive delicacy which is also known as ''yellow diamonds'' (because of the color and expense).  Revered in Japan, it''s usually eaten on special occasions.  An acquired taste for Westerners.' 475)
#('Kisu' 'Sillago' 'A fresh Sillago has bright-gold skin. The taste is mild and delicate.' 225)
#('Ohtoro Maguro' 'Fattiest Tuna' 'Fattiest part of the fatty tuna belly.  It is light pink in color and melts in your mouth.  Mild with a rich texture.  This is the most expensive of the three types of Maguro sushi.' 325)
#('Shima-Aji' 'Yellow Jack' 'A slice of white silvery shima-aji eaten with beef-steak plant and fresh ginger is delicious.  The flavor is delicate and the texture of good, fresh yellow jack is smooth and slides down easily.' 180)
#('Aji' 'Horse Mackerel' 'This fish is pink-grey and shiny.  When it''s fresh, the flesh is almost transparent.  The texture is slippery and easy on the tongue--it should melt in your mouth.  Aji is often eaten with soy sauce containing onion, ginger and garlic.' 250)
#('Inarizushi' 'Stuffed Bean Curd Rolls' '' 200)
#('Kappa Maki' 'Cucumber Rolls' '' 150)
#('Sakura Denbu' 'Shredded Cod Fish' 'Seasoned shredded cod fish.' 200)
#('California Roll' '' 'Rice, cucumber, crab meat, & avacado.' 250)
#('Futo-Maki' 'Fat Rolls' 'Kampyo gourd, oboro or denbu pink powder, tamago omelet, and shiitake mushrooms. May also include bamboo shoots, cucumbers, cooked eel, cooked carrots, and cooked spinach or other greens.' 275)
#('Tekkamaki' 'Tuna Roll' 'Tuna wrapped in rice and nori.' 225)
#('Chakinzushi' 'Omelet-wrapped Sushi' 'Sushi rice in a thin omelet wrapper shaped and tied like a lady''s drawstring purse.  Sometimes a single pea or small shrimp decorates the ruffled part of the wrapper.' 300)
#('Shiro Maguro' 'Albacore Tuna' '' 300)
#('Hamachi' 'Yellowtail' '' 325)
#('Kohada' 'Gizzard Shad' 'This Japanese shad is a member of the herring family, and is a small silver-grey fish, with a black spotted back.  Marinated in vinegar and cross- hatched before serving.  The taste is strong, and a favorite for herring fans.' 275)
#('Katsuo' 'Bonito' '' 275)
#('Saba' 'Mackerel' '' 200)
#('Sake' 'Salmon' '' 250)
#('Tai' 'Red Snapper' '' 250)
#('Hirame' 'Flounder' 'Good hirame is a sushi gourmet''s delight.  Since it''s cut from such a small part of the fish, it''s scarce and expensive.  In appearance, it''s pale pink and smooth, with no markings.  The taste is delicate and buttery.' 350)
#('Suzuki' 'Sea Bass' '' 300)
#('Unagi' 'Freshwater Eel' '' 300)
#('Ika' 'Cuttlefish' 'When fresh, cuttlefish is almost transparent.  It''s butter-like and melts in your mouth.  The texture is sticky.  Cuttlefish is smoky white and glistens. Also popular grilled and mixed with ginger soy sauce.  Also good with lemon for Western palettes.' 325)
#('Awabi' 'Abalone' 'Abalone or ''sea snail'' is another sushi favorite.  The color ranges from beige-grey to pinkish yellow.  Fresh abalone is not too rubbery, and is very subtle in flavor.' 300)
#('Mirugai' 'Horse Clam' 'Also known as Geoduck.  This is a large, hard-shelled clam which is yellowish-white in color.  It has a slight ''shellfish'' taste and an elastic type texture. The part used in sushi is the long muscular siphon which projects from the shell.' 350)
#('Akagai' 'Ark Shell Clam' 'The softest texture of any shellfish. Akagai has an attractive pink-orange color.  The taste is delicate and slightly sweet.' 300)
#('Kobashira' 'Trough Shell (Small) Scallop' 'The edible adductor muscle that opens the shell of the aoyagi.  More prized than the aoyagi itself.' 500)
#('Kani' 'Crab' '' 250)
#('Ebi' 'Cooked Prawn' '' 225)
#('Ikura' 'Salmon Roe' 'Appealing to the eye with its bright red color.  Very appetizing with a delicate taste.' 325)
#('Tobiko ' 'Flying-Fish Roe' '' 350)
#('Masago ' 'Capelin Roe' '' 350)
#('Anago' 'Conger Eel' 'Anago is one of the few pre-cooked sushi.  It is grilled and basted with a thick teriyaki sauce.  The soft, slighty warm eel, the sweet soy sauce, and the vinegared rice make a particularly delicious sushi.' 300)
#('Uni' 'Sea Urchin Roe' 'A prized delicacy with its oily, rich texture.  Mustard color, paste-like topping is held in place by a band of nori seaweed.' 400)
) asSortedCollection: [:a :b | a first <= b first]! !

Object subclass: #WAStoreItem
	instanceVariableNames: 'title subtitle description price'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

!WAStoreItem commentStamp: 'avi 1/1/2004 09:34' prior: 0!
Models a single item of inventory - stores a title, subtitle, fill description, and price.  The only real behavior is #matches:, which is used for search.!

!WAStoreItem methodsFor: 'accessing' stamp: 'ab 5/25/2003 13:27'!
description
	^ description! !

!WAStoreItem methodsFor: 'accessing' stamp: 'ab 5/25/2003 13:27'!
description: aString
	description := aString! !

!WAStoreItem methodsFor: 'private' stamp: 'ab 5/25/2003 13:30'!
matches: aString
	^ (title includesSubstring: aString caseSensitive: false)
		or: [description includesSubstring: aString caseSensitive: false]! !

!WAStoreItem methodsFor: 'accessing' stamp: 'ab 5/25/2003 13:28'!
price
	^ price! !

!WAStoreItem methodsFor: 'accessing' stamp: 'ab 5/25/2003 13:28'!
price: cents
	price := cents! !

!WAStoreItem methodsFor: 'printing' stamp: 'avi 12/9/2003 13:17'!
printString
	^ self title! !

!WAStoreItem methodsFor: 'accessing' stamp: 'ab 5/31/2003 23:17'!
subtitle
	^ subtitle! !

!WAStoreItem methodsFor: 'accessing' stamp: 'avi 8/29/2004 14:12'!
subtitle: aString
	subtitle := aString! !

!WAStoreItem methodsFor: 'accessing' stamp: 'ab 5/25/2003 13:27'!
title
	^ title! !

!WAStoreItem methodsFor: 'accessing' stamp: 'ab 5/25/2003 13:27'!
title: aString
	title := aString! !

Object subclass: #WAStringLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Libraries'!

WAStringLibrary subclass: #WAScriptLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Libraries'!

!WAScriptLibrary class methodsFor: 'as yet unclassified' stamp: 'mb 3/9/2006 10:46'!
generateXref
	"((( WAStandardScripts generateXref )))"
	| aStream sel |
	self new do:
		[:script |
		aStream := script readStream.
		[aStream atEnd] whileFalse:
			[aStream upToAll: 'function'.
			sel := (aStream upTo: $() trimBlanks.
			sel notEmpty ifTrue:
				[self compile: sel classified: 'for x-ref']]]
! !

!WAScriptLibrary class methodsFor: 'processing' stamp: 'avi 6/24/2004 00:34'!
updateRoot: anHtmlRoot
	self new do: [:ea | anHtmlRoot addScript: ea]! !

!WAScriptLibrary methodsFor: 'accessing' stamp: 'pmm 4/22/2006 00:31'!
extension
	^'.js'! !

!WAScriptLibrary methodsFor: 'accessing' stamp: 'lr 11/21/2006 20:43'!
mimetype
	^ 'text/javascript'! !

WAScriptLibrary subclass: #WAStandardScripts
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Libraries'!

!WAStandardScripts class methodsFor: 'processing' stamp: 'pmm 9/12/2006 19:28'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot bodyAttributes
		at: 'onKeyDown'
		put: 'onKeyDown(event)'
! !

!WAStandardScripts methodsFor: 'scripts' stamp: 'mb 3/8/2006 15:55'!
misc
	^ '
	function swapDisplay(a, b) {
		var tmp = document.getElementById(a).style.display;
		document.getElementById(a).style.display = document.getElementById(b).style.display;
		document.getElementById(b).style.display = tmp;
	}

	function submitFormTriggeringCallback(formName, callbackKey, value) {
		if (value)
			{
				var ele = document.createElement("input");
				ele.type = "hidden";
				ele.name = callbackKey;
				ele.value = value;
				document.forms[formName].appendChild(ele)
			}
		submitForm(formName)
	}

	function submitForm(formName) {
		document.forms[formName].submit();
	}
	
	function chooseOther(select, hiddenId, p) {
		value = prompt(p);
		document.getElementById(hiddenId).value = value;
		select.options[select.options.length-1].text = value;
	}
	
	function enableChoice(enableID, disableID) {
		document.getElementById(enableID).disabled = false;
		document.getElementById(disableID).disabled = true;
	}

	function setFocus(elementId) {
		document.getElementById(elementId).focus();
	}

	function setCursor(elementId, pos) {
		var input = document.getElementById(elementId);
		input.focus();
		/* When pos parameter not supplied, place cursor at end of input field */
		if (!!pos) pos = input.value.length;
		if (typeof document.selection !!= "undefined") {
	    		/* Place cursor in MS-IE */
	    		var range = document.selection.createRange();
	     	range.moveStart("character", pos);
	 		range.select();
	  	} else if (typeof input.selectionStart !!= "undefined") {
		  	/* Place cursor in Gecko browsers */
	    		input.selectionStart = pos;
	    		input.selectionEnd = pos;
	  	} else {
	  		/* Other browsers, please feel free to implement */
			alert("unknown browser");
		}
	}

'! !

!WAStandardScripts methodsFor: 'scripts' stamp: 'mb 3/9/2006 11:08'!
shortcuts
	^ '

	var shortcutKeys = [];
	var shortcutElements = [];	

	function resetShortcuts() {
		shortcutKeys = [];
		shortcutElements = [];	
	}

	function addShortcut(shortcut, elementID) {
		var elem = document.getElementById(elementID);
		if ((elem.tagName == "INPUT" & (elem.type == "submit" || elem.type == "checkbox" || elem.type == "radio")) || elem.tagName == "A")
			{
			shortcutKeys[shortcutKeys.length] = shortcut;
			shortcutElements[shortcutElements.length] = elem;
			}
		else alert("Attempt to assign a shortcut (" + shortcut + ") to something that is not clickable");
	}

	function onKeyDown(event) {
		var keyname = "";
		var element;
		var nav;
		if (navigator.userAgent.indexOf("Safari") > 0)
			nav = "Safari";
		else if (navigator.product == "Gecko")
			nav = "Gecko";
		else
			nav = "IE";
		// cope with MS-IE
		if (event == null) event = window.event;
		if (event) {
			if (event.ctrlKey) keyname = keyname + "Ctrl-";
			if (event.altKey) keyname = keyname + "Alt-";
			if (event.metaKey) keyname = keyname + "Meta-";
			// cope with Netscape
			var keyCode = event.which;
			if (keyCode == null) keyCode = event.keyCode;
			if (keyCode == null) keyCode = event.charCode;
			if (keyCode !!= 0) {
				var character = String.fromCharCode(keyCode);
				character = character.toLowerCase();
				if (event.shiftKey) character = character.toUpperCase();
				// cope with special keys, designated with some logical names
				if (keyCode == 27) character = "Esc";
				if (keyCode == 8) character = "Backspace";
				if (keyCode == 9) character = "Tab";
				if (keyCode == 13) character = "Return";
				if (keyCode == 37) character = "Left";
				if (keyCode == 38) character = "Up";
				if (keyCode == 39) character = "Right";
				if (keyCode == 40) character = "Down";
				// cope with func-keys (some keys not intercepted for MS-IE)
				if ((keyCode >= 112) & (keyCode <= 123)) character = "F" + (keyCode - 112 + 1);
				for ( var x = 1 ; x <= shortcutKeys.length ; x++ ) {
					if (shortcutKeys[x-1] == keyname+character) {
						// alert("key=" + keyCode + " " + keyname + character);
						element = shortcutElements[x-1];
						if (element.tagName == "A" & nav !!= "IE") {
							if (element.onclick) 
								element.onclick.call();
							else
								/* This does not work for anchor in IE */
								location.href = element.href;
						} else  {
							element.click();
						}
					}
				}
				return false;
			}
		}
	}

'! !

!WAStringLibrary methodsFor: 'converting' stamp: 'pmm 4/22/2006 00:49'!
asSelector: aFilename
	^(aFilename copyUpToLast: $.) asSymbol! !

!WAStringLibrary methodsFor: 'printing' stamp: 'avi 6/24/2004 00:28'!
asString
	^ self class name! !

!WAStringLibrary methodsFor: 'accessing' stamp: 'avi 6/24/2004 00:13'!
at: aSymbol
	^ self perform: aSymbol! !

!WAStringLibrary methodsFor: 'accessing' stamp: 'avi 6/24/2004 00:13'!
at: aSymbol put: aString
	self class compile: aSymbol, '
	^ ', aString printString! !

!WAStringLibrary methodsFor: 'accessing' stamp: 'pmm 4/22/2006 00:42'!
configurationComponent
	^ WAStringLibraryEditor new
		library: self;
		yourself! !

!WAStringLibrary methodsFor: 'printing' stamp: 'mbany 4/14/2005 13:01'!
displayString
	^ self class name! !

!WAStringLibrary methodsFor: 'enumerating' stamp: 'mb 2/9/2006 16:02'!
do: aBlock
	self keys do: 
		[:each |
		| object |
		object := self at: each.
		object isString ifTrue: [aBlock value: object]].! !

!WAStringLibrary methodsFor: 'accessing' stamp: 'lr 11/16/2006 19:10'!
documentAt: aFilename ifAbsent: aBlock
	| selector |
	selector := self asSelector: aFilename.
	^(self fileSelectors includes: selector)
		ifTrue: [ WAResponse
			document: (self at: selector)
			mimeType: (self mimetype)
			fileName: aFilename	 ]
		ifFalse: [ aBlock value ]! !

!WAStringLibrary methodsFor: 'accessing' stamp: 'pmm 4/22/2006 00:32'!
extension
	self subclassResponsibility ! !

!WAStringLibrary methodsFor: 'accessing' stamp: 'mb 10/17/2006 13:59'!
fileSelectors
	^self keys select: [:each | (self at: each) isString].! !

!WAStringLibrary methodsFor: 'accessing' stamp: 'mb 10/17/2006 13:59'!
filenames
	^self fileSelectors collect: [ :each |
		each , self extension ]! !

!WAStringLibrary methodsFor: 'accessing' stamp: 'avi 9/21/2005 21:52'!
keys
	^ (self class selectors select: [:ea | ea isUnary]) asSortedCollection! !

!WAStringLibrary methodsFor: 'accessing' stamp: 'pmm 4/22/2006 00:36'!
mimetype
	self subclassResponsibility ! !

!WAStringLibrary methodsFor: 'accessing' stamp: 'mb 10/17/2006 13:42'!
name
	^ self class name! !

WAStringLibrary subclass: #WAStyleLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Libraries'!

WAStyleLibrary subclass: #WAStandardStyles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Libraries'!

!WAStandardStyles methodsFor: 'styles' stamp: 'lr 9/26/2005 15:15'!
basics
	^ 'div.clearer {clear: both}
.option-selected {font-weight: bold}'! !

!WAStandardStyles methodsFor: 'styles' stamp: 'mb 11/16/2006 18:59'!
kalseyTabs
	"this is from http://kalsey.com/tools/csstabs/ - would also be nice to do http://www.alistapart.com/articles/slidingdoors/"
	^ '
.kalsey .navigation-options {
	border-bottom : 1px solid #ccc;
	margin : 0;
	padding-bottom : 19px;
	padding-left : 10px;
}

.kalsey .navigation-options ul, .kalsey .navigation-options li	{
	display : inline;
	list-style-type : none;
	margin : 0;
	padding : 0;
}

	
.kalsey .navigation-options a:link, .kalsey .navigation-options a:visited	{
	background : #E8EBF0;
	border : 1px solid #ccc;
	color : #666;
	float : left;
	font-size : small;
	font-weight : normal;
	line-height : 14px;
	margin-right : 8px;
	padding : 2px 10px 2px 10px;
	text-decoration : none;
}

.kalsey .navigation-options a:link.active, .kalsey .navigation-options a:visited.active	{
	background : #fff;
	border-bottom : 1px solid #fff;
	color : #000;
}

.kalsey .navigation-options ul a:hover	{
	color : #f00;
}

.kalsey .navigation-options .option-selected a {
	background : #fff;
	border-bottom : 1px solid #fff;
	color : #000;
}

.kalsey .navigation-content {
	background : #fff;
	border : 1px solid #ccc;
	border-top : none;
	clear : both;
	margin : 0px;
	padding : 15px;
	line-height: 1.1;  /* IE6 CSS workaround - http://www.dracos.co.uk/web/css/ie6floatbug/ */
}
'! !

!WAStandardStyles methodsFor: 'styles' stamp: 'lr 10/3/2006 09:27'!
sourceStyle
	^'.halo .halo-source .tag-known {
	font-weight: bold;
	color: navy;
}
.halo .halo-source .attribute-known {
	color: navy;
}
.halo .halo-source .attribute-value {
	color: purple;
}
.halo-source .comment {
	font-style: italic;
	color: green;
}'! !

!WAStyleLibrary class methodsFor: 'processing' stamp: 'avi 6/24/2004 00:34'!
updateRoot: anHtmlRoot
	self new do: [:ea | anHtmlRoot addStyle: ea]! !

!WAStyleLibrary methodsFor: 'accessing' stamp: 'pmm 4/22/2006 00:31'!
extension
	^'.css'! !

!WAStyleLibrary methodsFor: 'accessing' stamp: 'pmm 4/22/2006 00:36'!
mimetype
	^'text/css'! !

Object subclass: #WAUrl
	instanceVariableNames: 'host port scheme path params fragment parameterString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-HTTP'!

!WAUrl class methodsFor: 'instance creation' stamp: 'avi 3/18/2004 16:07'!
new
	^ self basicNew initialize! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/22/2004 00:45'!
addParameter: aString
	self addParameter: aString value: nil
! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 11/7/2005 13:09'!
addParameter: keyString value: valueString
	params at: keyString put: valueString.
	parameterString := nil! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/22/2004 00:45'!
addToPath: aString
	path addAll: (aString findTokens: '/')! !

!WAUrl methodsFor: 'printing' stamp: 'avi 3/22/2004 00:42'!
asString
	^ self urlWithQueryString! !

!WAUrl methodsFor: 'copying' stamp: 'avi 4/15/2004 11:35'!
copy
	| copy |
	copy := self class new.
	copy hostname: host; port: port; scheme: scheme; fragment: fragment.
	copy addToPath: self pathString.
	params keysAndValuesDo: [:k :v | copy addParameter: k value: v].
	^ copy! !

!WAUrl methodsFor: 'private' stamp: 'avi 3/22/2004 00:47'!
defaultPortForScheme: aSymbol
	^ aSymbol = #http
		ifTrue: [80]
		ifFalse: [aSymbol = #https
					ifTrue: [443]]! !

!WAUrl methodsFor: 'printing' stamp: 'mbany 4/14/2005 13:02'!
displayString
	^ self urlWithQueryString! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 4/15/2004 11:35'!
fragment
	^ fragment! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 4/15/2004 11:35'!
fragment: aString
	fragment := aString! !

!WAUrl methodsFor: 'printing' stamp: 'avi 4/15/2004 11:35'!
fragmentString
	^ fragment ifNil: [''] ifNotNil: ['#', fragment]! !

!WAUrl methodsFor: 'requesting' stamp: 'mb 3/24/2006 18:03'!
getDocument
	^ SeasidePlatformSupport getDocumentWithUrl: self! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/19/2004 14:37'!
hostname
	^ host! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/19/2004 14:37'!
hostname: aString
	host := aString! !

!WAUrl methodsFor: 'initialize-release' stamp: 'avi 3/22/2004 00:48'!
initialize
	path := OrderedCollection new.
	params := Dictionary new.
	scheme := #http! !

!WAUrl methodsFor: 'printing' stamp: 'avi 11/7/2005 12:25'!
isSeasideField: aString
	^ aString first  = $_ or: [aString allSatisfy: [:ea | ea isDigit]]! !

!WAUrl methodsFor: 'private' stamp: 'avi 11/7/2005 12:26'!
orderedParameterKeys 
	| keys |
	keys := OrderedCollection new.
	params keys do: [:ea | (self isSeasideField: ea) ifTrue: [keys addLast: ea] ifFalse: [keys addFirst: ea]].
	^ keys! !

!WAUrl methodsFor: 'printing' stamp: 'avi 11/7/2005 13:08'!
parameterString
	| v |
	^ parameterString ifNil: [parameterString := String streamContents:
		[:s |
		params isEmpty ifFalse:
			[s nextPut: $?.
			self orderedParameterKeys do:
				[:k |
				v := params at: k.
				s nextPutAll: k encodeForHTTP.
				v ifNotNil: [s nextPut: $=; nextPutAll: v encodeForHTTP].
				s nextPut: $&].
			s skip: -1]]]! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/19/2004 13:11'!
parameters
	^ params! !

!WAUrl methodsFor: 'accessing' stamp: 'pmm 9/12/2006 19:22'!
parametersForHttpSocket
	"ugly dictionary should support some form of #collect: that creates a Dictionary, maybe #map: or so"
	| dictionary |
	dictionary := Dictionary new.
	self parameters keysAndValuesDo: [ :key :value |
		dictionary at: key put: (Array with: value) ].
	^ dictionary! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/22/2004 00:46'!
path
	^ path! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 5/3/2005 08:51'!
pathString
	^ String streamContents: [ :stream | 
		stream nextPut: $/.
		path 
			do: [ :each | stream nextPutAll: each ]
			separatedBy: [ stream nextPut: $/ ] ]
! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/22/2004 00:47'!
port
	^ port ifNil: [self defaultPortForScheme: scheme]! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/18/2004 16:07'!
port: aNumber
	port := aNumber! !

!WAUrl methodsFor: 'printing' stamp: 'avi 11/7/2005 12:31'!
queryString
	^ self parameterString, self fragmentString! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/22/2004 00:47'!
scheme
	^ scheme! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/22/2004 00:47'!
scheme: aSymbol
	scheme := aSymbol! !

!WAUrl methodsFor: 'printing' stamp: 'avi 11/28/2005 16:07'!
serverString
	host ifNil: [^ ''].
	
	^ String streamContents:
		[:stream |
		stream nextPutAll: scheme.
		stream nextPutAll: '://'.
		stream nextPutAll: host.
		
		((self defaultPortForScheme: scheme) = self port)
			ifFalse: [stream nextPutAll: ':', port displayString]]! !

!WAUrl methodsFor: 'private' stamp: 'avi 11/7/2005 13:07'!
setParameterString: aString
	parameterString := aString! !

!WAUrl methodsFor: 'accessing' stamp: 'pmm 10/29/2006 07:29'!
takeServerParametersFromRequest: aRequest
	| httpHost |
	host ifNil: [
		httpHost := aRequest hostIfAbsent: [^ self]. 
		host := httpHost copyUpTo: $:.
		(httpHost includes: $:) ifTrue: [
			port := (httpHost copyAfter: $:) asNumber ] ]! !

!WAUrl methodsFor: 'printing' stamp: 'avi 4/15/2004 11:36'!
urlString
	^ self serverString, self pathString, self fragmentString! !

!WAUrl methodsFor: 'printing' stamp: 'avi 10/6/2005 10:00'!
urlWithQueryString
	^ String streamContents:
		[:s |
		s nextPutAll: self serverString.
		s nextPutAll: self pathString.
		s nextPutAll: self queryString]! !

!WAUrl methodsFor: 'copying' stamp: 'avi 3/22/2004 00:52'!
with: pathString
	^ self copy
		addToPath: pathString;
		yourself! !

!WAUrl methodsFor: 'copying' stamp: 'avi 11/7/2005 13:08'!
withParameter: aString
	^ self copy
		addParameter: aString;
		setParameterString: (self parameterString, '&', aString);
		yourself! !

!WAUrl methodsFor: 'copying' stamp: 'avi 3/22/2004 00:51'!
withParameter: aString value: valueString
	^ self copy
		addParameter: aString value: valueString;
		yourself! !

Object subclass: #WAUtf8EncodingStream
	instanceVariableNames: 'stream encoder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

!WAUtf8EncodingStream commentStamp: 'pmm 10/14/2006 14:37' prior: 0!
I wrap a SocketStream and encode the input to utf-8.
Unfortunately such hacks are needed because of the Squeak Stream hierarchy.!

!WAUtf8EncodingStream class methodsFor: 'instance creation' stamp: 'pmm 10/14/2006 04:03'!
on: aStream
	^self new
		setStream: aStream;
		yourself! !

!WAUtf8EncodingStream methodsFor: 'accessing' stamp: 'pmm 10/14/2006 11:12'!
basicNextPut: aCharacter
	stream nextPut: aCharacter! !

!WAUtf8EncodingStream methodsFor: 'accessing' stamp: 'pmm 10/14/2006 04:09'!
crlf
	stream crlf! !

!WAUtf8EncodingStream methodsFor: 'initialize-release' stamp: 'pmm 10/14/2006 14:15'!
initialize
	super initialize.
	encoder := TextConverter newForEncoding: 'utf8'! !

!WAUtf8EncodingStream methodsFor: 'accessing' stamp: 'pmm 10/14/2006 11:14'!
isBinary
	^false! !

!WAUtf8EncodingStream methodsFor: 'accessing' stamp: 'pmm 10/14/2006 11:13'!
nextPut: aCharacter
	encoder nextPut: aCharacter toStream: self ! !

!WAUtf8EncodingStream methodsFor: 'accessing' stamp: 'pmm 10/14/2006 04:02'!
nextPutAll: aColllection
	aColllection do: [ :each |
		self nextPut: each ]! !

!WAUtf8EncodingStream methodsFor: 'initialize-release' stamp: 'pmm 10/14/2006 04:02'!
setStream: aStream
	stream := aStream! !

!WAUtf8EncodingStream methodsFor: 'accessing' stamp: 'pmm 10/14/2006 11:16'!
socket
	^stream socket! !

PackageInfo subclass: #Seaside2Info
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

!Seaside2Info class methodsFor: 'initialization' stamp: 'avi 3/24/2004 12:19'!
initialize
	[self new register] on: MessageNotUnderstood do: ["must be an old version of PackageInfo"]! !

!Seaside2Info methodsFor: 'naming' stamp: 'ab 10/26/2002 15:41'!
packageName
	^ 'Seaside2'! !

!Seaside2Info methodsFor: 'naming' stamp: 'cwp 4/25/2004 18:40'!
systemCategoryPrefix
	^ 'Seaside'! !

PackageInfo subclass: #SeasideAddonVWInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

!SeasideAddonVWInfo class methodsFor: 'accessing' stamp: 'mb 10/6/2006 19:30'!
addonName
	self subclassResponsibility! !

!SeasideAddonVWInfo class methodsFor: 'actions' stamp: 'mb 10/6/2006 19:30'!
fileOutVW5
	(Smalltalk classNamed: #VW5PackageExporter)
		ifNotNilDo: [ :class | 
			class 
				fileOutPackage: self default 
				on: (FileStream forceNewFileNamed: self addonName , 'VW5.st') ]! !

!SeasideAddonVWInfo methodsFor: 'accessing' stamp: 'mb 10/6/2006 19:31'!
addonName
	^self class addonName! !

!SeasideAddonVWInfo methodsFor: 'accessing' stamp: 'mb 10/6/2006 19:31'!
externalName
	^ self addonName! !

!SeasideAddonVWInfo methodsFor: 'accessing' stamp: 'mb 10/6/2006 19:31'!
ignoredCategories
	^ #('Platform')! !

!SeasideAddonVWInfo methodsFor: 'accessing' stamp: 'mb 10/6/2006 19:32'!
includesSystemCategory: aString
	^ (aString beginsWith: self addonName , '-') 
		and: [(self ignoredCategories includes: (aString copyAfter: $-)) not]! !

!SeasideAddonVWInfo methodsFor: 'accessing' stamp: 'mb 10/6/2006 19:32'!
isYourClassExtension: aString
	^ (self category: aString asLowercase matches: '*' , self addonName asLowercase)
		and: [(aString endsWith: 'squeak') not]! !

!SeasideAddonVWInfo methodsFor: 'accessing' stamp: 'mb 10/6/2006 19:33'!
name
	^ self addonName! !

!SeasideAddonVWInfo methodsFor: 'accessing' stamp: 'mb 10/6/2006 19:33'!
namespace
	^ 'Seaside'! !

!SeasideAddonVWInfo methodsFor: 'accessing' stamp: 'mb 10/6/2006 19:33'!
needsNamespace
	^false! !

!SeasideAddonVWInfo methodsFor: 'accessing' stamp: 'mb 10/6/2006 19:33'!
packageName
	^ self addonName , 'VW'! !

!SeasideAddonVWInfo methodsFor: 'accessing' stamp: 'mb 10/6/2006 19:34'!
versionString
	| ancestor |
	ancestor := (MCPackage named: self name) workingCopy ancestry ancestors first.
	^ancestor name , '.mcz      ' , ancestor date printString, ' ', ancestor time printString ! !

PackageInfo subclass: #SeasideVWInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

!SeasideVWInfo class methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 17:00'!
fileOutVW3
	VW3PackageExporter fileOutPackage: self default on: (FileStream forceNewFileNamed: 'SeasideVW3.st')! !

!SeasideVWInfo class methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 17:00'!
fileOutVW5
	VW5PackageExporter fileOutPackage: self default on: (FileStream forceNewFileNamed: 'SeasideVW5.st')! !

!SeasideVWInfo methodsFor: 'naming' stamp: 'ab 6/14/2003 17:46'!
externalName
	^ 'Seaside'! !

!SeasideVWInfo methodsFor: 'accessing' stamp: 'mb 3/21/2006 17:40'!
ignoredCategories
	^ #('Platform' 'Base-Connections' 'Rendering-Buttons' 'Components-Tools-Squeak' 'Utilities-Squeak')! !

!SeasideVWInfo methodsFor: 'testing' stamp: 'avi 3/20/2004 17:55'!
includesSystemCategory: aString
	^ (aString beginsWith: 'Seaside-') and: [(self ignoredCategories includes: (aString copyAfter: $-)) not]! !

!SeasideVWInfo methodsFor: 'testing' stamp: 'ab 5/28/2003 23:13'!
isYourClassExtension: aString
	^ (self category: aString asLowercase matches: '*seaside2')
		and: [(aString endsWith: 'squeak') not]! !

!SeasideVWInfo methodsFor: 'naming' stamp: 'mb 5/30/2006 13:52'!
name
	^ 'Seaside2'! !

!SeasideVWInfo methodsFor: 'testing' stamp: 'mb 11/27/2005 10:17'!
needsNamespace
	^true
! !

!SeasideVWInfo methodsFor: 'naming' stamp: 'mb 5/30/2006 13:52'!
packageName
	^ 'SeasideVW'! !

!SeasideVWInfo methodsFor: 'accessing' stamp: 'mb 5/30/2006 13:59'!
versionString
	| ancestor |
	ancestor := (MCPackage named: self name) workingCopy ancestry ancestors first.
	^ancestor name , '.mcz      ' , ancestor date printString, ' ', ancestor time printString ! !

!HttpRequest methodsFor: '*seaside2-squeak' stamp: 'dc 11/5/2006 21:45'!
parseCookies: aString 
	"PRIVATE: Parse a string in the format:  
	Cookie: NAME1=OPAQUE_STRING1; NAME2=OPAQUE_STRING2 ..."

	| dict |
	dict := Dictionary new.
	(aString findTokens: ';') do: 
			[:pairStr | 
			| pair |
			pair := pairStr findTokens: '='.
			pair size > 0 
				ifTrue: 
					[| key value |
					key := pair first withBlanksTrimmed asSymbol.
					value := pair size > 1 
						ifTrue:
							[pair second withBlanksTrimmed]
						ifFalse:
							[nil].
					dict at: key put: value]
				ifFalse: 
					["self log: 'Cookie invalid pair format: ''' , pairStr , ''''"

					]].
	^dict! !

!Number methodsFor: '*seaside2' stamp: 'mb 3/23/2006 07:34'!
convertSeasideString: aString
	^ aString asNumber! !

!Number methodsFor: '*seaside2' stamp: 'mb 5/20/2006 10:01'!
em
	^ self printString , 'em'! !

!Number methodsFor: '*seaside2' stamp: 'mb 5/20/2006 10:01'!
px
	^ self printString , 'px'! !

!True methodsFor: '*seaside2' stamp: 'ac 3/22/2005 20:23'!
yesNoString
	^ 'Yes'! !

!Dictionary methodsFor: '*seaside2' stamp: 'ab 10/1/2002 13:48'!
inspectorFields
	^ self! !

!JPEGReadWriter2 methodsFor: '*seaside2-squeak' stamp: 'mb 6/12/2006 13:58'!
nextPutImage: aForm quality: quality progressiveJPEG: progressiveFlag
	"Encode the given Form on my stream with the given settings. Quality goes from 0 (low) to 100 (high), where -1 means default. If progressiveFlag is true, encode as a progressive JPEG."

	| sourceForm jpegCompressStruct jpegErrorMgr2Struct buffer byteCount |
	aForm unhibernate.
	"odd width images of depth 16 give problems; avoid them."
	sourceForm _ (aForm depth = 32) | (aForm width even & (aForm depth = 16))
		ifTrue: [aForm]
		ifFalse: [aForm asFormOfDepth: 32].
	jpegCompressStruct _ ByteArray new: self primJPEGCompressStructSize.
	jpegErrorMgr2Struct _ ByteArray new: self primJPEGErrorMgr2StructSize.
	buffer _ ByteArray new: sourceForm width * sourceForm height + 1024.
	byteCount _ self primJPEGWriteImage: jpegCompressStruct 
		onByteArray: buffer
		form: sourceForm
		quality: quality
		progressiveJPEG: progressiveFlag
		errorMgr: jpegErrorMgr2Struct.
	byteCount = 0 ifTrue: [self error: 'buffer too small for compressed data'].
	stream next: byteCount putAll: buffer startingAt: 1.
	self close.
! !

!Fraction methodsFor: '*seaside2' stamp: 'mb 11/27/2005 10:11'!
asSeasideString
	^ self asFloat displayString
! !

!Fraction methodsFor: '*seaside2' stamp: 'mb 3/23/2006 07:37'!
convertSeasideString: aString
	^ aString = self asSeasideString ifTrue: [self] ifFalse:[ aString asNumber]
! !

Notification subclass: #WADeprecatedApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Utilities'!

Notification subclass: #WADynamicVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Utilities'!

WADynamicVariable subclass: #WACurrentSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WADynamicVariable class methodsFor: 'defaults' stamp: 'avi 3/29/2004 14:12'!
defaultValue
	^ nil! !

!WADynamicVariable class methodsFor: 'as yet unclassified' stamp: 'avi 3/29/2004 14:13'!
use: anObject during: aBlock
	^ aBlock
		on: self
		do: [:n | n resume: anObject]! !

!WADynamicVariable class methodsFor: 'evaluating' stamp: 'avi 4/27/2004 14:25'!
value
	^ self raiseSignal! !

!WADynamicVariable methodsFor: 'defaults' stamp: 'avi 3/29/2004 14:12'!
defaultAction
	self resume: self class defaultValue! !

Notification subclass: #WAPageExpired
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

Notification subclass: #WARenderNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

Notification subclass: #WAValidationNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WAValidationNotification commentStamp: 'cds 7/25/2005 10:17' prior: 0!
I am signaled to indicate that a validation has occurred.  See: Object>>validationError:, WAComponent>>validateWith: and WAValidationDecoration.!

!ContextPart methodsFor: '*seaside2-squeak' stamp: 'avi 5/22/2004 12:57'!
homeReceiver
	^ self home receiver! !

!ContextPart methodsFor: '*seaside2-squeak' stamp: 'avi 4/24/2004 12:27'!
localAt: aNumber
	^ self at: aNumber! !

!ContextPart methodsFor: '*seaside2-squeak' stamp: 'avi 4/24/2004 12:27'!
localAt: aNumber put: anObject
	^ self at: aNumber put: anObject! !

!ContextPart methodsFor: '*seaside2-squeak' stamp: 'avi 4/24/2004 12:27'!
localSize
	^ self size! !

!PositionableStream methodsFor: '*seaside2-squeak' stamp: 'mb 6/2/2006 10:47'!
asMIMEDocument
	^self asMIMEDocumentType: 'text/plain'! !

!PositionableStream methodsFor: '*seaside2-squeak' stamp: 'mb 6/2/2006 10:54'!
asMIMEDocumentType: mimeType
	^MIMELocalFileDocument contentType: mimeType contentStream:  self! !

!PositionableStream methodsFor: '*seaside2-squeak' stamp: 'ab 7/11/2003 00:10'!
upToAndSkipThroughAll: aCollection
	^ self upToAll: aCollection! !

!False methodsFor: '*seaside2' stamp: 'ac 3/22/2005 20:23'!
yesNoString
	^ 'No'! !

!Integer methodsFor: '*seaside2' stamp: 'mbany 4/14/2005 12:09'!
printStringAsCents
	^ '$', (self // 100) displayString, '.', (self \\ 100) asTwoCharacterString! !

!Collection methodsFor: '*seaside2' stamp: 'ab 10/1/2002 13:47'!
inspectorFields
	|i|
	i _ 0.
	^ self asArray collect: [:each | i _ i + 1. i -> each]! !

!Collection methodsFor: '*seaside2' stamp: 'lr 3/8/2006 08:43'!
renderOn: html
	self do: [ :each | each renderOn: html ]! !

!Date class methodsFor: '*seaside2-squeak' stamp: 'ab 7/10/2003 11:29'!
newDay: dayNumber monthNumber: monthNumber year: yearNumber
	^ self newDay: dayNumber month: monthNumber year: yearNumber! !

!Form methodsFor: '*seaside2-squeak' stamp: 'mb 6/12/2006 14:01'!
asMIMEDocument 
	^self asMIMEDocumentType: self defaultMimeType.! !

!Form methodsFor: '*seaside2-squeak' stamp: 'mb 6/2/2006 11:05'!
asMIMEDocumentType: mimeType
	| aStream |
	aStream _ (RWBinaryOrTextStream on: '').
	(self writerForMimeType: mimeType)
		putForm: (self asFormOfDepth: 32) onStream: aStream.
	^MIMEDocument contentType: mimeType content: aStream contents
! !

!Form methodsFor: '*seaside2-squeak' stamp: 'mb 6/12/2006 14:00'!
defaultMimeType
	^'image/gif'! !

!Form methodsFor: '*seaside2-squeak' stamp: 'mb 6/12/2006 14:01'!
mimeType
	^ self defaultMimeType! !

!Form methodsFor: '*seaside2-squeak' stamp: 'mb 6/12/2006 14:02'!
writerForMimeType: mimeTypeString
	| mimeType tokens type |
	mimeType _ mimeTypeString isString
		ifTrue: [mimeTypeString]
		ifFalse: [self mimeType].
	[tokens _ mimeType findTokens: '/'.
	tokens size < 2] whileTrue: [mimeType _ self defaultMimeType].
	"First token is assumed to be 'image'"
	type _ tokens second.
	type = 'jpg' ifTrue: [^JPEGReadWriter2].
	type = 'jpeg' ifTrue: [^JPEGReadWriter2].
	type = 'png' ifTrue: [^PNGReadWriter].
	type = 'pcx' ifTrue: [^PCXReadWriter].
	type = 'bmp' ifTrue: [^BMPReadWriter].
	type = 'gif' ifTrue: [^GIFReadWriter].
	^nil! !

TcpService subclass: #WAModLisp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

!WAModLisp methodsFor: 'accessing' stamp: 'avi 5/5/2005 13:45'!
entryPoint
	^ WADispatcher default! !

!WAModLisp methodsFor: 'actions' stamp: 'avi 5/5/2005 13:45'!
handleRequest: aRequest
	^ (self entryPoint handlerForRequest: aRequest) handleRequest: aRequest! !

!WAModLisp methodsFor: 'actions' stamp: 'avi 5/5/2005 13:38'!
parseFields: aString
	| dict key value start end eqSignPos more |
	dict := Dictionary new.
	aString isEmptyOrNil ifTrue: [^dict].
	more := true.
	start := 1.
	[end := aString indexOf: $& startingAt: start.
	end == 0
		ifTrue: [end := aString size. more := false]
		ifFalse: [end := end - 1].
	eqSignPos := aString indexOf: $= startingAt: start.
	(eqSignPos > end or: [eqSignPos == 0])
		ifTrue: [key := (key := aString copyFrom: start to: end) unescapePercents.
			value := '']
		ifFalse: [key := (key := aString copyFrom: start to: eqSignPos-1) unescapePercents.
			value := (value := aString copyFrom: eqSignPos+1 to: end) unescapePercents].
	dict at: key put: value.
	start := end + 2.
	more] whileTrue.

	^dict! !

!WAModLisp methodsFor: 'actions' stamp: 'avi 5/5/2005 13:04'!
readHeadersFrom: aStream
	| headers key |
	headers := Dictionary new.
	[(key := (aStream upTo: Character lf)) = 'end'] whileFalse:
		[headers at: key put: (aStream upTo: Character lf)].
	^ headers! !

!WAModLisp methodsFor: 'conversation' stamp: 'avi 5/5/2005 13:25'!
serve: aSocket
	| stream |
	stream := SocketStream on: aSocket.
	[aSocket isConnected] whileTrue: [self serveOn: stream]! !

!WAModLisp methodsFor: 'actions' stamp: 'pmm 10/2/2006 21:10'!
serveOn: aStream
	| headers request response content method url query fields |
	headers := self readHeadersFrom: aStream.
	
	headers at: 'Content-Length' ifPresent:
		[:cl |
		content := aStream next: cl asInteger].	
	method := headers at: 'method'.
	url := (headers at: 'url') copyUpTo: $?.
	query := (headers at: 'url') copyAfter: $?.
	
	fields := method asLowercase = 'get'
		ifTrue: [ self parseFields: query ]
		ifFalse: [ self parseFields: content ].
		
	request := WARequest
				method: method
				url: url
				headers: headers
				fields: fields
				cookies: Dictionary new.

	response := self handleRequest: request.
	self writeResponse: response on: aStream.
	aStream flush! !

!WAModLisp methodsFor: 'printing' stamp: 'avi 5/10/2005 14:33'!
writeKey: keyString value: valueString on: aStream
	aStream nextPutAll: keyString displayString; nextPut: Character lf.
	aStream nextPutAll: valueString displayString; nextPut: Character lf! !

!WAModLisp methodsFor: 'actions' stamp: 'avi 5/5/2005 13:30'!
writeResponse: aResponse on: aStream
	self writeKey: 'Status' value: aResponse status on: aStream.
	self writeKey: 'Content-Type' value: aResponse contentType on: aStream.
	aResponse headers keysAndValuesDo:
		[:k :v |
		self writeKey: k value: v on: aStream].
	self writeKey: 'Content-Length' value: aResponse contents size on: aStream.
	self writeKey: 'Keep-Socket' value: 1 on: aStream.
	aStream nextPutAll: 'end'; nextPut: Character lf.
	aStream nextPutAll: aResponse contents contents! !

!UndefinedObject methodsFor: '*seaside2' stamp: 'mb 11/27/2005 10:20'!
asSeasideString
	^ ''
! !

!UndefinedObject methodsFor: '*seaside2' stamp: 'mb 3/23/2006 07:36'!
convertSeasideString: aString
	^ aString = '' ifTrue: [nil] ifFalse: [aString]
! !

!UndefinedObject methodsFor: '*seaside2' stamp: 'ab 11/11/2002 12:06'!
renderOn: html
! !

!Parser methodsFor: '*seaside2-override-squeak' stamp: 'ab 2/21/2003 02:00'!
interactive

	^ (requestor == nil or: [requestor isKindOf: SyntaxError] or: [requestor isKindOf: WAMethodEditor]) not! !

!Exception class methodsFor: '*seaside2-squeak' stamp: 'ab 7/10/2003 11:42'!
raiseSignal
	^ self signal! !

!Exception class methodsFor: '*seaside2-squeak' stamp: 'mb 3/23/2006 17:53'!
raiseSignal: aString
	^ self signal: aString! !

!Exception methodsFor: '*seaside2-squeak' stamp: 'ab 3/28/2003 17:36'!
reactivateHandler 
  handlerContext ifNotNil: [handlerContext tempAt: 3 put: true].
! !

!ByteArray methodsFor: '*seaside2' stamp: 'mb 6/2/2006 10:46'!
asMIMEDocument
	^self asMIMEDocumentType: 'application/octet-stream'! !

!ByteArray methodsFor: '*seaside2' stamp: 'mb 6/2/2006 10:53'!
asMIMEDocumentType: mimeType
	^SeasidePlatformSupport mimeDocumentClass contentType: mimeType content: self! !

!ByteArray methodsFor: '*seaside2' stamp: 'mb 9/22/2006 12:17'!
renderOn: aRenderer
	aRenderer text: self! !

ByteArray variableByteSubclass: #WAExternalID
	instanceVariableNames: ''
	classVariableNames: 'Generator GeneratorMutex'
	poolDictionaries: ''
	category: 'Seaside-Utilities'!

!WAExternalID class methodsFor: 'defaults' stamp: 'ab 5/28/2003 23:34'!
defaultSize
	^ 8! !

!WAExternalID class methodsFor: 'instance creation' stamp: 'pmm 10/2/2006 21:31'!
fromString: aString
	| id |
	id := self new: aString size.
	aString withIndexDo: [ :each :index |
		id at: index put: each asInteger].
	^ id
! !

!WAExternalID class methodsFor: 'class initialization' stamp: 'mb 11/27/2005 17:19'!
initialize
	"WAExternalID initialize"

	GeneratorMutex := Semaphore forMutualExclusion.
	SeasidePlatformSupport addToStartUpList: self.
	self startUp.! !

!WAExternalID class methodsFor: 'instance creation' stamp: 'ab 5/28/2003 23:53'!
new
	^ self new: self defaultSize! !

!WAExternalID class methodsFor: 'instance creation' stamp: 'pmm 11/2/2005 23:19'!
new: aNumber
	^ (self basicNew: aNumber) initialize! !

!WAExternalID class methodsFor: 'class initialization' stamp: 'al 6/29/2005 09:08'!
startUp
	Generator := Random new.! !

!WAExternalID methodsFor: 'private' stamp: 'lr 5/3/2006 09:40'!
initialize
	GeneratorMutex critical:
		[1 to: self size do: [:i | self at: i put: ((($a to: $z), ($A to: $Z)) atRandom: Generator) asInteger]]! !

!WAExternalID methodsFor: 'private' stamp: 'ab 5/29/2003 00:00'!
printOn: stream
	self do: [:i | stream nextPut: (Character value: i)]! !

!Morph methodsFor: '*seaside2-squeak' stamp: 'mb 6/2/2006 10:47'!
asMIMEDocument
	^self imageForm asMIMEDocument! !

!Morph methodsFor: '*seaside2-squeak' stamp: 'mb 6/2/2006 10:53'!
asMIMEDocumentType: mimeType
	^self imageForm asMIMEDocumentType: mimeType! !
WAAbstractHtmlBuilder initialize!
WACachedDocument initialize!
WAGlobalConfiguration initialize!
WAUserConfiguration initialize!
WAFileLibrary initialize!
WAKom initialize!
WAListener initialize!
WABrowser initialize!
WACounter initialize!
WADateSelectorTest initialize!
WADispatcherEditor initialize!
WADispatcherNavigator initialize!
WAExampleBrowser initialize!
WAAllCanvasTests initialize!
WAAllTests initialize!
WAHalo initialize!
WAMultiCounter initialize!
WAStore initialize!
WAVNCController initialize!
WAFileHandler initialize!
WAExpirySession initialize!
WASpotProfiler initialize!
Seaside2Info initialize!
WAExternalID initialize!
